// Acces.cpp
// algorithme d'accessibilite a la volee
//
// Agnes, 25 Juillet 2001
//


#include "acces.h"


/***************************************************************
*	Rconfig                                                     *
***************************************************************/

void Rconfig::aff()
{cout << " noeud " << _noeud << ", zone " << _zone;}

Ident Rconfig::n()
{return _noeud;}

int Rconfig::Phi()
{return 0;}

int operator == (Rconfig c1,Rconfig c2)
{ return (Eq_str(c1.n(),c2.n()) && c1._zone->Est_equiv(c2._zone));}


/***************************************************************
*	RSconfig	& RProblem														*
***************************************************************/


RProblem::RProblem(STable * T,Lnu * prop)
{
  int i,j;
  Ident id;
//  cout << " constructeur RProblem !" << endl;

// Verifier que prop est de la bonne forme (atomique)
// et que les noms d' automates correspondent
// remplacer les nom d' aut par des numeros ?
  if (! prop->Is_Atomic()) {
    cout << "La formule n'est pas une formule atomique..."<< endl;
    prop = new LnuBool(Top);
  }
	_goal = prop;

// Construire _Aut en parcourant T
	_Tab = T->Taille();
   _NomAut = new Ident[_Tab];
   _Aut = new TA*[_Tab];
   for (i=0;i<_Tab;i++) {
		id = T->Composant(i);
		_NomAut[i] = strcpy(new char [strlen(id)+1],id);
		_Aut[i] = Envir.Recherche(id)->OTA();
      }

//cout << "construction de la table..." << endl;
// Construire _Table en parcourant T
	Liste<char**> lvec = T->LVecteur();
//cout << "on a recupere LVecteur..." << endl;
	_NbVec = lvec.Longueur();
   char ** vec;
   _Table = new Ident *[_NbVec];
   for (i=0;i<_NbVec;i++)
		_Table[i] = new Ident[_Tab];

	for (i=0;i<_NbVec;i++,lvec.Reste()) {
		vec = lvec.Tete();
		for (j=0;j<_Tab;j++) {
	  		id = vec[j];
	  		_Table[i][j]= strcpy(new char [strlen(id)+1],id);
			}
      }

//      Print();

// Construire _RG
	Ident_L lc, laux;
   int Max=0, aux;
   for (i=0;i<_Tab;i++) {
		for (laux = _Aut[i]->Get_Clocks();! laux.Est_vide();laux.Reste())
	  		lc.Ajouter(laux.Tete());
//		lc.Concat(_Aut[i]->Get_Clocks());
		aux = _Aut[i]->Get_CsteMax();
      Max = (aux < Max) ? Max : aux;
      }
	_RG = new RegionGraph(lc,Max,0);
//	cout << " constructeur RProblem - fin !" << endl;
}


void RProblem::Print()
{
	int i,j;
	cout << "Formule : " ; _goal->Print();cout << endl;
  	for (i=0;i<_Tab;i++)
   	cout << _NomAut[i] << " ";
	cout << endl;
	for (i=0;i<_NbVec;i++) {
    	for (j=0;j<_Tab;j++)
      	cout << _Table[i][j]<< " ";
    	cout << endl;
  		}
	cout << "RegionGraph global : " << endl;
  	_RG->Print();
}


int RProblem::NumAut(Ident nom)
{
	for (int i=0;i<_Tab;i++)
   	if (Eq_str(_NomAut[i],nom))
      	return i;
	assert(0);
	return -1;
}


int accessible(RSconfig , Lnu *);

void RProblem::Reach()
{
  	cout << "System Reachability." << endl;
  	cout << "------------------------------------------"<< endl;

  	Print();

//	cout << "a faire !" << endl;
	RSconfig c0 (this);
	
	cout << "Config de depart:" << endl;
	c0.Print();

	if (accessible(c0,_goal))
	  cout << "Etat accessible !!" << endl;
	else cout << "Etat NON accessible !!" << endl;

}



RSconfig::RSconfig(RSconfig * c,Pt_Transition * t,Zone * z) 
{

  _Tab=c->_Tab;
 _noeud = new Ident[_Tab];
 _RP = c->_RP;

 for (int j=0;j!=_Tab;j++)
   _noeud[j]=(t[j]==0)?c->_noeud[j]:t[j]->To();

 _zone=z;

}


RSconfig::RSconfig(RProblem * RP)
{
  _RP = RP;
   _Tab = RP->NbAut();

   _noeud = new Ident[_Tab];
   for (int j=0;j!=_Tab;j++)
   	_noeud[j]=(RP->Aut(j))->Get_init();

   _zone = new Zone(RP->RG());
   _zone->Initial();
}

int RSconfig::Phi()
{return 0;}

void  RSconfig::Print()
{
  cout << "(";
  for (int i=0;i<_Tab-1;i++)
    cout << _RP->NomAut(i)<<":"<<_noeud[i]<<", ";
  
  cout << _RP->NomAut(_Tab-1)<<":"<<_noeud[_Tab-1]<<")";

   cout << endl;
   cout << "zones : ";
   _zone->PrintShort();
   cout << endl;
   cout << "(";_RP->Prop()->Print();cout << ")"<< endl;
}




int RSconfig::Verify(Ident nta,Ident prop)
{
  	int res=0;
  	if (Eq_str(nta,"*"))
    	for (int i=0;!res && i<_Tab;i++)
      	res = Eq_str(_noeud[i],prop);
  	else {
    	int aut = _RP->NumAut(nta);
    	res = Eq_str(_noeud[aut],prop);
  		}
  	return res;
}

int operator == (RSconfig c1,RSconfig c2)
{
  if (c1._Tab != c2._Tab)
    return 0;
  for (int j=0;j<c1._Tab;j++) 
    if (!Eq_str(c1._noeud[j],c2._noeud[j])) 
      return 0;

  return (c1._zone->Est_equiv(c2._zone));
}

int operator >= (RSconfig c1,RSconfig c2)
{
  if (c1._Tab != c2._Tab)
    return 0;
  for (int j=0;j<c1._Tab;j++) 
    if (!Eq_str(c1._noeud[j],c2._noeud[j])) 
      return 0;

  return (c1._zone->Est_inclu(c2._zone));
}


/***************************************************************
*	Methodes de PSet                                            *
***************************************************************/

PSet::PSet(int taille)
{
   _liste = new elt*[taille];
	for (int t=0;t!=taille;t++)
		_liste[t]=0;}

void PSet::aff(int taille)
{
	for (int t=0;t!=taille;t++) {
   	elt *n = _liste[t];
   	if (n!=0)
      	for (elt*e=n;e!=0;e=e->suivant)
         	e->couple.aff();
      else cout << "vide";
   }
}

int PSet::contient(Rconfig c)
{
	int n=c.Phi();
//   cout << "passed = "; aff(1); cout << endl;
   elt *p = _liste[n];
//   cout << p << endl;
   if (p!=0)
   	for(elt *e=p;e!=0;e=e->suivant)
      	if (e->couple==c) return 1;
   return 0;
}

void PSet::ajoute(Rconfig c)
{
  int n=c.Phi();

  elt *nouveau = new elt(c,_liste[n]);
  _liste[n] = nouveau;
}

/* et de P_Set *********************************************/

P_Set::P_Set(int taille)
{
  _nbliste = taille;
  _liste = new elt*[taille];
  for (int t=0;t<taille;t++)
    _liste[t]=0;
}


int P_Set::contient(RSconfig c)
{
  int n=c.Phi();
   elt *p = _liste[n];
   if (p!=0)
     for(elt *e=p;e!=0;e=e->suivant)
       if (e->couple==c) return 1; // FL: en fait il suffit que e->couple >= c
   return 0;
}

void P_Set::ajoute(RSconfig c)
{
  int n=c.Phi();

  elt *nouveau = new elt(c,_liste[n]);
  _liste[n] = nouveau;
}

int P_Set::Taille() {
  int res = 0;
  for (int i=0;i<_nbliste;i++) {
    for (elt * aux=_liste[i];aux !=0;aux=aux->suivant) 
      res++;
  }
  return res;
}


/***************************************************************
*	Methodes de WSet                                            *
***************************************************************/

WSet::WSet()
{_dernier=0;}

WSet::WSet(Rconfig c)
{
  elt *d = new elt;
  d->couple=c;
  d->suivant=d;
  _dernier=d;
}

void WSet::aff()
{
  elt *d=_dernier;
   if (d!=0) {
     for (elt *e=d->suivant;e!=d;e=e->suivant)
       (e->couple).aff();
     (d->couple).aff();}
   else cout << " vide";
}

int WSet::est_vide()
{ return (_dernier==0); }


Rconfig WSet::piocher()
{
//   if est_vide() erreur... mais ca ne peut pas arriver.
	elt *res = _dernier->suivant;
//   cout << "waiting = "; aff(); cout << endl;
//   res->couple.aff(); cout << " pioche." << endl;
   if (res == res-> suivant)
   	_dernier=0;
   else
   	_dernier = res->suivant;
//   cout << "waiting = "; aff(); cout << endl;
   return res->couple;
}

int WSet::appartient(Rconfig c)
{
	if (est_vide()) return 0;
   if (_dernier->couple==c) return 1;
	for (elt *p=_dernier->suivant;p!=_dernier;p=p->suivant)
   	if (p->couple==c) return 1;
   return 0;
}

void WSet::ajoute(Rconfig c)
{
	elt *nouveau;
	nouveau = new elt;

   nouveau->couple=c;

   if (est_vide())
   	nouveau->suivant=nouveau;
   else {
   	nouveau->suivant=_dernier->suivant;
		_dernier->suivant=nouveau;
   }

   _dernier=nouveau;
}

void WSet::fusionne(Liste<Rconfig> l)
{
	while (!l.Est_vide()) {
   	Rconfig c = l.SupprimerRes(1);
// ce qui, si j'ai bien compris, recupere le premier Rconfig le l et l'efface de la liste.
		if (!appartient(c)) ajoute(c);
	}
}

/* et de W_Set ************************************************************/

W_Set::W_Set()
{_dernier=0;}

W_Set::W_Set(RSconfig c)
{
  elt *d;
  d=new elt;
  d->couple=c;
  d->suivant=d;
  _dernier=d;
}

int W_Set::est_vide()
{ return (_dernier==0); }

RSconfig W_Set::piocher()
{ //   if est_vide() erreur... mais ca ne peut pas arriver.
  RSconfig res;
  elt * aux;

  if (_dernier == _dernier->suivant) 
    {
      res = _dernier->couple;
      delete _dernier;
      _dernier =0;
      return res;
    }

  aux = _dernier->suivant;
  res = aux->couple;
  _dernier->suivant = aux->suivant;
  delete aux;
  return res;
}

int W_Set::appartient(RSconfig c)
{
	if (est_vide()) return 0;
   if (_dernier->couple==c) return 1;
	for (elt *p=_dernier->suivant;p!=_dernier;p=p->suivant)
   	if (p->couple==c) return 1;
   return 0;
}

void W_Set::ajoute(RSconfig c)
{
	elt *nouveau;
	nouveau = new elt;

   nouveau->couple=c;

   if (est_vide())
   	nouveau->suivant=nouveau;
   else {
   	nouveau->suivant=_dernier->suivant;
		_dernier->suivant=nouveau;
   }

   _dernier=nouveau;
}

void W_Set::fusionne(Liste<RSconfig> l)
{
	RSconfig c;
	while (!l.Est_vide()) {
	  c = l.Tete();
	  l.Cdr();
	  if (!appartient(c)) ajoute(c);
	}
}

int W_Set::Taille() {
  int res =0 ;

  if (!_dernier) return 0;

  for (elt * aux = _dernier->suivant;aux!=_dernier;aux=aux->suivant) 
    res++;
  return res++;
}


/**********************************************************************
*	Algorithme principal                                               *
**********************************************************************/

Liste<Rconfig> Rconfig::Succ()
{

   Liste<Rconfig> res;

   Zone *zone_f = _zone->Add_FutureC();
   SetReg *zones_f = _automate->Get_Z_Invariant(_noeud);
   zones_f->Intersection(zone_f);

   Pt_Transition t;
   Lnu *cond_t;
   SetReg *zones_t;
   for(	Transition_L liste_t = _automate->Get_T_from_n(_noeud);
         !liste_t.Est_vide();                       //enumeration des transitions possibles
         liste_t.Reste()) {
		t = liste_t.Tete();
      cond_t = t->Get_cond();
      zones_t = (SetReg*) cond_t->StateSat(_automate->Get_RG(0),0);

      zones_t->Intersection(zones_f);
      if (!zones_t->Est_vide()) {

      	Assign r;                                  //Reset des horloges nescessaires
      	for(	Assign_L liste_r = *t->Get_rs();
         		!liste_r.Est_vide();
               liste_r.Reste()) {
				r = liste_r.Tete();
				zones_t->Projection(r._ci,r._cj,r._k);
         }

      	zones_t->Intersection(_automate->Get_Z_Invariant(t->To()));
      	if (!zones_t->Est_vide()) {

         	Pt_Zone z;                              //Creation des nouveaux Rconfig
            Rconfig c;
            for(	Liste<Pt_Zone> liste_z = zones_t->Get_lz();
            		!liste_z.Est_vide();
                  liste_z.Reste()) {
            	z = liste_z.Tete();
               c._noeud=t->To();
            	c._zone=z;
            	c._automate=_automate;
            	res.Ajouter(c);
            }
         }
      }
   }
   return res;
}

int accessible(Rconfig c0, Ident arrivee)
{
	PSet Passed=PSet(1);				//PSet(automate.nb_noeud);
   WSet Waiting=WSet(c0);    		//ne contient que c0 (pour l'instant)
//   int t=0;
   while (!Waiting.est_vide()) {
//		cout << "?"; int i; cin >>i;
//		if (i==0) return 0;
//		cout << "etape " << t++ << endl;
		Rconfig a = Waiting.piocher();
//		a.aff(); cout << " pioche." << endl;
      if (Eq_str(a.n(),arrivee)) return 1;
//		cout << " passed ="; Passed.aff(1);cout<<endl;
      if (!Passed.contient(a)) {
      	Passed.ajoute(a);
//			cout << " passed ="; Passed.aff(1);cout<<endl;
         Waiting.fusionne(a.Succ());
      }
//      else cout << " passed contient a" << endl;
//      cout << " waiting = "; Waiting.aff(); cout <<endl;
   }

   return 0;
}

/* et pour plusieurs automates... *********************************************/


int decale(int i, Transition_L l[], Transition_L s[])
{
	if (i<0) return 1;
   l[i].Reste();
   if (l[i].Est_vide()) {
   	l[i]=s[i];
      return decale(i-1,l,s);
      }
   return 0;
}

Liste<Pt_Transition *> RSconfig::SuccV(int i)	//calcule les vecteurs de transitions possibles
{															//pour le vecteur i de la table
  Liste<Pt_Transition *> res;
   Ident label;
   Transition_L * liste;
   liste = new Transition_L[_Tab];

//rcupration des ensembles de transitions associ  chaque label
   for (int j=0;j!=_Tab;j++) {
     label=_RP->Table(i,j);
	if (Eq_str(label,".")) {
	  Pt_Transition t=0;   							//le pointeur nul correspond donc a
	  liste[j].Ajouter(t);							//une transition "vide".
	}
	else {
	  liste[j]=(_RP->Aut(j))->Get_T_from_n_l(_noeud[j],label);
	  if (liste[j].Est_vide()) return res;	//si un seul noeud n'a pas de transitions,
	}													//SuccV est vide.
   }

//produit de ces ensembles en les lisant ds l'ordre lexicographique
   Transition_L * sauv;
   sauv = new Transition_L[_Tab];
   for (int j=0;j!=_Tab;j++) 
     sauv[j]=liste[j];
   int fin=0;
   Pt_Transition *v;
   while (!fin) {
   	v = new Pt_Transition[_Tab];
   	for (int j=0;j!=_Tab;j++)
	  v[j]=liste[j].Tete();
	fin = decale(_Tab-1,liste,sauv);
	res.Ajouter(v);
   }

   /*   
   cout << "RSconfig::SuccV" << endl;
   for (Liste<Pt_Transition *> laux = res;!laux.Est_vide();laux.Reste()) {
     Pt_Transition * tt = laux.Tete();
     for (i=0;i<_T;i++) {
       if (tt[i]) {
	 laux.Tete()[i]->Print();
	 cout << endl;
       }
       else cout << " - " << endl;
     }
     cout << "***" << endl;
   }
   */

   return res;
}

//calcule les vecteurs de transitions possibles
//pour un vecteur de noeud et une table
Liste<Pt_Transition *> RSconfig::SuccT()	
{
  Liste<Pt_Transition *> res;
  int N=_RP->NbVec();
  
  for (int i=0;i!=N;i++)
    res.Concat(SuccV(i));
  
  return res;
}



Liste<RSconfig> RSconfig::Succ()
{
   Liste<RSconfig> res;

   Zone *zone_f = _zone->Add_FutureC();
   SetReg *zones_f = new SetReg(_RP->RG(),1);
   for (int j=0;j<_Tab;j++)
     zones_f->Intersection((_RP->Aut(j))->Get_Z_Invariant(_noeud[j],_RP->RG()));
   zones_f->Intersection(zone_f);

   /*
   cout << "Succ avec " << endl;
   zones_f->Print();
   */

   Pt_Transition * t = new Pt_Transition[_Tab];
   Lnu *cond_t;
   SetReg *zones_t = new SetReg(_RP->RG(),1);
   //enumeration des transitions possibles
   for(	Liste<Pt_Transition*> liste_t = SuccT();!liste_t.Est_vide();liste_t.Reste()) {
     for (int j=0;j<_Tab;j++) {
       t[j] = liste_t.Tete()[j];
       if (t[j]) {
	  cond_t = t[j]->Get_cond();
	  zones_t->Intersection(cond_t->StateSat(_RP->RG(),0));
	  if (zones_t->Est_vide()) 
	    break;
       }
     }
     zones_t->Intersection(zones_f);
     /*
     cout << "Les transitions synchro : " << endl;
      for (int j=0;j!=_Tab;j++) {
      	if (t[j]) {t[j]->Print();cout << endl;}
	else cout << " - " << endl;
	}
      cout << "sont tirables depuis :" << endl;
      zones_t->Print();
     */

      if (!zones_t->Est_vide()) {
	Assign r;                                  //Reset des horloges nescessaires
	for (int j=0;j!=_Tab;j++) {
	  if (t[j]) {
	   for(	Assign_L liste_r = *t[j]->Get_rs();!liste_r.Est_vide();liste_r.Reste()){
	     r = liste_r.Tete();
	     zones_t->Projection(r._ci,r._cj,r._k);
	   }
	   Ident ndest = (t[j]==0)?_noeud[j]:t[j]->To();
	   SetReg * Saux = _RP->Aut(j)->Get_Z_Invariant(ndest,_RP->RG());
	   zones_t->Intersection(Saux);
	   if (zones_t->Est_vide()) break;
	 }
       }

      	if (!zones_t->Est_vide()) {

	  Pt_Zone z;                              //Creation des nouveaux RSconfig
	  RSconfig * c;
	  for(	Liste<Pt_Zone> liste_z = zones_t->Get_lz();
		!liste_z.Est_vide();
		liste_z.Reste()) {
	    z = liste_z.Tete();
	    c = new RSconfig(this,t,z);
	    res.Ajouter(*c);
	    //cout << "La nouvelle config est : " << endl;
	    //c->Print();
	  }
	}
	else zones_t->Destroy();
     }
     else zones_t->Destroy();
     zones_t = new SetReg(_RP->RG(),1);
   }


   /*   
   cout << "Succ : " << endl;
   cout << "de :"; this->Print();
   cout << "( ";
   for (Liste<RSconfig> laux = res;!laux.Est_vide();laux.Reste()) {
     laux.Tete().Print();
     cout << endl;
   }
   cout << ")"<<endl;
   */


   return res;
}


// 

int accessible(RSconfig c0, Lnu * formule)
{
  P_Set Passed=P_Set(1);
   W_Set Waiting=W_Set(c0);    		//ne contient que c0 (pour l'instant)

   if (formule->Is_In_Config(&c0)){
     cout << "malin..." <<endl;
     return 1;
   }

   while (!Waiting.est_vide()) {
     RSconfig a = Waiting.piocher();

     //               cout << "Pioche : " << endl;
     //               a.Print();
     RSconfig::NbVisitSucc++;
     if (RSconfig::NbVisitSucc == 100) 
       {cout << "*"<< endl;
       RSconfig::NbVisitSucc=0;
       cout << "Passed  :" << Passed.Taille() << endl;
       cout << "Waiting :" << Waiting.Taille() << endl;
       }

     if (formule->Is_In_Config(&a)) return 1;
     if (!Passed.contient(a)) {
       Passed.ajoute(a);
       Waiting.fusionne(a.Succ());
     }
   }

   return 0;
}


// --------------------  Interfacage avec le reste --------------------
// pour 1 automate et un noeud


void Reachability(TA * A,Ident n)
{

  cout << "Reachability." << endl;

  Ident qinit = A->Get_init();
  Zone * zinit = new Zone(A->Get_RG(0));
  zinit->Initial();

  SetReg * Saux = A->Get_Z_Invariant(qinit);
  Saux->Intersection(zinit);

  if (Saux->Est_vide()) {
    cout << "Etat initial non inclu dans l'invariant de qinit !!";
    return ;
  }
  Saux->Destroy();

  Rconfig rc (qinit,zinit,A);
  if (accessible(rc,n))
    cout << " etat accessible ! " << endl;
  else cout << "etat non accessible !"<< endl;


  //  cout << "a faire !" << endl;
}




//    System


