/* File: arbre.cc -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      
 *
 */

#include "arbre.h"

#include <stdlib.h>


ASNoeud::ASNoeud(char * n,ArbreS ex)
{
  tnode = ASSIGN;
  nass.id = n;
  nass.exp = ex;
}

ASNoeud::ASNoeud(char * n,LArbreS *l)
{
  if (l) {
    tnode = CALL;
    nc.nfct = new ASNoeud(n);
    nc.larg =l;
  }
  else {
    tnode = IDF;
    nom = strcpy(new char[strlen(n)+1],n);
  }
}

ASNoeud::ASNoeud(int st, char * n)
{
  if (st != 1) {
    cout << " Erreur dans ASNoeud::ASNoeud(int st, char * n) " << endl;
  }
  tnode = STR;
  nom = strcpy(new char[strlen(n)+1],n);
}

ASNoeud::ASNoeud(ArbreS a,LArbreS *l)
{
tnode = CALL;
nc.nfct = a;
nc.larg = l;
}

ASNoeud::ASNoeud(int v)
{
tnode = NAT;
val = v;
}

ASNoeud::ASNoeud(Lnu * f)
{tnode = TLNU;
form = f;
}

ASNoeud::ASNoeud(Ident_L * l)
{tnode = TLID;
lid = l;
}

ASNoeud::ASNoeud(Specif * sp)
{tnode = TSPEC;
spec = sp;
}
ASNoeud::ASNoeud(TA * aut)
{tnode = TTA;
ta = aut;
}
ASNoeud::ASNoeud(Declaration * d)
{tnode = TDEC;
dec = d;
}

ASNoeud::ASNoeud(Fsynchro * f)
{tnode = TFSY;
fs = f;
}

ASNoeud::ASNoeud(STable * t)
{tnode = TTABLE;
tab = t;
}

ASNoeud::ASNoeud(Liste<VerifElet *> * syst)
{tnode = TSYSTEM;
system = syst;
}

TYPENOEUD ASNoeud::Type()
{return tnode;}

char * ASNoeud::Nom()
{if (tnode != IDF) 
  cout << " Erreur ASNoeud::Nom " << endl;
return nom;}

ArbreS ASNoeud::Nfct()
{if (tnode != CALL) 
  cout << " Erreur ASNoeud::Nfct " << endl;
return nc.nfct;}

LArbreS * ASNoeud::Larg()
{if (tnode != CALL) 
  cout << " Erreur ASNoeud::Larg " << endl;
return nc.larg;}

char * ASNoeud::Id()
{
if (tnode == ASSIGN) 
  return nass.id;
else if (tnode == STR)
  return nom;
else { 
  cout << " Erreur ASNoeud::Id() " << endl;
  return nom;
}
}


ArbreS ASNoeud::Ex()
{if (tnode != ASSIGN) 
  cout << " Erreur ASNoeud::Ex() " << endl;
return nass.exp;}


int ASNoeud::Val()
{if (tnode != NAT) 
  cout << " Erreur ASNoeud::Val " << endl;
return val;}

Lnu * ASNoeud::Form()
{if (tnode != TLNU) 
  cout << " Erreur ASNoeud::Form " << endl;
return form;}

Ident_L * ASNoeud::Lident()
{if (tnode != TLID) 
  cout << " Erreur ASNoeud::Lident " << endl;
return lid;}

Specif * ASNoeud::Spec()
{if (tnode != TSPEC) 
  cout << " Erreur ASNoeud::Spec " << endl;
return spec;}

TA * ASNoeud::Ta()
{if (tnode != TTA) 
  cout << " Erreur ASNoeud::Ta " << endl;
return ta;}

Declaration * ASNoeud::Dec()
{if (tnode != TDEC) 
  cout << " Erreur ASNoeud::Dec " << endl;
return dec;}

Fsynchro * ASNoeud::Fs()
{if (tnode != TFSY) 
  cout << " Erreur ASNoeud::Fs " << endl;
return fs;}

STable * ASNoeud::Table()
{if (tnode != TTABLE) 
  cout << " Erreur ASNoeud::Table " << endl;
return tab;}

Liste<VerifElet *> * ASNoeud::System()
{if (tnode != TSYSTEM) 
  cout << " Erreur ASNoeud::System " << endl;
return system;}


void ASNoeud::Print()
{
Declaration d;
Fsynchro Fs;
Pt_Synch_Vect_L lv;
Liste<ArbreS> la;
  switch(tnode) {
  case IDF : cout << "IDF : "; cout << nom ; break;
  case ASSIGN : cout << "ASSIGN : ";cout << nass.id << " <- "; nass.exp->Print();
    cout << endl; break;
  case  CALL: cout << " CALL : [";
    nc.nfct->Print(); cout << "( ";
    la = * nc.larg;
    if (! la.Est_vide()) {
      la.Tete()->Print();cout << endl; la.Reste();}
    while (! la.Est_vide()) {
      cout << "..."; la.Tete()->Print();cout << endl;
      la.Reste();
    }
    cout << ")]";
    break;
  case TLNU : cout << "TLNU : ";form->Print();break;
  case TLID : cout << "TLID : ";PrintIdent_L(lid);break;
  case TTA :  cout << "TTA : "; ta->Print(); break;
  case TDEC : cout << "TDEC :"; 
    cout << "Lnu declaration : " << endl;
    d = *dec;
    while (! d.Est_vide()) {
      cout << d.TeteN() << " = ";
      (d.Tete())->Print();
      cout << endl;
      d.Reste();
    }
    break;
  case TFSY : cout << "FSY :";
      cout << "Synchro. function :" << endl;
      Fs = *fs;
      while(! Fs.Est_vide()) {
	lv = *(Fs.Tete());
	cout << Fs.TeteN() << " -> {";
	while (! lv.Est_vide()) {
	  cout << "("; 
	  if (Eq_str(lv.Tete()->Get_la(),"")) cout << "_";
	  else cout << lv.Tete()->Get_la();
	  cout << ",";
	  if (Eq_str(lv.Tete()->Get_lb(),"")) cout << "_";
	  else cout << lv.Tete()->Get_lb();
	  cout << ") ";
	  lv.Reste();
	}
	cout << "}" << endl;
	Fs.Reste();
      }
      break;
  case TTABLE : cout << "TTABLE :";tab->Print();break;
  case TSPEC : cout << "TSPEC :";spec->Print();break;
  case NAT : cout << "NAT :";cout << val;break;
  case TSYSTEM : cout << "TSYSTEM ... not implemented !";break;
  default : cout << " Erreur ASNoeud::Print() " << endl;
  }
}

