/* File: arbre.h -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      Mon arbre syntaxique
 *
 */



#ifndef ARBRE_H
#define ARBRE_H

#include "liste.h"
#include "lnu.h"
#include "ta.h"
#include "specif.h"
#include "setval.h"
#include "table.h"

enum TYPENOEUD {IDF, CALL, TLNU, TTA, TDEC, TFSY, TSPEC, NAT, ASSIGN, STR, TTABLE, TSYSTEM, TLID};

class ASNoeud;
typedef ASNoeud * ArbreS;
typedef Liste<ArbreS> LArbreS;

class Specif;
class Lnu;


class NC {
public:
  ArbreS nfct;
  LArbreS * larg;
};

class NASSIGN {
public : 
  char * id;
  ArbreS exp;
};

class ASNoeud {
  private :
    TYPENOEUD tnode;
  union {
    char * nom;
    NC nc;
    NASSIGN nass;
    int val;
    Lnu * form;
    Ident_L *lid;
    Specif * spec;
    TA * ta;
    Declaration * dec;
    Fsynchro * fs;
    STable * tab;
    Liste<VerifElet *> * system;
  };
  public :
    ASNoeud(char * n,LArbreS *l =0);
    ASNoeud(int st,char * n);
    ASNoeud(ArbreS a,LArbreS *l);
    ASNoeud(char * n,ArbreS ex);
    ASNoeud(int v);
    ASNoeud(Lnu * f);
    ASNoeud(Ident_L * l);
    ASNoeud(Specif * sp);
    ASNoeud(TA * aut);
    ASNoeud(Declaration * d);
    ASNoeud(Fsynchro * f);
    ASNoeud(STable * t);
    ASNoeud(Liste<VerifElet *> * syst);
    
    TYPENOEUD Type();
    char * Nom();
    ArbreS Nfct();
    LArbreS * Larg();
    char * Id();
    ArbreS Ex();
    int Val();
    Lnu * Form();
    Ident_L * Lident();
    Specif * Spec();
    TA * Ta();
    Declaration * Dec();
    Fsynchro * Fs();
    STable * Table();
    Liste<VerifElet *> * System();

    void Print();
};


#endif
