// manages the environment: functions, flags, variables etc.


#include <iostream>

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

#include "acces.h"
#include "arbre.h"
#include "env.h"
#include "type.h"
//#include <ppl.hh>

extern char * AjouterCar(char *,char);

void MaJ_Flag(char *n,int v)
{
if (Eq_str(n,"verbose")) 
  {if (VERBOSE) cout << "Flag : verbose = "<< v << endl;
  VERBOSE = v;}
else if (Eq_str(n,"plc")) 
  {if (VERBOSE) cout << "Flag : plc = " << v << endl;
  __DBMPLC = v;}
else if (Eq_str(n,"trace")) 
  {if (VERBOSE) cout << "Flag : trace = " << v << endl;
  PTRACE = v;}
else if (Eq_str(n,"hash")) 
  {if (VERBOSE) cout << "Flag : hash = " << v << endl;
  __HACHAGE = v;}
//else if (Eq_str(n,"splitting"))
//  {if (VERBOSE) cout << "Flag : splitting = " << v << endl;
//  SIMPLSPLIT = v;}
else if (Eq_str(n,"simplhzp"))  
  {if (VERBOSE) cout << "Flag : simplhzp = " << v << endl;
  SIMPLHZ2 = v;}
else if (Eq_str(n,"hitzone")) 
  {if (VERBOSE) cout << "Flag : hitzone = " << v << endl;;
  SIMPLHZ = v;}
else if (Eq_str(n,"trivequation")) 
  {if (VERBOSE) cout << "Flag : trivequation = " << v << endl;
  SIMPLTE = v;}
else if (Eq_str(n,"equivequation")) 
  {if (VERBOSE) cout << "Flag : equivequation = " << v << endl;
  SIMPLEE = v;}
else if (Eq_str(n,"unguardedvar")) 
  {if (VERBOSE) cout << "Flag : unguardedvar = " << v << endl;
  SIMPLUNGVAR = v;}
else if (Eq_str(n,"nbfpit")) 
  {if (VERBOSE) cout << "Flag : nbfpit = " << v << endl;
  __NBFIXPOINT = v;}
else if (Eq_str(n,"Cmax")) 
  {if (VERBOSE) cout << "Flag : Cmax = " << v << endl;
  __CMAX = v;}
else if (Eq_str(n,"NoAbstraction")) 
  {if (VERBOSE) cout << "Flag : NoAbstraction = " << v << endl;
    if (v) 
      cout << "Warning : the abstraction will not be applied after Floyd algorithm, the termination of model checking is not ensured. " << endl;
  __NOABSTRACT = v;}
else if (Eq_str(n,"minfp")) 
  {if (VERBOSE) cout << "Flag : minfp = " << v << endl;
  __MINFIXPOINT = v;}
else if (Eq_str(n,"bell")) 
  {if (VERBOSE) cout << "Flag : bell = " << v << endl;
  BELL = v;}
}



//------------------------------------------------------------
//                 CLASSE OBJET
//------------------------------------------------------------



Objet::Objet(type t,int v,char * nom)
{_ot = t;
 _envname = nom; 
 _val = v;}

Objet::Objet(Lnu * v,char * nom)
{_ot = type(Flnu);
 _envname = nom; 
 _form = v;}

Objet::Objet(TA * v,char * nom)
{_ot = type(Ta);
 _envname = nom;
 _ta = v;}

Objet::Objet(Declaration * v,char * nom)
{_ot = type(Dec);
 _envname = nom;
 _d = v;}

Objet::Objet(Specif * v,char * nom)
{_ot = type(Spec);
 _envname = nom;
 _spec = v;}

Objet::Objet(Fsynchro * v,char * nom)
{_ot = type(Fsy);
 _envname = nom; 
 _fs = v;}

Objet::Objet(type t,TFCT v,char * nom)
{_ot = t;
 _envname = nom;
 _fct = v;}

Objet::Objet(type t,char * v,char * nom)
{_ot = t;
 _envname = nom;
 _vname = v;}

Objet::Objet(STable * tab,char * nom)
{_ot = type(Table);
 _envname = nom;
 _stab = tab;}

Objet::Objet(Liste<VerifElet *> * s,char * nom)
{_ot = type(System);
 _envname = nom;
 _syst = s;}

Objet::Objet(Zone * z,char * nom)
{_ot = type(Dbm);
 _envname = nom;
 _zone = z;}

Objet::Objet(SetVal * z,char * nom)
{_ot = type(Setval);
 _envname = nom;
 _setv = z;}

Objet::Objet(Ident_L * l,char * nom)
{_ot = type(Lid);
 _envname = nom;
 _lid = l;}


// jtype = 1 => juste le type
// jtype = -1 => pas le type... juste la valeur !
void Objet::Print(int jtype)
{
Declaration dec;
Liste<VerifElet *> lve;

 if (jtype >= 0) {
   if (_envname) cout << _envname << " : ";
   else 
     if ((!_ot.Est_typeb()) || (_ot.Valb() != Undef)) 
       cout << "(without name) : ";
   if (jtype>0) {
     _ot.Print();
     return;}
 }

if (_ot.Est_typeb()) {
  switch(_ot.Valb()) {
  case Void : _ot.Print();cout << endl; break;
  case Int :  if (jtype >= 0)
      cout << "(int) " << _val << endl; 
    else cout << _val << endl; 
    break;
  case String :  if (jtype >= 0) cout << "(String) " << _vname << endl; 
    else cout << _vname << endl; 
    break;
  case CFlag :  if (jtype >= 0) cout << "Flag : " << _val << endl; 
    else cout << _val << endl;
    break;
  case Flnu : if (jtype >= 0) cout << "(Lnu) "; 
    _form->Print();cout << endl; break;
  case Ta : if (jtype >= 0) cout << "(TA) ";
    _ta->Print(); break;
  case Spec : if (jtype >= 0) cout << "(Specif) "; 
    _spec->Print(); break;
  case Dec : if (jtype >= 0) cout << "(Decl) "; 
    cout << "Lnu declaration : " << endl;
    dec = *_d;
    while (! dec.Est_vide()) {
      cout << dec.TeteN() << " = ";
      (dec.Tete())->Print();
      cout << endl;
      dec.Reste();
    }
    break;
  case Fsy : PrintFs(_fs);
      break;
  case Table : _stab->Print(); break;
  case System : lve = * _syst;
    cout << "System : " << endl;
    while (! lve.Est_vide()) {
      cout << lve.Tete()->_nta << "; Flag : [";
      if (lve.Tete()->_vflag)
	for (int k=0;k<5;k++) 
	  cout << lve.Tete()->_vflag[k] << " ";
      cout << " ]"<< endl;
      lve.Reste();
    }
    break;
  case Dbm : if (jtype >= 0) cout << "(DBM)";
    _zone->PrintShort();cout << endl;
    _zone->PrintM();
    break;
  case Setval : _setv->Print();cout << endl;
    break;
  case Lid : PrintIdent_L(_lid);
    break;
  case Undef : cout << " - " << endl;break;
  default : cout << " Erreur in Objet::Print() "; _ot.Print(); cout << endl;
  }
}
else {
  _ot.Print();
}
}

void Objet::Destroy()
{
Liste<VerifElet *> lve;
VerifElet * veaux;

  if (_ot.Est_typeb()) {
    switch(_ot.Valb()) {
    case Flnu : _form->Destroy();break;
    case Ta :   _ta->Destroy();break;
    case Dec :  
      if (_d) {
	for (Declaration Dec= (*_d); !Dec.Est_vide(); Dec.Reste()) 
	  if (Dec.Tete())
	    Dec.Tete()->Destroy();
	_d->Vide();
      }
      break;
    case Spec : _spec->Destroy();break;
    case Fsy : DestroyFs(_fs); break;
    case String : delete _vname;
      break;
    case Table : _stab->Destroy(); 
      break;
    case Dbm : _zone->Destroy();delete _zone;
      break;
    case Setval : _setv->Destroy();
      break;
    case Lid : DestroyIdent_L(_lid);
      break;
    case System : 
      lve = *_syst;
      while (! lve.Est_vide()) {
	veaux = lve.Tete();
	delete veaux->_nta;
	if (veaux->_vflag) 
	  delete [] veaux->_vflag;
	lve.Reste();
	delete veaux;
      }
      _syst->Vide();
      delete _syst;
      _syst = 0;
      break;
    case Void : 
    case Int :
    case Undef :
    case Star :   
    case CFlag :  break;
    }
    
    delete _envname;
    delete this;
  }  

}

Objet * Objet::Copy()
{
Liste<VerifElet *> lve, * lvec;
VerifElet * veaux;
Objet * res;
Declaration * dc;

  if (_ot.Est_typeb()) {
    switch(_ot.Valb()) {
    case Flnu : res = new Objet(_form->Copy());break;
    case Ta :  res = new Objet(_ta->Copy());break;
    case Dec :  
      dc = new Declaration;
      if (_d) {
	for (Declaration Dec= (*_d); !Dec.Est_vide(); Dec.Reste()) 
	  dc->Ajouter(Dec.TeteN(),Dec.Tete()->Copy());
      }
      res = new Objet(dc);
      break;
    case Spec : res = new Objet(_spec->Copy());break;
    case Fsy : 
      res = new Objet(CopyFs(_fs)); // in lnu.cc
      break;
    case String : res = new Objet(type(String),
				  strcpy(new char[strlen(_vname)+1],_vname));
    break;
    case Table : res = new Objet(_stab->Copy());
      break;
    case System : 
      lvec = new Liste<VerifElet *>;
      lve = *_syst;
      while (! lve.Est_vide()) {
	veaux = lve.Tete();
	lvec->Ajouterf(veaux->Copy());
	lve.Reste();
      }
      res = new Objet(lvec);
      break;
    case Int :
      res = new Objet(type(Int),_val);
      break;
    case Dbm :
      res = new Objet(_zone->Copy());
      break;
    case Setval :
      res = new Objet(_setv->Copy());
      break;
    case Lid :
      res = new Objet(CopyIdent_L(_lid));
      break;
    case Void : 
    case Undef :
    case Star :   
    case CFlag :  cout << "Wrong argument for Copy function." << endl;
      res = new Objet(type(Undef),"");
      break;
    }
    
  }  
return res;
}


type Objet::Otype()
{return _ot;}

char * Objet::OEnvname()
{return _envname;}

void Objet::PutEnvname(char * nom)
{_envname = nom;}

Lnu * Objet::OLnu()
{return _form;}

TA * Objet::OTA()
{return _ta;}

Declaration * Objet::ODecl()
{return _d;}

Specif * Objet::OSpec()
{return _spec;}

Fsynchro * Objet::OFsyn()
{return _fs;}

TFCT Objet::Ofct()
{return _fct;}

char * Objet::OVname()
{return _vname;}

int Objet::Oval()
{return _val;}

STable * Objet::Otable()
{return _stab;}

Zone * Objet::Ozone()
{return _zone;}

SetVal * Objet::Osetval()
{return _setv;}

Ident_L * Objet::Olid()
{return _lid;}

Liste<VerifElet *> * Objet::Osystem()
{return _syst;}


//------------------------------------------------------------------------
//                    INTERFACE DES FONCTIONS DE L'ENVIR
//------------------------------------------------------------------------



// definition dans help.cc
void HelpFct(char * nf);


//-----------------------------------------------------
//               HELP

Objet * Help_interface(LObjet * l)
{char * n;
Objet * o = l->Tete();
n = o->OVname();
HelpFct(n);
return new Objet(type(Undef),"");}

//-----------------------------------------------------
//               DELETE

Objet * Delete_interface(LObjet * l)
{char * n;
Objet * o = l->Tete();
n = o->OEnvname();
if (n) 
  Envir.Supprimer(n);
 else cout << "It is not a variable of the environment !" << endl; 
return new Objet(type(Undef),"");}

//--------- REACHABILITY -----------------
// Objet * Reach_interface(LObjet * l)
// {
//   TA * aut;
//   Ident noeud;
//   LObjet lo = *l;

//   Objet * o = lo.Tete();
//   aut = o->OTA();
//   lo.Reste();
//   o = lo.Tete();
//   noeud = o->OVname();

//   Reachability(aut,noeud);
  
//   cout << "Warning ! The reachability procedure is not under debugging..." << endl; 

// return new Objet(type(Undef),"");
// }

//--------- SREACHABILITY -----------------
Objet * SReach_interface(LObjet * l)
{
  STable * table;
  Lnu * prop;
  LObjet lo = *l;
  Objet * o = lo.Tete();
  table = o->Otable();
  lo.Reste();
  o = lo.Tete();
  prop = o->OLnu();
  RProblem rp (table,prop);
  rp.Reach();

  cout << "Warning ! The reachability procedure is under debugging..." << endl; 

return new Objet(type(Undef),"");
}



//--------- TEST -----------------
Objet * Test_interface(LObjet * l)
{
  TA * aut;
  Ident nnoeud;
  SetReg * saux;
  Objet * o = l->Tete();
  aut = o->OTA();
  Map_propL lnoeud = aut->Get_Noeud();
  while (! lnoeud.Est_vide()) {
    nnoeud = lnoeud.TeteN();
    saux = aut->Get_Z_Invariant(nnoeud);
    cout << "Noeud : " << nnoeud << " : ";
    saux->Print(); 
    cout << endl;
    lnoeud.Reste();
  }

return new Objet(type(Undef),"");
}


//   Objet * BTA_interface(LObjet * l)   
//   {TA * autom;			    
//   Objet * o = l->Tete();		    
//   autom = o->OTA();		    
//   return new Objet(autom->MakeBTA());}
 



// ---------- SETVAL 
//--------- SetVal
Objet * SetVal_interface(LObjet * l)
{
Lnu * f;
Objet * o = l->Tete();
f = o->OLnu()->Copy();
Specif * sp = new Specif(f);
RegionGraph * rg = sp->RegionG();
 SetVal * Sres = f->StateSat(rg,0,__DBMPLC);
return new Objet(Sres);
}

//--------- Convex H. 
Objet * CH_interface(LObjet * l)
{
Objet * o = l->Tete();
 if (__DBMPLC == 1) {
   cout << " Convex H. not implemented for PPL Polyh. " << endl;
   return new Objet(type(Undef),"");
 }
 if (o->Otype().Valb() == Dbm) 
   return new Objet(o->Ozone()->Copy());
 SetReg * sr = (SetReg *) o->Osetval();
 return new Objet(sr->ConvexH());
}




//--------- Intersection SetVal -----------------
Objet * Inter_interface(LObjet * l)
{
  Objet * o1 = l->Tete(); 
  l->Reste();
  Objet * o2 = l->Tete(); // dbm ou setval 
  RegionGraph * r1, * r2, * r;

 if (__DBMPLC==0) {
   
   if ((o1->Otype().Valb() == Dbm) && (o2->Otype().Valb() == Dbm)) {
     // Dbm + Dbm  
     Zone * z1 = o1->Ozone();
     Zone * z2 = o2->Ozone();
     r1 = z1->Get_RegionG();
     r2 = z2->Get_RegionG();
     r = new RegionGraph(r1,r2);
     z1->ExtensionRG(r);
     z2->ExtensionRG(r);
     Zone * zres = z1->Copy();
     zres->Intersection(z2);
     return new Objet(zres);
   }
   
   // pour les autres cas on convertit en SetReg...
   SetReg * sr1, * sr2, * sres = 0;
   if (o1->Otype().Valb() == Dbm) {
     sr1 = new SetReg(o1->Ozone());
     sres = sr1; }
   else sr1 = (SetReg *) o1->Osetval();
   if (o2->Otype().Valb() == Dbm) {
     sr2 = new SetReg(o2->Ozone());
     sres = sr2; }
   else sr2 = (SetReg *) o2->Osetval();
   r1 = sr1->Get_rg();
   r2 = sr2->Get_rg();
   r = new RegionGraph(r1,r2);
   sr1->ExtensionRG(r);
   sr2->ExtensionRG(r);
   if (!sres) sres = (SetReg*) sr1->Copy(); /// cas ou setval + setval 
   if (sres == sr1) 
     sres->Intersection(sr2);
   else sres->Intersection(sr1);
   return new Objet(sres);
 // il faudrait faire le menage: detruire r1, r2...
 }
 else { // PPL 
   //   cout << "Inter - PPL"<< endl;
   SetVal * s1 = o1->Osetval();
   SetVal * s2 = o2->Osetval();
   SetVal * res = s1->Copy();
   res->Intersection(s2);
   return new Objet(res);
 }
return new Objet(type(Undef),"");
}

//--------- Union SetVal  -----------------
Objet * Union_interface(LObjet * l)
{
  Objet * o1 = l->Tete();
  l->Reste();
  Objet * o2 = l->Tete();
  SetVal * res =0;

 if (__DBMPLC==0) {  // DBM v SETREG
   SetReg * sr1; 
   SetReg * sr2; 
   if (o1->Otype().Valb() == Dbm) 
     sr1 = new SetReg(o1->Ozone());
   else sr1 = (SetReg *) o1->Osetval();
   if (o2->Otype().Valb() == Dbm) 
     sr2 = new SetReg(o2->Ozone());
   else sr2 = (SetReg *) o2->Osetval();
   RegionGraph * r1 = sr1->Get_rg();
   RegionGraph * r2 = sr2->Get_rg();
   RegionGraph * r = new RegionGraph(r1,r2);
   sr1->ExtensionRG(r);
   sr2->ExtensionRG(r);
   SetReg * sres = (SetReg *) sr1->Copy();
   sres->Union(sr2);
   res = (SetVal *) sres;
 // il faudrait faire le menage: detruire r1, r2...
 }
 
 else {
   SetVal * s1 = o1->Osetval();
   SetVal * s2 = o2->Osetval();
   //   cout << "Union - PPL "<< endl;
   o1->Otype().Print(); cout << endl;
   o2->Otype().Print(); cout << endl;
   //   cout << s1->Type() << " - " << s2->Type() << endl;
   res = s1->Copy();
   res->Union(s2);
 }

return new Objet(res);
}



Objet * InitPPL_interface(LObjet * l)
{
  Objet * o1 = l->Tete();
  Ident_L * lc = o1->Olid();

  if (__CurrentRG) __CurrentRG->Destroy();
  __CurrentRG = new RegionGraph(*lc,0,1);

  __CurrentRG->Print();

 return new Objet(type(Undef),"");
}

//--------- Future SetVal
Objet * Future_interface(LObjet * l)
{
Objet * o1 = l->Tete();
 l->Reste();
 Objet * o2 = l->Tete(); // Dbm ou Setval
 Ident_L * lc = o1->Olid();



 if (__DBMPLC==0) {
   RegionGraph * r2 = new RegionGraph(*lc,0,0);

   if (o2->Otype().Valb() == Dbm) { // version DBM 
     Zone * z = o2->Ozone();
     Zone * zres = z->Copy();
     RegionGraph * r1 = z->Get_RegionG();
     RegionGraph * r = new RegionGraph(r1,r2);
     zres->ExtensionRG(r);
     zres->Add_Future(lc);  
     return new Objet(zres);
   } // Version Setval

   SetVal * s = o2->Osetval();
   SetReg * sr = (SetReg *) s->Copy();
   RegionGraph * r1 = sr->Get_rg();
   RegionGraph * r = new RegionGraph(r1,r2);
   sr->ExtensionRG(r);
   sr->Add_Future(lc);
   return new Objet(sr);
 }
 else { //PPL 
   assert(o2->Otype().Valb() == Setval);
   SetVal * s = o2->Osetval();
   SetVal * res = s->Copy();

   //   cout << "Future - PPL"<< endl;
   res->Add_Future(lc);
   return new Objet(res);
 }
 // il faudrait faire le menage: detruire r1, r2...
 return new Objet(type(Undef),"");
}

//--------- Past SetVal
Objet * Past_interface(LObjet * l)
{
Objet * o1 = l->Tete();
 l->Reste();
 Objet * o2 = l->Tete(); // Dbm ou Setval
 Ident_L * lc = o1->Olid();



 if (__DBMPLC==0) {
   RegionGraph * r2 = new RegionGraph(*lc,0,0);

   if (o2->Otype().Valb() == Dbm) { // version DBM 
     Zone * z = o2->Ozone();
     Zone * zres = z->Copy();
     RegionGraph * r1 = z->Get_RegionG();
     RegionGraph * r = new RegionGraph(r1,r2);
     zres->ExtensionRG(r);
     zres->Add_Past(lc);  
     return new Objet(zres);
   } // Version Setval

   SetVal * s = o2->Osetval();
   SetReg * sr = (SetReg *) s->Copy();
   RegionGraph * r1 = sr->Get_rg();
   RegionGraph * r = new RegionGraph(r1,r2);
   sr->ExtensionRG(r);
   sr->Add_Past(lc);
   return new Objet(sr);
 }
 else { //PPL 
   assert(o2->Otype().Valb() == Setval);
   SetVal * s = o2->Osetval();
   SetVal * res = s->Copy();

   //   cout << "Past - PPL"<< endl;
   res->Add_Past(lc);
   return new Objet(res);
 }
 // il faudrait faire le menage: detruire r1, r2...
 return new Objet(type(Undef),"");
}

//------------- Compact SetVal
Objet * Compact_interface(LObjet * l) 
{
  Objet * o = l->Tete(); // sv
  SetVal * sv = o->Osetval();
  SetVal * res = sv->Copy();
  res->Compacter();
  return new Objet(res);
}

//------------- Complement SetVal
Objet * Complement_interface(LObjet * l) 
{
  Objet * o = l->Tete(); // sv
  SetVal * sv = o->Osetval();
  SetVal * res = sv->Complement();
  //  res->Compacter();
  return new Objet(res);
}

//--------- Projection SetVal
Objet * Projection_interface(LObjet * l)
{
  Objet * o1 = l->Tete();  // Ident   x
  l->Reste();
  Objet * o2 = l->Tete();  // Ident   ca
  l->Reste();
  Objet * o3 = l->Tete();  // Int     ia
  l->Reste();
  Objet * o4 = l->Tete();  // SetVal v Dbm
  l->Reste();
  Ident x = o1->OVname();
  Ident ca = o2->OVname();
  int ia = o3->Oval();

if (__DBMPLC==0) {

  // on construit un RG avec x et ca...
  Ident_L lc;
  lc.Ajouter(x);
  lc.Ajouter(ca);
  RegionGraph * r2 = new RegionGraph(lc,0,0);

  if (o4->Otype().Valb() == Dbm) { // version DBM 
    Zone * z = o4->Ozone();
    Zone * res = z->Copy();
    RegionGraph * r1 = z->Get_RegionG();
    RegionGraph * r = new RegionGraph(r1,r2);
    res->ExtensionRG(r);
    res->Projection(x,ca,ia);
    return new Objet(res);
  }
  // Version Setval -> SetReg
  SetVal * s = o4->Osetval();
  SetReg * sr = (SetReg *) s->Copy();
  RegionGraph * r1 = sr->Get_rg();
  RegionGraph * r = new RegionGraph(r1,r2);
  sr->ExtensionRG(r);
  sr->Projection(x,ca,ia);
  return new Objet(sr);
 }
 else { // PPL
   assert(o4->Otype().Valb() == Setval);
  SetVal * s = o4->Osetval();
  SetVal * res = s->Copy();
  //  cout << "Projection - PPL"<< endl;
   res->Projection(x,ca,ia);
   return new Objet(res);
 }
 // il faudrait faire le menage: detruire r1, r2...


 return new Objet(type(Undef),"");
}

//--------- RevProj SetVal
Objet * RevProj_interface(LObjet * l)
{
  Objet * o1 = l->Tete();  // Ident   x
  l->Reste();
  Objet * o2 = l->Tete();  // Ident   ca
  l->Reste();
  Objet * o3 = l->Tete();  // Int     ia
  l->Reste();
  Objet * o4 = l->Tete();  // SetVal v Dbm
  l->Reste();
  Ident x = o1->OVname();
  Ident ca = o2->OVname();
  int ia = o3->Oval();

if (__DBMPLC==0) {

  // on construit un RG avec x et ca...
  Ident_L lc;
  lc.Ajouter(x);
  lc.Ajouter(ca);
  RegionGraph * r2 = new RegionGraph(lc,0,0);

  if (o4->Otype().Valb() == Dbm) { // version DBM 
    Zone * z = o4->Ozone();
    Zone * res = z->Copy();
    RegionGraph * r1 = z->Get_RegionG();
    RegionGraph * r = new RegionGraph(r1,r2);
    res->ExtensionRG(r);
    res->Rev_In(x,ca,ia);
    return new Objet(res);
  }
  // Version Setval -> SetReg
  SetVal * s = o4->Osetval();
  SetReg * sr = (SetReg *) s->Copy();
  RegionGraph * r1 = sr->Get_rg();
  RegionGraph * r = new RegionGraph(r1,r2);
  sr->ExtensionRG(r);
  sr->Rev_In(x,ca,ia);
  return new Objet(sr);
 }
 else { // PPL
   assert(o4->Otype().Valb() == Setval);
  SetVal * s = o4->Osetval();
  SetVal * res = s->Copy();
  //  cout << "RevProj - PPL"<< endl;
   res->Rev_In(x,ca,ia);
   return new Objet(res);
 }
 // il faudrait faire le menage: detruire r1, r2...


 return new Objet(type(Undef),"");
}

// ---------- ZONE --------


//--------- ZONE -----------------
Objet * Zone_interface(LObjet * l)
{
Lnu * f;
Objet * o = l->Tete();
f = o->OLnu()->Copy();
Specif * sp = new Specif(f);
RegionGraph * rg = sp->RegionG();
SetReg * Sres = (SetReg *) f->StateSat(rg,0);
Liste<Pt_Zone> lz = Sres->Get_lz();

 if (lz.Longueur() > 1) 
   cout << " pb in Zone : (Lnu) -> Zone " << endl;

 Zone * res;
 if (lz.Longueur() == 0) 
   res = new Zone(rg,1);
 else res = lz.Tete();

 /*
 sp->Destroy();
 // f->Destroy();
 rg->Destroy();
 delete Sres;
 */

return new Objet(res);
}

//--------- EZONE -----------------
Objet * EZone_interface(LObjet * l)
{
Lnu * f;
 int M;
Objet * o = l->Tete();
 M = o->Oval();
 l->Reste();
o = l->Tete();
f = o->OLnu()->Copy();
Specif * sp = new Specif(f);
RegionGraph * rg = sp->RegionG(M);
SetReg * Sres = (SetReg *) f->StateSat(rg,0);
Liste<Pt_Zone> lz = Sres->Get_lz();

 if (lz.Longueur() > 1) 
   cout << " pb in Zone : (Lnu) -> Zone " << endl;

 Zone * res;
 if (lz.Longueur() == 0) 
   res = new Zone(rg,1);
 else res = lz.Tete();

return new Objet(res);
}




//--------- Union (convexe) ZONE -----------------
Objet * ApUnion_interface(LObjet * l)
{
Objet * o1 = l->Tete();
 l->Reste();
Objet * o2 = l->Tete();
 Zone * z1 = o1->Ozone();
 Zone * z2 = o2->Ozone();
 RegionGraph * r1 = z1->Get_RegionG();
 RegionGraph * r2 = z2->Get_RegionG();
 RegionGraph * r = new RegionGraph(r1,r2);
 z1->ExtensionRG(r);
 z2->ExtensionRG(r);

 Zone * res = z1->Copy();
 res->ApproxUnion(z2);

return new Objet(res);
}




//--------- Reset SetVal -----------------
// difference avec Projection : juste une liste de reset...
Objet * Reset_interface(LObjet * l)
{
  Objet * o1 = l->Tete(); // liste de reset
  l->Reste();
  Objet * o2 = l->Tete();  // setval ou dbm
  Ident_L * lc = o1->Olid();
  Ident cl;

  if (__DBMPLC==0) {  // DBM ou SETREG 
    RegionGraph * r2 = new RegionGraph(*lc,0,0);

  if (o2->Otype().Valb() == Dbm) { // version DBM 
    Zone * z = o2->Ozone();
    Zone * zres = z->Copy();
    RegionGraph * r1 = z->Get_RegionG();
    RegionGraph * r = new RegionGraph(r1,r2);
    zres->ExtensionRG(r);
    while (! lc->Est_vide()) {
      cl = lc->Tete();
      zres->Projection(cl);
      lc->Reste();
    }
    return new Objet(zres);
  }
  // Version SetReg
  SetVal * s = o2->Osetval();
  SetReg * sr = (SetReg *) s->Copy();
  RegionGraph * r1 = sr->Get_rg();
  RegionGraph * r = new RegionGraph(r1,r2);
  sr->ExtensionRG(r);
  while (! lc->Est_vide()) {
    cl = lc->Tete();
    sr->Projection(cl);
    lc->Reste();
  }
  return new Objet(sr);
 }
 else { // PPL
   assert(o2->Otype().Valb() == Setval);
   SetVal * s = o2->Osetval();
   SetVal * res = s->Copy();
   while (! lc->Est_vide()) {
     cl = lc->Tete();
     res->Projection(cl,0,0);
    lc->Reste();
  }
   return new Objet(res);
 }
 // il faudrait faire le menage: detruire r1, r2...
 return new Objet(type(Undef),"");
}




//-----------------------------------------------------
//               FBINARY

Objet * Fbinary_interface(LObjet * l)
{TA * autom;
Objet * o = l->Tete();
autom = o->OTA();
return new Objet(autom->MakeFs("Fbinary"));}

//-----------------------------------------------------
//               FNIL

Objet * Fnil_interface(LObjet * l)
{TA * autom = new TA();
 Objet * res; // = l->Tete();
 //autom = o->OTA();
 res = new Objet(autom->MakeFs("Fnil"));
 autom->Destroy();
 return res;}


//-----------------------------------------------------
//               FBISIM

Objet * Fbisim_interface(LObjet * l)
{TA * autom;
Objet * o = l->Tete();
autom = o->OTA();
return new Objet(autom->MakeFs("Fbisim"));}


//-----------------------------------------------------
//               SIMPL_NIL

Objet * SimplNil_interface(LObjet * l)
{Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec()->Copy();
return new Objet(sp->SimplNil(1));}


//-----------------------------------------------------
//               NF

Objet * NF_interface(LObjet * l)
{Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec()->Copy();

return new Objet(sp->NormF_res());}

//-----------------------------------------------------
//               SIMPL

Objet * Simpl_interface(LObjet * l)
{Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec()->Copy();
sp->Simplify();

return new Objet(sp);
}

//-----------------------------------------------------
//               CHECK

Objet * Check_interface(LObjet * l)
{Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec();
sp->MCheck();
return new Objet(type(Undef),"");
}


//-----------------------------------------------------
//               LATEX

Objet * Latex_interface(LObjet * l)
{
Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec();
sp->PrintLatex();
return new Objet(type(Undef),"");
}

//-----------------------------------------------------
//               PRINTENV

Objet * Printenv_interface(LObjet * )
{
Envir.Print();
return new Objet(type(Undef),"");
}

//-----------------------------------------------------
//               VCG
/*
Objet * VCG_interface(LObjet * l)
{
ofstream OFSVCG;
TA * aut;
Objet * o = l->Tete();
aut = o->OTA();

 if ((VCGOUTPUT) && strlen(VCGOUTPUT)) {
   cout << endl << "VCG output file : " << VCGOUTPUT << endl;
   OFSVCG.open(VCGOUTPUT,ios::app);
   OFSVCG << "graph: {"<<endl;
   OFSVCG << "display_edge_labels:yes "<<endl;
   OFSVCG << "layoutalgorithm:maxdepth"<<endl<<endl;
   aut->PrintVCG(OFSVCG);
   OFSVCG <<"}"<<endl;
 }
 else {
   cout << endl << "standard output." << endl;
   cout << "graph: {"<<endl;
   cout << "display_edge_labels:yes "<<endl;
   cout << "layoutalgorithm:maxdepth"<<endl<<endl;
   aut->PrintVCG(cout);
   cout<< "}"<<endl;
 }
return new Objet(type(Undef),"");
}
*/


//-----------------------------------------------------
//               VIEW
/*
Objet * View_interface(LObjet * l)
{
ofstream OFSVCG;
TA * aut;
Objet * o = l->Tete();
aut = o->OTA();


unlink("tmp_xvcg");
 OFSVCG.open("tmp_xvcg",ios::app);
 OFSVCG << "graph: {"<<endl;
 OFSVCG << "display_edge_labels:yes "<<endl;
 OFSVCG << "layoutalgorithm:maxdepth"<<endl<<endl;
 aut->PrintVCG(OFSVCG);
 OFSVCG <<"}"<<endl;

system("xvcg -silent tmp_xvcg &");


return new Objet(type(Undef),"");
}
*/

//-----------------------------------------------------
//               PRINT
/*
Objet * Print_interface(LObjet * l)
{
ofstream OFSVCG;
Objet * o = l->Tete();

 o->Print(-1); // on imprime sans le type.

return new Objet(type(Undef),"");
}
*/

//-----------------------------------------------------
//               QUOTIENT

Objet * Quotient_interface(LObjet * l)
{Specif * sp;
TA * autom;
Fsynchro * f;
Config * cf;
LObjet lo = *l;
Objet * res , * o = lo.Tete();
sp = o->OSpec();
lo.Reste();
autom = (lo.Tete())->OTA();
lo.Reste();
f = (lo.Tete())->OFsyn();
cf = new Config(autom->Get_init(),autom->Get_nom(),autom,f);
res = new Objet(sp->Quotient(cf,0));
cf->Destroy();
return res;
}

//-----------------------------------------------------
//               QUOTIENT complet

Objet * Quotientc_interface(LObjet * l)
{Specif * sp;
char * noeud;
TA * autom;
Fsynchro * f;
Config * cf;
LObjet lo = *l;
Objet * res, * o = lo.Tete();
sp = o->OSpec();
lo.Reste();
noeud = (lo.Tete())->OVname();
lo.Reste();
autom = (lo.Tete())->OTA();
lo.Reste();
f = (lo.Tete())->OFsyn();
 if (autom->Is_a_node(noeud)) {
  cf = new Config(noeud,autom->Get_nom(),autom,f);
  res = new Objet(sp->Quotient(cf,0));
  cf->Destroy();
 }
 else {
   cout << noeud << " is not a node of the automaton "<< autom->Get_nom() << " !" << endl;
   res = new Objet(type(Undef),"");
 }
return res;
}

//-----------------------------------------------------
//               SVERIFY  (Simple Verification A |= phi)

void NewSpecName(char *);

Objet * SVerify_interface(LObjet * l)
{
Specif * sp;
TA * autom;
Fsynchro * fsb;
Config * cf;
char NewNS[20];
int fin;
LObjet lo = *l;

Objet * o = lo.Tete();
sp = o->OSpec();
lo.Reste(); 
autom = lo.Tete()->OTA();

 cout << endl << " Verification : "<< lo.Tete()->OEnvname() << " |= " << o->OEnvname() << " ? " << endl << endl;

fsb = autom->MakeFs("Fnil");
 if (VERBOSE || PTRACE) {
   cout << "With the binary synchronization function : " << endl;
   PrintFs(fsb);
 }    

__TABRESQUOT[0] = new int[1];
__TABRESQUOT[1] = new int[1];
__TABRESQUOT[0][0]=__TABRESQUOT[1][0]=0;

cf = new Config(autom->Get_init(),autom->Get_nom(),autom,fsb);

NewSpecName(NewNS);
cout << "The Quotient specification is " << NewNS << endl; 

sp = sp->Quotient(cf,0,0,1);
Envir.Ajouter(NewNS,new Objet(sp));
cf->Destroy();
DestroyFs(fsb);

fin = ((sp->Get_f()->Type() == Top)||(sp->Get_f()->Type() == Bot));

if (!fin) 
  sp->MCheck();
else 
  if (sp->Get_f()->Type() == Top) 
    cout << " v0 satisfies the specification."<<endl;
  else cout << " v0 does not satisfy the specification."<<endl;

if (BELL) 	  
  cout << '\a';


 cout << " Quotient Result: "<<__TABRESQUOT[0][0]<< " var before the simpl." << endl;
 cout << " Quotient Result: "<<__TABRESQUOT[1][0]<< " var after the simpl." << endl;
 delete [] __TABRESQUOT[0];
 delete [] __TABRESQUOT[1];
 __TABRESQUOT[0] = 0;
 __TABRESQUOT[1] = 0;

return new Objet(type(Undef),"");
}



//-----------------------------------------------------
//               VERIFY


void NewSpecName(char tab[20])
{
  sprintf(tab, "~SP%d", __NOUVELLESPEC);
  __NOUVELLESPEC++;
}


//-------------------------------------------------

Objet * Verify_interface(LObjet * l)
{Specif * sp;
char NewNS[20];
TA * autom;
Fsynchro * fsb;
STable * tab, * sstab=0, * tabaux;
Liste<VerifElet *> lve, *plve;
VerifElet * ve;
Config * cf;
LObjet lo = *l;
int i, pb, pb2, nbquot=0,fin,MAXQ;
char * auxname=0;
 Objet * o = lo.Tete();
 int VALDBMPLC = __DBMPLC;

 if (__DBMPLC) {
   cout << "Use SetReg instead of PPL for quotienting" << endl;
  __DBMPLC = 0; // on ne met que pour check... 
 }

sp = o->OSpec();
lo.Reste(); 
plve = lo.Tete()->Osystem();

 cout << endl << " Verification : "<< lo.Tete()->OEnvname() << " |= " << o->OEnvname() << " ? " << endl << endl;

lo.Reste();
tab = (lo.Tete())->Otable();

// Verifions si les automates du systeme sont definis...
pb=0;
 for (lve = *plve;!lve.Est_vide(); lve.Reste()) {
   pb2 = 0;
   if (Envir.Est_def(lve.Tete()->_nta,o)) 
     pb2 = (! o->Otype().Est_typeb()) || (o->Otype().Valb() != Ta);
   else pb2 = 1;
   if (pb2)
     cout << lve.Tete()->_nta << " is not defined ! " << endl;
   pb +=pb2;
 }

 if (pb) {
   return new Objet(type(Undef),"");
 }

// Verifions si la tab correspond au systeme...
pb=0;
lve = *plve;
MAXQ = tab->Taille();
if (lve.Longueur() != tab->Taille()) 
  pb=1;
 else {
   while (!pb && !lve.Est_vide()) {
     auxname = lve.Tete()->_nta;
     pb=1;
     for (i=0;i<tab->Taille();i++) 
       if (Eq_str(auxname,tab->Composant(i))) pb=0;
     lve.Reste();
   }
 }
 if (pb) {
   cout << "The synchronization table and the system are not compatible: " << endl;
   if (auxname) cout << auxname << " is not present in the table." << endl;
   else cout << "There is not the same number of TA ! " << endl;
 }
 else {
   lve = * plve;

   __TABRESQUOT[0] = new int[tab->Taille()];
   __TABRESQUOT[1] = new int[tab->Taille()];
   for (i=0;i<tab->Taille();i++) {
     __TABRESQUOT[0][i] = 0;
     __TABRESQUOT[1][i] = 0;
   }
     
   fin = 0;
   while (!fin && !lve.Est_vide()) {
     ve = lve.Tete();

     NewSpecName(NewNS);
     cout << "Quotient of " << ve->_nta << " ("<<NewNS<<") " << endl; 
     // MaJ des Flags:
     if (ve->_vflag) {
       if (SIMPLEE != ve->_vflag[0]) 
	 cout << "equivequation is put to " << ve->_vflag[0] << endl;
       SIMPLEE = ve->_vflag[0];
       if (SIMPLTE != ve->_vflag[1]) 
	 cout << "trivequation is put to " << ve->_vflag[1] << endl;
       SIMPLTE = ve->_vflag[1];
       if (SIMPLHZ != ve->_vflag[2]) 
	 cout << "hitzone is put to " << ve->_vflag[2] << endl;
       SIMPLHZ = ve->_vflag[2];
       if (SIMPLUNGVAR != ve->_vflag[3]) 
	 cout << "unguardedvar is put to " << ve->_vflag[3] << endl;
       SIMPLUNGVAR = ve->_vflag[3];
       if (SIMPLSPLIT != ve->_vflag[4]) 
	 cout << "splitting is put to " << ve->_vflag[4] << endl;
       SIMPLSPLIT = ve->_vflag[4];
     }
     tab->ElimComposant(ve->_nta,fsb,sstab);
     tabaux = tab;
     tab = sstab;
     if (nbquot  && tabaux) tabaux->Destroy();
     autom = Envir.Recherche(ve->_nta)->OTA();
     cf = new Config(autom->Get_init(),autom->Get_nom(),autom,fsb);
     if (VERBOSE || PTRACE) {
       cout << "With the binary synchronization function : " << endl;
       PrintFs(fsb);
       cout << "With the synchronization table of the subsystem : " << endl;
       tab->Print();
     }

     if (lve.Longueur() == 1) 
       sp = sp->Quotient(cf,nbquot,0,1);
     else sp = sp->Quotient(cf,nbquot);
     Envir.Ajouter(NewNS,new Objet(sp));

     nbquot++;
     cf->Destroy();
     DestroyFs(fsb);
     lve.Reste();
     fin = ((sp->Get_f()->Type() == Top)||(sp->Get_f()->Type() == Bot));
   }
   __DBMPLC = VALDBMPLC;
   if (!fin) {
// 	int __auxtest; 
// 	cout << " suite... ? " << endl;
// 	cin >> __auxtest;
// 	if (__auxtest) 
     if (__DBMPLC) cout << "Mode PPL... " << endl;
       sp->MCheck();
   }
   else if (sp->Get_f()->Type() == Top) 
     cout << " v0 satisfies the specification."<<endl;
   else cout << " v0 does not satisfy the specification."<<endl;

   if (BELL) 	  
     cout << '\a';
   cout << " Results table: " << endl;
 for (i=0;i<MAXQ;i++) 
   cout << __TABRESQUOT[0][i] << '\t';
 cout << endl;
 for (i=0;i<MAXQ;i++) 
   cout << __TABRESQUOT[1][i] << '\t';
 cout << endl;

 delete [] __TABRESQUOT[0];
 delete [] __TABRESQUOT[1];
 __TABRESQUOT[0] = 0;
 __TABRESQUOT[1] = 0;
 }

return new Objet(type(Undef),"");
}


//-----------------------------------------------------
//               DECL

Objet * Decl_interface(LObjet * l)
{Specif * sp;
Objet * o = l->Tete();
sp = o->OSpec()->Copy(-1);
return new Objet(sp->Get_d());}

//-----------------------------------------------------
//               COPY

Objet * Copy_interface(LObjet * l)
{
Objet * o = l->Tete();
return o->Copy();
}

//-----------------------------------------------------
//               FLAG

Objet * Flag_interface(LObjet * )
{
  cout << " Flags : " << endl;
  cout << "verbose       = "<< VERBOSE << endl;
  cout << "plc           = "<< __DBMPLC << endl;
  cout << "trace         = " <<PTRACE << endl;
  //  cout << "splitting     = "<< SIMPLSPLIT << endl;
  cout << "hitzone       = "<< SIMPLHZ << endl;
  cout << "trivequation  = "<< SIMPLTE << endl;
  cout << "equivequation = "<< SIMPLEE << endl;
  cout << "unguardedvar  = "<< SIMPLUNGVAR << endl;
  cout << "bell  = "<< BELL << endl;
  cout << "nbfpit  = "<< __NBFIXPOINT << endl;
  cout << "NoAbstraction  = "<< __NOABSTRACT << endl;
  cout << "Cmax  = "<< __CMAX << endl;
  cout << "minfp  = "<< __MINFIXPOINT << endl;
  cout << "hash  = "<< __HACHAGE << endl;
  return new Objet(type(Undef),"");
}

//-----------------------------------------------------
//               BISIM


Objet * Bisim_interface(LObjet * l)
{
TA * ta1, * ta2;
Ident_L al1, al2, al;
Ident action, lab;
int trouve, bta1 = 1, bta2 = 1;
Fsynchro * Fs = new Fsynchro, * Fsaux;
Synch_Vect * sv;
Pt_Synch_Vect_L * lsv;
Lnu_L la;
Lnu * auxf, * ftop, * fbot, * auxf2, * auxf3;
Declaration D;
Specif * specZ, * spec1, * spec2;
Config * cf;

LObjet lo = *l;
Objet * o = lo.Tete();
ta1 = o->OTA();
lo.Reste();
ta2 = (lo.Tete())->OTA();

 cout << "Bisimulation checking, " << endl;


 // on previent en cas d'exsistence de propositions atomiques...
Map_propL ln = ta1->Get_Noeud();
int existeAP=0;
Ident_L * lid;
 while (!existeAP && (! ln.Est_vide())) {
   lid = ln.Tete();
   if ((lid) && (! lid->Est_vide()))
     existeAP = 1;
   ln.Reste();
 }
 ln = ta2->Get_Noeud();
 while (!existeAP && (! ln.Est_vide())) {
   lid = ln.Tete();
   if ((lid) && (! lid->Est_vide()))
     existeAP = 1;
   ln.Reste();
 }

 if (existeAP) 
   cout << "Warning ! The atomic proposition are not considered in the bisimulation checking ! " << endl;


if (! ta1->Is_BTA()) {

  cout << "The first automaton is transformed into a basic timed automaton." << endl;

//   cout << "The Bisim function considers only BASIC timed automata." << endl;	       
//   return new Objet(type(Undef),"");						       
// 										       //   if (PTRACE%2) 								      
// cout << " We transform the first automaton into a basic timed automaton..." << endl;
  
ta1 = ta1->MakeBTA();
  bta1 = 0;
}

if (! ta2->Is_BTA()) {

  cout << "The second automaton is transformed into a basic timed automaton." << endl;

//cout << "The Bisim function considers only BASIC timed automata." << endl;	      
//return new Objet(type(Undef),"");						      
//if (PTRACE%2) 								       //cout << " We transform the second automaton into a basic timed automaton..." << endl;

  ta2 = ta2->MakeBTA();
  bta2 = 0;
}

al1 = ta1->Get_Alph();
al2 = ta2->Get_Alph();
// al = al1 + al2
// comme Ajouter se fait en tete, l'algo qui suit est OK (ie ne 
// modifie pas al1...).
al = al1;
while (! al2.Est_vide()) {
  action = al2.Tete();
  al2.Reste();
  al1 = al;
  trouve = 0;
  while ((! trouve) && (! al1.Est_vide())) {
    trouve = Eq_str(action,al1.Tete());
    al1.Reste();
  }
  if (! trouve) al.Ajouter(action);
}

// Fs = Fbisim(al)
al1 = al;
while (! al.Est_vide()) {
    lab = al.Tete();
    sv = new Synch_Vect("",lab);
    lsv = new Pt_Synch_Vect_L();
    lsv->Ajouter(sv);
    action = AjouterCar(lab,'r');
    Fs->Ajouter(action,lsv);    
    delete action;
    sv = new Synch_Vect(lab,"");
    lsv = new Pt_Synch_Vect_L();
    lsv->Ajouter(sv);
    action = AjouterCar(lab,'l');
    Fs->Ajouter(action,lsv);
    delete action;
    al.Reste();
  }
al = al1;

 if ((PTRACE) || (VERBOSE)) {
  Fsynchro fs = *Fs;
  Pt_Synch_Vect_L lv;
  cout << "The synchronization function for the bisimulation checking is : " << endl;
      while(! fs.Est_vide()) {
	lv = *(fs.Tete());
	cout << fs.TeteN() << " -> {";
	while (! lv.Est_vide()) {
	  cout << "("; 
	  if (Eq_str(lv.Tete()->Get_la(),"")) cout << "_";
	  else cout << lv.Tete()->Get_la();
	  cout << ",";
	  if (Eq_str(lv.Tete()->Get_lb(),"")) cout << "_";
	  else cout << lv.Tete()->Get_lb();
	  cout << ") ";
	  lv.Reste();
	}
	cout << "}" << endl;
	fs.Reste();
      }
 }

// Construction de Def(Z)

while(! al.Est_vide()) {
  lab = al.Tete();
  if (! Eq_str(lab,"InvFail")) {
    action = AjouterCar(lab,'r');
    auxf = new LnuMod(Diam,action,new LnuVar("Z"));
    delete action;
    if (!bta1 || !bta2)  // condition sur l'invariant du nouveau noeud...
      auxf = new LnuCD(Or,auxf,new LnuMod(Diam,"InvFaill",new LnuBool(Top)));
    action = AjouterCar(lab,'l');
    auxf = new LnuMod(Box,action,auxf);
    delete action;
    la.Ajouter(auxf);
    action = AjouterCar(lab,'l');
    auxf = new LnuMod(Diam,action,new LnuVar("Z"));
    delete action;
    if (!bta1 || !bta2) // condition sur l'invariant du nouveau noeud...
      auxf = new LnuCD(Or,auxf,new LnuMod(Diam,"InvFailr",new LnuBool(Top)));
    action = AjouterCar(lab,'r');
    auxf = new LnuMod(Box,action,auxf);
    delete action;
    la.Ajouter(auxf);
  }
  al.Reste();
}
al = al1;

auxf = new LnuUn(Forall,new LnuVar("Z"));
la.Ajouter(auxf);
// on a : /\ [al](<IFl>tt v <ar> Z) ^ [ar](<IFr>tt v<al>Z) ^ [@] Z

// il reste a ajouter la condiftion sur les invariants (si besoin) :
// Z = (<IFl> tt ^ <IFr> tt) v ([IFl]ff ^ [IFr]ff ^ auxf) ;

 if (!bta1 || !bta2) {
   auxf = new LnuMod(Box,"InvFailr",new LnuBool(Bot));
   la.Ajouter(auxf);
   auxf = new LnuMod(Box,"InvFaill",new LnuBool(Bot));
   la.Ajouter(auxf);
   auxf = new LnuCD(And,la);

   auxf2 = new LnuMod(Diam,"InvFaill",new LnuBool(Top));
   auxf3 = new LnuMod(Diam,"InvFailr",new LnuBool(Top));
   auxf2 = new LnuCD(And,auxf2,auxf3);

   auxf = new LnuCD(Or,auxf,auxf2);
 }
 else auxf = new LnuCD(And,la);

// Construction de D
D.Ajouter("Z",auxf);

// Construction de SpecBisim
specZ = new Specif(new LnuVar("Z"),&D,"BisimDecl");

if ((PTRACE) || (VERBOSE)) {
  cout << " The specification for the bisimulation checking is : ";
  specZ->Print();
}

// Quotient de specZ par ta1 suivant Fs...
cf = new Config(ta1->Get_init(),ta1->Get_nom(),ta1,Fs);
spec1 = specZ->Quotient(cf,0,1);

//cout << " Step 1 : " << endl;
//spec1->Print();


// Quotient de specZ' par ta2 suivant Fnil...
Fsaux = Fs;
while (! Fsaux->Est_vide()) {
  lsv = Fsaux->Tete();
  while (! lsv->Est_vide()) {
    sv = lsv->Tete();
    sv->Destroy();
    lsv->Cdr();
  }
  delete lsv;
  Fsaux->Reste();
}
Fs->Vide();
delete Fs;
Fs = ta2->MakeFs("Fnil");
cf = new Config(ta2->Get_init(),ta2->Get_nom(),ta2,Fs);
spec2 = spec1->Quotient(cf,0,1);

//cout << " Step 2 : " << endl;
//spec2->Print();

ftop = new LnuBool(Top);
fbot = new LnuBool(Bot);
auxf = spec2->Get_f();

if (auxf->Equivalent(ftop)) 
  cout << " Yes. The automata are bisimilar. " << endl;
else if (auxf->Equivalent(fbot)) 
  cout << " No. The automata are not bisimilar. " << endl;
else // Check au besoin...
  spec2->MCheck(1);

// Nettoyage

ftop->Destroy();
fbot->Destroy();
Fsaux = Fs;
while (! Fsaux->Est_vide()) {
  lsv = Fsaux->Tete();
  while (! lsv->Est_vide()) {
    sv = lsv->Tete();
    sv->Destroy();
    lsv->Cdr();
  }
  delete lsv;
  Fsaux->Reste();
}
Fs->Vide();
delete Fs;
specZ->Destroy();
spec1->Destroy();
spec2->Destroy();
if (! bta1) ta1->Destroy();
if (! bta2) ta2->Destroy();

return new Objet(type(Undef),"");
}


//---------------------------------------------------------------------
//                 INITIALISATION DE L'ENVIR
//---------------------------------------------------------------------


void Env::initialisation()
{
  // definition des fct de bases de l' environnement
  type * t1;
  Ltype * lt;
  Objet * ob;

  // Flags divers...
  ob = new Objet(type(CFlag),VERBOSE);
  Envir.Ajouter("verbose",ob);
  ob = new Objet(type(CFlag),__DBMPLC);
  Envir.Ajouter("plc",ob);
  ob = new Objet(type(CFlag),__HACHAGE);
  Envir.Ajouter("hash",ob);
  ob = new Objet(type(CFlag),PTRACE);
  Envir.Ajouter("trace",ob);
  ob = new Objet(type(CFlag),SIMPLEE);
  Envir.Ajouter("equivequation",ob);
  ob = new Objet(type(CFlag),SIMPLTE);
  Envir.Ajouter("trivequation",ob);
  ob = new Objet(type(CFlag),SIMPLHZ);
  Envir.Ajouter("hitzone",ob);
  ob = new Objet(type(CFlag),SIMPLHZ2);
  Envir.Ajouter("simplhzp",ob);
  //ob = new Objet(type(CFlag),SIMPLSPLIT);
  //  Envir.Ajouter("splitting",ob);
  ob = new Objet(type(CFlag),SIMPLUNGVAR);
  Envir.Ajouter("unguardedvar",ob);
  ob = new Objet(type(CFlag),BELL);
  Envir.Ajouter("bell",ob);
  ob = new Objet(type(CFlag),__NBFIXPOINT);
  Envir.Ajouter("nbfpit",ob);
  ob = new Objet(type(CFlag),__CMAX);
  Envir.Ajouter("Cmax",ob);
  ob = new Objet(type(CFlag),__NOABSTRACT);
  Envir.Ajouter("NoAbstraction",ob);
  ob = new Objet(type(CFlag),__MINFIXPOINT);
  Envir.Ajouter("minfp",ob);

  // Help :  String -> Void
  lt = new Ltype(String);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Help_interface);
  Envir.Ajouter("help",ob);

  // Delete:  * -> Void
  lt = new Ltype(Star);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Delete_interface);
  Envir.Ajouter("Delete",ob);

  // Load:  String -> Void
  lt = new Ltype(String);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,TFCT(0));  // la fct load n'est jamais evaluee !
  Envir.Ajouter("load",ob);

  // Test
  // Test:  (Ta) -> Void
  lt = new Ltype(Ta);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Test_interface);
  Envir.Ajouter("Test",ob);

  // // Reach:  (Ta,String) -> Void
//   lt = new Ltype(String);
//   lt->Ajouter(Ta);
//   t1 = new type(lt,Void);
//   ob = new Objet(*t1,Reach_interface);
//   Envir.Ajouter("Reach",ob);

  // SReach:  (Table,Lnu) -> Void
  // A finir
  lt = new Ltype(Flnu);
  lt->Ajouter(Table);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,SReach_interface);
  Envir.Ajouter("SReach",ob);


  // Set of valuations 

  // SetVal:  (Lnu) -> Setval
  lt = new Ltype(Flnu);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,SetVal_interface);
  Envir.Ajouter("SetVal",ob);

  // CH:  (SetVal) -> Dbm
  lt = new Ltype(Setval);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,CH_interface);
  Envir.Ajouter("CH",ob);

  // Inter:  (Setval, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Setval);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Inter_interface);
  Envir.Ajouter("Inter",ob);

  // Union:  (Setval, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Setval);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Union_interface);
  Envir.Ajouter("Union",ob);

  // Projection:  (Ident,Ident,Int, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Int);
  lt->Ajouter(String);
  lt->Ajouter(String);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Projection_interface);
  Envir.Ajouter("Projection",ob);

// RevProj:  (Ident,Ident,Int, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Int);
  lt->Ajouter(String);
  lt->Ajouter(String);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,RevProj_interface);
  Envir.Ajouter("RevProj",ob);

  // InitPPL:  (Lid) -> void
  lt = new Ltype(Lid);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,InitPPL_interface);
  Envir.Ajouter("InitPPL",ob);

  // Compact:  (Setval) -> Setval
  lt = new Ltype(Setval);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Compact_interface);
  Envir.Ajouter("Compact",ob);

  // Complement :  (Setval) -> Setval
  lt = new Ltype(Setval);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Complement_interface);
  Envir.Ajouter("Complement",ob);

  // Future:  (Lid, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Lid);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Future_interface);
  Envir.Ajouter("Future",ob);

 // Past:  (Lid, Setval) -> Setval
  lt = new Ltype(Setval);
  lt->Ajouter(Lid);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Past_interface);
  Envir.Ajouter("Past",ob);

  // Zone & Cie
  // New: Zone:  (Lnu) -> Dbm
  lt = new Ltype(Flnu);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,Zone_interface);
  Envir.Ajouter("Zone",ob);

  // New: EZone:  (Int, Lnu) -> Dbm
  lt = new Ltype(Flnu);
  lt->Ajouter(Int);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,EZone_interface);
  Envir.Ajouter("EZone",ob);

  /*
  // New: Inter:  (Dbm, Dbm) -> Dbm
  lt = new Ltype(Dbm);
  lt->Ajouter(Dbm);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,Inter_interface);
  Envir.Ajouter("Inter",ob);
  */

  // New: ApUnion:  (Dbm, Dbm) -> Dbm
  lt = new Ltype(Dbm);
  lt->Ajouter(Dbm);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,ApUnion_interface);
  Envir.Ajouter("ApUnion",ob);

  /*
  // New: Future:  (Lid, Dbm) -> Dbm
  lt = new Ltype(Dbm);
  lt->Ajouter(Lid);
  t1 = new type(lt,Dbm);
  ob = new Objet(*t1,Future_interface);
  Envir.Ajouter("Future",ob);
  */

  // New: Reset:  (Lid, Dbm) -> Dbm
  lt = new Ltype(Setval);
  lt->Ajouter(Lid);
  t1 = new type(lt,Setval);
  ob = new Objet(*t1,Reset_interface);
  Envir.Ajouter("Reset",ob);


  // Verify:  (Spec, System , Table) -> Void
  lt = new Ltype(Table);
  lt->Ajouter(System);
  lt->Ajouter(Spec);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Verify_interface);
  Envir.Ajouter("Verify",ob);

  // SVerify:  (Spec, Automata) -> Void
  lt = new Ltype(Ta);
  lt->Ajouter(Spec);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,SVerify_interface);
  Envir.Ajouter("SVerify",ob);


//     // BTA:  Ta -> Ta	    
//     lt = new Ltype(Ta);	    
//     t1 = new type(lt,Ta);   	  
//     ob = new Objet(*t1,BTA_interface);
//     Envir.Ajouter("BTA",ob);

  // Fbinary:  Ta -> Fsy
  lt = new Ltype();
  t1 = new type(lt,Fsy);
  ob = new Objet(*t1,Fbinary_interface);
  Envir.Ajouter("Fbinary",ob);

  // Fnil:  Ta -> Fsy
  lt = new Ltype();
  t1 = new type(lt,Fsy);
  ob = new Objet(*t1,Fnil_interface);
  Envir.Ajouter("Fnil",ob);

  // Fbisim:  Ta -> Fsy
  lt = new Ltype(Ta);
  t1 = new type(lt,Fsy);
  ob = new Objet(*t1,Fbisim_interface);
  Envir.Ajouter("Fbisim",ob);

//    // BSpec:  Spec -> Spec   
//    lt = new Ltype(Spec);	    
//    t1 = new type(lt,Spec);   
//    ob = new Objet(*t1,BSpec_interface);
//    Envir.Ajouter("BSpec",ob);

  // SimplNil:  Spec -> Spec
  lt = new Ltype(Spec);
  t1 = new type(lt,Spec);
  ob = new Objet(*t1,SimplNil_interface);
  Envir.Ajouter("SimplNil",ob);

//    // BLnu:  Lnu -> Lnu	   
//    lt = new Ltype(Flnu);	   
//    t1 = new type(lt,Flnu);  
//    ob = new Objet(*t1,BLnu_interface);
//    Envir.Ajouter("BLnu",ob);

  // NF:  Spec -> Spec
  lt = new Ltype(Spec);
  t1 = new type(lt,Spec);
  ob = new Objet(*t1,NF_interface);
  Envir.Ajouter("NF",ob);

  // Decl:  Spec -> Decl
  lt = new Ltype(Spec);
  t1 = new type(lt,Dec);
  ob = new Objet(*t1,Decl_interface);
  Envir.Ajouter("Decl",ob);

  // Latex:  (Spec) -> Void
  lt = new Ltype(Spec);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Latex_interface);
  Envir.Ajouter("Latex",ob);

//   // VCG:  (TA) -> Void
//   lt = new Ltype(Ta);
//   t1 = new type(lt,Void);
//   ob = new Objet(*t1,VCG_interface);
//   Envir.Ajouter("VCG",ob);

//   // View:  (TA) -> Void
//   lt = new Ltype(Ta);
//   t1 = new type(lt,Void);
//   ob = new Objet(*t1,View_interface);
//   Envir.Ajouter("View",ob);

//   // Print:  (*) -> Void
//   lt = new Ltype(Star);
//   t1 = new type(lt,Void);
//   ob = new Objet(*t1,Print_interface);
//   Envir.Ajouter("Print",ob);

  // Printenv:  () -> Void
  lt = new Ltype();
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Printenv_interface);
  Envir.Ajouter("Printenv",ob);

  // Quotient:  (Spec , Ta , Fs) -> Spec
  lt = new Ltype(Fsy);
  lt->Ajouter(Ta);
  lt->Ajouter(Spec);
  t1 = new type(lt,Spec);
  ob = new Objet(*t1,Quotient_interface);
  Envir.Ajouter("Quotient",ob);

  // Quotientc:  (Spec , Ident, Ta , Fs) -> Spec
  lt = new Ltype(Fsy);
  lt->Ajouter(Ta);
  lt->Ajouter(String);  // Attention ! c' est faux: il faut ajouter le typeB String
  lt->Ajouter(Spec);
  t1 = new type(lt,Spec);
  ob = new Objet(*t1,Quotientc_interface);
  Envir.Ajouter("Quotientc",ob);

  // Simpl:  Spec -> Spec
  lt = new Ltype(Spec);
  t1 = new type(lt,Spec);
  ob = new Objet(*t1,Simpl_interface);
  Envir.Ajouter("Simpl",ob);

  // check:  Spec -> Void
  lt = new Ltype(Spec);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Check_interface);
  Envir.Ajouter("Check",ob);

  // Copy:  * -> *
  lt = new Ltype(Star);
  t1 = new type(lt,Star);
  ob = new Objet(*t1,Copy_interface);
  Envir.Ajouter("Copy",ob);

  // Bisim: (Ta , Ta ) -> void
  lt = new Ltype(Ta);
  lt->Ajouter(Ta);
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Bisim_interface);
  Envir.Ajouter("Bisim",ob);

  // Flag:  Void -> Void
  lt = new Ltype();
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Flag_interface);
  Envir.Ajouter("Flag",ob);

  // Flags:  Void -> Void   (la meme chose... )
  lt = new Ltype();
  t1 = new type(lt,Void);
  ob = new Objet(*t1,Flag_interface);
  Envir.Ajouter("Flags",ob);

  // la suite ...

}

void Env::Ajouter(char * n, Objet * x)
{
  Element * aux;
  type *taux = new type(CFlag);
  int isflag=0;

  //   cout << "Env::Ajouter -> " << endl;
  // cout << n << ";" << endl;
   //   x->Print();cout<<endl;


  Objet * ob = 0;
  if (Est_def(n,ob,1)) {
    if (ob->Otype().Egal(taux)) isflag = 1;
    if ((ob->Otype().Est_typeb()) && (ob->Otype().Valb() != Void)) {
      Supprimer(n);
    }
    else 
      {cout << n << " is a key-word... " << endl;
      return ;}
  }

  if (Eq_str(n,"LatexOutput")) {
    char * auxname;
    delete LATEXOUTPUT;
    if ((! x->Otype().Est_typeb()) || (x->Otype().Valb() != String)) 
      {cout << "LatexOutput is a String variable." << endl;}
    else {
      auxname = x->OVname();
      LATEXOUTPUT = strcpy(new char[strlen(auxname)+1],auxname);
      aux = new Element;
      x->PutEnvname(strcpy(new char [strlen(n)+1],n));
      aux->_val = x;
      aux->_suivant = debut;  // 19-01-98 !! Avant 0 ??
      debut = aux;           // Avant rien ??
    }
  } else 
    if (Eq_str(n,"VcgOutput")) {
    char * auxname;
    delete VCGOUTPUT;
    if ((! x->Otype().Est_typeb()) || (x->Otype().Valb() != String)) 
      {cout << "VcgOutput is a String variable." << endl;}
    else {
      auxname = x->OVname();
      VCGOUTPUT = strcpy(new char[strlen(auxname)+1],auxname);
      aux = new Element;
      x->PutEnvname(strcpy(new char [strlen(n)+1],n));
      aux->_val = x;
      aux->_suivant = debut;  // 19-01-98 !! Avant 0 ??
      debut = aux;           // Avant rien ??
    }
  } else 
    if (isflag) {
      MaJ_Flag(n,x->Oval());
      aux = new Element;
      aux->_val = new Objet(type(CFlag),x->Oval(),strcpy(new char[strlen(n)+1],n));
      aux->_suivant = debut;
      debut = aux;
    }
    else { // si il s'agit d'un flag, c'est son initialisation, 
      // sinon il s'agit d'une cste entiere...
      aux = new Element;
      x->PutEnvname(strcpy(new char [strlen(n)+1],n));
      aux->_val = x;
      aux->_suivant = debut;
      debut = aux;
    }

  taux->Destroy();

  if (x->Otype().Est_typeb() && (x->Otype().Valb() == Ta)) {
    // on ajoute le nom !
    x->OTA()->Put_nom(n);
  }    

  //  cout << "-> Ajouter" << endl;

}

void Env::Ajouterf(char * n,Objet * x)
{ 
  int isflag=0;
  type *taux = new type(CFlag);
  Element * aux;
  Element * l;
  Objet * ob = 0;
  int ERR=0;

  if (Est_def(n,ob)) {
    if (ob->Otype().Egal(taux)) isflag = 1;
    if ((ob->Otype().Est_typeb()) && (ob->Otype().Valb() != Void))
      Supprimer(n);
    else 
      {cout << n << " is a key-word... " << endl;
      return ;}
  }
  if (Eq_str(n,"LatexOutput")) {
    char * auxname;
    if ((! x->Otype().Est_typeb()) || (x->Otype().Valb() != String)) 
      {cout << "LatexOutput is a String variable." << endl;
      ERR=1;}
    else {
      //XXXX      delete LATEXOUTPUT;
      auxname = x->OVname();
      LATEXOUTPUT = strcpy(new char[strlen(auxname)+1],auxname);
      aux = new Element;
      x->PutEnvname(strcpy(new char [strlen(n)+1],n));
      aux->_val = x;
      aux->_suivant = 0;  
    }
  } else 
    if (Eq_str(n,"VcgOutput")) {
    char * auxname;
    if ((! x->Otype().Est_typeb()) || (x->Otype().Valb() != String)) 
      {cout << "VcgOutput is a String variable." << endl;
      ERR=1;}
    else {
      delete VCGOUTPUT;
      auxname = x->OVname();
      VCGOUTPUT = strcpy(new char[strlen(auxname)+1],auxname);
      aux = new Element;
      x->PutEnvname(strcpy(new char [strlen(n)+1],n));
      aux->_val = x;
      aux->_suivant = 0;  
    }
  } else 
    if (isflag) {
      MaJ_Flag(n,x->Oval());
      aux = new Element;
      aux->_val = new Objet(type(CFlag),x->Oval(),strcpy(new char[strlen(n)+1],n));
      aux->_suivant = 0;
    }
    else   
      { // si il s'agit d'un flag, c'est son initialisation, 
	// sinon il s'agit d'une cste entiere ou une str...
	aux = new Element;
	x->PutEnvname(strcpy(new char [strlen(n)+1],n));
	aux->_val = x;
	aux->_suivant = 0;
      }
  if (!ERR) {
    if (debut == 0)
      { debut = aux; }
    else {
      l = debut;
      while (l->_suivant != 0)
	{ l = l->_suivant;}
      l->_suivant = aux;
    }
    if (x->Otype().Est_typeb() && (x->Otype().Valb() == Ta)) {
      // on ajoute le nom !
      x->OTA()->Put_nom(n);
    }
  }
}
 
void Env::Supprimer(char * n)
{ 
  Element * aux, * prec=0;
  aux = debut;
  while (aux != 0 && strcmp(n,aux->_val->OEnvname())) { 
      prec = aux;
    aux=aux->_suivant;}
  if (aux != 0)
    { 
      if (prec == 0) debut = aux->_suivant;
      else prec->_suivant = aux->_suivant;
      aux->_val->Destroy();
      //      delete aux;
    }
  else cout << n << " is not defined." << endl;
}

Objet * Env::Recherche(char * n,int cs)
{ Element * aux=debut;
Objet * res = 0;
while (aux != 0 && strcmp(n,aux->_val->OEnvname()))
  aux=aux->_suivant;
if (aux) 
  res = aux->_val;
 else 
   if (! cs) 
     {
       aux=debut;
       while (aux != 0 && strcasecmp(n,aux->_val->OEnvname()))
	 aux=aux->_suivant;
       if (aux) {
	 if (VERBOSE) 
	   cout << "The correct name is " << aux->_val->OEnvname() << endl;
	 res = aux->_val;
       }
       else 
	 cout << "Error - There is no object of name "<<n<<" in the environment !"<< '\a' << endl;
     }
   else 
     cout << "Error - There is no object of name "<<n<<" in the environment !"<< '\a' << endl;
 
return res;
}

int Env::Est_def(char * n, int cs)
{ Element * aux = debut;
int res = 0;
while (aux != 0 && strcmp(n,aux->_val->OEnvname()))
  aux=aux->_suivant;
if (aux != 0) 
  res=1;
 else 
   if (! cs) 
     {
       aux=debut;
       while (aux != 0 && strcasecmp(n,aux->_val->OEnvname()))
	 aux=aux->_suivant;
       if (aux) 
	 res = 1;
     }
return res;
}

int Env::Est_def(char * n,Pt_Objet & po,int cs)
{ Element * aux = debut;
int res = 0;
while (aux != 0 && strcmp(n,aux->_val->OEnvname()))
  aux=aux->_suivant;
if (aux) 
  {res=1;
  po = aux->_val;}
 else 
   if (! cs) 
     {
       aux=debut;
       while (aux != 0 && strcasecmp(n,aux->_val->OEnvname()))
	 aux=aux->_suivant;
       if (aux) {
	 res = 1;
	 po = aux->_val;
       }
     }
return res;
}

int Env::Taille()
{ Element * aux = debut;
int l = 0;
while (aux != 0)
  { aux = aux->_suivant;
  l++;}
return l;
}

int Env::Est_vide()
{return (debut == 0);}

void Env::Vide()
{
  Element * aux;
  Element * aux2;
  aux = debut;
  while (aux != 0)
    { aux2 = aux;
    //    cout << aux2->nom << " : "; aux2->val->Print(1); cout << endl;
    aux = aux->_suivant;
    aux2->_val->Destroy();
    delete aux2; 
    }
  debut = 0;
}

/*
void Env::Element::Destroy()
{
  //XXXXdelete nom;
 if ((val) && (val->Otype().Est_typeb())) {
   switch(val->Otype().Valb()) {
   case Flnu : val->OLnu()->Destroy();break;
   case Ta :   val->OTA()->Destroy();break;
   case Dec :  //val->ODecl()->Destroy();
     if (val->ODecl()) {
       for (Declaration Dec= (*val->ODecl()); !Dec.Est_vide(); Dec.Reste()) 
	 if (Dec.Tete())
	   Dec.Tete()->Destroy();
       val->ODecl()->Vide();
     }
     break;
   case Spec : val->OSpec()->Destroy();break;
   case Fsy :  //val->OFsyn()->Destroy();break;
   case Void : 
   case Int :
   case Undef :
   case Star :
   case String :
   case CFlag :  break;
   }
 }
}
*/

void Env::Print()
{
Element * aux = debut;
 while (aux != 0) {
   cout << aux->_val->OEnvname() << " : "; 
   aux->_val->Otype().Print();
   /*
   if (aux->val->Otype().Est_typeb()) 
     aux->val->Otype().Print();
   else aux->val->Print(); 
   */
   cout << endl;
   aux = aux->_suivant;
 }

}


/************************************************************************************/
//        Appliquer un IDF a une liste d'arguments !
/************************************************************************************/

TEval Env::Appliquer(char * n,LObjet * la)
{
TEval res;
Objet * ffct;
type taux,tres;
TYPEF tf;
Ltype * lty;

if (! Est_def(n)) {
  cout << n << " is undefined ! " << endl;
  taux = type(Undef);
  res.flag = 0;
  res.res = new Objet(type(Undef),"");
  return res;
}

ffct = Recherche(n);
taux = ffct->Otype();

if (taux.Est_typeb()) {
  cout << "Type of " << n << " is "; taux.Print();
  cout << "it is not a function !" << endl;
  res.flag = 0;
  res.res = new Objet(type(Undef),"");
  return res;
}

tf = taux.Valf();
tres = *(tf.val);  // type du resultat  -> tres
lty = tf.larg;     // liste des types des parametres attendue

if (lty->EstComp(la)) {  // type correct
  if (!tres.Est_typeb()) {
      // le type res n'est pas de base... bizarre !
    cout << " I was waiting a basic type for the result's type of "<< n << " and not: ";
    tres.Print(); cout << endl;
    res.flag = 0;
    res.res = new Objet(type(Undef),"");
    return res;
  }
  else {
    res.flag = 1;
    res.res = (ffct->Ofct())(la);
  }
}
else {
  cout << "Type error: Arguments of "<< n << " don't match with : "<< endl;
  taux.Print();
  cout << endl ;
  res.flag = 0;
  res.res = new Objet(type(Undef),"");
}
    
return res;
}




TEval Env::Eval(ASNoeud * n,int toplevel)
{
TEval res;
Declaration * auxDecl;
char * nomfct;
 Ident_L * lidaux;

  switch(n->Type()) {
  case IDF :
    //    cout << " Eval : idf -> " << n->Nom() << endl;

    if (! Est_def(n->Nom())) {
      res.flag = 0;
      res.res = new Objet(type(Undef),"");
    } else {
      res.flag = 1;
      res.res = Recherche(n->Nom());
      
      //      cout << " Eval de " << n->Nom() << endl;
      //      res.res->Print();
    }
    break;
  case CALL :  // A faire !
    if (n->Nfct()->Type() != IDF) {
      cout << "well... too difficult for me !" << endl;
      res.flag = 0;
      res.res = new Objet(type(Undef),"");
    }
    else { // le n->nc.nfct est un IDF
      LObjet * la = new LObjet; 
      int ok = 1;
      ASNoeud * naux;
      LArbreS larbre = *(n->Larg()); // CALL => larg =/= 0
      nomfct = n->Nfct()->Nom();

      //     cout << " Eval : CALL -> " << nomfct << endl;
      
      //      if (Eq_str(nomfct,"delete")) 
      //	res = TraitementDelete(n->Larg());
      //else 
      //	if (Eq_str(nomfct,"help"))
      //	res = TraitementHelp(n->Larg());
      //else {
      while ((! larbre.Est_vide()) && ok) {
	naux = larbre.Tete();
	res = Eval(naux); 
	ok = res.flag;
	if (ok) 
	  la->Ajouterf(res.res);
	larbre.Reste();
      }
      if (ok) res = Appliquer(n->Nfct()->Nom(),la);
    }
    break;
  case TLNU :
    //    cout << " Eval : TLNU -> "; n->Form()->Print(); cout << endl;

    res.flag = 1;
    res.res = new Objet(n->Form());
    break;
  case TLID :
    //    cout << " Eval : TLID -> "; PrintIdent_L(n->Lident()); cout << endl;
    res.flag = 1;
    res.res = new Objet(n->Lident());
    break;
  case TTA :
    //        cout << " Eval : TTA -> " << endl; n->Ta()->Print(); cout << endl;
    res.flag = 1;
    res.res = new Objet(n->Ta());
    break;
  case TDEC :
    res.flag = 1;
    res.res = new Objet(n->Dec());
    break;
  case TFSY :
    res.flag = 1;
    res.res = new Objet(n->Fs());
    break;
  case TTABLE :
    res.flag = 1;
    res.res = new Objet(n->Table());
    break;
  case TSYSTEM :
    res.flag = 1;
    res.res = new Objet(n->System());
    break;
  case TSPEC :
    if (! n->Spec()->Get_d()) {
      if ((Est_def(n->Spec()->Get_nomdecl())) &&
	  (Recherche(n->Spec()->Get_nomdecl())->Otype().Est_typeb()) &&
	  (Recherche(n->Spec()->Get_nomdecl())->Otype().Valb() == Dec))
	{
	  auxDecl = Recherche(n->Spec()->Get_nomdecl())->ODecl();
	  //	  auxf = n->Spec()->Get_f()->Copy(); 20-01-98

	  // 10 mai 2003: ajout du test syntaxique sur les ident des spec:
	  // il faut verifier que tout ident de la spec est defini dans auxdecl
	  Lnu * auxf = n->Spec()->Get_f();
	  int stop = 0;
	  lidaux = new Ident_L;
	  auxf->Lvariables(lidaux);
	  while (!lidaux->Est_vide()) {
	    if (!auxDecl ||  ! auxDecl->Est_def(lidaux->Tete())) {
	      // pb !
	      cout << "The identifier " << lidaux->Tete() << " is not defined in the declaration " << n->Spec()->Get_nomdecl() << endl;
	      //	      res.flag = 0;
	      //	      res.res = new Objet(type(Undef),"");
	      stop = 1;
	    }
	    lidaux->Cdr();
	  }
	  // verif de la decl...
	  if (auxDecl) {
	    Declaration auxDecl2 = (*auxDecl);
	    while (! auxDecl2.Est_vide()) {
	      auxf = auxDecl2.Tete();
	      auxf->Lvariables(lidaux);
	      while (!lidaux->Est_vide()) {
		if (! auxDecl->Est_def(lidaux->Tete())) {
		  // pb !
		  cout << "The identifier " << lidaux->Tete() << " is not defined in the declaration " << n->Spec()->Get_nomdecl() << "." << endl;
		  //		  res.flag = 0;
		  //		  res.res = new Objet(type(Undef),"");
		  stop = 1;
		}
		lidaux->Cdr();
	      }
	      auxDecl2.Reste();
	    }
	  }
	  delete lidaux;
	  if (stop) {
	    res.flag = 0;
	    res.res = new Objet(type(Undef),""); }
	  else {
	    res.res = new Objet(new Specif(n->Spec()->Get_f(),auxDecl,n->Spec()->Get_nomdecl()));
	    res.flag = 1;   // il faudrait detruire la premiere version de nv->spec...
	  }

	}
      else {res.flag = 0;
      res.res = new Objet(type(Undef),"");
      }
    }
    else {
      // ici la decl est tjs vide
      // on verifie qu'il n'y a pas d'ident dans f...
      if (! n->Spec()->Get_d()->Est_vide()) {
	cout << " Pb in Env:Eval(...) !"<< endl;
	res.flag = 0;
	res.res = new Objet(type(Undef),"");lidaux = new Ident_L;
      }
      else {
	lidaux = new Ident_L;
	n->Spec()->Get_f()->Lvariables(lidaux);
	if (! lidaux->Est_vide()) {
	  cout << "The specification "; n->Spec()->Get_f()->Print(); 
	  cout << " contains the following identifier(s):"; 
	  PrintIdent_L(lidaux);
	  cout <<"But there is no declaration !" << endl;
	  res.flag = 0;
	  res.res = new Objet(type(Undef),"");
	}
	else {
	  res.flag = 1;
	  res.res = new Objet(n->Spec());
	}
	lidaux->Vide();
	delete lidaux;
      }}
    break;
  case NAT :
    res.flag = 1;
    res.res = new Objet(type(Int),n->Val());
    break;
  case String :
    res.flag = 1;
    res.res = new Objet(type(String),n->Id());
    break;
  case ASSIGN :
    //        cout << "ASSIGN ->" << endl;
    Objet * auxassign;
    //    res = Eval(n->nass.exp);
    res = Eval(n->Ex());
    if (res.flag) {
      //      Ajouter(n->nass.id,res.res);
      Ajouter(n->Id(),res.res);
      if (Est_def(n->Id(),auxassign)) {
	if (auxassign->Otype().Egal(& type(CFlag)))
	  res.res = new Objet(type(Undef),"");
      }
    }
    //   cout << "ASSIGN <-" << endl;
    break;
  default: cout << " Erreur Env::Eval(ASNoeud *) ! " << endl;
  }

  if (toplevel) {
    if (! res.flag) {
      if (n->Type() == IDF) 
	cout << n->Nom() << " is not defined. " << endl;
      else  cout << "**  Error (line." << yylinenumber << "). The expression is not correct. "<< endl;
    }
    else if (((Est_def("verbose")) && (Recherche("verbose")->Oval())) ||
	     (n->Type() == IDF))
      res.res->Print();
  }

  return res;
}

// l'objet n de type t n'est pas def... 0 est retourne
int Env::VarNonDef(char * t, char * n)
{
  cout << "The " << t << " " << n << " is not defined ! 0 is used ! " << '\a' << endl;
  return 0;
}



