/* File: help.cc -- Francois -- Last modified on 7 Feb 2001
 * 	
 *      Fonction d'aide 
 *
 */

#include <iostream>

#include "arbre.h"
#include "env.h"
#include "type.h"


void HelpFct(char * nf)
{
  //Objet * ob;

if (!strcasecmp(nf,"help")) {
  cout << "help(topics) gives informations about topics."<< endl;
  cout << "(use lower cases in key words)" << endl;
}
else if (!strcasecmp(nf,"version")) {
  cout << "This version differs from 1.6 by the zero slope !"<< endl;
  cout << "(many changes...)" << endl;
}
else if (!strcasecmp(nf,"delete")) {
  cout << "Delete(obj) removes obj from the environment."<< endl;
} 
else if (!strcasecmp(nf,"load")) {
  cout << "load(\"toto\") evaluates the commands contained in the file toto."<< endl;
} 
// else if (!strcasecmp(nf,"BTA")) {
//   cout << "BTA(ta) builds (and returns) a (new) Basic Timed Automata from ta."<<endl;
// }
else if (!strcasecmp(nf,"Fbinary")) {
  cout << "Fbinary(ta) builds (and returns) a synchronization function for a "<<endl;
  cout << "simple binary synchronization with ta"<<endl;
}
else if (!strcasecmp(nf,"Fnil")) {
  cout << "Fnil() builds (and returns) the synchronization function * -> {(_,*)} "<<endl;
  cout << "(that is the synchronization function of a TA with the nil process)"<<endl;
}
else if (!strcasecmp(nf,"Fbisim")) {
  cout << "Fnil(ta) builds (and returns) a synchronization function for a "<<endl;
  cout << "interleaving synchronization of ta "<<endl;
}
// else if (!strcasecmp(nf,"BLnu")) {
//   cout << "BLnu(f) transforms (and returns) f into a Basic formula : "<<endl;
//   cout << "Any (E g) subformulae is replaced by (E ([InvFail]ff ^ g))  "<<endl;
//   cout << "Any (A g) subformulae is replaced by (A (<InvFail> tt v g))  "<<endl;
// }
else if (!strcasecmp(nf,"NF")) {
  cout << "NF(spec) builds (and returns) a new specification in "<<endl;
  cout << "normal form. "<<endl;
}
else if (!strcasecmp(nf,"Decl")) {
  cout << "Decl(spec) returns the declaration of spec."<<endl;
}
else if (!strcasecmp(nf,"Verify")) {
  cout << "Verify(spec, system, sync. table) verifies if spec holds for the system."<<endl;
  cout << "Note that the system defines the order of quotienting."<<endl;
  cout << "See also SVerify." << endl;
}
else if (!strcasecmp(nf,"SVerify")) {
  cout << "SVerify(spec, ta) verifies if ta |= spec, that is if spec holds for" << endl;
  cout << "the simple system ta."<<endl;
}
else if (!strcasecmp(nf,"Quotient")) {
  cout << "Quotient(spec,ta,fs) builds (and returns) the specification  "<<endl;
  cout << "quotiented by ta w.r.t. the synchronization functiont fs."<<endl;
}
else if (!strcasecmp(nf,"Quotientc")) {
  cout << "Quotient(spec,id,ta,fs) builds (and returns) the specification  "<<endl;
  cout << "quotiented by ta w.r.t. the synchronization functiont fs."<<endl;
  cout << "id is taken as the initial node of ta." << endl;
}
else if (!strcasecmp(nf,"Simpl")) {
  cout << "Simpl(spec) simplifies (and returns) the specification spec."<<endl;
}
else if (!strcasecmp(nf,"SimplNil")) {
  cout << "SimplNil(spec) simplifies (and returns) the specification spec using ";
  cout << "the hypothesis that spec deals with the nil process:"<<endl;
  cout << "*:prop  <-> ff and  - *:prop <-> tt "<< endl;
}
else if (!strcasecmp(nf,"Check")) {
  cout << "Check(spec) verifies if nil |= spec."<<endl;
}
else if (!strcasecmp(nf,"Copy")) {
  cout << "Copy( o ) returns a copy of the object o."<<endl;
  cout << "o belongs to one of the following types: Lnu, TA, Dec, Spec, Fct_Synch, String, Table, System, Int" << endl;
}
 else if ((!strcasecmp(nf,"flag")) || (!strcasecmp(nf,"flags"))) {
  cout << "Flags() prints the values of every flags. " << endl;
  cout << "Different flags can be used to modify the system :"<<endl << endl;
  cout << "trace : print details on the execution of quotient function." << endl;
  cout << "verbose : print the value of exp in the assignments id := exp ."<< endl;
  cout << "Flag about the simplifications for the quotient:"<< endl;
  cout << "equivequation : to remove equivalent equations."<< endl;
  cout << "trivequation  : to remove trivial equations."<< endl;
  cout << "hitzone       : to simplify w.r.t the constraints propagation."<< endl;
  cout << "splitting     : to split the variables w.r.t the HitZones."<< endl;
  cout << "         (three degrees of splitting are possible: 1 normal, 2 fine, 3 very fine)."<< endl;
  cout << "unguardedvar  : to removed the unguarded variables (without losing the normal form)."<< endl;
  cout << "bell          : to ring a bell when a verification is done."<< endl;
  cout << "minfp         : to compute Compl([[Spec]]) in Check procedure with minimal fixpoint." << endl;
  cout << "infty         : to fix a maximal constant for the zones computation."<< endl;
  cout << "         (for TA, the maximal constant in guard is sufficient)"<< endl;
  cout << "nbfpit        : Number of FixPoint Iterations. To avoid non-termination" << endl;
  cout << "         in the fixpoint computation for hybrid systems."<<endl;
  cout << "         (-1 if no bound is fixed)" << endl;
  cout << endl << "To put on (resp. off) a boolean flag f, type : 'f := 1' (resp 'f := 0'). "<<endl;
  cout << "To assign a value v to an integer flag f, type : 'f := v' "<<endl;
}
else if (!strcasecmp(nf,"object")) {
  cout << "An object is a Lnu formula, a specification, a timed automaton,"<< endl;
  cout << "a system, a synchronization function, a synchronization table,"<<endl;
  cout << "a Lnu declaration or an integer variable." << endl;
}
else if (!strcasecmp(nf,"system")) {
  cout << "A system gives an order for quotient a parallel composition " << endl;
  cout << "of timed automata a system and the value of simplifications flags" << endl;
  cout << "for each quotient." << endl;
  cout << "syntax: System (A1, A2, ... An) " << endl;
  cout << "Any automaton can be followed by an array of 5 integer values to" << endl;
  cout << "put on or off the simpification flags (equiv. eq., triv. eq.,"<<endl;
  cout << "hitzone, unguarded var. elim., splitting)." << endl;
}
else if (!strcasecmp(nf,"synchro")) {
  cout << "The synchronization can be described either by binary"<<endl;
  cout << "synchronization functions (see also Fbinary, Fnil) or "<< endl;
  cout << "by a n-ary synchronization table."<< endl;
  cout << "See also: Table, Fsynchro, Fbinary and Fnil."<<endl;
}
else if (!strcasecmp(nf,"topics")) {
  cout << "help, delete, load, synchro, Verify, Quotient, Quotientc, Simpl," << endl;
  cout << "SimplNil, Check, Copy, flag, object, System, synchro, topics, keyword" << endl;
  cout << "VCG, View, Print, Latex, Decl, Fnil, Fbinary, table, automata, declaration, fsynchro " << endl;
}
else if (!strcasecmp(nf,"Bisim")) {
  cout << "Bisim(ta1,ta2) checks if the two basic timed automata ta1 and ta2 are bisimilar."<< endl;
}
// else if (!strcasecmp(nf,"VCG")) {
//   cout << "VCG(ta) creates a xvcg source of ta."<< endl;
// }
// else if (!strcasecmp(nf,"View")) {
//   cout << "View(ta) dislays (with xvcg) the timed automaton ta."<< endl;
// }
// else if (!strcasecmp(nf,"Print")) {
//   cout << "Print(ta) sends the xvcg code of the timed automaton ta to the standard printer ."<< endl;
// }
else if (!strcasecmp(nf,"Latex")) {
  cout << "Latex(sp) generates a LaTeX code of the specification sp."<< endl;
  cout << "The source is written in the file whose name is specified by the variable LatexOutput."<< endl;
}
else if ((!strcasecmp(nf,"Automata")) || (!strcasecmp(nf,"Automaton"))) {
  cout << "Automata is a key work used to define (and assign to a variable) an automaton." << endl;
  cout << "Syntax:  " << endl;
  cout << "Automata :  _varname_ [ _list of clocks_  _list of nodes_ ";
  cout << "_list of transitions_ _list of invariants_ _list of atomic propositions_ " << endl;
  cout << "With : " << endl;
  cout <<"_list of clocks_ =       Clocks : x_1, ... ,x_n       [optional] " << endl;
  cout <<"_list of nodes_ =        Nodes : r_1, ... ,r_n   " << endl;
  cout <<"_list of transitions_ =  Transitions : t_1,...,t_n    [optional] " << endl;
  cout << "ti (are transitions) =  source - guard, label, reset_set -> dest" << endl;
  cout << "   the reset set is of the form  {x1, ... ,xn} " << endl;
  cout << "   guard and the reset set are optional. " << endl;
  cout <<"_list of invariants_ =   Invariants : r_1 |= i_1,...,r_n |= i_n [optional]" << endl;
  cout << "each i_i is a Lnu clocks constraint" << endl;
  cout <<"_list of at. prop_ =   Atomic Propositions : r_1 |= p_1 ... p_k,..., r_n |= p_i ... p_l [optional]" << endl;
  cout << "];" << endl;
  cout << "The first node of the list is the initial node. " << endl;
}
else if (!strcasecmp(nf,"Table")) {
  cout << "Table is a key work used to define (and assign to a variable) a synchronization." << endl;
  cout << "table. " << endl;
  cout << "Syntax:  " << endl;
  cout << "Table : _varname_ { ( _list of automata_) ; " << endl;
  cout << "                    ( _list of actions_ ) -> _visible action_ ; "<<endl;
  cout << "                                  ... " << endl;
  cout << "};"<<endl;
  cout << "The no action symbol is . "<<endl;
}
else if (!strcasecmp(nf,"Fsynchro")) {
  cout << "Fsynchro is a key work used to define (and assign to a variable) a binary " << endl;
  cout << "synchronization function (used in Quotient function)" << endl;
  cout << "Syntax:  " << endl;
  cout << "Fsynchro : _varname_ { _list of actions' def_ }; " << endl;
  cout << "The actions' definitions are of the form: _visible ac_ -> {_list of synch. pair_} and are separated with ;" << endl;
  cout << "The synch. pairs are of the form (ac1,ac2) and are separated with ;"<< endl;
  cout << "The action's definition * -> {(_,*)} is used to mean that other actions are performed by the quotiented automaton." << endl;
  cout << "The action's definition * -> {(*,_)} is used to mean that other actions are performed by the remaining network." << endl;
 }
else if (!strcasecmp(nf,"Declaration")) {
  cout << "Declaration is a key work used to define (and assign to a variable) an Ln declaration. " << endl;
  cout << "Syntax:  " << endl;
  cout << "Declaration : _varname_ [ _list of equations_ ]; " << endl;
  cout << "An equation is of the form:  IDENT = _Lnu def_" << endl;
  cout << "Equations are separated with ;" << endl;
}
else if (!strcasecmp(nf,"keyword")) {
  cout << "List of key words : " << endl;
  cout << "quit, Automata, Declaration, Fsynchro, Table, System, Invariant" << endl;
}
else if (!strcasecmp(nf,"Future")) {
  cout << "Computes the Future of a zone w.r.t a list of _inactive_ clocks." << endl;
}
else {cout << "no information is available for "<< nf << endl;
}
if (Envir.Est_def(nf))   
  Envir.Recherche(nf)->Print();
}

