/* File: liste.h -- Francois -- Last modified on 25 Mar 1998
 * 	
 *      
 *
 */

#include<iostream>


#ifndef LISTE_H
#define LISTE_H

template <class Type>
class Liste {
 private:

  class Element {
  public:
    Type val;
    Element * suivant;
  };
  typedef Element * Ptr_Element;

  Ptr_Element debut;

 public:

  Liste()
    {debut = 0;}

  Liste(Type x)
    {debut = 0; Ajouter(x);}

  void NewListe();

  void Ajouter(Type x);
  Liste<Type> * Ajouter2(Type x);

  void Ajouterf(Type x);
  Liste<Type> * Ajouterf2(Type x);

  void Supprimer();

  void Supprimerf();

  Type SupprimerRes(int n);
  void Supprimer(int n);

  void Concat(Liste l);

  Liste<Type> * Concat2(Liste l);

  int Longueur();

  int Est_vide();

  Type Tete();

  void Reste();
  void Cdr();

  void Vide();

};


template <class Type>
inline void Liste<Type>::NewListe()
    {debut = 0;}

template <class Type>
inline void Liste<Type>::Ajouter(Type x)
    { Element * aux;
      aux = new Element;
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
   }

template <class Type>
Liste<Type> * Liste<Type>::Ajouter2(Type x)
    { Element * aux;
      aux = new Element;
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
      return this;
   }

template <class Type>
void Liste<Type>::Ajouterf(Type x)
    { Element * aux;
      Element * l;
      aux = new Element;
      aux->val = x;
      aux->suivant = 0;
      if (debut == 0)
	{ debut = aux; }
      else {
	l = debut;
	while (l->suivant != 0)  {
	   l = l->suivant;}
	l->suivant = aux;
      }
   }

template <class Type>
Liste<Type> * Liste<Type>::Ajouterf2(Type x)
    { Element * aux;
      Element * l;
      aux = new Element;
      aux->val = x;
      aux->suivant = 0;
      if (debut == 0)
	{ debut = aux; }
      else {
	l = debut;
	while (l->suivant != 0)  {
	   l = l->suivant;}
	l->suivant = aux;
      }
      return this;
   }

template<class Type>
inline void Liste<Type>::Supprimer()
    { Element * aux;
      if (debut == 0)
       { cout << " Erreur dans Supprimer: Liste vide ! " << endl; }
     else
       {
	 aux = debut->suivant;
	 delete debut;
	 debut = aux;
       }
    }



template<class Type>
inline void Liste<Type>::Supprimer(int n)
    { Element * aux, * aux2;
      int cp = 0;

      if (debut == 0)
	if (n != 0) 
	  { cout << " Erreur dans Supprimer_n: Liste vide ! " << endl; }
	else return;
     else
       { 
	 if (n == 1) 
	   {aux= debut;
	    debut = debut->suivant;
	    delete aux;}
	 else {
	   aux = debut; aux2 = debut;
	   cp = 1;
	   while ((aux != 0) && (cp < n))
	     { aux2 = aux; aux = aux->suivant; cp++;}
	   if (cp != n) 
	     {
	     cout << " Erreur dans Supprimer_n: pas assez d'element !" << endl;
	     cout << " n = " << n << " Longueur = " << this->Longueur()  << endl;
	   }
	   else {
	     aux2->suivant = aux->suivant;
	     delete aux;
	   }
	 }
       }
    }

template<class Type>
inline Type Liste<Type>::SupprimerRes(int n)
    { Element * aux, * aux2;
      Type res;
      int cp = 0;

      if (debut == 0)
	if (n != 0) 
	  { cout << " Erreur dans Supprimer_n: Liste vide ! " << endl; }
	else return res;
     else
       { 
	 if (n == 1) 
	   {aux= debut;
	    debut = debut->suivant;
	    res = aux->val;
	    delete aux;}
	 else {
	   aux = debut; aux2 = debut;
	   cp = 1;
	   while ((aux != 0) && (cp < n))
	     { aux2 = aux; aux = aux->suivant; cp++;}
	   if (cp != n) 
	     {
	     cout << " Erreur dans Supprimer_n: pas assez d'element !" << endl;
	     cout << " n = " << n << " Longueur = " << this->Longueur()  << endl;
	   }
	   else {
	     aux2->suivant = aux->suivant;
	     res = aux->val;
	     delete aux;
	   }
	 }
       }
      return res;
    }

template <class Type>
void Liste<Type>::Supprimerf()
    { Element * aux;
      if (debut == 0)
       { cout << " Erreur dans Supprimer: Liste vide ! " << endl; }
     else
       {
	 aux = debut;
	 if (aux->suivant == 0) Supprimer();
	 else {
	   while (aux->suivant !=0)
	     {aux = aux->suivant;}
	   delete aux->suivant;
	   aux->suivant = 0;
	 }
       }
    }

template <class Type>
void Liste<Type>::Concat(Liste<Type> l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l.debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l.debut;
	}
    }

template <class Type>
Liste<Type> * Liste<Type>::Concat2(Liste<Type> l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l.debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l.debut;
	}
      return this;
    }

template <class Type>
int Liste<Type>::Longueur()
    { Element * aux = debut;
      int l = 0;
      while (aux != 0)
      { aux = aux->suivant;
	  l++;}
      return l;
    }

template <class Type>
inline int Liste<Type>::Est_vide()
    {return (debut == 0);}

template <class Type>
inline Type Liste<Type>::Tete()
    { if (debut == 0) cout << " Erreur dans Liste::Tete() " << endl;
      return debut->val;
    }

template <class Type>
inline void Liste<Type>::Reste()
    {
      if (debut == 0) cout << " Erreur dans Liste::Reste() " << endl;
	 else debut = debut->suivant;
    }
template <class Type>
inline void Liste<Type>::Cdr()
    {
      Element * aux = debut;
      if (debut == 0) cout << " Erreur dans Liste::Cdr() " << endl;
	 else {debut = debut->suivant;
	       delete aux;}
	       
    }

template <class Type>
void Liste<Type>::Vide()
    {
      Element * aux;
      Element * aux2;
      aux = debut;
      while (aux != 0)
	{ aux2 = aux;
	  aux = aux->suivant;
	  delete aux2; }
      debut = 0;
    }


#endif
