/* File: lnu.cc -- Francois -- Last modified on 30 Jul 2001
 * 	
 *      Definition des formules
 *
 */

#ifndef SUN
#define SUN
#endif


#include "lnu.h"
#include "ta.h"
#include "setval.h"

#include "PLC2.h"

#include "acces.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>




// Fonctions sur les chaines

// transforme IdentL en une chaine et detruit IdentL...
Ident IdentL2String(Ident_L *l)
{
  if (l==0) return strcpy(new char[1],"");
  
  Ident_L laux = (*l);
  int longueurtotale = 0;
  for (;!laux.Est_vide();laux.Reste()) {
    if (longueurtotale) longueurtotale++; 
    longueurtotale += strlen(laux.Tete());
  }
  Ident res = new char[longueurtotale];
  int pointeur = 0;
  
  for (; ! l->Est_vide(); l->Cdr()) {
    if (pointeur) res[pointeur-1]=' ';
    strcpy(res+pointeur,l->Tete());
    pointeur += 1+strlen(l->Tete());
    delete l->Tete();
  }
  return res;
}

Ident_L * CopyIdent_L(Ident_L *l)
{
Ident_L * res=0, laux;
char * chaine, * copie;

if (l==0) return res;

res = new Ident_L;
laux = (*l);
 while (! laux.Est_vide()) {
   chaine = laux.Tete();
   copie = strcpy(new char[strlen(chaine)+1],chaine);
   res->Ajouterf(copie);
   laux.Reste();
 }
return res;
}

int EstDefIdent_L(Ident_L *l, Ident c)
{
  int res = 0;
  if (l!=0) {
   Ident_L laux = (*l);
   while (! laux.Est_vide()) {
     if (Eq_str(c,laux.Tete())) 
       {res=1;break;}
     laux.Reste();
   }
  }
  return res;
}

void DestroyIdent_L(Ident_L *l)
{
Ident_L laux;

 if (l!=0) {
   laux = (*l);
   while (! laux.Est_vide()) {
     delete laux.Tete();
     laux.Reste();
   }
   l->Vide();
 }
}

void PrintIdent_L(Ident_L *l)
{
Ident_L laux;

 if (l!=0) {
   laux = (*l);
   if (laux.Est_vide()) 
     cout << "liste vide";
   while (! laux.Est_vide()) {
     cout << laux.Tete() << " " ;
     laux.Reste();
   }
 }
 else cout << "liste vide";
 cout << endl;
}


void NewName(char *,int );

int Eq_str(char * s1,char * s2)
{
  return (strcmp(s1,s2) == 0) ? 1 : 0;
}


int Eq_lstr(Ident_L *l1, Ident_L *l2)
{
int res=1;
 if (l1 == 0) {
   if (l2 == 0) return 1;
   else   return (l2->Est_vide()) ? 1 : 0;
 }
 
 if (l2 == 0) 
   return (l1->Est_vide()) ? 1 : 0;
 
 if (l1->Est_vide() && l2->Est_vide()) 
   return 1;

 Ident_L laux1,laux2;
 Ident aux;
 int trouve;
 
 laux1=*l1;
 while (res && (! laux1.Est_vide())) {
   aux = laux1.Tete();
   trouve = 0;
   laux2 = *l2;
   while ((!trouve) && (!laux2.Est_vide())) {
     if (Eq_str(aux,laux2.Tete())) trouve=1;
     laux2.Reste();
   }
   if (!trouve) res=0;
   laux1.Reste();
 }
 if (!res) return 0;
 laux1=*l2;
 while (res && (! laux1.Est_vide())) {
   aux = laux1.Tete();
   trouve = 0;
   laux2 = *l1;
   while ((!trouve) && (!laux2.Est_vide())) {
     if (Eq_str(aux,laux2.Tete())) trouve=1;
     laux2.Reste();
   }
   if (!trouve) res=0;
   laux1.Reste();
 }
return res;
}


char * Add_Rec(char * s)
{
char * res;
int l; 
if (! s) cout << "Erreur Add_Rec !! " << endl;

l = strlen(s);
res = new char[l+2];
strcpy(res,s);
res[l] = '?';
res[l+1] = '\0';
return res;
}

char * Add_Sen(char * s)
{
char * res;
int l; 
if (! s) cout << "Erreur Add_Sen !! " << endl;

l = strlen(s);
res = new char[l+2];
strcpy(res,s);
res[l] = '!';
res[l+1] = '\0';
return res;
}

int Is_Rec(char * s)
{
int l, res=0;
if (!s) cout << "Erreur dans Is_Rec !!" << endl;
l = strlen(s);
if (l) 
  res = (s[l-1] == '?');
return res;
}

char * Rem_RS(char * s)
{
char * res;
int l; 
if (! s) cout << "Erreur Rem_RS !! " << endl;

l = strlen(s);
if ((s[l-1] != '?') && (s[l-1] != '!')) 
  cout << "Erreur 2 Rem_RS !! " << endl;

res = strncpy(new char[l],s,l-1);
res[l-1] = '\0';
return res;
}

char * Trans_Rec(char * s)
{
char * res;
int l; 
if (! s) cout << "Erreur Trans_Rec !! " << endl;

l = strlen(s);
res = strcpy(new char[l+1],s);
res[l-1] = '?';
return res;
}


char * Trans_Sen(char * s)
{
char * res;
int l; 
if (! s) cout << "Erreur Trans_Sen !! " << endl;

l = strlen(s);
res = strcpy(new char[l+1],s);
res[l-1] = '!';
return res;
}

int Is_Sen(char * s)
{
int l, res=0;
if (!s) cout << "Erreur dans Is_Sen !!" << endl;
l = strlen(s);
if (l) 
  res = (s[l-1] == '!');
return res;
}


int ExtVal(char * c)
{
if (c == 0) 
  {cout << " Erreur dans ExtVal ! "<< endl;
   return 0;}
if (c[0] == '\0') 
  {cout << " Erreur 2 dans ExtVal ! "<< endl;
   return 0;}
c++;
return atoi(c);
}

int EstXnum(char * c)
{
int res,i,l;
if (! c) return 0;
l = strlen(c);
if (l<2) return 0;
res = 1;
for (i=1;i<l;i++)
  switch (c[i]) {
  case '0' :
  case '1' :
  case '2' :
  case '3' :
  case '4' :
  case '5' :
  case '6' :
  case '7' :
  case '8' :
  case '9' : break;
  default : res = 0;
  }
return res;
}

//-------------------------------------------------------------------
//            Fonction de synchro binaire
//-------------------------------------------------------------------

void DestroyFs(Fsynchro * fs)
{
Fsynchro fsaux = *fs;
 Pt_Synch_Vect_L * laux;
 Synch_Vect * svaux;
    
 while (! fsaux.Est_vide()) {
   laux = fsaux.Tete();
   while (! laux->Est_vide()) {
     svaux = laux->Tete();
     svaux->Destroy(); // ne s'auto-detruit pas ...
     delete svaux;
     laux->Cdr();
   }
   delete laux;
   fsaux.Reste();
 }
 fs->Vide();
 delete fs;
}


Fsynchro * CopyFs(Fsynchro * fs)
{
Mapping<Pt_Synch_Vect_L *> * res;
Mapping<Pt_Synch_Vect_L *> aux;
Pt_Synch_Vect_L lv, *lc;

res = new Mapping<Pt_Synch_Vect_L *>;

 for (aux = *fs; !aux.Est_vide(); aux.Reste()) {
   lc = new Pt_Synch_Vect_L;
   for (lv = * aux.Tete(); !lv.Est_vide(); lv.Reste()) 
     lc->Ajouter(lv.Tete()->Copy());
   res->Ajouterf(aux.TeteN(),lc);
 }

return res;
}


void PrintFs(Fsynchro * fsb)
{
Fsynchro Fs;
Pt_Synch_Vect_L lv;
 cout << "Synchro. function :" << endl;
  Fs = *fsb;
  while(! Fs.Est_vide()) {
    lv = *(Fs.Tete());
    cout << Fs.TeteN() << " -> {";
    while (! lv.Est_vide()) {
      cout << "("; 
      if (Eq_str(lv.Tete()->Get_la(),"")) cout << "_";
      else cout << lv.Tete()->Get_la();
      cout << ",";
      if (Eq_str(lv.Tete()->Get_lb(),"")) cout << "_";
      else cout << lv.Tete()->Get_lb();
      cout << ") ";
      lv.Reste();
    }
    cout << "}" << endl;
    Fs.Reste();
  }
  cout << endl;
}


//--------------------------------------------------------------
//                                 Config
//--------------------------------------------------------------

Config::Config(Ident n,Ident nta, TA * t,Fsynchro * f)
{
noeud = n;
nomta = nta;
ta = t;
fs = f;
nbp = 1;
 __CPCF++;
 // cout << "Config::Config : "<< nomta << " - " << noeud << " - nbp = " << nbp << endl;
}

Ident Config::Get_noeud()
{ return noeud;}

Ident Config::Get_nta()
{ return nomta;}

TA * Config::Get_ta()
{return ta;}

Fsynchro * Config::Get_fs()
{return fs;}

void Config::Print()
{
  cout << " Configuration : " << nomta << "_" << noeud;
}

void Config::NewPt()
{nbp++;
// cout << "Config::NewPt : "<< nomta << " - " << noeud << " - nbp = " << nbp << endl;
}

void Config::Destroy()
{
nbp--;
// cout << "Config::Destroy : "<< nomta << " - " << noeud << " - nbp = " << nbp << endl;
if (! nbp) {
   delete this;
   __CPCF--;
}
}


//--------------------------------------------------------------
//                  Fonctions auxiliaires
//--------------------------------------------------------------

OPC Aux_eq(OPC o)
{
switch(o) {
 case Inf : 
  return Sup;
 case Sup : 
  return Inf;
 case Supe:
  return Infe;
 case Infe : 
  return Supe;
 case Egal :
  return Egal;
 case Diff :
  return Diff;
  default :
  return Egal;
}
}

void NewName(char tab[20],int n)
{
  sprintf(tab, "X%d", n);
}

/*
====================================================================

                 LNU CLASS

====================================================================
*/

//-----------------------------------------------------------------
//                          Constructeurs
//-----------------------------------------------------------------

LnuBool::LnuBool (OP o)
{if ( (o != Bot) && (o != Top)) 
   cout << "Erreur dans LnuBool !" << endl;
 prop = (char *) 0;
 op = o;
__CPLNU++;
// cout << "LnuBool ";Print();cout << endl;
}

LnuBool::LnuBool (OP o,Ident p,Ident ta)
{if ((o != AP) && (o != NAP))
   cout << "Erreur dans LnuBool-Prop !" << endl;
 op = o;
 prop = strcpy(new char[strlen(p)+1],p);
 if (ta) nta = strcpy(new char[strlen(ta)+1],ta);
 else nta = 0;
__CPLNU++;
 //cout << "LnuBool ";Print();cout << endl;
}

Ident LnuBool::Prop()
{return prop;}

Ident LnuBool::Nta()
{return nta;}

LnuUn::LnuUn(OP o,Lnu * f,Ident_L * lsc)
{ if ((o != Exists) && (o != Forall) && (o != Not)) 
   cout << "Erreur dans LnuUn !" << endl;
 op = o;
 subf = f;
 lstop = lsc; // sans copie...
__CPLNU++;
//cout << "LnuCD ";Print();cout << endl;
}

LnuCD::LnuCD(OP o,Lnu * f,Lnu * g)
{if ((o != And) && (o != Or)) 
  cout << "Erreur dans LnuCD 1 !" << endl;
 op = o;
 larg.Vide();
 larg.Ajouter(f);
 larg.Ajouter(g);
__CPLNU++;
//cout << "LnuCD ";Print();cout << endl;
}

LnuCD::LnuCD(OP o,Lnu_L l)
{if ((o != And) && (o != Or)) 
  cout << "Erreur dans LnuCD 2 !" << endl;
 op = o;
 larg = l;
__CPLNU++;
//cout << "LnuCD ";Print();cout << endl;
}



LnuMod::LnuMod(OP o,Ident id,Lnu * f)
{if ( (o != Diam) && (o != Box) && (o != In)) 
   cout << "Erreur dans LnuMod !" << endl;
 op = o;
 assert(id);
 lab = strcpy(new char [strlen(id)+1],id);
 subf = f;
 carg=(char *) 0;
 iarg=0;
__CPLNU++;
//cout << "LnuMod ";Print();cout << endl;
}


LnuMod::LnuMod(OP o,Ident id, Ident c,Lnu * f)
{if (o != In) 
   cout << "Erreur dans LnuMod !" << endl;
 op = o;
 assert(id);
 lab = strcpy(new char [strlen(id)+1],id);
 if (c) 
   carg = strcpy(new char [strlen(c)+1],c);
 else c= (char *) 0;
 iarg=0;
 subf = f;
__CPLNU++;
//cout << "LnuMod ";Print();cout << endl;
}

LnuMod::LnuMod(OP o,Ident id, int v,Lnu * f)
{if (o != In) 
   cout << "Erreur dans LnuMod !" << endl;
 op = o;
 assert(id);
 lab = strcpy(new char [strlen(id)+1],id);
 carg = (char *) 0;
 iarg=v;
 subf = f;
__CPLNU++;
//cout << "LnuMod ";Print();cout << endl;
}


LnuMod::LnuMod(OP o,Ident id, Ident c,int v,Lnu * f)
{if (o != In) 
   cout << "Erreur dans LnuMod !" << endl;
 op = o;
 assert(id);
 lab = strcpy(new char [strlen(id)+1],id);
 if (c) 
   carg = strcpy(new char [strlen(c)+1],c);
 else carg = (char *) 0;
 iarg=v;
 subf = f;
__CPLNU++;
//cout << "LnuMod ";Print();cout << endl;
}


Ident_L * LnuUn::LSClocks()
{return lstop;}

Lnu * LnuMod::Subf()
{return subf;}

Ident LnuMod::Lab()
{return lab;}

Ident LnuMod::Carg()
{return carg;}

int LnuMod::Iarg()
{return iarg;}

int LnuMod::IsExtendedIn()
{return ( (op == In) && ((carg != 0) || (iarg != 0)));}

Lnu_L LnuCD::Get_larg()
{return larg;}

LnuTest::LnuTest(OPC o,Ident cl1,int m1, Ident cl2,int m2)
{
  opc = o;
  c1 = strcpy(new char[strlen(cl1)+1],cl1);
  c2 = strcpy(new char[strlen(cl2)+1],cl2);
  n1 = m1;
  n2 = m2;
__CPLNU++;
//cout << "LnuTest ";Print();cout << endl;
}



void LnuTest::InvOPC()
{
  switch(opc) {
     case Inf : opc = Supe;break;
     case Infe: opc = Sup;break;
     case Sup : opc = Infe;break;
     case Supe: opc = Inf;break;
     case Egal: opc = Diff;break;
     case Diff: opc = Egal;break;
     default  : break;
     };
}

OPC LnuTest::Get_opc()
{return opc;}

Ident LnuTest::Get_c1()
{return c1;}

int LnuTest::Get_n1()
{return n1;}

Ident LnuTest::Get_c2()
{return c2;}

int LnuTest::Get_n2()
{return n2;}


LnuBin::LnuBin(OP o,Lnu * f,Lnu * g,Ident_L * lsc)
{assert((o==Impl && !lsc) || o==EUntil);
 op = o;
 f1 = f;
 f2 = g;
 lstop = lsc;
__CPLNU++;
//cout << "LnuTest ";Print();cout << endl;
}

LnuVar::LnuVar(int n)
{
char t[20];
NewName(t,n);
name= strcpy(new char[strlen(t)+1],t);
 num = n;
__CPLNU++;
//cout << "LnuVar ";Print();cout << endl;
}

LnuVar::LnuVar(Ident n)
{name=strcpy(new char[strlen(n)+1],n);
 num = 0;
__CPLNU++;
//cout << "LnuVar ";Print();cout << endl;
}

LnuVar::LnuVar(Ident n,int x)
{if (n) name=strcpy(new char[strlen(n)+1],n);
 else name = 0;
 num = x;
__CPLNU++;
//cout << "LnuVar ";Print();cout << endl;
}

int LnuVar::GetNum()
{return num;}


//-------------------------------------------------------------------
//                              TYPE 
//-------------------------------------------------------------------

inline OP LnuBool::Type()
{return op;}

inline OP LnuMod::Type()
{return op;}

inline OP LnuUn::Type()
{return op;}

inline OP LnuCD::Type()
{return op;}

inline OP LnuTest::Type()
{return Test;}

inline OP LnuBin::Type()
{return op;}

inline OP LnuVar::Type()
{return Var;}

//-----------------------------------------------------------------
//                               PRINT 
//-----------------------------------------------------------------


 void LnuBool::Print(ostream & output)
{
  switch(op) {
  case Bot : 
    output << "ff "; 
    break;
  case Top :
    output << "tt ";
    break;
  case AP :
    if (nta) output << nta << ":";
    else output << "*:";
    output <<prop<<" ";
    break;
  case NAP :
    output << "-";
    if (nta) output << nta << ":";
    else output << "*:";
    output <<prop<<" ";
    break;
  default : break;
  }
}

 void LnuMod::Print(ostream & output) 
{if (op == Diam)
   output << "<"<<lab<<">";
else if (op == Box) 
  output << "["<<lab<<"]";
else if (! IsExtendedIn()) 
  output << lab << " in ";
 else {
   output << lab << ":=";
   if (carg && iarg) 
     output << carg<<"+"<<iarg<<" in ";
   else if (carg) 
     output << carg<<" in ";
   else 
     output << iarg<<" in ";
 }
 subf->Print(output);
}

 void LnuUn::Print(ostream & output)
{
  if ((op == Exists) || (op == Forall)) {
    if (op == Exists) 
      output << "<@";
    else 
      output << "[@";
    if (lstop) {
      if (! lstop->Est_vide()) {
	output << "\\";
	Ident_L laux = *lstop;
	output << laux.Tete();
	laux.Reste();
	while (!laux.Est_vide()) {
	  output << ","<<laux.Tete();
	  laux.Reste();
	}
      }
    }
    if (op == Exists) 
      output << "> ";
    else output << "] ";
  }
  else output << "-";
 subf->Print(output);
}

void LnuCD::Print(ostream & output)
{
  Lnu_L l;
  Lnu * f;
  char* sign1 = " v ";
  char* sign2 = " ^ ";
  char* sign;
  if (op == And)
    sign = sign2;
  else sign = sign1;
  l = larg;
  if (! l.Est_vide())
    {
      output << "(";
      f = l.Tete();
      f->Print(output);
      l.Reste();
      while (! l.Est_vide())
	{ f = l.Tete();
	  output << sign;
	  f->Print(output);
	  l.Reste();
	}
      output << ")";
    }
}

void LnuTest::Print(ostream & output)
{
if ((strcmp(c1,"") != 0) && (n1 != 0))
  output << c1 << "+" << n1;
else if (strcmp(c1,"") != 0) output << c1;
else output << n1;
  
switch(opc) {
  case Inf : output << "<";break;
  case Infe: output << "<=";break;
  case Sup : output << ">";break;
  case Supe: output << ">=";break;
  case Egal: output << "=";break;
  case Diff: output << "=/=";break;
  default  : output << " ? ";break;
	   };
if ((strcmp(c2,"")  != 0) && (n2 != 0))
  output << c2 << "+" << n2;
else if (strcmp(c2,"") != 0) output << c2;
else output << n2;
}

 void LnuBin::Print(ostream & output)
{

  switch (op) {
  case Impl :
    output << "(";
    if (f1) f1->Print(output);
    else cout << "LnuBin::Print - f1 not def" << endl;
    output << "=>";
    if (f2) f2->Print(output);
    else cout << "LnuBin::Print - f2 not def" << endl;
    output << ")";
    break;
  case EUntil :
    output << "(";
    if (f1) f1->Print(output);
    else cout << "LnuBin::Print - f1 not def" << endl;
    output << "[@";
    if (lstop) {
      if (! lstop->Est_vide()) {
	output << "\\";
	Ident_L laux = *lstop;
	output << laux.Tete();
	laux.Reste();
	while (!laux.Est_vide()) {
	  output << ","<<laux.Tete();
	  laux.Reste();
	}
      }
    }
    output << ")";
    if (f2) f2->Print(output);
    else cout << "LnuBIn::Print - f2 not def" << endl;
    output << ")";
    break;
  default : assert(0);
  }

}

 void LnuVar::Print(ostream & output)
{
if (name) output << name << " ";
else output << "X"<< num << " ";
}

//-----------------------------------------------------------------
//                               PRINTLATEX
//-----------------------------------------------------------------


inline void LnuBool::PrintLatex(ostream & latexoutput)
{
switch(op) {
 case Bot : 
  latexoutput << "\\falsesymb "; 
  break;
 case Top :
  latexoutput << "\\truesymb ";
  break;
 case AP :
   if (nta) latexoutput << "{\\sf "<< nta << ":";
   else latexoutput << "{\\sf *:";
  latexoutput <<prop<<"} ";
  break;
 case NAP :
   latexoutput << "\\negop ";
   if (nta) latexoutput << "{\\sf " << nta << ":";
   else latexoutput << "{\\sf *:";
  latexoutput <<prop<<"} ";
  break;
 default : break;
}
}

inline void LnuMod::PrintLatex(ostream & latexoutput) 
{if (op == Diam)
   latexoutput << "\\diamop{"<<lab<<"} ";
else if (op == Box) latexoutput << "\\boxop{"<<lab<<"}";
else { 
  latexoutput << "\\inop{";
  if (EstXnum(lab)) 
    latexoutput << lab[0] << "_{" << ExtVal(lab) << "} ";
    else latexoutput << lab << " ";
  latexoutput << ":=";
  if (carg && iarg) {
    if (EstXnum(carg)) 
      latexoutput << carg[0] << "_{" << ExtVal(carg) << "}";
    else latexoutput << carg;
    latexoutput << "+"<<iarg;
  }
  else if (carg) {
    if (EstXnum(carg)) 
      latexoutput << carg[0] << "_{" << ExtVal(carg) << "}";
    else latexoutput << carg;
  }
  else latexoutput << iarg;
  latexoutput <<  "}{";
}
subf->PrintLatex(latexoutput);
if (op == In) latexoutput<<"}";
}


inline void LnuUn::PrintLatex(ostream & latexoutput)
{


 if ((op == Exists) || (op == Forall)) {
   if (op == Exists)
   latexoutput << "\\existsymb{";
   else latexoutput << "\\forallsymb{";
   if (lstop) {
     if (! lstop->Est_vide()) {
	Ident_L laux = *lstop;
	latexoutput << laux.Tete();
	laux.Reste();
	while (!laux.Est_vide()) {
	  latexoutput << ","<<laux.Tete();
	  laux.Reste();
	}
      }
   }
   latexoutput << "}";
 }
 else latexoutput << "\\negop";
 subf->PrintLatex(latexoutput);
}

void LnuCD::PrintLatex(ostream & latexoutput)
{
  Lnu_L l;
  Lnu * f;
  char* sign1 = "\\orsep ";
  char* sign2 = "\\andsep ";
  char* sign;
  if (op == And)
    sign = sign2;
  else sign = sign1;
  l = larg;
  if (! l.Est_vide())
    {
      if (op == And) 
	latexoutput << "\\CparsymbB ";
      else latexoutput << "\\DparsymbB ";
      f = l.Tete();
      f->PrintLatex(latexoutput);
      l.Reste();
      while (! l.Est_vide())
	{ f = l.Tete();
	  latexoutput << sign;
	  f->PrintLatex(latexoutput);
	  l.Reste();
	}
      if (op == And) 
	latexoutput << "\\CparsymbE ";
      else latexoutput << "\\DparsymbE ";
    }
}

void LnuTest::PrintLatex(ostream & latexoutput)
{
if ((strcmp(c1,"") != 0) && (n1 != 0))
  latexoutput << c1 << "+" << n1;
else if (strcmp(c1,"") != 0) latexoutput << c1;
else latexoutput << n1;
  
switch(opc) {
  case Inf : latexoutput << "<";break;
  case Infe: latexoutput << "\\leq ";break;
  case Sup : latexoutput << ">";break;
  case Supe: latexoutput << "\\geq ";break;
  case Egal: latexoutput << "=";break;
  case Diff: latexoutput << "\\not = ";break;
  default  : latexoutput << " ? ";break;
	   };
if ((strcmp(c2,"")  != 0) && (n2 != 0))
  latexoutput << c2 << "+" << n2;
else if (strcmp(c2,"") != 0) latexoutput << c2;
else latexoutput << n2;
}

inline void LnuBin::PrintLatex(ostream & latexoutput)
{
  latexoutput << "(";
  f1->PrintLatex(latexoutput);
  if (op == Impl)  latexoutput << "\\Rightarrow ";
  else {latexoutput << "[\\delta)";
    if (lstop) {
      if (! lstop->Est_vide()) {
	latexoutput << "\\";
	Ident_L laux = *lstop;
	latexoutput << laux.Tete();
	laux.Reste();
	while (!laux.Est_vide()) {
	  latexoutput << ","<<laux.Tete();
	  laux.Reste();
	}
      }
    }
    latexoutput << ")";
  }
  f2->PrintLatex(latexoutput);
  latexoutput <<")";
}

inline void LnuVar::PrintLatex(ostream & latexoutput)
{
if (name) {
  if (EstXnum(name)) 
    latexoutput << name[0] << "_{" << ExtVal(name) << "} ";
    else latexoutput << name << " ";
}
else latexoutput << "X_{"<< num << "} ";
}



//---------------------------------------------------------------------
//                               NORMAL
//---------------------------------------------------------------------

// x := x+0 in g -> g
// x in tt -> tt ; x in ff -> ff ; [a] tt -> tt ; <a> ff -> ff ; - - g -> g
// - (x ~ c) -> x -~ c ; - a -> a_ ; - a_ -> a ; E E g -> E g (if E=E); 
// E tt -> tt ; E ff -> ff ; 
// A A g -> A g (if A=A) ; A tt -> tt ; A ff -> ff ; g ^ tt -> g ; 
// g ^ ff -> ff ; g v tt -> tt ; g v ff -> g ; tt => g -> g ; ff => g -> tt
// g => tt -> tt ; g => ff -> -g ; h v h -> h ; h ^ h -> h; [a]ff ^ [a] h = [a] ff

inline Lnu * LnuBool::Normal()
{return this;}

Lnu * LnuMod::Normal()
{
Lnu * res = this;
subf= subf->Normal();
 
switch(op) {
 case In :
  {
     switch(subf->Type()) {
     case Top :
       res = subf;
       delete lab;  // 20-01-98
       delete carg;
       delete this; __CPLNU--;
       break;
     case Bot :
       res = subf;
       delete lab;  // 20-01-98
       delete carg;
       delete this; __CPLNU--;
       break;
     default : 
       if (carg && (Eq_str(lab,carg)) && (iarg == 0)) { // 22-09-99
	 res = subf;
	 delete lab;
	 delete carg;
	 delete this; __CPLNU--;
	 return res;
       }
       break;
     }
   }
  break;
 case Box :
  if (subf->Type() == Top) {
    res = subf;
    delete lab;  // 20-01-98
    delete this; __CPLNU--;
  }
  break;
 case Diam :
  if (subf->Type() == Bot) {
    res = subf;
    delete lab;  // 20-01-98
    delete this; __CPLNU--;
  }
  break;
 default : break;
}
return res;
}


Lnu * LnuUn::Normal()
{LnuUn * aux1;
 Lnu * aux2, *res = this;
 LnuTest * aux3;
 LnuBool * aux4;

 subf = subf->Normal();
 
 switch(op) {
 case Not :
   switch(subf->Type()) {
   case Not :
       aux1 = (LnuUn *) subf;
       aux2 = aux1->subf;
       delete aux1; __CPLNU--;
       delete this; __CPLNU--;
       res = aux2;
       break;
   case Test :
       aux3 = (LnuTest *) subf;
       aux3->InvOPC();
       res = aux3;
       delete this; __CPLNU--;
       break;
   case AP :
   case NAP:
   case Top :
   case Bot :
       aux4 = (LnuBool *) subf;
       aux4->Reverse();
       res = aux4;
       delete this; __CPLNU--;
       break;
   case And :
     if (subf->Is_PG_Impl()) {
       res = subf->Reverse();
       delete this; __CPLNU--;
     }
     break;
   default : break;
     }
   break;
 case Exists :
   switch((subf->Type())) {
   case Exists :
     aux1 = (LnuUn *) subf;  // Attention - hybride !
     if (Eq_lstr(lstop,aux1->lstop)) {
       res = subf;
       DestroyIdent_L(lstop);
       delete this; __CPLNU--;      
     }
     break;
   case Top :
   case Bot :
     res = subf;
     delete this; __CPLNU--;
     break;
   default :
     break;
   }
   break;
 case Forall :
   switch((subf->Type())) {
   case Forall :
     aux1 = (LnuUn *) subf;  // Attention - hybride !
     if (Eq_lstr(lstop,aux1->lstop)) {
       res = subf;
       DestroyIdent_L(lstop);
       delete this; __CPLNU--;      
     }
     break;
   case Top :
   case Bot :
     res = subf;
     delete this; __CPLNU--;
     break;
   default :
     break;
   }
   break;
 default : break;
 }
 return res;
}


Lnu * LnuCD::Normal()
{
  Lnu_L l,l3,laux;
  Lnu * f, *res;
  LnuCD * fao;
  LnuMod * auxbox;
  LnuBool * auxbot = new LnuBool(Bot);
  LnuBool * auxtop = new LnuBool(Top);
  int fin=0, trouve, reduction;
  Ident_L listlab, listlab2;   // contient les labels des [a] ff
  res = this;

  //  cout << " -> LnuCD::Normal... avec : "; Print();cout << endl;

  l.Vide();
  while (! larg.Est_vide()) {
    f=larg.Tete();
    f = f->Normal();
    l.Ajouter(f);
    larg.Reste();
  }
  larg.Vide(); // 20-01-98

  while (!l.Est_vide() && !fin) {
    f = l.Tete();
    l.Cdr();

    // Ajout du 16-06-97 : pour h ^ h = h et h v h = h ...
    // on teste si f est deja dans larg...
    l3 = larg;
    trouve = 0;
    while (!trouve && (! l3.Est_vide())) {
      if (l3.Tete()->Equivalent(f)) trouve = 1;
      l3.Reste();
    }  // faudrait detruire f... Attention pour le nettoyage... fait le 20-01-98
    if (!trouve) {
      switch(f->Type()) {
      case And :
	if (op == And) {
	  fao = (LnuCD *) f;
	  l.Concat(fao->larg);
	  delete f; __CPLNU--; // 20-01-98
	}
	else larg.Ajouter(f);
	break;
      case Or :
	if (op == Or) {
	  fao = (LnuCD *) f;
	  l.Concat(fao->larg);
	  delete f; __CPLNU--; // 20-01-98
	}
	else larg.Ajouter(f);
	break;
      case Bot :
	if (op == And) 
	  {res = f; // new LnuBool(Bot); 21-01-98
	  fin = 1;}
	else f->Destroy(); // 20-01-98
	break;
      case Top : 
	if (op == Or)
	  {res = f; // new LnuBool(Top); 21-01-98
	  fin = 1;}
	else f->Destroy(); //20-01-98
	break;
      case Box :
	auxbox = (LnuMod *) f;
	if (auxbox->Subf()->Equivalent(auxbot)) 
	  listlab.Ajouter(auxbox->Lab());
	larg.Ajouter(f);
	break;
      default :
	larg.Ajouter(f);
      }
    }
    else f->Destroy(); // 20-01-98
  }  // fin de la boucle while  (!l.Est_vide() && ! fin)
  if (fin) 
    {// on doit detruire les formules ds l2 et vider larg.
      while (! l.Est_vide()) {
	f = l.Tete();
	f->Destroy();
	l.Cdr();}
      while (! larg.Est_vide()) {
	f = larg.Tete();
	f->Destroy();
	larg.Cdr();}
      delete this; __CPLNU--;
    }
  else 
    switch(larg.Longueur()) {
    case 1 : 
      res = larg.Tete();
      larg.Vide();
      delete this; __CPLNU--;
      break;
    case 0:
      if (op == And) res = new LnuBool(Top);
      else res = new LnuBool(Bot);
      delete this; __CPLNU--;
      break;
    default :
      Ident action;
      // il reste a reduire les eventuels [a] ff ^ [a] h en [a] ff
      // et a reduire les eventuels [a] ff ^ <a> h en ff
      // et a reduire les eventuels [a] ff v <a> tt en tt

      if ((op == And) && (! listlab.Est_vide())) {
	reduction = 0;
	while (!larg.Est_vide()) {
	  f = larg.Tete();
	  if (f->Type() == Box) {
	    auxbox = (LnuMod *) f;
	    if (! auxbox->Subf()->Equivalent(auxbot)) {
	      action = auxbox->Lab();
	      listlab2 = listlab;
	      trouve = 0;
	      while (! trouve && ! listlab2.Est_vide()) {
		trouve = Eq_str(action,listlab2.Tete());
		listlab2.Reste();
	      }
	      if (! trouve) 
		laux.Ajouter(f);
	      else f->Destroy();
	    }
	    else laux.Ajouter(f);
	  }
	  else if (f->Type() == Diam) {
	    auxbox = (LnuMod *) f;
	    action = auxbox->Lab();
	    listlab2 = listlab;
	    trouve = 0;
	    while (! trouve && ! listlab2.Est_vide()) {
	      trouve = Eq_str(action,listlab2.Tete());
	      listlab2.Reste();
	    }
	    if (! trouve) 
	      laux.Ajouter(f);
	    else {reduction = 1;}  // a ff
	  }
	  else laux.Ajouter(f);
	  larg.Cdr();
	}
	if (! reduction) larg = laux;
	else {
	  res = new LnuBool(Bot);
	  delete this; __CPLNU--;              // 21-01-98
	  while(!laux.Est_vide()) {
	    laux.Tete()->Destroy();
	    laux.Cdr();}
	}
      }  // cas du OU : [a] ff v <a> tt = tt
      else if ((op == Or) && (! listlab.Est_vide())) {
	reduction = 0;
	while (!larg.Est_vide()) {
	  f = larg.Tete();
	  if (f->Type() == Diam) {
	    auxbox = (LnuMod *) f;
	    if (auxbox->Subf()->Equivalent(auxtop)) {
	      action = auxbox->Lab();
	      listlab2 = listlab;
	      trouve = 0;
	      while (! trouve && ! listlab2.Est_vide()) {
		trouve = Eq_str(action,listlab2.Tete());
		listlab2.Reste();
	      }
	      if (! trouve) 
		laux.Ajouter(f);
	      else {reduction = 1;}
	    }
	    else laux.Ajouter(f);
	  }
	  else laux.Ajouter(f);
	  larg.Cdr();
	}
	if (! reduction) larg = laux;
	else {
	  res = new LnuBool(Top);
	  delete this; __CPLNU--;              // 21-01-98
	  while(!laux.Est_vide()) {
	    laux.Tete()->Destroy();
	    laux.Cdr();}
	}
      }
      break;
    }

  //   cout << " <- LnuCD::Normal... avec : "; Print();cout << endl;

auxbot->Destroy();
auxtop->Destroy();
listlab.Vide();
      
  return res;
}

inline Lnu * LnuTest::Normal()
{
Lnu * res = this;
if (Eq_str(c1,"")) {
    if ((n1-n2 <= 0) && opc==Sup) res = new LnuBool(Bot);
    else if ((n1-n2 < 0) && opc==Supe) res = new LnuBool(Bot);
    else if ((n1-n2 <= 0) && opc==Infe) res = new LnuBool(Top);
    else if ((n1-n2 < 0) && opc==Inf) res = new LnuBool(Top); }
else 
if (Eq_str(c2,"")) {
    if ((n2-n1 <= 0) && opc==Inf) res = new LnuBool(Bot);
    else if ((n2-n1 < 0) && opc==Infe) res = new LnuBool(Bot);
    else if ((n2-n1 <= 0) && opc==Supe) res = new LnuBool(Top);
    else if ((n2-n1 < 0) && opc==Sup) res = new LnuBool(Top);
}

 if (res != this) {
   delete this; 
   __CPLNU--;}
return res;
}

inline Lnu * LnuBin::Normal()
{
Lnu * res = this;

// cout << " Entree : ";Print();cout << endl;

f1 = f1->Normal();
f2 = f2->Normal();


 if (op == EUntil) {

  switch(f1->Type()) {
   case Top : 
     f2->Destroy();   
     DestroyIdent_L(lstop);
     delete this; __CPLNU--;
     res = f1;
     break;
   case Bot :
     f1->Destroy();     
     DestroyIdent_L(lstop);
     delete this; __CPLNU--;
     res = f2;
     break;
   default : 
    switch(f2->Type()) {
    case Top :
      res = f2;
      f1->Destroy();
      DestroyIdent_L(lstop);
      delete this;__CPLNU--;
      break;
    case Bot :
      f2->Destroy(); // debugg 
      res = new LnuUn(Forall,f1,lstop);
      delete this;__CPLNU--;
      break;
    default :
      break;
    }
   }
 } else { // => 

   switch(f1->Type()) {
   case Top : 
     f1->Destroy();   // 21-01-98
     delete this; __CPLNU--;
     res = f2;
     break;
   case Bot :
     res = new LnuBool(Top);
     f1->Destroy();     // ajout du 21-01-98
     f2->Destroy();
     delete this; __CPLNU--;
     break;
   default : 
    switch(f2->Type()) {
    case Top :
      res = f2;        // 21-01-98 au lieu de new LnuBool(Top)
      f1->Destroy();
      delete this;__CPLNU--;
      break;
    case Bot :
      //      res = new LnuUn(Not,f1);
      res = f1->Reverse();
      res = res->Normal();
      f2->Destroy(); // 21-01-98
      delete this;__CPLNU--;
      break;
    case Impl : {
      LnuBin * auximpl = (LnuBin *) f2;
      Lnu * aux1 = auximpl->f1;
      Lnu * aux2 = auximpl->f2;
      Lnu * auxcd;
      auxcd = new LnuCD(And,f1,aux1);
      auxcd = auxcd->Normal();
      f1 = auxcd;
      delete f2; __CPLNU--;
      f2 = aux2;
    }
      break; 
    default :
      break;
    }
   }
 }

return res;
}

inline Lnu * LnuVar::Normal()
  {return this;}



//-----------------------------------------------------------
//                        ELIM_IDENT
//-----------------------------------------------------------

Lnu * LnuBool::ElimIdent(Map_int * ,Map_int * ,int & )
{return this;}


Lnu * LnuMod::ElimIdent(Map_int * MaR,Map_int * MdR,int & nv)
{
subf = subf->ElimIdent(MaR,MdR,nv);
return this;
}

Lnu * LnuUn::ElimIdent(Map_int * MaR,Map_int * MdR,int & nv)
{
subf = subf->ElimIdent(MaR,MdR,nv);
return this;
}

Lnu * LnuCD::ElimIdent(Map_int * MaR,Map_int * MdR,int & nv)
{
Lnu * aux;
Lnu_L lres, laux = larg;

while (! larg.Est_vide()) {
  aux = larg.Tete();
  aux = aux->ElimIdent(MaR,MdR,nv);
  lres.Ajouter(aux);
  larg.Reste();
}
laux.Vide();
larg = lres;
return this;
}

Lnu * LnuTest::ElimIdent(Map_int * ,Map_int * ,int & )
{return this;}


Lnu * LnuBin::ElimIdent(Map_int * MaR,Map_int * MdR,int & nv)
{
f1 = f1->ElimIdent(MaR,MdR,nv);
f2 = f2->ElimIdent(MaR,MdR,nv);
return this;
}


Lnu * LnuVar::ElimIdent(Map_int * MaR,Map_int * MdR,int & nv)
{
Lnu * res;
int Numero;

if (MdR->Est_defr(name,Numero)) res = new LnuVar(Numero);
else
if (MaR->Est_defr(name,Numero)) res = new LnuVar(Numero);
else
  {
    MaR->Ajouter(name,nv);
    res = new LnuVar(nv);
    nv++;
  }
if (name)
  delete name;
delete this; __CPLNU--;

return res;
}

//------------------------------------------------------------
//                           NORM_F
//------------------------------------------------------------

Lnu * LnuBool::NormF(Number<int> * ,Number<int> * ,int & ,
Number<Pt_Lnu> * )
{return this;}

Lnu * LnuMod::NormF(Number<int> * MaR,Number<int> * MdR,int & nv,
Number<Pt_Lnu> * D)
{
  //Lnu * aux;
subf = subf->NormF(MaR,MdR,nv,D);
 if ((subf->Type() == And) || (subf->Type() == Or) || 
     (__FIXPOINT && (subf->Type()==Impl)))
  { 
    D->Ajouter(nv,subf);
    subf = new LnuVar(nv);
    nv++;
  }
return this;
}

Lnu * LnuUn::NormF(Number<int> * MaR,Number<int> * MdR,int & nv,
Number<Pt_Lnu> * D)
{
  //Lnu * aux, * auxv;
subf = subf->NormF(MaR,MdR,nv,D);
 if ((subf->Type() == And) || (subf->Type() == Or) || 
     (__FIXPOINT && (subf->Type()==Impl)))
  { 
    D->Ajouter(nv,subf);
    subf = new LnuVar(nv);
    nv++;
  }
return this;
}

Lnu * LnuCD::NormF(Number<int> * MaR,Number<int> * MdR,int & nv,
Number<Pt_Lnu> * D)
{
  Lnu * aux; //, * auxv;
Lnu_L laux = larg;
Lnu_L lres;

switch(op) {
 case And :
  while (!laux.Est_vide()) {
    aux = laux.Tete();
    aux = aux->NormF(MaR,MdR,nv,D);
    if ((aux->Type() == Or) || (__FIXPOINT && (aux->Type()==Impl)))
      {
      D->Ajouter(nv,aux);
      aux = new LnuVar(nv);
      nv++;
      lres.Ajouter(aux);
    }
    else lres.Ajouter(aux);
    laux.Reste();
  }
  break;
 case Or :
  while (!laux.Est_vide()) {
    aux = laux.Tete();
    aux = aux->NormF(MaR,MdR,nv,D);
    if ((aux->Type() == And) || (__FIXPOINT && (aux->Type() == Impl)))
      {
      D->Ajouter(nv,aux);
      aux = new LnuVar(nv);
      nv++;
      lres.Ajouter(aux);
    }
    else lres.Ajouter(aux);
    laux.Reste();
  }
  break;
 default : break;
}
larg = lres;
return this;
}

Lnu * LnuTest::NormF(Number<int> * ,Number<int> * ,int & ,
Number<Pt_Lnu> * )
{
if (opc != Diff) 
  return this;

LnuTest * aux = new LnuTest(Sup,c1,n1,c2,n2);
Lnu_L lres;
opc = Inf;
lres.Ajouter(this);
lres.Ajouter(aux);
return new LnuCD(Or,lres);

}

Lnu * LnuBin::NormF(Number<int> * MaR,Number<int> * MdR,int & nv,
Number<Pt_Lnu> * D)
{
Lnu * aux;

 if (op == Impl) {
   if (f1->Is_PG_Impl()) 
     {
       f2 = f2->NormF(MaR,MdR,nv,D);
       if ((f2->Type() == And) || (f2->Type() == Or)) 
	 { 
	   D->Ajouter(nv,f2);
	   f2 = new LnuVar(nv);
	   nv++;
	 }
       return this;
     }
   
   f1 = f1->Reverse();
   aux = new LnuCD(Or,f1,f2);
   aux = aux->NormF(MaR,MdR,nv,D);
   return aux;
 }
 else {  // EUntil

   f1 = f1->NormF(MaR,MdR,nv,D);
   f2 = f2->NormF(MaR,MdR,nv,D);

   if ((f1->Type() == And) || (f1->Type() == Or))
     { 
       D->Ajouter(nv,f1);
       f1 = new LnuVar(nv);
       nv++;
     }
   if ((f2->Type() == And) || (f2->Type() == Or) || 
     (__FIXPOINT && (f2->Type()==Impl)))
     { 
       D->Ajouter(nv,f2);
       f2 = new LnuVar(nv);
       nv++;
     }
   return this;
 }

}

Lnu * LnuVar::NormF(Number<int> * MaR,Number<int> * MdR,int & nv,
Number<Pt_Lnu> * )
{
Lnu * res;
int Nom;

if (MdR->Est_defr(num,Nom)) res = new LnuVar(Nom);
else
if (MaR->Est_defr(num,Nom)) res = new LnuVar(Nom);
else
  {
    MaR->Ajouter(num,nv);
    res = new LnuVar(nv);
    nv++;
  }
if (name) delete name;
name = 0;
delete this; __CPLNU--;
return res;
}

//--------------------------------------------------------------------
//                        SUBSTITUTE
//--------------------------------------------------------------------

inline Lnu * LnuBool::Substitute(NFDeclaration )
{return this;}

Lnu * LnuMod::Substitute(NFDeclaration d)
{
subf = subf->Substitute(d);
return this;
}

Lnu * LnuUn::Substitute(NFDeclaration d)
{
subf = subf->Substitute(d);
return this;
}

Lnu * LnuCD::Substitute(NFDeclaration d)
{
Lnu_L laux = larg;
Lnu_L lres;
Lnu * aux;

while (!larg.Est_vide()) {
  aux = larg.Tete();
  lres.Ajouter(aux->Substitute(d));
  larg.Reste();
}
laux.Vide();
larg = lres;
return this;
}

Lnu * LnuTest::Substitute(NFDeclaration )
{return this;}

Lnu * LnuBin::Substitute(NFDeclaration d)
{
  //  cout << "entry - LnuBin:Subst" << endl;
  //  this->Print(); cout << endl;

f1 = f1->Substitute(d);
f2 = f2->Substitute(d);
// cout << "quit - LnuBin:Subst" << endl;

return this;
}

Lnu * LnuVar::Substitute(NFDeclaration d)
{
Lnu * res = this;
//Lnu * aux;
// cout << "LnuVar::Substitute : " << num << endl;
if (d[num]) {
  res = d[num]->Copy();
  Destroy();
}
return res;
}


//---------------------------------------------------------------------
//                         SUBSTITUTE_F
//---------------------------------------------------------------------

Lnu * LnuBool::SubstituteF(LnuTest * ,Lnu * )
{return this;}

Lnu * LnuMod::SubstituteF(LnuTest * f,Lnu * g)
{
subf = subf->SubstituteF(f,g);
return this;
}

Lnu * LnuUn::SubstituteF(LnuTest * f,Lnu * g)
{
subf = subf->SubstituteF(f,g);
return this;
}

Lnu * LnuCD::SubstituteF(LnuTest * f,Lnu * g)
{
Lnu_L laux = larg;
Lnu_L lres;
Lnu * aux;

while (!larg.Est_vide()) {
  aux = larg.Tete();
  lres.Ajouter(aux->SubstituteF(f,g));
  larg.Reste();
}
laux.Vide();
larg = lres;
return this;
}

Lnu * LnuTest::SubstituteF(LnuTest * f,Lnu * g)
{
if (this->Equivalent(f)) 
  return g->Copy();
else return this;
}

Lnu * LnuBin::SubstituteF(LnuTest * f,Lnu * g)
{
f1 = f1->SubstituteF(f,g);
f2 = f2->SubstituteF(f,g);
return this;
}

Lnu * LnuVar::SubstituteF(LnuTest * ,Lnu * )
{return this;}

//-------------------------------------------------------------------
//                      NF_SUBSTITUTE
//-------------------------------------------------------------------

void LnuBool::NF_Substitute(int * ,int * )
{return ;}


void LnuMod::NF_Substitute(int * Tab,int * Sub)
{subf->NF_Substitute(Tab,Sub);}

void LnuUn::NF_Substitute(int * Tab,int * Sub)
{subf->NF_Substitute(Tab,Sub);}

void LnuCD::NF_Substitute(int * Tab,int * Sub)
{
Lnu_L laux = larg;
while (! laux.Est_vide()) {
  laux.Tete()->NF_Substitute(Tab,Sub);
  laux.Reste();
}
}

void LnuTest::NF_Substitute(int * ,int * )
{return;}

void LnuBin::NF_Substitute(int * Tab,int * Sub)
{f1->NF_Substitute(Tab,Sub);
f2->NF_Substitute(Tab,Sub);}


void LnuVar::NF_Substitute(int * Tab,int * Sub)
{
char t[20];
// cout << "LnuVar::NF_sub  " << name << " ("<<num<<") -> ";
// cout << "Sub[Tab[num]] = " << Sub[Tab[num]] << endl;
if (Sub[Tab[num]] != num) {
  num = Sub[Tab[num]];
  NewName(t,num);
  name = strcpy(new char [strlen(t)+1],t);
}
}

//-------------------------------------------------------------------
//                      HZ_SUBSTITUTE
//-------------------------------------------------------------------

Lnu * LnuBool::Hz_Substitute(Pt_Zone ,int *,int *,Pt_Zone * * ,Zone * * )
{return this;}


Lnu * LnuMod::Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc)
{
  //  cout << " -> Hz_substitute Mod :" << endl;
  // Print();cout << endl;

if (op == In) 
  {
    Zone * zaux = z->Copy();
    zaux->Projection(lab,carg,iarg);
    subf = subf->Hz_Substitute(zaux,Im,Nz,hz,tabc);
    zaux->Destroy();
  }
else subf = subf->Hz_Substitute(z,Im,Nz,hz,tabc);

//cout << " <- Hz_substitute Mod :" << endl;
//Print();cout << endl;
return this;
}

Lnu * LnuUn::Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc)
{
  //  cout << " -> Hz_substitute Un :" << endl;
  // Print(); cout << endl;

if (op == Not) 
  {cout << " Erreur dans LnuUn::Hz_Substitute !! " << endl;
   return this;}

// A patcher: Hybride !
Zone * zaux = z->Add_FutureC(lstop);
subf = subf->Hz_Substitute(zaux,Im,Nz,hz,tabc);
zaux->Destroy();

// cout << " <- Hz_substitute Un :" << endl;
// Print(); cout << endl;

return this;
}

Lnu * LnuCD::Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc)
{
Lnu_L lres;
Lnu * aux;

// cout << " -> Hz_substitute CD :" << endl;
// Print(); cout << endl;

while (! larg.Est_vide()) {
  aux = larg.Tete()->Hz_Substitute(z,Im,Nz,hz,tabc);
  lres.Ajouter(aux);
  larg.Cdr();
}
larg = lres;

// cout << " <- Hz_substitute CD :" << endl;
// Print(); cout << endl;

return this;
}

Lnu * LnuTest::Hz_Substitute(Pt_Zone ,int *,int *,Pt_Zone * * ,Zone * * )
{
  // cout << " <-> Hz_substitute Test :" << endl;
  // Print(); cout <<endl;
return this;}

Lnu * LnuBin::Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc)
{
  // cout << " -> Hz_substitute Bin :" << endl;
  // Print();cout << endl;

  if (op == EUntil) {  // on propage le futur dans f1 et f2 comme Exits et Forall
    Zone * zaux = z->Add_FutureC(lstop);
    f1 = f1->Hz_Substitute(zaux,Im,Nz,hz,tabc);
    f2 = f2->Hz_Substitute(zaux,Im,Nz,hz,tabc);
    zaux->Destroy();
    return this;
  }
  
  // Impl : 
  if (! f1->Is_PG_Impl()) 
    {cout << " LnuBin::Hz_Substitute() ! Pas de forme normale ! " << endl;
      return this;}

  Definition auxDef ;
  SetReg * saux = (SetReg *) f1->StateSat(z->Get_RegionG(),auxDef);
  Zone * zaux;

  assert(saux->Get_lz().Longueur() < 2);  // conjonction de zones

  if (saux->Get_lz().Longueur() == 1) {
    zaux = saux->FstZone();
    zaux->Intersection(z);
    f2->Hz_Substitute(zaux,Im,Nz,hz,tabc);
  }
  saux->Destroy(); // zaux est detruite dans saux !!!

  // cout << " <- Hz_substitute Bin :" << endl;
  // Print();cout << endl;

  return this;
}


Lnu * LnuVar::Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc)
{
char t[20];
Zone * zfuture = z->Add_FutureC();
Zone * zaux;
int i;

// cout << " -> Hz_substitute Var: "<< num  << endl;
// Print(); cout << endl;
// cout << " avec : ";z->Print();cout << endl;
// cout << " et comme contraintes : ";tabc[num]->Print();cout << endl;
// cout << "nb de hzones pour "<< num << " : " << Nz[num] << endl;

// Ajout du 17-06-97
if (z->Est_vide()) {
  if (PTRACE) 
    cout << "X"<<num<<" is replaced by tt..." << endl;
  zfuture->Destroy();
  return new LnuBool(Top);
}

zaux = z->Copy();
zaux->Intersection(tabc[num]);
if (zaux->Est_vide()) {
  zaux->Destroy();
  zfuture->Destroy();
  //XXXX  delete name;
  if (PTRACE) 
    cout << " <- Hz_substitute var : avec ff" << endl;
  return new LnuBool(Bot);
}
zaux->Destroy();


// ENORME ERREUR :   i < Nz[i]   !
i=0;
if (SIMPLSPLIT == 2) 
  while ((i < Nz[num]) && (! hz[num][i]->Est_equiv(z)) && (! hz[num][i]->Est_equiv(zfuture))) i++;
else if (SIMPLSPLIT == 3) 
  while ((i < Nz[num]) && (! hz[num][i]->Est_equiv(z))) i++;
else 
  while ((i < Nz[num]) && (! hz[num][i]->Est_inclu(z))) i++;

zfuture->Destroy();

if (i < Nz[num]) {
  num = Im[num]+i;
  NewName(t,num);
  //XXXX  delete name;
  name = strcpy(new char [strlen(t)+1],t);
} else {
  cout << " Erreur dans LnuVar::Hz_Substitute(...) : " << num << " in ";
  z->Print();cout << endl;
}

// cout << " <- Hz_substitute var " << endl;
// Print(); cout << endl;

return this;	 
}

//----------------------------------------------------------------
//                      EST_EQUIV_MOD
//----------------------------------------------------------------

int LnuBool::Est_equiv_mod(Lnu * g,int * )
{return Equivalent(g);}

int LnuMod::Est_equiv_mod(Lnu * g,int * Tab)
{
LnuMod * aux;
Map_int l1, l2;
Lnu * sf1, * sf2;
int res;

if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuMod *) g;
switch(op) {
 case Diam :
 case Box :  res = ((Eq_str(lab,aux->lab)) && 
                    (subf->Est_equiv_mod(aux->subf,Tab)));
	     break;
 case In : sf1 = this->Subf_In();
           sf2 = g->Subf_In();
	   if (carg) {
	     if (aux->carg) 
	       if ((Eq_str(lab,aux->lab)) && (Eq_str(carg,aux->carg)) && 
		   (iarg == aux->iarg) && (subf->Equivalent(aux->subf))) return 1;
	       else return 0;
	   }
   if (aux->carg) return 0;
   // on sait que x:=k et x':=k'...

   l1 = this->LclocksR();
   l2 = g->LclocksR();
   if (sf1->Est_equiv_mod(sf2,Tab)) {
     Map_int l1p, l2p;
     int trouve = 1;
     l1p = l1;
     while ((! l1p.Est_vide()) && (trouve)) {
       l2p = l2;
       trouve = 0;
       while ((!l2p.Est_vide()) && (! Eq_str(l1p.TeteN(),l2p.TeteN())))
	 l2p.Reste();
       if ((!l2p.Est_vide()) && (l2p.Tete() == l1p.Tete()))
	 trouve = 1;
       l1p.Reste();
     }
     if ((l1p.Est_vide()) && (trouve)) {
       l2p = l2;
       while ((! l2p.Est_vide()) && (trouve)) {
	 l1p = l1;
	 trouve = 0;
	 while ((!l1p.Est_vide()) && (! Eq_str(l1p.TeteN(),l2p.TeteN())))
	   l1p.Reste();
	 if ((! l1p.Est_vide()) && (l2p.Tete() == l1p.Tete()))
	     trouve = 1;
	 l2p.Reste();
       }
       if ((l2p.Est_vide()) && (trouve)) res = 1;
       else res =0;
     }
     else res = 0;
   }
   else res = 0;
   //	   cout << " Est_equiv_mod -> " << endl;
   break;
 default :
   break;
}
return res;
}

int LnuUn::Est_equiv_mod(Lnu * g,int * Tab)
{
LnuUn * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuUn *) g;
if (! Eq_lstr(lstop,aux->lstop)) return 0;
return (subf->Est_equiv_mod(aux->subf,Tab));
}

int LnuCD::Est_equiv_mod(Lnu * g,int * Tab)
{
  //int res = 1, resint=1;
int resint=1;
LnuCD * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuCD *) g;

Lnu_L l1, l2;
l1 = larg;
Lnu * aux1, * aux2;
while ((!l1.Est_vide()) && resint) {
  aux1 = l1.Tete();
  l2 = aux->larg;
  resint = 0;
  while ((!l2.Est_vide()) && ! resint) {
    aux2 = l2.Tete();
    if (aux1->Est_equiv_mod(aux2,Tab)) resint=1;
    l2.Reste();
  }
  l1.Reste();
}
if (! resint) return 0;

l2 = aux->larg;
while ((!l2.Est_vide()) && resint) {
  aux1 = l2.Tete();
  l1 = larg;
  resint = 0;
  while ((!l1.Est_vide()) && ! resint) {
    aux2 = l1.Tete();
    if (aux1->Est_equiv_mod(aux2,Tab)) resint=1;
    l1.Reste();
  }
  l2.Reste();
}
return resint;
}

int LnuTest::Est_equiv_mod(Lnu * g,int * )
{return (this->Equivalent(g));}

int LnuBin::Est_equiv_mod(Lnu * g,int * Tab)
{
LnuBin * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;

 if (op == EUntil) {
   aux = (LnuBin *) g;
   if (! Eq_lstr(lstop,aux->lstop)) return 0;
   return ((f1->Est_equiv_mod(aux->f1,Tab)) && (f2->Est_equiv_mod(aux->f2,Tab)));
 } 
 else {
   aux = (LnuBin *) g;
   return ((f1->Est_equiv_mod(aux->f1,Tab)) && (f2->Est_equiv_mod(aux->f2,Tab)));
 }
}

int LnuVar::Est_equiv_mod(Lnu * g,int * Tab)
{
LnuVar * aux;
if (g == 0) return 0;
if (g->Type() != Var) return 0;
aux = (LnuVar *) g;
return (Tab[num] == Tab[aux->GetNum()]);
}


//----------------------------------------------------------------
//                        EQUIVALENT
//----------------------------------------------------------------

int LnuBool::Equivalent(Lnu * g)
{LnuBool * aux;
if (g == 0) return 0;
switch (g->Type()) {
 case Bot :
 case Top :
  return (op == g->Type());
 case AP :
  aux = (LnuBool *) g;
  return (op == AP) ? (Eq_str(aux->Prop(),prop) && Eq_str(aux->Nta(),nta)) : 0;
 case NAP :
  aux = (LnuBool *) g;
  return (op == NAP) ? (Eq_str(aux->Prop(),prop) && Eq_str(aux->Nta(),nta)) : 0;
  default : return 0;
}
}

int LnuMod::Equivalent(Lnu * g)
{
LnuMod * aux;
Map_int l1, l2;
Lnu * sf1, * sf2;

int res;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuMod *) g;
switch(op) {
 case Diam :
 case Box :  
   res = (Eq_str(lab,aux->lab)) && (subf->Equivalent(aux->subf));
   break;
 case In : 
   sf1 = this->Subf_In();
   sf2 = g->Subf_In();  // remq: si carg=/=0, this = sf1 !!!
   if (carg) {
     if (aux->carg) 
       if ((Eq_str(lab,aux->lab)) && (Eq_str(carg,aux->carg)) && 
	   (iarg == aux->iarg) && (subf->Equivalent(aux->subf))) return 1;
     else return 0;
   }
   if (aux->carg) return 0;
   // on sait que x:=k et x':=k'...

   l1 = this->LclocksR();
   l2 = g->LclocksR();
   if (sf1->Equivalent(sf2)) {
     Map_int l1p, l2p;
     int trouve = 1;
     l1p = l1;
     while ((! l1p.Est_vide()) && (trouve)) {
       l2p = l2;
       trouve = 0;
       while ((!l2p.Est_vide()) && (! Eq_str(l1p.TeteN(),l2p.TeteN())))
	 l2p.Reste();
       if ((!l2p.Est_vide()) && (l2p.Tete() == l1p.Tete()))
	 trouve = 1;
       l1p.Reste();
     }
     if ((l1p.Est_vide()) && (trouve)) {
       l2p = l2;
       while ((! l2p.Est_vide()) && (trouve)) {
	 l1p = l1;
	 trouve = 0;
	 while ((!l1p.Est_vide()) && (! Eq_str(l1p.TeteN(),l2p.TeteN())))
	   l1p.Reste();
	 if ((!l1p.Est_vide()) && (l2p.Tete() == l1p.Tete()))
	   trouve = 1;
	 l2p.Reste();
       }
       if ((l2p.Est_vide()) && (trouve)) res = 1;
       else res =0;
     }
     else res = 0;
   }
   else res = 0;
   break;
 default :
   break;
	   }
return res;
}
int LnuUn::Equivalent(Lnu * g)
{
LnuUn * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuUn *) g;
if (! Eq_lstr(lstop,aux->lstop)) return 0;
return (subf->Equivalent(aux->subf));
}

int LnuCD::Equivalent(Lnu * g)
{
int resint=1;
LnuCD * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuCD *) g;

Lnu_L l1, l2;
l1 = larg;
Lnu * aux1, * aux2;
while ((!l1.Est_vide()) && resint) {
  aux1 = l1.Tete();
  l2 = aux->larg;
  resint = 0;
  while ((!l2.Est_vide()) && ! resint) {
    aux2 = l2.Tete();
    if (aux1->Equivalent(aux2)) resint=1;
    l2.Reste();
  }
  l1.Reste();
}
if (! resint) return 0;

l2 = aux->larg;
while ((!l2.Est_vide()) && resint) {
  aux1 = l2.Tete();
  l1 = larg;
  resint = 0;
  while ((!l1.Est_vide()) && ! resint) {
    aux2 = l1.Tete();
    if (aux1->Equivalent(aux2)) resint=1;
    l1.Reste();
  }
  l2.Reste();
}
return resint;
}

int LnuTest::Equivalent(Lnu * g)
{
int res;
LnuTest * aux;
if (g == 0) return 0;
if (g->Type() != Test) return 0;
aux = (LnuTest *) g;
if (Eq_str(Get_c1(),aux->Get_c1())) {
  if (! Eq_str(Get_c2(),aux->Get_c2())) res = 0;
  else res = ((Get_opc() == aux->Get_opc()) && 
	      ((Get_n1()-Get_n2())==(aux->Get_n1()-aux->Get_n2())));}
else 
  if (Eq_str(Get_c1(),aux->Get_c2())) {
  if (! Eq_str(Get_c2(),aux->Get_c1())) res = 0;
  else res = ((Get_opc() == Aux_eq(aux->Get_opc())) && 
	      ((Get_n1()-Get_n2())==(aux->Get_n2()-aux->Get_n1())));}
else res = 0;
return res;
}

int LnuBin::Equivalent(Lnu * g)
{
LnuBin * aux;
if (g == 0) return 0;
if (g->Type() != op) return 0;
aux = (LnuBin *) g;

 if (op== EUntil) 
   if (! Eq_lstr(lstop,aux->lstop)) return 0;

return ((f1->Equivalent(aux->f1)) && (f2->Equivalent(aux->f2)));
}

int LnuVar::Equivalent(Lnu * g)
{
LnuVar * aux;
if (g == 0) return 0;
if (g->Type() != Var) return 0;
aux = (LnuVar *) g;
if (name) return (Eq_str(name,aux->name));
else return (num == aux->num);
}



//------------------------------------------------------------------
//                              EST_SUBF
//------------------------------------------------------------------

int LnuBool::Est_subf(Lnu * g)
{return this->Equivalent(g);}

int LnuMod::Est_subf(Lnu * g)
{
if (this->Equivalent(g)) return 1;
return subf->Est_subf(g);
}

int LnuUn::Est_subf(Lnu * g)
{
if (this->Equivalent(g)) return 1;
return subf->Est_subf(g);
}

int LnuCD::Est_subf(Lnu * g)
{
if (this->Equivalent(g)) 
  {return 1;}
int res = 0;
Lnu_L laux = larg;
Lnu * aux;

while ((!laux.Est_vide()) && (!res)) {
  aux = laux.Tete();
  res = aux->Est_subf(g);
  laux.Reste();
}
return res;
}

int LnuTest::Est_subf(Lnu * g)
{return (this->Equivalent(g));}

int LnuBin::Est_subf(Lnu * g)
{
if (this->Equivalent(g)) return 1;
return (f1->Est_subf(g) || f2->Est_subf(g));
}

int LnuVar::Est_subf(Lnu * g)
{return (this->Equivalent(g));}

//-----------------------------------------------------------------
//                            QUOTIENT
//-----------------------------------------------------------------

Lnu * LnuBool::Quotient(Config * cf,Liste<Quotvar> * ,Liste<Quotvar> * , int & )
{ 
  //  int trouve = 0;
  int satprop, pstar, pta;
  Ident noeud,confta;
  Ident_L * lp;
  LnuBool * res;
  switch (op) {
  case Top :
  case Bot :
    res = new LnuBool(op);
    break;
  case AP :
    pstar = Eq_str("*",nta);
    confta = cf->Get_nta();
    noeud  = cf->Get_noeud();
    pta = Eq_str(confta,nta);
    lp = cf->Get_ta()->Get_Noeud().Recherche(noeud);
    if (lp) {
      Ident_L Lp = (*lp);
      satprop = 0;
      while ((! Lp.Est_vide()) && !satprop) {
	satprop = Eq_str(Lp.Tete(),prop);
	Lp.Reste();
      }
    } else satprop = 0;

    if ((satprop) && (pstar || pta)) res = new LnuBool(Top);
    else if (pta && Eq_str(noeud,prop)) res = new LnuBool(Top); // nouveau: AT
    else if (pta && !satprop) res = new LnuBool(Bot);
    else res = new LnuBool(AP,prop,nta);
    break;
  case NAP :
    pstar = Eq_str("*",nta);
    confta = cf->Get_nta();
    noeud  = cf->Get_noeud();
    pta = Eq_str(confta,nta);
    lp = cf->Get_ta()->Get_Noeud().Recherche(noeud);
    if (lp) {
      Ident_L Lp = (*lp);
      satprop = 0;
      while ((! Lp.Est_vide()) && !satprop) {
	satprop = Eq_str(Lp.Tete(),prop);
	Lp.Reste();
      }
    } else satprop = 0;
    if ((satprop) && (pstar || pta)) res = new LnuBool(Bot);
    else if (pta && Eq_str(noeud,prop)) res = new LnuBool(Bot); // nouveau: AT
    else if (pta && !satprop) res = new LnuBool(Top);
    else res = new LnuBool(NAP,prop,nta);
    break;
  default :
    break;
  }
  return res;
}


Lnu * ExtendedGuard(Lnu * g,Lnu * invsrc,Lnu * invdest, Assign_L lcl)
{
  // g est la garde originale; invdest et invsrc sont des copies 

  // d'abord: si invdest = true, alors on retourne g->Copy
  // cas 1 : r in Inv(n') equiv true
  // cas 2 : g equiv true
  // cas 3 : invsrc = Top      dans ce cas, il faut le detruire !!

  //  cout << "ExtendedGuard : ";g->Print();cout << " - ";
  //  invsrc->Print();cout << " - "; invdest->Print();cout << endl;


int cas1=0,cas2=0;
Lnu * res;
SetReg * sr1, *sr2;
Lnu *auxf2;
Lnu *aux;
Specif * spaux;
RegionGraph * rg;
Assign_L lcaux, lcinv;
Assign ass;

/*  on ameliore en regardant si invsrc => g, auquel cas on retourne Top 

 if (invdest->Type() == Top) {
   invsrc->Destroy();
   invdest->Destroy();
   return g->Copy();
 }
*/

/*
 cout << " -> Extended guard avec : " << endl;
 cout << "g      = "; g->Print(); cout << endl;
 cout << "invsrc = "; invsrc->Print();cout << endl;
 cout << "invdest= "; invdest->Print();cout << endl;
*/

// auxf2 = " r in Inv(n') "
 auxf2 = invdest;
 lcaux = lcl;
 while (! lcl.Est_vide()) {
   ass = lcl.Tete();
   lcinv.Ajouter(ass);
   lcl.Reste();
 }
 while (! lcinv.Est_vide()) {
   ass = lcinv.Tete();
   auxf2 = new LnuMod(In,ass._ci,ass._cj,ass._k,auxf2);
   lcinv.Cdr();
 }

 // on va travailler sur le region graph associe a`  g, invdest et invsrc :

 aux = new LnuCD(And,g->Copy(),invsrc->Copy());
 aux = new LnuCD(And,aux,auxf2->Copy());
 spaux = new Specif(aux);
 rg = spaux->RegionG();
 // spaux->Destroy(); ?? 
 aux->Destroy();

 // cas 1: Inv(n) |= r in Inv(n') 
 // ie:    invsrc |= r in invdest

 if (invdest->Type() == Top) 
   cas1=1;   // trivialement vrai
 else {
   sr1 = (SetReg *) auxf2->StateSat(rg,0);  // [[ r in invdest ]]
   sr2 = (SetReg *) invsrc->StateSat(rg,0); // [[ invsrc ]]
   if (sr1->Est_inclu(sr2)) 
     cas1 = 1;
   else cas1 = 0;

   sr1->Destroy();
   sr2->Destroy();
 }


 // cas 2: g = tt ou invsrc |= g

 if (g->Type() == Top) 
   cas2 = 1;
 else {
   sr1 = (SetReg *) g->StateSat(rg,0);      // [[ g ]]
   sr2 = (SetReg *) invsrc->StateSat(rg,0); // [[ invsrc ]]
   if (sr1->Est_inclu(sr2)) 
     cas2 = 1;
   else cas2 = 0;  
   sr1->Destroy();
   sr2->Destroy();
 }

 // cas1 & cas 2 : Top
 // cas1         : g
 // cas2         : r in invdest
 // sinon        : (g ^ r in invdest)


 if (cas1 && cas2) {
   res = new LnuBool(Top);
   auxf2->Destroy();
 }
 else 
   if (cas1) {
     res = g->Copy();
     auxf2->Destroy();
   }
   else if (cas2) {
     res = auxf2;
   }
   else {
     res = new LnuCD(And,g->Copy(),auxf2);
   }

invsrc->Destroy();
rg->Destroy();

return res;


return res;
}


Lnu * LnuMod::Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv)
{  
  Lnu_L lres;
  Lnu * res, *aux, *extguard;
  Pt_Synch_Vect_L lvs;
  Synch_Vect * sv, * sv2 = (Synch_Vect *) 0;
  Transition_L lt;
  Transition * t;
  Config * cf2;
  Assign_L lc, lcinv;
  Assign ass;

  //  cout << " LnuMod:Quotient -> " << endl; Print(); cout << endl;

  if (op == In)
    { aux = subf->Quotient(cf,lvAq,lvDq,nv);
      res = new LnuMod(In,lab,carg,iarg,aux);

      //  cout << " LnuMod:Quotient <- " << endl << "Avec : "; res->Print(); cout << endl;

      return res;
    }

  if (cf->Get_fs()->Est_def(lab)) lvs = *(cf->Get_fs()->Recherche(lab));
  else { // il n'y a pas d'entree lab dans la table de synchro
    if (cf->Get_fs()->Est_def("*")) {
      lvs = *(cf->Get_fs()->Recherche("*"));
      sv = lvs.Tete();
      if (Eq_str(sv->Get_la(),"*") && Eq_str(sv->Get_lb(),"")) {
	//  * -> (*,_)  l'automate quotiente' ne fait rien...
	aux = subf->Quotient(cf,lvAq,lvDq,nv);
	res = new LnuMod(op,lab,aux);

	//  cout << " LnuMod:Quotient <- " << endl << "Avec : "; res->Print(); cout << endl;

	return res;
      }
      if (Eq_str(sv->Get_la(),"") && Eq_str(sv->Get_lb(),"*")) {
	// * -> (_,*)  l'automate quotiente fait lab...
	sv2 = new Synch_Vect("",lab);
	lvs.Ajouter(sv2);
      }
      // on pourrait definir * -> (*,*) : la synchro forte... On verra plus tard !
    }
    else {  // ni lab, ni * n'est defini...
      cout << " WARNING ! strange synchronization for : "<<lab << endl;
      if (op == Box) res = new LnuBool(Top);
      else res = new LnuBool(Bot);

      //   cout << " LnuMod:Quotient <- " << endl << "Avec : "; res->Print(); cout << endl;

      return res;
    }
  }
  
  while (! lvs.Est_vide()) 
    {
      sv = lvs.Tete();
      if (! Eq_str(sv->Get_lb(),"")) {
	lt = cf->Get_ta()->Get_T_from_n_l(cf->Get_noeud(),sv->Get_lb());
	while (! lt.Est_vide()) {
	  t = lt.Tete();
	  lt.Reste();
	  cf2 = new Config(t->To(),cf->Get_nta(),cf->Get_ta(),cf->Get_fs());
	  aux = subf->Quotient(cf2,lvAq,lvDq,nv);
	  cf2->Destroy();  // 1-04-98 ?????
	  lc = * t->Get_rs();
	  // on inverse lc pour respecter l'ordre des affectations...
	  while (! lc.Est_vide()) {
	    ass = lc.Tete();
	    lcinv.Ajouter(ass);
	    lc.Reste();
	  }
	  while (! lcinv.Est_vide())
	    { ass = lcinv.Tete();
	      aux = new LnuMod(In,ass._ci,ass._cj,ass._k,aux);
	      lcinv.Cdr(); }

	  switch(op) {
	  case Diam : 
	    if (! Eq_str(sv->Get_la(),"")) 
	      aux = new LnuMod(Diam,sv->Get_la(),aux);
	    extguard = ExtendedGuard(t->Get_cond(),
				     cf->Get_ta()->Get_Invariant(cf->Get_noeud()),
				     cf->Get_ta()->Get_Invariant(t->To()), 
				     * t->Get_rs());
	    if (extguard->Type() != Top)
	      aux = new LnuCD(And,extguard,aux);
	    else extguard->Destroy();
	    break;
	  case Box :  
	    if (! Eq_str(sv->Get_la(),"")) 
	      aux = new LnuMod(Box,sv->Get_la(),aux);
	    extguard = ExtendedGuard(t->Get_cond(),
				     cf->Get_ta()->Get_Invariant(cf->Get_noeud()),
				     cf->Get_ta()->Get_Invariant(t->To()), 
				     * t->Get_rs());
	    if (extguard->Type() != Top)
	      aux = new LnuBin(Impl,extguard,aux);
	    else extguard->Destroy();
	    break;
	  default :
	    break;
	  }
	  lres.Ajouter(aux);
	}
      }
      else {
	  aux = subf->Quotient(cf,lvAq,lvDq,nv);
	  switch (op) {
	  case Diam :
	    aux = new LnuMod(Diam,sv->Get_la(),aux);
	    break;
	  case Box :
	    aux = new LnuMod(Box,sv->Get_la(),aux);
	    break;
	  default :
	    break;
	  }
	  lres.Ajouter(aux);
	}
      lvs.Reste();
    }
  switch (lres.Longueur()) {
  case 0 : 
    res = (op == Diam) ? new LnuBool(Bot) : new LnuBool(Top);
    break;
  case 1 :
    res = lres.Tete();
    lres.Vide(); // ajout du 21-01-98
    break;
  default : 
    res = (op == Diam) ? new LnuCD(Or,lres) : new LnuCD(And,lres);
  }

  if (sv2) {
    sv2->Destroy();
    delete sv2;
  }

  //  cout << " LnuMod:Quotient <-  " << endl << "Avec : "; res->Print(); cout << endl;

  return res;
}

Lnu * LnuUn::Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv)
{ 
  Lnu * aux;
  Lnu * res;
  int isbta;
  Ident_L * pli, * newlstop;
  Ident noeud;
  TA * pta;

  //  cout << " Debug : noeud : "<< cf->Get_noeud() << endl;
  //  Print(); cout << endl;


  // A patcher : Hybride !!
  // on recupere la liste des horloges inactives pour le noeud courant
  // et on concatene cette liste a` celle deja existante de this

  noeud = cf->Get_noeud();
  pta = cf->Get_ta();
  pli = pta->Get_Act_node(noeud);

  newlstop = CopyIdent_L(lstop);
  pli = CopyIdent_L(pli);

  if (pli) {
    if (newlstop) {
      newlstop->Concat(*pli);
      delete pli;
    }
    else newlstop = pli;
  }

  aux = subf->Quotient(cf,lvAq,lvDq,nv);

  isbta =   cf->Get_ta()->Is_BTA();
  if (op == Not) 
    res  = new LnuUn(op,aux);
  else   if (isbta)
    res  = new LnuUn(op,aux,newlstop);
  else {  // on quotiente en tenant compte des invariants ! - 10-03-98
    Ident noeud = cf->Get_noeud();
    Lnu * inv = cf->Get_ta()->Get_Invariant(noeud);
    LnuBool top(Top); __CPLNU--; // on decremente car on n'appellera pas destroy...
    if (top.Equivalent(inv)) {  // inv == true
      res = new LnuUn(op,aux,newlstop); 
      inv->Destroy();
    }
    else {
      if (op == Exists) {
	Lnu_L lres;
	lres.Ajouter(aux);
	lres.Ajouter(inv);
	aux = new LnuCD(And,lres);
      }
      else 
	aux = new LnuBin(Impl,inv,aux);
      res = new LnuUn(op,aux,newlstop);
    }
  }

  //   cout << " res = "; res->Print(); cout << endl;
  return res;
}

Lnu * LnuCD::Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv)
{
  Lnu_L aux,aux2;
  Lnu * res, * f;
  aux2 = larg;
  while (! aux2.Est_vide()) {
    f = aux2.Tete();
    f = f->Quotient(cf,lvAq,lvDq,nv);
    aux.Ajouter(f);
    aux2.Reste();
  }
  res = new LnuCD(op,aux);
  return res;
}

Lnu * LnuTest::Quotient(Config * ,Liste<Quotvar> * ,Liste<Quotvar> * , int & )
{
LnuTest * res;

// cout << " LnuTest:Quotient avec : "; Print(); cout << endl;

res = new LnuTest(opc,c1,n1,c2,n2);

return res;}

Lnu * LnuBin::Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv)
{
  Lnu * res, *aux1, *aux2;
  aux1 = f1->Quotient(cf,lvAq,lvDq,nv);
  aux2 = f2->Quotient(cf,lvAq,lvDq,nv);

  if (op == Impl) 
    return new LnuBin(Impl,aux1,aux2);

  // EUntil :

  int isbta;
  Ident_L * pli, * newlstop;
  Ident noeud;
  TA * pta;

  noeud = cf->Get_noeud();
  pta = cf->Get_ta();
  pli = pta->Get_Act_node(noeud);
  newlstop = CopyIdent_L(lstop);
  pli = CopyIdent_L(pli);

  if (pli) {
    if (newlstop) {
      newlstop->Concat(*pli);
      delete pli;
    }
    else newlstop = pli;
  }

  isbta =   cf->Get_ta()->Is_BTA();
  if (isbta)
    res  = new LnuBin(op,aux1,aux2,newlstop);
  else {  // on quotiente en tenant compte des invariants ! - 10-03-98
    Lnu * inv = cf->Get_ta()->Get_Invariant(noeud);
    LnuBool top(Top); __CPLNU--; // on decremente car on n'appellera pas destroy...
    if (top.Equivalent(inv)) {  // inv == true
      res = new LnuBin(op,aux1,aux2,newlstop);
      inv->Destroy();
    }
    else {
	Lnu_L lres;
	lres.Ajouter(aux2);
	lres.Ajouter(inv);
	aux2 = new LnuCD(And,lres);
	aux1 = new LnuBin(Impl,inv->Copy(),aux1);
      res = new LnuBin(op,aux1,aux2,newlstop);
    }
  }


  return res;
}

Lnu * LnuVar::Quotient(Config * cf,Liste<Quotvar> * lvAq, 
                       Liste<Quotvar> * lvDq, int & nv) 
{
Lnu * res;
Liste<Quotvar> laux = *lvDq;
Quotvar aux;
int fin = 0;

while (!fin && (!laux.Est_vide())) {
  aux = laux.Tete();
  if ((aux.var == num) && (Eq_str(aux.cf->Get_noeud(),cf->Get_noeud())))
      {  res = new LnuVar(aux.Nvar);
	 fin = 1; }
  laux.Reste();
}

if (!fin)
    { laux = *lvAq;
      fin = 0;
      while (!fin && (!laux.Est_vide())) {
	aux = laux.Tete();
	if ((aux.var == num) && (Eq_str(aux.cf->Get_noeud(),cf->Get_noeud())))
	  {  res = new LnuVar(aux.Nvar);
	     fin = 1; }
	laux.Reste();
      }
      if (!fin) 
	{ 
	  res = new LnuVar(nv);
	  aux.var = num;
	  aux.cf = cf;
	  cf->NewPt(); 
	  aux.Nvar = nv;
	  lvAq->Ajouter(aux);
	  nv++;}
    }

return res;
}



//-----------------------------------------------------------------
//                          CONSTRAINT
//-----------------------------------------------------------------


Zone * LnuBool::Constraint(RegionGraph * rg,Zone * * )
{
  //  cout << "Constraint -> ";Print();cout << endl;
return new Zone(rg);
}

Zone * LnuMod::Constraint(RegionGraph * rg,Zone * * TabC)
{
Zone * z;

// cout << "Constraint -> ";Print();cout << endl;

switch(op) {
 case Diam :
  z = subf->Constraint(rg,TabC);
  break;
 case Box :
  z = new Zone(rg);
  break;
 case In :
   // cout << "Constraint -> ";Print();cout << endl;
  z = subf->Constraint(rg,TabC);
  //  cout << "Avec : "; z->Print();cout << endl;

  z->Rev_In(lab,carg,iarg);
  
  // cout << "Constraint <- ";Print();cout << endl;
  // cout << "Avec : "; z->Print();cout << endl;
  break;
 default : break;
}

// cout << "Constraint <- ";Print();cout << endl;

return z;
}

Zone * LnuUn::Constraint(RegionGraph * rg,Zone * * TabC)
{
Zone * z;

// cout << "Constraint -> ";Print();cout << endl;

// A patcher : Hybrid 

switch(op) {
 case Not :
  cout << " Erreur dans LnuUn::Constraint !! " << endl;
  Print();cout << endl;
  z = new Zone(rg);
  break;
 case Exists :
  z = (subf->Constraint(rg,TabC));
  z->Add_Past(lstop);
  break;
 case Forall :
  z = subf->Constraint(rg,TabC);
  if (__LASTQUOTIENT) // 24-11-98
    z->Forall(lstop);
  break;
 default : break;
}
return z;
}

Zone * LnuCD::Constraint(RegionGraph * rg,Zone * * TabC)
{
Lnu_L laux = larg;
Zone * z, * zaux;
Lnu * aux;

// cout << "Constraint -> ";Print();cout << endl;

if (op == And) {
  z = new Zone(rg);
  while (! laux.Est_vide()) {
    aux = laux.Tete();
    zaux = aux->Constraint(rg,TabC);
    z->Intersection(zaux);
    zaux->Destroy();
    laux.Reste();
  }
}
else {
  if (laux.Est_vide()) 
    cout << " Specif non normalisee dans LnuCD::Constraint !! " << endl;
  aux = laux.Tete();
  z = aux->Constraint(rg,TabC);
  laux.Reste();
  while (! laux.Est_vide()) {
    aux = laux.Tete();
    zaux = aux->Constraint(rg,TabC);
    z->ApproxUnion(zaux);
    zaux->Destroy();
    laux.Reste();
  }
}
return z;
}

Zone * LnuTest::Constraint(RegionGraph * rg,Zone * * )
{
Zone * res;

// cout << "Constraint -> ";Print();cout << endl;

if (opc == Diff) {
  //  cout << "Erreur -> LnuTest::Constraint() non implemente pour Diff !" << endl;
  return new Zone(rg);  // l'enveloppe convexe ...
}
res = new Zone(rg,this);
return res;
}

Zone * LnuBin::Constraint(RegionGraph * rg,Zone * * TabC)
{
Lnu * auxf;
Zone * z1, * z2;

 if (op == EUntil) { 
   z2 = (f2->Constraint(rg,TabC));
   z2->Add_Past(lstop);
   z1 = (f1->Constraint(rg,TabC));
   if (__LASTQUOTIENT) 
     z1->Forall(lstop); // ???
   z2->ApproxUnion(z1);
   z1->Destroy();
   return z2;

 } else { // Impl 
   // cout << "Constraint -> ";Print();cout << endl;
   if (!f1->Is_PG_Impl()) {
     cout << "Erreur : LnuBin::Constraint ! specification non normalisee ! " << endl;
     return new Zone(rg);
   }
   auxf = f1->Copy();
   auxf = auxf->Reverse();
   z1 = auxf->Constraint(rg,TabC);
   z2 = f2->Constraint(rg,TabC);
   z2->ApproxUnion(z1);
   auxf->Destroy();
   z1->Destroy();
   return z2;
 }

}

Zone * LnuVar::Constraint(RegionGraph * ,Zone * * TabC)
{
  // cout << "Constraint -> ";Print();cout << endl;

  //  cout << "LnuVar::Constraint : X"<<num<<endl;
  // TabC[num]->Print();cout << "** " << endl;
return TabC[num]->Copy();
}

//------------------------------------------------------------
//                           STATE_SAT
//------------------------------------------------------------

SetVal * LnuBool::StateSat(RegionGraph * r, Definition, int DbmPlc)
{
SetVal * res;
switch(op) {
 case Top :
 case NAP :
   if (DbmPlc) res = new PLC(1); //PLC(r,1);
   else res = new SetReg(r,1);
  break;
 case Bot :
 case AP :
   if (DbmPlc) res = new PLC(0); //PLC(r,0);
  else res = new SetReg(r);
  break;
 default : break;
}
return res;
}

SetVal * LnuMod::StateSat(RegionGraph * r,Definition Def, int DbmPlc)
{
SetVal * res;

// cout << "StateSat::LnuMod > ";Print();cout << endl;

switch (op) {
 case Diam :
   if (DbmPlc) res = new PLC(0); //PLC(r,0);
   else res = new SetReg(r);
  break;
 case Box :
   if (DbmPlc) res = new PLC(1); //PLC(r,1);
   else res = new SetReg(r,1);
  break;
 case In :
   res = subf->StateSat(r,Def,DbmPlc);
   res->Rev_In(lab,carg,iarg);
   break;
 default : break;
}

//  cout << "StateSat::LnuMod (fin) avec ";cout << endl;
//  res->Print();

return res;
}

SetVal * LnuUn::StateSat(RegionGraph * r,Definition Def, int DbmPlc)
{
  SetVal * res;

  //       cout << " LnuUn::StateSat > ";
  //       Print(); cout << endl;

switch(op) {
 case Exists :
   res = subf->StateSat(r,Def,DbmPlc);
   res->Add_Past(lstop);
   break;
 case Forall :
   res = subf->StateSat(r,Def,DbmPlc);
  //  cout << "LnuUn::StateSat - ForAll - suite : " << endl;
  //  res->Print();
   res->Forall(lstop);
   break;
 default : break;
 }
//  cout << " LnuUn::StateSat (fin) avec " << endl;
//  res->Print(); cout << endl;
return res;
}

SetVal * LnuCD::StateSat(RegionGraph * r,Definition Def, int DbmPlc)
{
  //Lnu * aux;
  SetVal * res, * sr ;
  Lnu_L laux = larg;

// cout << " LnuCD::StateSat > ";
// Print(); cout << endl;

switch(op) {
 case And :
   if (DbmPlc) res = new PLC(1); //PLC(r,1);
   else res = new SetReg(r,1);
   
   while (!laux.Est_vide()) {
     sr = laux.Tete()->StateSat(r,Def,DbmPlc);
    //  cout << "LnuCD::StateSat And - Intersection ... " << endl;
     res->Intersection(sr);
     sr->Destroy(); // Ajout du 25/06
     laux.Reste();
   }
   break;
 case Or :
   if (DbmPlc) res = new PLC(0); //PLC(r,0);
   else res = new SetReg(r);
   
   while (!laux.Est_vide()) {
     sr = laux.Tete()->StateSat(r,Def,DbmPlc);
     res->Union(sr);
     sr->Destroy();  // Ajout du 25/06
     laux.Reste();
  }
  break;
 default : break; 
}

//  cout << " LnuCD::StateSat (fin) avec " << endl;
//  res->Print(); cout << endl;

return res;
}

SetVal * LnuTest::StateSat(RegionGraph * r,Definition Def, int DbmPlc)
{
Zone * z;
SetVal * res;

//  cout << " LnuTest::StateSat > ";
//  Print(); cout << endl;

 if (DbmPlc) 
   res = new PLC(this);  //PLC(r,this);
 else {
   if (opc != Diff) {
     z = new Zone(r,this);
     res = new SetReg(z);
     z->Destroy();
   }
   else {
     //     SetReg * saux;
     this->Reverse();
     z = new Zone(r,this);
     this->Reverse();
     res = z->Complement();
     z->Destroy();

     //     Lnu * aux;
     //     aux = this->Copy()->Reverse();
     //     z = new Zone(r,aux);
     //          aux->Destroy();
   }
 }

//  cout << " LnuTest::StateSat (fin) " << endl;
//  res->Print(); cout << endl;

  return res;
}

SetVal * LnuBin::StateSat(RegionGraph * r,Definition Def, int DbmPlc)
{
  SetVal * aux1, * aux2, * res, * aux3, * aux7;
  //  SetVal * aux4, * aux5, * aux6;
  Lnu * auxf;


 if (op == EUntil) {
   aux1 = f1->StateSat(r,Def,DbmPlc);
   aux2 = f2->StateSat(r,Def,DbmPlc);
   if (DbmPlc) res = new PLC(0);  //PLC(r);
   else res = new SetReg(r);
   // le premier terme: Compl(Passe(Compl(z1 + Future(z2))))
   res->Union(aux2);
   res->Add_Future(lstop);
   res->Union(aux1);
   aux3 = res->Complement();
   aux3->Add_Past(lstop);
   res->Destroy();
   res = aux3->Complement();
   aux3->Destroy();

   //   aux4 = res->Copy(); // copie de verif - ancien calcul
   //   aux5 = res->Copy(); // copie de verif pour affichage

   // le second terme: z2 + (z1 inter Passe(z1(+) inter z2)) 
   aux3 = new SetReg(r);
   aux3->Union(aux1);
   aux3->Add_FermetureTemp(lstop);
   aux3->Intersection(aux2);
   aux3->Add_Past(lstop);
   aux3->Intersection(aux1);
   aux3->Union(aux2);

   // le premier inter le second
   res->Intersection(aux3);

   // comparaison avec ancien calcul:
   //   aux6 = new SetReg(r);
   //   aux6->Union(aux1);
   //   aux6->Union(aux2);
   //   aux4->Intersection(aux6);


   // on calcule Forall(aux1)
   aux7 = new SetReg(r);
   aux7->Union(aux1);
   aux7->Forall(lstop);

   // On ajoute a res...
   res->Union(aux7);
   res->Compacter();
 
   // aux4->Destroy();
   // aux5->Destroy();
   // aux6->Destroy();

   aux7->Destroy();
   //   aux4->Destroy();
   aux3->Destroy();
   aux1->Destroy();
   aux2->Destroy();
   return res;
 }

// cout << " LnuBin::StateSat -> ";
// Print(); cout << endl;

 auxf = f1->Copy()->Reverse();
 aux1 = auxf->StateSat(r,Def,DbmPlc);
 res = f2->StateSat(r,Def,DbmPlc);

// cout << "-f1 = " << endl;
// auxf->Print();cout << endl;

// aux1->Print();
// cout << "f2 =" << endl;
// f2->Print();cout << endl;
//  res->Print();

res->Union(aux1);
aux1->Destroy();   // Ajout du 25/06
auxf->Destroy();

// cout << " LnuBin::StateSat (fin) avec " << endl;
// res->Print(); cout << endl;
return res;
}

SetVal * LnuVar::StateSat(RegionGraph * ,Definition Def, int DbmPlc)
{
SetVal * res;

// cout << " LnuVar::StateSat > ";
// Print(); cout << endl;

 assert(Def);

res = Def[num]->Copy();

// cout << " LnuVar::StateSat (fin) avec " << endl;
// res->Print(); cout << endl;

return res;
}

//---------------------------------------------------------------
//                            REVERSE
//---------------------------------------------------------------

Lnu * LnuBool::Reverse(int )
{
switch(op) {
 case Top : 
  op = Bot;
  break;
 case Bot :
  op = Top;
  break;
 case AP :
  op = NAP;
  break;
 case NAP :
  op = AP;
  break;
 default : break;
}
return this;
}

Lnu * LnuMod::Reverse(int i)
{
switch(op) {
 case Diam :
  op = Box;
  break;
 case Box :
  op = Diam;
  break;
  default : break;
}
subf = subf->Reverse(i);
return this;
}

Lnu * LnuUn::Reverse(int i)
{
Lnu * res;

switch(op) {
 case Not :
  res = subf;
  delete this; __CPLNU--;
  return res;
  break;
 case Exists :
  op = Forall;
  break;
 case Forall :
  op = Exists;
  break;
  default : break;
}

subf = subf->Reverse(i);
return this;
}

Lnu * LnuCD::Reverse(int i)
{
switch(op) {
 case And :
  op = Or;
  break;
 case Or :
  op = And;
  break;
 default : break;
}

Lnu_L laux = larg;
Lnu_L lres;
Lnu * aux;

while (! laux.Est_vide()) {
  aux = laux.Tete();
  aux = aux->Reverse(i);
  lres.Ajouter(aux);
  laux.Reste();
}

larg=lres;
return this;
}

Lnu * LnuTest::Reverse(int )
{
LnuCD * aux;
LnuTest * t1, *t2;

switch(opc) {
 case Inf : 
  opc = Supe; break;
 case Infe :
  opc = Sup; break;
 case Sup :
  opc = Infe; break;
 case Supe :
  opc = Inf; break;
 case Egal :
  t1 = new LnuTest(Inf,this->c1,this->n1,this->c2,this->n2);
  t2 = new LnuTest(Sup,this->c1,this->n1,this->c2,this->n2);
  aux = new LnuCD(Or,t1,t2);
  delete this; __CPLNU--;
  return aux;
  break;
 case Diff :
  opc = Egal;
  break;
 default : break;
}

return this;
}

Lnu * LnuBin::Reverse(int i)
{
LnuCD * aux;
Lnu * aux2;

 assert(op != EUntil);

aux2 = f2->Reverse(i);
aux = new LnuCD(And,f1,aux2);
delete this; __CPLNU--;
return aux;
}

Lnu * LnuVar::Reverse(int i)
{
if (i==0) 
  cout << " Erreur (Var::Reverse) !! - X non def !! " << endl;
return this;
}



//---------------------------------------------------------------
//                             COPY
//---------------------------------------------------------------

Lnu * LnuBool::Copy()
{
if ((op == Bot) || (op == Top)) 
  return new LnuBool(op);
else return new LnuBool(op,prop,nta);
}

Lnu * LnuMod::Copy()
{
if (op==In) 
  return new LnuMod(op,lab,carg,iarg,subf->Copy());
 else return new LnuMod(op,lab,subf->Copy());
}

Lnu * LnuUn::Copy()
{

if (lstop) 
  return new LnuUn(op,subf->Copy(),CopyIdent_L(lstop));
 return new LnuUn(op,subf->Copy());
}

Lnu * LnuCD::Copy()
{
Lnu_L laux = larg;
Lnu_L lres;
Lnu * auxf;

while (!laux.Est_vide()) {
  auxf = laux.Tete();
  lres.Ajouter(auxf->Copy());
  laux.Reste();
}
return new LnuCD(op,lres);
}

Lnu * LnuTest::Copy()
{return new LnuTest(opc,c1,n1,c2,n2);}

Lnu * LnuBin::Copy()
{

if (lstop) 
  return new LnuBin(op,f1->Copy(),f2->Copy(),CopyIdent_L(lstop));
 else  return new LnuBin(op,f1->Copy(),f2->Copy());

}

Lnu * LnuVar::Copy()
{return new LnuVar(name,num);}

//----------------------------------------------------------------
//                            DESTROY
//      Modifiee le 20-01-98 : ajout des delete this 
//----------------------------------------------------------------


void LnuBool::Destroy()
{if ((op == AP) || (op == NAP)) 
    {
      if (prop) 
	delete prop;
      if (nta) 
	delete nta;
    }
delete this;
__CPLNU--;
}

void LnuMod::Destroy()
{
  if (lab) 
    delete lab;
  if (carg) 
    delete carg;
  subf->Destroy();
  delete this;
  __CPLNU--;
}

void LnuUn::Destroy()
{
  subf->Destroy();
  DestroyIdent_L(lstop);
  delete this;
  __CPLNU--;
}

void LnuCD::Destroy()
{Lnu_L laux = larg;
while (! laux.Est_vide()) {
  laux.Tete()->Destroy();
  laux.Reste();}
 larg.Vide();
 delete this;
__CPLNU--;
}

void LnuTest::Destroy()
{
  if (c1) 
    delete c1;
  if (c2) 
    delete c2;
  delete this;
__CPLNU--;
}

void LnuBin::Destroy()
{
f1->Destroy();
f2->Destroy();
DestroyIdent_L(lstop);
delete this;
__CPLNU--;
}


void LnuVar::Destroy()
{
  if (name) 
    delete name;
  delete this;
  __CPLNU--;
}

//----------------------------------------------------------------
//                          LCLOCKS_M
//----------------------------------------------------------------

McLi LnuBool::LclocksM()
{Map_int res1;
 Ident_L res2;
 McLi res;
 res.mc = res1; res.li = res2;res.ishyb=0;
return  res;}

McLi LnuMod::LclocksM()
{
if (op != In) return subf->LclocksM();

McLi res = subf->LclocksM();
res.mc.Ajouter(lab,iarg);
if (carg)  
  res.mc.Ajouter(carg,iarg);
 if (carg && iarg) // si x:=y+k... c'est hybride !
   res.ishyb=1;
return res;
}

McLi LnuUn::LclocksM()
{
McLi res = subf->LclocksM();
 
 if (lstop && (! lstop->Est_vide())) {
   for (Ident_L laux = *lstop;!laux.Est_vide();laux.Reste()) 
     res.mc.Ajouter(laux.Tete(),0);
   res.ishyb=1;
 }
return res;
}

McLi LnuCD::LclocksM()
{Lnu_L laux = larg;
McLi res,aux;
res.ishyb=0;
while (! laux.Est_vide()) {
  aux = laux.Tete()->LclocksM();
  res.mc.Concat(&(aux.mc));
  res.li.Concat(aux.li);
  res.ishyb = (res.ishyb || aux.ishyb);
  laux.Reste();}
return res;
}

McLi LnuTest::LclocksM()
{
McLi res;
int m;
res.ishyb=0;
m = max(n1,n2);
if (! Eq_str(c1,"")) res.mc.Ajouter(c1,m);
if (! Eq_str(c2,"")) res.mc.Ajouter(c2,m);
return res;
}

McLi LnuBin::LclocksM()
{
McLi res,aux;
res = f1->LclocksM();
aux = f2->LclocksM();
res.mc.Concat(&(aux.mc));
res.li.Concat(aux.li);
res.ishyb = aux.ishyb;

 if (lstop && (! lstop->Est_vide())) {
   for (Ident_L laux = *lstop;!laux.Est_vide();laux.Reste()) 
     res.mc.Ajouter(laux.Tete(),0);
   res.ishyb=1;
 }

return res;
}

McLi LnuVar::LclocksM()
{McLi res;
 res.ishyb=0; 
 res.li.Ajouter(name);
 return res;
}


//----------------------------------------------------------------
//                          Lvariables(Ident_L * lidaux)
//----------------------------------------------------------------

void LnuBool::Lvariables(Ident_L *)
{return ;}

void LnuMod::Lvariables(Ident_L * lidaux)
{ subf->Lvariables(lidaux);}


void LnuUn::Lvariables(Ident_L * lidaux)
{ subf->Lvariables(lidaux);}


void LnuCD::Lvariables(Ident_L * lidaux)
{Lnu_L laux = larg;
while (! laux.Est_vide()) {
  laux.Tete()->Lvariables(lidaux);
  laux.Reste();}
}

void LnuTest::Lvariables(Ident_L * lidaux)
{return ;}

void LnuBin::Lvariables(Ident_L * lidaux)
{
  f1->Lvariables(lidaux);
  f2->Lvariables(lidaux);
}

void LnuVar::Lvariables(Ident_L * lidaux)
{
  if (! EstDefIdent_L(lidaux, name)) lidaux->Ajouter(name);
}


//----------------------------------------------------------------
//                          MaxCste
//----------------------------------------------------------------

int LnuBool::MaxCste()
{return  0;}

int LnuMod::MaxCste()
{
 int res = subf->MaxCste();
 if (op != In) 
   return res;
 return max(res,iarg);
}

int LnuUn::MaxCste()
{return subf->MaxCste();}

int LnuCD::MaxCste()
{
Lnu_L laux = larg;
int res=-1,aux;
while (! laux.Est_vide()) {
  aux = laux.Tete()->MaxCste();
  res = max(aux,res);
  laux.Reste();}
return res;
}

int LnuTest::MaxCste()
{ return max(n1,n2);}

int LnuBin::MaxCste()
{return max(f1->MaxCste(),f2->MaxCste());}

int LnuVar::MaxCste()
{return 0;}


//----------------------------------------------------------------
//                          LCLOCKS_R
//----------------------------------------------------------------

Map_int LnuBool::LclocksR()
{Map_int lres;
return lres;}

Map_int LnuMod::LclocksR()
{
Map_int lres;
if (op != In) return lres;

 if (carg)  // on ne descend pas plus loin dans le cas x:=y
   return lres;
 // 22/09/99
lres = subf->LclocksR();
if (lres.Est_def(lab))
  return lres;  // si lab est reassigne plus tard, on peut oublier la premiere 
                // affectation 
lres.Ajouter(lab,iarg);
return lres;
}

Map_int LnuUn::LclocksR()
{Map_int lres;
return lres;}

Map_int LnuCD::LclocksR()
{Map_int lres;
return lres;}

Map_int LnuTest::LclocksR()
{Map_int lres;
return lres;}

Map_int LnuBin::LclocksR()
{Map_int lres;
return lres;}

Map_int LnuVar::LclocksR()
{Map_int lres;
return lres;}

//----------------------------------------------------------------
//                          SUBF_IN
//----------------------------------------------------------------
// Modif 22/09/99 : LnuMod...

Lnu * LnuBool::Subf_In()
{return this;}

Lnu * LnuMod::Subf_In()
{
if (op != In) 
  return this;
if (carg)    // 22/09/99
  return this;
return subf->Subf_In();
}

Lnu * LnuUn::Subf_In()
{return this;}

Lnu * LnuCD::Subf_In()
{return this;}

Lnu * LnuTest::Subf_In()
{return this;}

Lnu * LnuBin::Subf_In()
{return this;}

Lnu * LnuVar::Subf_In()
{return this;}


//---------------------------------------------------------------
//                           PROP_HZONE
//---------------------------------------------------------------

void LnuBool::PropHzone(Zone * ,Pt_SetReg * ,Pt_SetReg * ,int ,Zone * * )
{return ;}

void LnuMod::PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc)
{
  //  cout << "PropHzone: LnuMod > " << endl;
  //	Print();
  //	cout << endl;
if (op == In) 
  { 
    Zone * zaux = z->Copy();
    zaux->Projection(lab,carg,iarg);
    subf->PropHzone(zaux,Hz,HzW,n,tabc);
    zaux->Destroy();
  }
 else { 
 subf->PropHzone(z,Hz,HzW,n,tabc);}
// cout << "PropHzone: LnuMod < " << endl;
}

void LnuUn::PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n, Zone * * tabc)
{
assert(op != Not);

// cout << "PropHzone: LnuUn > " << endl;

Zone * zaux = z->Add_FutureC(lstop);
subf->PropHzone(zaux,Hz,HzW,n,tabc);
zaux->Destroy();

// cout << "PropHzone: LnuUn < " << endl;
}

void LnuCD::PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n, Zone * * tabc)
{
Lnu_L laux = larg;
Lnu * auxf;

// cout << "PropHzone: LnuCD > " << endl;

while (! laux.Est_vide()) {
  auxf = laux.Tete();
  auxf->PropHzone(z,Hz,HzW,n,tabc);
  laux.Reste();
}
// cout << "PropHzone: LnuCD < " << endl;

}

void LnuTest::PropHzone(Zone *,Pt_SetReg *,Pt_SetReg *,int , Zone * *)
{
  //   cout << "PropHzone: LnuTest <> " << endl;
return ;}

void LnuBin::PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc)
{
  //   cout << "PropHzone: LnuBin > " << endl;
Zone * zaux;

 if (op == EUntil) {
   zaux = z->Add_FutureC(lstop);
   f1->PropHzone(zaux,Hz,HzW,n,tabc);
   f2->PropHzone(zaux,Hz,HzW,n,tabc);
   zaux->Destroy();
 }
 else {
 Definition auxDef ;
 SetReg * saux = (SetReg *) f1->StateSat(z->Get_RegionG(),auxDef);
 
// cout << "PropHzone: LnuBin <suite> " << endl;

//  cout << " LnuBin::PropHzone " << endl;
//  Print(); cout << endl;
//  saux->Print();
 
 assert(saux->Get_lz().Longueur() < 2);
 if (saux->Get_lz().Longueur() == 1) {
   zaux = saux->FstZone();
   zaux->Intersection(z);
   f2->PropHzone(zaux,Hz,HzW,n,tabc);
 }
 saux->Destroy(); // zaux est detruite dans saux !!!
 }
 //  cout << "PropHzone: LnuBin < " << endl;
}

void LnuVar::PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc)
{
  //    cout << "PropHzone: LnuVar > " << endl;

  //Zone * zaux = z->Copy();
assert(num < n);

// GROS PROBLEME !!! on le squize pour le moment
//zaux->Intersection(tabc[num]);


//if (zaux->Est_vide()) {
//  zaux->Destroy();
//  return;
//}

 if (z->Est_vide()) return;

//zaux->Destroy();

if (SIMPLSPLIT == 2) {
  if (Hz[num]->Est_inclu_ZW(z)) 
    return;
  else
    if (HzW[num]->Est_inclu_ZW(z))
      return ;
    else   { 
      //    Hz[num]->Elim_Zinclues(z);
      if (! z->Est_vide())
	HzW[num]->UnionW(z);  // suppression de Copy() - 16-05-97
    }
}
else if (SIMPLSPLIT == 3) {
  if (Hz[num]->Est_inclu_ZWW(z)) 
    return;
  else
    if (HzW[num]->Est_inclu_ZWW(z))
      return ;
    else   { 
      //    Hz[num]->Elim_Zinclues(z);
      if (! z->Est_vide())
	HzW[num]->UnionWW(z);  // suppression de Copy() - 16-05-97
    }
}
else {
  if (Hz[num]->Est_inclu_Z(z))  // 29-07-98 !! _Z ou non...
    return;
  else
    HzW[num]->Union(z); // 29-07-98 !!
  // au lieu de :
  //     if (HzW[num]->Est_inclu_Z(z))
  // 	 return ;
  //     else   { 
  // 	 //    Hz[num]->Elim_Zinclues(z);
  // 	 HzW[num]->Elim_Zinclues(z);
  // 	 HzW[num]->Union(z);   // suppression de Copy() - 16-05-97
  //     }
}

// cout << "PropHzone: LnuVar < " << endl;

}




//-----------------------------------------------------------
//                      SIMPL_HZONE
//-----------------------------------------------------------

Lnu * LnuBool::SimplHzone(SetReg *,int &,Zone * *,int)
{return this;}

Lnu * LnuMod::SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit)
{
if (op == In) 
  {

    //    cout << "LnuMod::SimplHzone : " <<endl;
    //    Print();cout << endl;
    //    sr->Print();
    
    SetReg * saux = (SetReg *) sr->Copy();
    saux->Projection(lab,carg,iarg);
    subf = subf->SimplHzone(saux,si,tabc,issplit);
    saux->Destroy();
  }
else subf = subf->SimplHzone(sr,si,tabc,issplit);
return this;
}

Lnu * LnuUn::SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit)
{
assert(op != Not);

// cout << "LnuUn::SimplHzone : " <<endl;
// Print();cout << endl;
// sr->Print();
    

 SetReg * s = (SetReg *) sr->Copy();
s->Add_Future(lstop);
subf = subf->SimplHzone(s,si,tabc,issplit);
s->Destroy();
return this;
}

Lnu * LnuCD::SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit)
{
Lnu_L laux = larg, lres;
Lnu * auxf;

while (! laux.Est_vide()) {
  auxf = laux.Tete();
  auxf = auxf->SimplHzone(sr,si,tabc,issplit);
  lres.Ajouter(auxf);
  laux.Cdr();
}
larg = lres;
return this;
}

Lnu * LnuTest::SimplHzone(SetReg * sr,int & si,Zone * *,int)
{

  //  cout << "LnuTest::SimplHzone : " <<endl;
  //  Print();cout << endl;
  //  sr->Print();
    

Lnu * res;
int eval;
Zone * z = new Zone(sr->Get_rg(),this);

eval = sr->Test_inclusion(z);
switch(eval) {
 case 0 : 
  res = this;
  break;
 case 1 : 
  res = new LnuBool(Top);
  if (PTRACE>1) {
    this->Print(); cout << " in : "; sr->Print();
    cout << " is equivalent to tt.  (lnutest::simplhzone) " << endl;
  }
  Destroy();        // 21-01-98
  si++;
  break;
 case 2 :
  res = new LnuBool(Bot);
  if (PTRACE>2) {
    this->Print(); cout << " in : "; sr->Print();
    cout << " is equivalent to ff." << endl;
  }
  Destroy();   // 21-01-98
  si++;
  break;
}
z->Destroy();
return res;
}



Lnu * LnuBin::SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit)
{
assert(f1->Is_PG_Impl());
Definition auxDef ;
SetReg * saux1, * saux2; 
Zone * zaux;

// cout << "LnuBin::SimplHzone : " <<endl;
// Print();cout << endl;
// sr->Print();
    
 if (op == EUntil) {
   saux1 = (SetReg*) sr->Copy();
   saux1->Add_Future(lstop);
   f1->SimplHzone(saux1,si,tabc,issplit);
   f2->SimplHzone(saux1,si,tabc,issplit);
   saux1->Destroy();
   return this;
 } else {

 f1 = f1->SimplHzone(sr,si,tabc,issplit);
 saux1 = (SetReg *) f1->StateSat(sr->Get_rg(),auxDef);  
 assert(saux1->Get_lz().Longueur() < 2);

 if (saux1->Get_lz().Longueur() == 1) {

   zaux = saux1->FstZone();
   saux2 = (SetReg *) sr->Copy();
   saux2->Intersection(zaux);
   f2 = f2->SimplHzone(saux2,si,tabc,issplit);
   //   f2 = f2->SimplHzone(saux1,si,tabc,issplit); - 22/09/99 
   saux2->Destroy();
 }
 else {  // cas vide
   saux1->Destroy();
   f1->Destroy();
   f2->Destroy();
   delete this; __CPLNU--;
   si++;
   return new LnuBool(Top); // nouveau - 29-07-98
   // On met Top car .. c'est ca qu'il faut ! ;-) 
 }

 saux1->Destroy(); // detruit aussi zaux
 }

return this;

}

Lnu * LnuVar::SimplHzone(SetReg * sr,int & ,Zone * * tabc,int issplit)
{
  if (! issplit) {   // si split, cela est fait dans Hz_substitute
    SetReg * saux = (SetReg *) sr->Copy();
    saux->Intersection(tabc[num]);
    if (saux->Est_vide()) {
      saux->Destroy();
      Destroy();
      return new LnuBool(Bot);
    }
    saux->Destroy();
  }
return this;
}




//-----------------------------------------------------------
//                        IS_INVAR
//-----------------------------------------------------------


int LnuBool::Is_Invar(int ish)
{return (op == Top);}

int LnuMod::Is_Invar(int ish)
{return 0;}

int LnuUn::Is_Invar(int ish)
{
return 0;
}

int LnuCD::Is_Invar(int ish)
{Lnu_L laux = larg;
int res = 1;
int cont = ! laux.Est_vide();
while (cont) {
  res = laux.Tete()->Is_Invar(ish);
  laux.Reste();
  cont = (! laux.Est_vide()) && (res);}
return res;
}

int LnuTest::Is_Invar(int ish)
{
if (ish) 
  return 1;

  if (Eq_str(c1,"")) {
    // n > x | n >= x
    if ((opc == Sup) || (opc == Supe)) 
      return 1;
    else return 0;
  }
  else if (Eq_str(c2,"")) {
     // x < n | x <= n
    if ((opc == Inf) || (opc == Infe)) 
      return 1;
    else return 0;   
  }
  else return 0;
}

int LnuBin::Is_Invar(int ish)
{return 0;}

int LnuVar::Is_Invar(int ish)
{return 0;}

//-----------------------------------------------------------
//                        IS_PG_IMPL
//-----------------------------------------------------------


int LnuBool::Is_PG_Impl()
{return ((op == Top) || (op == Bot));}

int LnuMod::Is_PG_Impl()
{return 0;}

int LnuUn::Is_PG_Impl()
{return 0;}

int LnuCD::Is_PG_Impl()
{Lnu_L laux = larg;
int res = (op == And);
int cont = res && (! laux.Est_vide());
while (cont) {
  res = laux.Tete()->Is_PG_Impl();
  laux.Reste();
  cont = (! laux.Est_vide()) && (res);}
return res;
}

int LnuTest::Is_PG_Impl()
{return 1;}

int LnuBin::Is_PG_Impl()
{return 0;}

int LnuVar::Is_PG_Impl()
{return 0;}

//-----------------------------------------------------------
//                        IS_GUARD
//-----------------------------------------------------------


int LnuBool::Is_Guard()
{
int res;
  switch(op) {
  case Bot :
  case Top : res=1;
    break;
  default : res =0;
  }
return res;

}

int LnuMod::Is_Guard()
{return 0;}

int LnuUn::Is_Guard()
{
if (op == Not) return subf->Is_Guard();
else return 0;
}

int LnuCD::Is_Guard()
{Lnu_L laux = larg;
int res = 1;
int cont = ! laux.Est_vide();
while (cont) {
  res = laux.Tete()->Is_Guard();
  laux.Reste();
  cont = (! laux.Est_vide()) && (res);}
return res;
}

int LnuTest::Is_Guard()
{return 1;}

int LnuBin::Is_Guard()
{return ((op==Impl) && f1->Is_Guard() && f2->Is_Guard());}

int LnuVar::Is_Guard()
{return 0;}



//-----------------------------------------------------------
//                        IS_ATOMIC
//-----------------------------------------------------------


int LnuBool::Is_Atomic()
{
  return 1;
}

int LnuMod::Is_Atomic()
{return 0;}

int LnuUn::Is_Atomic()
{
if (op == Not) return subf->Is_Atomic();
else return 0;
}

int LnuCD::Is_Atomic()
{Lnu_L laux = larg;
int res = 1;
int cont = ! laux.Est_vide();
while (cont) {
  res = laux.Tete()->Is_Atomic();
  laux.Reste();
  cont = (! laux.Est_vide()) && (res);}
return res;
}

int LnuTest::Is_Atomic()
{return 1;}

int LnuBin::Is_Atomic()
{return ((op==Impl) && f1->Is_Atomic() && f2->Is_Atomic());}

int LnuVar::Is_Atomic()
{return 0;}


//-----------------------------------------------------------
//                        IS_IN_CONFIG
//-----------------------------------------------------------


int LnuBool::Is_In_Config(RSconfig * c)
{
  int res;
  switch(op) {
  case Top : res=1; break;
  case Bot : res=0; break;
  case AP :
    //    cout << nta << ":" << prop << endl;
    res = c->Verify(nta,prop);
    //    cout << "Is_In::Res = " << res << endl;
  break;
  case NAP :
    res = ! c->Verify(nta,prop);
  break;
  default : assert(0);
  }

  return res;
}

int LnuMod::Is_In_Config(RSconfig * c)
{return 0;}

int LnuUn::Is_In_Config(RSconfig * c)
{
if (op == Not) return ! (subf->Is_In_Config(c));
else return 0;
}

int LnuCD::Is_In_Config(RSconfig * c)
{Lnu_L laux = larg;
int res = 1;
int cont = ! laux.Est_vide();
while (cont) {
  res = laux.Tete()->Is_In_Config(c);
  laux.Reste();
  if (op == And)
    cont = (! laux.Est_vide()) && (res);
  else cont = (! laux.Est_vide()) && (!res);
}
return res;
}

int LnuTest::Is_In_Config(RSconfig * c)
{
  Zone * ztest = new Zone(c->RP()->RG(),this);
  Zone * zconf = c->ZoneC();

  int res = ztest->Est_inclu(zconf);
  ztest->Destroy();

  return res;

}

int LnuBin::Is_In_Config(RSconfig * c)
{
  if (op==EUntil) return 0;
  else return (! f1->Is_In_Config(c)) || f2->Is_In_Config(c);
}

int LnuVar::Is_In_Config(RSconfig * c)
{return 0;}



//-----------------------------------------------------------
//                        Basic Specif (for BTA)
//-----------------------------------------------------------


Lnu * LnuBool::BSpec()
{return this;}

Lnu * LnuMod::BSpec()
{
subf = subf->BSpec();
return this;
}

Lnu * LnuUn::BSpec()
{
  Lnu * aux; // Lnu * res, * aux;
subf = subf->BSpec();
  switch(op) {
  case Not : 
    break;
  case Exists : aux = new LnuMod(Box,"InvFail",new LnuBool(Bot));
    subf = new LnuCD(And,aux,subf);
    break;
  case Forall : aux = new LnuMod(Diam,"InvFail",new LnuBool(Top));
    subf = new LnuCD(Or,aux,subf);
    break;
  default : cout << " Error in LnuUn::BSpec() ! " << endl;
  }
return this;
}

Lnu * LnuCD::BSpec()
{
Lnu * aux;
Lnu_L laux = larg, lres;
while (! laux.Est_vide()) {
  aux = laux.Tete()->BSpec();
  lres.Ajouter(aux);
  laux.Cdr();
}
larg = lres;
return this;
}

Lnu * LnuTest::BSpec()
{return this;}

Lnu * LnuBin::BSpec()
{
f1 = f1->BSpec();
f2 = f2->BSpec();

 if (op == EUntil) {
   Lnu* aux;
   aux = new LnuMod(Diam,"InvFail",new LnuBool(Top));
   f1 = new LnuCD(Or,aux,f1);
   aux = new LnuMod(Box,"InvFail",new LnuBool(Bot));
   f2 = new LnuCD(And,aux,f2);
 }

return this;
}

Lnu * LnuVar::BSpec()
{return this;}

//-----------------------------------------------------------
//                        Simplif for nil process
//-----------------------------------------------------------
//  AP -> ff,  NAP -> tt

Lnu * LnuBool::SimplNil()
{
  switch (op) {
  case AP : op = Bot;
    if (prop) delete prop;
    if (nta) delete nta;
    break;
  case NAP : op = Top;
    if (prop) delete prop;
    if (nta)  delete nta;
    break;
  default : break;
  }
return this;
}

Lnu * LnuMod::SimplNil()
{
subf = subf->SimplNil();
return this;
}

Lnu * LnuUn::SimplNil()
{
subf = subf->SimplNil();
return this;
}

Lnu * LnuCD::SimplNil()
{
Lnu * aux;
Lnu_L laux = larg, lres;
while (! laux.Est_vide()) {
  aux = laux.Tete()->SimplNil();
  lres.Ajouter(aux);
  laux.Cdr();
}
larg = lres;
return this;
}

Lnu * LnuTest::SimplNil()
{return this;}

Lnu * LnuBin::SimplNil()
{
f1 = f1->SimplNil();
f2 = f2->SimplNil();
return this;
}

Lnu * LnuVar::SimplNil()
{return this;}



//-----------------------------------------------------------
//       Substitution of unguarded variable by a formula
//-----------------------------------------------------------


Lnu * LnuBool::SubstituteUngVar(int , Lnu * ,int)
{return this;}

Lnu * LnuMod::SubstituteUngVar(int , Lnu * ,int )
{return this;}

Lnu * LnuUn::SubstituteUngVar(int , Lnu * ,int)
{return this;}

Lnu * LnuCD::SubstituteUngVar(int vnum, Lnu * g,int cjtype)
{
Lnu_L la, lres;
la = larg;
Lnu * auxf;

// on ne propage pas si ca cree une alternation ^ v ou v ^
//cout << " <== " << endl;

if (((op == And) && (cjtype == 2)) ||
    ((op == Or) && (cjtype == 1))) return this;

while(!la.Est_vide()) {
  auxf = la.Tete();
  auxf = auxf->SubstituteUngVar(vnum,g,cjtype);
  lres.Ajouter(auxf);
  la.Reste();
}
larg.Vide();
larg=lres;

//cout << " ==> " << endl;

//return Normal();
return this;  // la Normalisation se fait plus tard...
}


Lnu * LnuTest::SubstituteUngVar(int, Lnu * ,int)
{return this;}


// meriterait d'etre regarde de pres... :-)
Lnu * LnuBin::SubstituteUngVar(int , Lnu * ,int)
{return this;}


Lnu * LnuVar::SubstituteUngVar(int vnum, Lnu * g,int)
{
  if (num == vnum) {
    Destroy();
    return g->Copy();
  }
  else 
    return this;
}


//-----------------------------------------------------------
//       Test if there is an unguarded variable num
//-----------------------------------------------------------


int LnuBool::IsThereUngVar(int ,int)
{return 0;}

int LnuMod::IsThereUngVar(int ,int )
{return 0;}

int LnuUn::IsThereUngVar(int ,int )
{return 0;}

int LnuCD::IsThereUngVar(int vnum,int cjtype)
{
Lnu_L la;
la = larg;
Lnu * auxf;
int res=0;

// on ne propage pas si ca cree une alternation ^ v ou v ^

if (((op == And) && (cjtype == 2)) ||
    ((op == Or) && (cjtype == 1))) return 0;

while  ((!res) && (!la.Est_vide())) {
  auxf = la.Tete();
  res = auxf->IsThereUngVar(vnum,cjtype);
  la.Reste();
}
return res;
}


int LnuTest::IsThereUngVar(int,int)
{return 0;}


// meriterait d'etre regarde de pres... :-)
int LnuBin::IsThereUngVar(int,int)
{return 0;}


int LnuVar::IsThereUngVar(int vnum,int )
{
return (num == vnum);
}

//-----------------------------------------------------------
//       returns the list of the variables
//-----------------------------------------------------------

void LnuBool::Liste_Var(int_L * )
{return ;}

void LnuMod::Liste_Var(int_L * l)
{subf->Liste_Var(l);}

void LnuUn::Liste_Var(int_L * l)
{subf->Liste_Var(l);}

void LnuCD::Liste_Var(int_L * l)
{
Lnu_L la;
la = larg;
Lnu * auxf;

while  (!la.Est_vide()) {
  auxf = la.Tete();
  auxf->Liste_Var(l);
  la.Reste();
}
}


void LnuTest::Liste_Var(int_L * )
{return ;}

void LnuBin::Liste_Var(int_L * l)
{f1->Liste_Var(l);
 f2->Liste_Var(l);}

void LnuVar::Liste_Var(int_L * l)
{l->Ajouter(num);}




