/* File: lnu.h -- Francois -- Last modified on 26 Jul 2001
 *
 *      Definition des classes LNU
 *
  class Lnu =
     class LnuBool  : Bot | Top | AP | NAP
     class LnuMod   : Box | Diam | In
     class LnuUn    : Exists | Forall | Not
     class LnuCD    : And | Or
     class LnuTest  : Test
     class LnuBin   : Impl | EUntil
     class LnuVar   : Var

 */

#ifndef LNU_H
#define LNU_H


#include <iostream.h>
#include <string.h>
#include <fstream.h>

#include <new.h>
#include <assert.h>
//#include "nnew.h"

#include "liste.h"
#include "map.h"
#include "number.h"
//#include "acces.h"

//extern cell *memoryMap, *currentCell;
//extern char *pool;
//extern int available;
//extern char *P;
//extern int cellAvailable;




typedef char * Clocks;
typedef char * Label;
typedef char * Ident;

typedef Mapping<int> Map_int;
typedef Liste<Ident> Ident_L;
typedef Liste<int> int_L;
typedef Mapping<Ident> Map_Ident;

int Eq_str(char * s1, char * s2);
int Eq_lstr(Ident_L * l1, Ident_L * s2);
Ident_L * CopyIdent_L(Ident_L * l);
void DestroyIdent_L(Ident_L * l);
void PrintIdent_L(Ident_L * l);
char * Add_Rec(char * s);
char * Add_Sen(char * s);
char * Rem_RS(char * s);
char * Trans_Rec(char * s);
char * Trans_Sen(char * s);
int Is_Rec(char * s);
int Is_Sen(char * s);


class RSconfig;

enum OP {Bot, Top, And, Or, Not, Diam, Box, Exists, Forall, In, Impl, EUntil, Var, Test, AP, NAP};

enum OPC {Ndef, Inf, Infe, Egal, Sup, Supe, Diff};

class McLi {
  public :
  Map_int mc;
  Ident_L li;
  int ishyb;
};

class Lnu;
class LnuTest;
class SetReg;
class SetVal;
class Zone;

typedef Lnu * Pt_Lnu;
typedef Liste<Pt_Lnu> Lnu_L;
typedef Mapping<Pt_Lnu> Declaration;
typedef Declaration * Pt_Declaration;
typedef SetReg * Pt_SetReg;
typedef SetVal * Pt_SetVal;
typedef Pt_SetVal * Definition;
typedef Pt_Lnu * NFDeclaration;


class TA;
class Synch_Vect;
class RegionGraph;
class Zone;
typedef Zone * Pt_Zone;

typedef Synch_Vect * Pt_Synch_Vect;

typedef  Liste<Pt_Synch_Vect>  Pt_Synch_Vect_L;

typedef  Mapping<Pt_Synch_Vect_L *> Fsynchro;
typedef  Fsynchro * Pt_Fsynchro;

void DestroyFs(Fsynchro *);
Fsynchro * CopyFs(Fsynchro *);
void PrintFs(Fsynchro *);

class Config {
  private :
    Ident noeud;
    TA * ta;
    Ident  nomta;  // nom du TA
    Fsynchro * fs;
    int nbp;   // nb de quotvar pointant sur la config
  public :
    Config(Ident n,Ident nta, TA * t,Fsynchro * f);
    Ident Get_nta();
    Ident Get_noeud();
    TA * Get_ta();
    Fsynchro * Get_fs();
    void Print();
    void NewPt();
    void Destroy();
};


class Quotvar {
  public :
    int var;
    Config * cf;
    int Nvar;  // Nouveau nom
};


//------------------------------------------------------------------
//                          LNU
//------------------------------------------------------------------

class Lnu {
  public :

    //   void * operator new(size_t s);
    //   void operator delete(void* addr);

  virtual void Print(ostream & output =cout) = 0;
  virtual void PrintLatex(ostream & latexoutput) = 0;
  virtual Lnu * Normal() = 0;
  //  virtual Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c) = 0;
  virtual Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv) = 0;
  virtual Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D) = 0;
  virtual Lnu * Substitute(NFDeclaration d) = 0;
  virtual Lnu * SubstituteF(LnuTest * f,Lnu * g) = 0;
  virtual void NF_Substitute(int * Tab,int * Sub) = 0;
  virtual Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc) = 0;
  virtual Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype) = 0; // cjtype=1 si And, 2 si Or
  virtual int IsThereUngVar(int vnum,int cjtype) = 0; // cjtype=1 si And, 2 si Or
  virtual int Est_equiv_mod(Lnu * g,int * Tab) =0;
  virtual int Equivalent(Lnu * g) =0;
  virtual int Est_subf(Lnu * g) =0;
  virtual OP  Type() = 0;
  virtual Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv) = 0;
  virtual Lnu * Reverse(int i =0) =0;
  virtual Lnu * Copy() =0;
  virtual void Destroy() =0;
  
  virtual SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0) =0;
  virtual Zone * Constraint(RegionGraph * rg,Zone * * TabC) =0;
  virtual McLi LclocksM() =0;
  virtual void Lvariables(Ident_L * lv) =0;
  virtual int MaxCste() =0;
  virtual Map_int LclocksR() =0;  // {x1,..} /  x1 in x2 in ... f
  virtual Lnu * Subf_In() =0;   // f / x1 in x2 in ... in f
  virtual void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc) = 0;
  virtual Lnu * SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit =0) = 0;
  //  virtual LnuTest * SubTest() = 0;

  virtual void Liste_Var(int_L * l) =0;
  virtual int Is_Invar(int ish=0) = 0;
  virtual int Is_Guard() = 0;
  virtual int Is_Atomic() = 0;
  virtual int Is_In_Config(RSconfig * c) = 0;
  virtual int Is_PG_Impl() = 0;
  virtual Lnu * BSpec() = 0;
  virtual Lnu * SimplNil() = 0;
  };


//------------------------------------------------------------------
//               LNU BOOLEEN
//------------------------------------------------------------------

class LnuBool : public Lnu {
  private :
  OP op;
  Ident prop;
  Ident nta;
  public :
  LnuBool (OP o);
  LnuBool (OP o,Ident p,Ident ta = 0);
  OP Type();
  Ident Prop();
  Ident Nta();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum, int cjtype);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr,int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
  };

//-----------------------------------------------------------------
//               LNU MOD : In , Diam , Box
//-----------------------------------------------------------------

class LnuMod : public Lnu {
  private :
  OP op;
  Ident lab;  // label or clock
  Ident carg; // for assignment := cl + k
  int iarg;   // for assignment := cl + k
  Lnu * subf;
  public :
  LnuMod(OP o,Ident id,Lnu * f);

  LnuMod(OP o,Ident id,Ident c,Lnu * f);  // special for IN
  LnuMod(OP o,Ident id,int v,Lnu * f);
  LnuMod(OP o,Ident id,Ident c,int v,Lnu * f);

  OP Type();
  Lnu * Subf();
  Ident Lab();
  Ident Carg();
  int Iarg();
  int IsExtendedIn();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr, int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
  };

//------------------------------------------------------------------
//                   Lnu Unary :  Exists, Forall, Not
//------------------------------------------------------------------

class LnuUn : public Lnu {
  private :
  OP op;
  Lnu * subf;
  Ident_L * lstop;   // liste des horloges arretees (pente nulle)
  public :
  LnuUn(OP o,Lnu * f,Ident_L * lsc =0);
  OP Type();
  Ident_L * LSClocks();  // pointeur lstop
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr, int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
  };

//---------------------------------------------------------------
//           Lnu Conj. and Disj. : And, Or
//---------------------------------------------------------------

  class LnuCD : public Lnu {
  private :
  OP op;
  Lnu_L larg;
  public :
  LnuCD(OP o,Lnu * f,Lnu * g);
  LnuCD(OP o,Lnu_L l);

  Lnu_L Get_larg();
  OP Type();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Copy() ;
  void Destroy() ;
  Lnu * Reverse(int i =0);

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr, int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
};

//------------------------------------------------------------------
//                 Lnu Test 
//------------------------------------------------------------------

class LnuTest : public Lnu {
  private :
	OPC opc;
	Ident c1;
	int n1;
	Ident c2;
	int n2;
  public :
  LnuTest(OPC o,Ident cl1,int m1, Ident cl2,int m2);
  OP Type();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  void InvOPC();
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Equivalent(Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  OPC Get_opc();
  Ident Get_c1();
  Ident Get_c2();
  int Get_n1();
  int Get_n2();
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr,  int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
};

//-----------------------------------------------------------------
//               Lnu Bin    Impl (=>) + EUntil [@) 
//-----------------------------------------------------------------

 class LnuBin : public Lnu {
  private :
  OP op;
  Lnu * f1;
  Lnu * f2;
  Ident_L * lstop;   // liste des horloges arretees POUR EUNTIL !
  public :
  LnuBin(OP o,Lnu * f,Lnu * g,Ident_L * lsc =0);

  OP Type();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  void Lvariables(Ident_L * lv);
  int MaxCste();
  Map_int LclocksR();
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr, int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
};

//--------------------------------------------------------------
//                Lnu Var
//--------------------------------------------------------------

class LnuVar : public Lnu {
  private :
  Ident name;
  int num;
  public :
  LnuVar(int n);
  LnuVar(Ident n);
  LnuVar(Ident n,int x);
  OP Type();
  int GetNum();
  void Print(ostream & output =cout);
  void PrintLatex(ostream & latexoutput);
  Lnu * Normal();
  //  Lnu * SimplPEval(RegionGraph * r,SetReg * hz, Definition ds1, Definition ds2, int & c);
  Lnu * ElimIdent(Map_int * MaR,Map_int * MdR,int & nv);
  Lnu * NormF(Number<int> * MaR,Number<int> * MdR,int & nv,Number<Pt_Lnu> * D);
  Lnu * Substitute(NFDeclaration d);
  Lnu * SubstituteF(LnuTest * f,Lnu * g);
  void NF_Substitute(int * Tab,int * Sub);
  Lnu * Hz_Substitute(Pt_Zone z,int Im[],int Nz[],Pt_Zone * * hz,Zone * * tabc);
  Lnu * SubstituteUngVar(int vnum, Lnu * g,int cjtype);
  int IsThereUngVar(int vnum,int cjtype);
  int Est_equiv_mod(Lnu * g,int * Tab);
  int Equivalent(Lnu * g);
  int Est_subf(Lnu * g);
  Lnu * Quotient(Config * cf,Liste<Quotvar> * lvAq,Liste<Quotvar> * lvDq, int & nv);
  SetVal * StateSat(RegionGraph * rg,Definition Def, int DbmPlc =0);
  Lnu * Reverse(int i =0);
  Lnu * Copy() ;
  void Destroy() ;

  Zone * Constraint(RegionGraph * rg,Zone * * TabC);
  McLi LclocksM();
  int MaxCste();
  Map_int LclocksR();
  void Lvariables(Ident_L * lv);
  Lnu * Subf_In();
  void PropHzone(Zone * z,Pt_SetReg * Hz, Pt_SetReg * HzW,int n,Zone * * tabc);
  Lnu * SimplHzone(SetReg * sr, int & si,Zone * * tabc,int issplit =0);
  //  LnuTest * SubTest();
  int Is_Invar(int ish=0);
  int Is_Guard();
  int Is_Atomic();
  int Is_In_Config(RSconfig * c);
  int Is_PG_Impl();
  Lnu * BSpec();
  Lnu * SimplNil();
  void Liste_Var(int_L * l);
};



#endif



