/* File: map.h -- Francois -- Last modified on 24 Feb 1998
 * 	
 *      
 *
 */

#include <string.h>

#ifndef MAP_H
#define MAP_H

typedef char * Ident;

template <class Type>
class Mapping {
 private:

  class Element {
  public:
    char * nom;
    Type val;
    Element * suivant;
  };
  typedef Element * Ptr_Element;

  Ptr_Element debut;

 public:

  Mapping()
    {debut = 0;}

  Mapping(Ident n,Type x)
    {debut = 0;
     Ajouter(n,x);}

  void Ajouter(char * n, Type x);
  Mapping * Ajouter2(char * n, Type x);

  void Ajouterf(char * n,Type x);
  Mapping * Ajouterf2(char * n, Type x);

  void Supprimer(char * n);

  Type Recherche(char * n);

  int Est_def(char * n);

  int Est_defr(char * n,Type & t);

  void Concat(Mapping * l);

  Mapping * Concat2(Mapping * l);

  int Taille();

  int Est_vide();

  char * TeteN();

  Type Tete();

  void Reste();

  void Vide();

};

template <class Type>
inline void Mapping<Type>::Ajouter(char * n, Type x)
    { Element * aux;
      aux = new Element;
      aux->nom = strcpy(new char [strlen(n)+1],n);
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
   }
template <class Type>
Mapping<Type> * Mapping<Type>::Ajouter2(char * n, Type x)
    { Element * aux;
      aux = new Element;
      aux->nom = strcpy(new char [strlen(n)+1],n);
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
      return this;
   }

template <class Type>
void Mapping<Type>::Ajouterf(char * n,Type x)
    { Element * aux;
      Element * l;
      aux = new Element;
      aux->nom = strcpy(new char [strlen(n)+1],n);
      aux->val = x;
      aux->suivant = 0;
      if (debut == 0)
	{ debut = aux; }
      else {
	l = debut;
	while (l->suivant != 0)
	  { l = l->suivant;}
	l->suivant = aux;
      }
   }

template <class Type>
Mapping<Type> * Mapping<Type>::Ajouterf2(char * n,Type x)
    { Element * aux;
      Element * l;
      aux = new Element;
      aux->nom = strcpy(new char [strlen(n)+1],n);
      aux->val = x;
      aux->suivant = 0;
      if (debut == 0)
	{ debut = aux; }
      else {
	l = debut;
	while (l->suivant != 0)
	  { l = l->suivant;}
	l->suivant = aux;
      }
      return this;
    }

template <class Type>
void Mapping<Type>::Supprimer(char * n)
    { Element * aux, * prec=0;
      aux = debut;
      while (aux != 0 && strcmp(n,aux->nom))
	{prec = aux;
	 aux=aux->suivant;}
      if (aux != 0)
	{
	  if (prec == 0) debut = aux->suivant;
	  else prec->suivant = aux->suivant;
	  delete aux;
	}
    }

template <class Type>
Type Mapping<Type>::Recherche(char * n)
    { Element * aux=debut;
      Type v;
      while (aux != 0 && strcmp(n,aux->nom))
	aux=aux->suivant;
      if (aux) v = aux->val;
      return v;
    }

template <class Type>
int Mapping<Type>::Est_def(char * n)
    { Element * aux = debut;
      int res = 0;
      while (aux != 0 && strcmp(n,aux->nom))
	aux=aux->suivant;
      if (aux != 0) res=1;
      return res;
    }

template <class Type>
int Mapping<Type>::Est_defr(char * n,Type & t)
    { Element * aux = debut;
      int res = 0;
      while (aux != 0 && strcmp(n,aux->nom))
	aux=aux->suivant;
      if (aux) {res=1;
		t = aux->val;}
      return res;
    }

template<class Type>
void Mapping<Type>::Concat(Mapping<Type> * l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l->debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l->debut;
	}
    }

template<class Type>
Mapping<Type> * Mapping<Type>::Concat2(Mapping<Type> * l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l->debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l->debut;
	}
      return this;
    }

template <class Type>
int Mapping<Type>::Taille()
    { Element * aux = debut;
      int l = 0;
      while (aux != 0)
	{ aux = aux->suivant;
	  l++;}
      return l;
    }

template <class Type>
inline int Mapping<Type>::Est_vide()
    {return (debut == 0);}

template <class Type>
inline Type Mapping<Type>::Tete()
    { if (debut == 0) cout << " Erreur dans Mapping::Tete() " << endl;
      return debut->val;
    }

template<class Type>
inline char * Mapping<Type>::TeteN()
    { if (debut == 0) cout << " Erreur dans Mapping::Tete() " << endl;
      return debut->nom;
    }

template <class Type>
inline void Mapping<Type>::Reste()
    {
      if (debut == 0) cout << " Erreur dans Mapping::Reste() " << endl;
	 else debut = debut->suivant;
    }

template <class Type>
void Mapping<Type>::Vide()
    {
      Element * aux;
      Element * aux2;
      aux = debut;
      while (aux != 0)
	{ aux2 = aux;
	  aux = aux->suivant;
	  delete aux2->nom; // Nouveau : 14/06/97
	  delete aux2; }
      debut = 0;
    }


#endif
