%{


#include "arbre.h"
#include "env.h"
#include "lnu.h"
#include "specif.h"
#include "ta.h"
#include <stdlib.h>

  int yylinenumber = 0;

int yyerror(char * s)
{
  //cout << "!! :"<< s << " line : " << yylineno-1 << endl;
cout << "!! :"<< s << " line : " << yylinenumber << endl;
return 0;
}

 extern char * IdentL2String(Ident_L *);
 extern int yylex();
%}

%union {
  int Val;
  char * Id;
  Lnu * Form;
  OPC Oper;
  ASNoeud * Arbr;
  Liste<ASNoeud *> * LArbr;
  Mapping<Pt_Lnu> * Decl;
  Transition * Tra;
  Transition_L * TraL;
  TA * Ta;
  Ident_L * LCLO;
  Assign_L * LAFFECTA;
  Map_propL * LNOPROP;
  Synch_Vect * Sv;
  Pt_Synch_Vect_L * lsv;
  Fsynchro * Fs;
  Specif * spe;
  SetReg * setreg;
  RegionGraph * regg;
  Config * cf;
  STable * tabs;
  Id_LId * pidlid;
  Liste<Id_LId *> * pidlid_L;
  VerifElet * pverifelet;
  Liste<VerifElet *> * pLpverifelet;
}

%token <Val> NUMTOK 
%token <Id> IDTOK
%token AFF AUTOM DECL FSYNCH INVAR QUIT WITHOUT NUL ACTIVITIES
%token ACCOG ACCOD CROG CROD PARG PARD FSEP SEP FLECHE SOUL AROB
%token AND OR NOT BOT TOP IN EXISTS FORALL PLUS EGA SUP SUPE INFE INF IMPL STAR PARAM EUNTIL
%token REC SEN SAT QUOTE TABLE POINT SYSTEM
%token CLOCKS NODES TRANSITIONS ATOMIC PROPOSITIONS

%type <Form> lnuf
%type <Oper> test
%type <Val> vnum
%type <Id> label label2
%type <Decl> decldef equation list_eq list_eq2 list_inv list_inv2 invariant tainv

%type <Arbr>  exp litt
%type <LArbr> larg larg1

%type <Tra>  transition
%type <TraL> list_trans tatransition
%type <Ta> ta      
%type <LCLO> lclocks lclocks2 lclocks3 llabel2 lid lidplus taclocks tanodes
%type <LNOPROP> lnodes lnodes2 lap taprop taact lact
%type <LAFFECTA> laff laff2 laff3 laffc3

%type <Fs> fsyn fsyn_el1, fsyn_el2, fsyn_el3
%type <lsv> list_paire_id
%type <Sv> paire_id
%type <pidlid> paire_id_plid;
%type <pidlid_L> lpaire_id_plid;
%type <tabs> tablesynchro;
%type <pverifelet> eletverif
%type <pLpverifelet> listeletverif


%left OR
%left AND
%left NOT EXISTS FORALL 
%left IMPL EUNTIL
%left SUP ACCOD CROD IN
%right REC SEN


%%

input:  /* rien */ //{ cout << __PRETTY_FUNCTION__ << ' ' << __LINE__ << endl; }
       | input line 
;


line:      // { cout << "debut de la commande" << endl; } 
         commande FSEP {cout << endl << "% ";}
       | error FSEP  {cout << '\a' << endl << "% ";}
       | FSEP        {cout << endl << "% ";}
       | fin
;

 fin: QUIT FSEP  {cout << " -- end -- "<< endl;return 1;}
;


commande:    IDTOK larg {Envir.Eval(new ASNoeud($1,$2),1);}
/* {(new ASNoeud($1,$2))->Print();}  */
|  IDTOK AFF EGA exp {Envir.Eval(new ASNoeud($1,$4),1);}
	   /*{(new ASNoeud($1,$4))->Print();}*/
           |  AUTOM AFF IDTOK ta { Envir.Eval(new ASNoeud($3,new ASNoeud($4)),1);}
	   /*{(new ASNoeud($2,new ASNoeud($3)))->Print();}*/
           |  DECL AFF IDTOK decldef  {Envir.Eval(new ASNoeud($3,new ASNoeud($4)),1);}
	   /*{(new ASNoeud($2,new ASNoeud($3)))->Print();}*/
           |  FSYNCH AFF IDTOK fsyn  {Envir.Eval(new ASNoeud($3,new ASNoeud($4)),1);}
	   /*{(new ASNoeud($2,new  ASNoeud($3)))->Print();}*/
           |  TABLE AFF IDTOK tablesynchro  {Envir.Eval(new ASNoeud($3,new ASNoeud($4)),1);}
	   /*{(new ASNoeud($2,new  ASNoeud($3)))->Print();}*/
           |  SYSTEM AFF IDTOK PARG listeletverif PARD {Envir.Eval(new ASNoeud($3,new ASNoeud($5)),1);}


;

exp:          litt {$$ = $1;}
           | IDTOK larg {$$ = new ASNoeud($1,$2);}
           | PARG lnuf SEP IDTOK PARD {$$ = new ASNoeud(new Specif($2,$4));}
           | PARG lnuf SEP NOT PARD  
             {$$ = new ASNoeud(new Specif($2,new Declaration));}
;

larg:        /* vide */ {$$ = 0;}
           | PARG PARD {$$ = new Liste<ASNoeud *>;}
           | PARG larg1 PARD {$$ = $2;}
;

larg1:        exp SEP larg1     {$$ = $3->Ajouter2($1);}
           |  exp {$$ = new Liste<ASNoeud *>($1);}
;

litt:         PARG lnuf PARD {$$ = new ASNoeud($2);}    // LNU
           |  NUMTOK{$$ = new ASNoeud($1);}             // Num
           |  QUOTE IDTOK QUOTE {$$ = new ASNoeud(1,$2);} // Sring
           |  QUOTE QUOTE  lidplus QUOTE QUOTE {$$ = new ASNoeud(1,IdentL2String($3));}  // String + espace 
           |  lclocks {$$ = new ASNoeud($1);} // { xx , xx } 

;

lnuf:        lnuf AND lnuf    {$$ = new LnuCD (And,$1,$3);}
           |  lnuf OR lnuf     {$$ = new LnuCD (Or,$1,$3);}  
           |  lnuf IMPL lnuf   {$$ = new LnuBin (Impl,$1,$3);}  
           |  lnuf EUNTIL lnuf   {$$ = new LnuBin (EUntil,$1,$3);}  
           |  NOT lnuf         {$$ = new LnuUn (Not,$2);}
           |  BOT              {$$ = new LnuBool (Bot);}
           |  TOP              {$$ = new LnuBool (Top);}
           |  STAR AFF IDTOK      {$$ = new LnuBool (AP,$3,"*");}
           |  IDTOK AFF IDTOK        {$$ = new LnuBool (AP,$3,$1);}
/*           |  ACCOG label ACCOD lnuf     {$$ = new LnuMod (Diam,$2,$4);}  */
           |  INF label SUP lnuf     {$$ = new LnuMod (Diam,$2,$4);} 
           |  CROG label CROD lnuf       {$$ = new LnuMod (Box,$2,$4);}
           |  INF AROB SUP lnuf     {$$ = new LnuUn (Exists,$4);} 
           |  INF AROB WITHOUT lclocks2 SUP lnuf     
                     {$$ = new LnuUn (Exists,$6,$4);} 
           |  CROG AROB WITHOUT lclocks2  CROD lnuf       
                     {$$ = new LnuUn (Forall,$6,$4);}
           |  CROG AROB CROD lnuf       {$$ = new LnuUn (Forall,$4);}
           |  IDTOK IN lnuf              {$$ = new LnuMod (In,$1,$3);}
           |  IDTOK AFF EGA IDTOK PLUS NUMTOK IN lnuf              
                                  {$$ = new LnuMod (In,$1,$4,$6,$8);}
           |  IDTOK AFF EGA IDTOK IN lnuf              
                                  {$$ = new LnuMod (In,$1,$4,$6);}
           |  IDTOK AFF EGA NUMTOK IN lnuf              
                                  {$$ = new LnuMod (In,$1,$4,$6);}
           |  IDTOK                      {$$ = new LnuVar ($1);}           
           |  EXISTS lnuf             {$$ = new LnuUn (Exists,$2);}
           |  FORALL lnuf             {$$ = new LnuUn (Forall,$2);}
           |  PARG lnuf PARD          {$$ = $2;}
           |  IDTOK PLUS vnum test IDTOK PLUS vnum {$$ = new LnuTest($4,$1,$3,$5,$7);}
           |  IDTOK PLUS vnum test IDTOK           {$$ = new LnuTest($4,$1,$3,$5,0);}
           |  IDTOK PLUS vnum test vnum         {$$ = new LnuTest($4,$1,$3,"",$5);}
           |  IDTOK test IDTOK PLUS vnum           {$$ = new LnuTest($2,$1,0,$3,$5);}
           |  IDTOK test IDTOK                     {$$ = new LnuTest($2,$1,0,$3,0);}
           |  IDTOK test vnum                   {$$ = new LnuTest($2,$1,0,"",$3);}
           |  vnum test IDTOK PLUS vnum         {$$ = new LnuTest($2,"",$1,$3,$5);}
           |  vnum test IDTOK                   {$$ = new LnuTest($2,"",$1,$3,0);} 
;

vnum:        NUMTOK            {$$ = $1;}
| PARAM IDTOK       {$$ = (Envir.Est_def($2)) ? Envir.Recherche($2)->Oval(): Envir.VarNonDef("parameter",$2);}
;

 test:        EGA  {$$ = Egal;}
           |  SUP  {$$ = Sup;}
           |  SUPE {$$ = Supe;}
           |  INF  {$$ = Inf;}
           |  INFE {$$ = Infe;}
;

 decldef:      CROG list_eq CROD   {$$ = $2;}
;

 list_eq:     /* liste vide */ {$$ = new Declaration;}
           |  list_eq2         {$$ = $1;}
;
 list_eq2:    equation FSEP list_eq2  {$$ = $1->Concat2($3);}
           |  equation               {$$ = $1;}
;
equation:    IDTOK EGA lnuf            {$$ = new Declaration($1,$3->Normal());}
;

 ta:      CROG lclocks FSEP lnodes FSEP ACCOG list_trans ACCOD CROD 
             {$$ = new TA($2,$4,$7);}
           | CROG lclocks FSEP lnodes FSEP list_trans CROD 
             {$$ = new TA($2,$4,$6);}  /* old version ! */
          |  CROG lclocks FSEP lnodes FSEP ACCOG list_trans ACCOD FSEP INVAR AFF list_inv CROD
             {$$ = new TA($2,$4,$7,$12);} 
/*    | CROG taclocks tanodes tatransition tainv CROD
      {$$ = new TA($2,$3,$4,$5);} */
    | CROG taclocks tanodes tatransition tainv taprop taact CROD
           {$$ = new TA($2,$3,$4,$5,$6,$7);}
;


taclocks:   CLOCKS AFF lclocks2 {$$ = $3}
            | /* liste vide */ {$$ = new Ident_L;}
;

tanodes:    NODES AFF lclocks2 {$$ = $3}
/*            |                {$$ = new Ident_L;} */
;

tatransition: TRANSITIONS AFF list_trans {$$ = $3}
            | /* liste vide */ {$$ = new Transition_L;}
;

tainv:        INVAR AFF list_inv   {$$ = $3}
            | /* liste vide */ {$$ = 0;}
;

taprop: ATOMIC PROPOSITIONS AFF lap {$$ = $4;}
            | /* liste vide */ {$$ = 0;}
;

taact: NUL ACTIVITIES AFF lact {$$ = $4;}
            | /* liste vide */ {$$ = 0;}
;

 list_trans: list_trans FSEP transition     {$$ = $1->Ajouter2($3);}
           | list_trans SEP transition     {$$ = $1->Ajouter2($3);}
           | transition                    {$$ = new Transition_L ($1);}
;
 transition: IDTOK NOT label SEP lnuf SEP laff FLECHE IDTOK 
                   {$$ = new Transition($1,$9,$3,$7,$5);}
         | IDTOK NOT label SEP laff FLECHE IDTOK 
                   {$$ = new Transition($1,$7,$3,$5,new LnuBool(Top));}
         | IDTOK NOT label SEP lnuf FLECHE IDTOK 
                   {$$ = new Transition($1,$7,$3,new Assign_L,$5);}
         | IDTOK NOT label FLECHE IDTOK 
                   {$$ = new Transition($1,$5,$3,new Assign_L,new LnuBool(Top));}

;

 label: IDTOK  {$$ = $1;}
      | IDTOK REC  {$$ = Add_Rec($1);}
      | IDTOK SEN  {$$ = Add_Sen($1);}
;

 list_inv:     /* liste vide */ {$$ = new Declaration;}
           |  list_inv2         {$$ = $1;}
;
 list_inv2:   list_inv2 FSEP invariant  {$$ = $3->Concat2($1);}
           |  list_inv2 SEP invariant  {$$ = $3->Concat2($1);}
           |  invariant               {$$ = $1;}
;
 invariant:    IDTOK SAT lnuf            {$$ = new Declaration($1,$3->Normal());}
;

lap:       lap SEP IDTOK SAT lid {$$ = $1->Ajouterf2($3,$5);}
           | IDTOK SAT lid       {$$ = new Map_propL($1,$3);}
; 


lidplus:       lidplus IDTOK {$$ = $1->Ajouterf2($2);}
           | lidplus OR {$$ = $1->Ajouterf2(strcpy(new char[2],"v"));}
           | lidplus PARG {$$ = $1->Ajouterf2(strcpy(new char[2],"("));}
           | lidplus PARD {$$ = $1->Ajouterf2(strcpy(new char[2],")"));}
           | lidplus POINT {$$ = $1->Ajouterf2(strcpy(new char[2],"."));}
           | lidplus SEP {$$ = $1->Ajouterf2(strcpy(new char[2],","));}
           | lidplus FSEP {$$ = $1->Ajouterf2(strcpy(new char[2],";"));}
           | lidplus AFF {$$ = $1->Ajouterf2(strcpy(new char[2],":"));}
           | lidplus REC {$$ = $1->Ajouterf2(strcpy(new char[2],"?"));}
           | lidplus SEN {$$ = $1->Ajouterf2(strcpy(new char[2],"!"));}
           | IDTOK {$$ = new Ident_L($1);}
           | OR {$$ = new Ident_L(strcpy(new char[2],"v"));}
           | PARG {$$ = new Ident_L(strcpy(new char[2],"("));}
           | PARD {$$ = new Ident_L(strcpy(new char[2],")"));}
           | POINT {$$ = new Ident_L(strcpy(new char[2],"."));}
           | SEP {$$ = new Ident_L(strcpy(new char[2],","));}
           | FSEP {$$ = new Ident_L(strcpy(new char[2],";"));}
           | AFF {$$ = new Ident_L(strcpy(new char[2],":"));}
           | REC {$$ = new Ident_L(strcpy(new char[2],"?"));}
           | SEN {$$ = new Ident_L(strcpy(new char[2],"!"));}
;

lid:       lid IDTOK {$$ = $1->Ajouter2($2);}
           | IDTOK {$$ = new Ident_L($1);}
;

lact:       lact SEP IDTOK AFF lid {$$ = $1->Ajouterf2($3,$5);}
           | IDTOK AFF lid       {$$ = new Map_propL($1,$3);}
; 

laff: ACCOG laff2 ACCOD        {$$ = $2;}
;

 laff2:  /* vide */                {$$ = new Assign_L;}
           | laff3                 {$$ = $1;}
           | laffc3                 {$$ = $1;}
;
 laff3:   laff3 SEP IDTOK AFF EGA IDTOK PLUS vnum   
               {$$ = $1->Ajouterf2(Assign($3,$6,$8));}
           | laff3 SEP IDTOK AFF EGA IDTOK    
               {$$ = $1->Ajouterf2(Assign($3,$6,0));}
           | laff3 SEP IDTOK AFF EGA vnum
               {$$ = $1->Ajouterf2(Assign($3,0,$6));}
           | IDTOK AFF EGA IDTOK PLUS vnum   {$$ = new Assign_L(Assign($1,$4,$6));}
           | IDTOK AFF EGA IDTOK    {$$ = new Assign_L(Assign($1,$4,0));}
           | IDTOK AFF EGA vnum    {$$ = new Assign_L(Assign($1,0,$4));}
;


 laffc3:   laffc3 SEP IDTOK          {$$ = $1->Ajouter2(Assign($3,0,0));}
           | IDTOK                       {$$ = new Assign_L(Assign($1,0,0));}
;


 lclocks: ACCOG lclocks2 ACCOD        {$$ = $2;}
;
 lclocks2:  /* vide */                {$$ = new Ident_L;}
           | lclocks3                 {$$ = $1;}
;
 lclocks3:   lclocks3 SEP IDTOK          {$$ = $1->Ajouterf2($3);}
           | IDTOK                       {$$ = new Ident_L($1);}
;

 lnodes: ACCOG lnodes2 ACCOD        {$$ = $2;}
;

 lnodes2:   lnodes2 SEP IDTOK                         {$$ = $1->Ajouterf2($3,0);}
           | lnodes2 SEP PARG IDTOK FSEP lclocks2 PARD {$$ = $1->Ajouterf2($4,$6);}
           | IDTOK                                    {$$ = new Map_propL($1,0);}
           | PARG IDTOK FSEP lclocks2 PARD             {$$ = new Map_propL($2,$4);}
;   /* lclocks represente une liste de prop */

 fsyn: ACCOG fsyn_el1 ACCOD           {$$ = $2;}
;
 fsyn_el1:    /* vide */              {$$ = new Fsynchro;}
            | fsyn_el2                {$$ = $1;}
;
 fsyn_el2: fsyn_el2 FSEP fsyn_el3     {$$ = $1->Concat2($3);}
           | fsyn_el3                 {$$ = $1;}
;
 fsyn_el3: label FLECHE ACCOG list_paire_id ACCOD {$$ = new Fsynchro($1,$4);}
| STAR FLECHE ACCOG PARG STAR SEP SOUL PARD ACCOD 
     {$$ = new Fsynchro("*",new Pt_Synch_Vect_L(new Synch_Vect("*","")));}
| STAR FLECHE ACCOG PARG STAR SEP POINT PARD ACCOD 
     {$$ = new Fsynchro("*",new Pt_Synch_Vect_L(new Synch_Vect("*","")));}
| STAR FLECHE ACCOG PARG SOUL SEP STAR PARD ACCOD 
     {$$ = new Fsynchro("*",new Pt_Synch_Vect_L(new Synch_Vect("","*")));}
| STAR FLECHE ACCOG PARG POINT SEP STAR PARD ACCOD 
     {$$ = new Fsynchro("*",new Pt_Synch_Vect_L(new Synch_Vect("","*")));}
;
 list_paire_id: list_paire_id FSEP paire_id {$$ = $1->Ajouter2($3);}
                | paire_id     {$$ = new Pt_Synch_Vect_L($1);}
;
 paire_id: PARG label SEP label PARD  {$$ = new Synch_Vect($2,$4);}
           | PARG label SEP SOUL PARD {$$ = new Synch_Vect($2,"");}
           | PARG label SEP POINT PARD {$$ = new Synch_Vect($2,"");}
           | PARG SOUL SEP label PARD {$$ = new Synch_Vect("",$4);}
           | PARG POINT SEP label PARD {$$ = new Synch_Vect("",$4);}
;

tablesynchro: ACCOG PARG lclocks2 PARD FSEP lpaire_id_plid ACCOD 
{$$ = new STable($3,$6);}

lpaire_id_plid: lpaire_id_plid FSEP paire_id_plid     {$$ = $1->Ajouter2($3);}
           | paire_id_plid     {$$ = new Liste<Id_LId *>($1);}
;

paire_id_plid: PARG llabel2 PARD FLECHE label2 {$$ = new Id_LId($5,$2);}
;

llabel2:   llabel2 SEP label2          {$$ = $1->Ajouterf2($3);}
           | label2                       {$$ = new Ident_L($1);}
;

label2: label {$$ = $1}
      | POINT {$$ = strcpy(new char[2],".");}
;

listeletverif: listeletverif SEP eletverif {$$ = $1->Ajouterf2($3);}
             | eletverif {$$ = new Liste<VerifElet *>($1);}

eletverif: IDTOK CROG NUMTOK NUMTOK NUMTOK NUMTOK NUMTOK CROD 
                             {$$ = new VerifElet($1,$3,$4,$5,$6,$7);}
           |  IDTOK          {$$ = new VerifElet($1);}

%%
