/* File: number.h -- Francointntumbers -- Last modified on 24 Feb 1998
 * 	
 *      
 *
 */

#include <string.h>

#ifndef MUMBER_H
#define MUMBER_H

template <class Type>
class Number {
 private:

  class Element {
  public:
    int num;
    Type val;
    Element * suivant;
  };
  typedef Element * Ptr_Element;

  Ptr_Element debut;

 public:

  Number()
    {debut = 0;}

  Number(int n,Type x)
    {debut = 0;
     Ajouter(n,x);}

  void Ajouter(int n, Type x);

  Number * Ajouter2(int n, Type x);

  void Ajouterf(int n,Type x);

  void Supprimer(int n);

  Type Recherche(int n);

  int Est_def(int n);

  int Est_defr(int n,Type & t);

  void Concat(Number * l);

  Number * Concat2(Number * l);

  int Taille();

  int Est_vide();

  int TeteN();

  Type Tete();

  void Reste();

  void Vide();

};

template <class Type>
inline void Number<Type>::Ajouter(int n, Type x)
    { Element * aux;
      aux = new Element;
      aux->num = n;
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
   }
template <class Type>
Number<Type> * Number<Type>::Ajouter2(int n, Type x)
    { Element * aux;
      aux = new Element;
      aux->num = n;
      aux->val = x;
      aux->suivant = debut;
      debut = aux;
      return this;
   }

template <class Type>
void Number<Type>::Ajouterf(int n,Type x)
    { Element * aux;
      Element * l;
      aux = new Element;
      aux->num = n;
      aux->val = x;
      aux->suivant = 0;
      if (debut == 0)
	{ debut = aux; }
      else {
	l = debut;
	while (l->suivant != 0)
	  { l = l->suivant;}
	l->suivant = aux;
      }
   }

template <class Type>
void Number<Type>::Supprimer(int n)
    { Element * aux, * prec=0;
      aux = debut;
      while ((aux != 0) && (n != aux->num))
	{prec = aux;
	 aux=aux->suivant;}
      if (aux != 0)
	{
	  if (prec == 0) debut = aux->suivant;
	  else prec->suivant = aux->suivant;
	  delete aux;
	}
    }

template <class Type>
Type Number<Type>::Recherche(int n)
    { Element * aux=debut;
      Type v;
      while (aux != 0 && (n != aux->num))
	aux=aux->suivant;
      if (aux) v = aux->val;
      return v;
    }

template <class Type>
int Number<Type>::Est_def(int n)
    { Element * aux = debut;
      int res = 0;
      while (aux != 0 && (n != aux->num))
	aux=aux->suivant;
      if (aux != 0) res=1;
      return res;
    }

template <class Type>
int Number<Type>::Est_defr(int n,Type & t)
    { Element * aux = debut;
      int res = 0;
      while (aux != 0 && (n != aux->num))
	aux=aux->suivant;
      if (aux) {res=1;
		t = aux->val;}
      return res;
    }

template<class Type>
void Number<Type>::Concat(Number<Type> * l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l->debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l->debut;
	}
    }

template<class Type>
Number<Type> * Number<Type>::Concat2(Number<Type> * l)
    {
      Element * aux;
      aux = debut;
      if (aux == 0) debut = l->debut;
      else
	{ while (aux->suivant != 0)
	    { aux = aux->suivant; }
	  aux->suivant = l->debut;
	}
      return this;
    }

template <class Type>
int Number<Type>::Taille()
    { Element * aux = debut;
      int l = 0;
      while (aux != 0)
	{ aux = aux->suivant;
	  l++;}
      return l;
    }

template <class Type>
inline int Number<Type>::Est_vide()
    {return (debut == 0);}

template <class Type>
inline Type Number<Type>::Tete()
    { if (debut == 0) cout << " Erreur dans Number::Tete() " << endl;
      return debut->val;
    }

template<class Type>
inline int Number<Type>::TeteN()
    { if (debut == 0) cout << " Erreur dans Number::Tete() " << endl;
      return debut->num;
    }

template <class Type>
inline void Number<Type>::Reste()
    {
      //      Number<Type> l;
      if (debut == 0) cout << " Erreur dans Number::Reste() " << endl;
	 else debut = debut->suivant;
    }

template <class Type>
void Number<Type>::Vide()
    {
      Element * aux;
      Element * aux2;
      aux = debut;
      while (aux != 0)
	{ aux2 = aux;
	  aux = aux->suivant;
	  delete aux2; }
      debut = 0;
    }


#endif

