/* File: region.cc -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      ceci est un modele d'en-tete de fichier C++
 *
 */

#include <assert.h>
#include <stdio.h>
#include "lnu.h"
#include "setval.h"

int max(int i,int j)
{return (i<j) ? j : i;}

int min(int i,int j)
{return (i<j) ? i : j;}

int Impaire(int i)
{if (i<0) return ((-i)% 2);
 else return (i%2);
}


// utilise pour calculer l'enveloppe convexe de tps en tps...
// retourne un entier entre 0 et i-1
/*
int Alea(int i)
{
int k;
k = rand() % i;
return k;
}
*/


//-------------------------------------------------------
//                   Class RegionGraph
//-------------------------------------------------------


// plutot qu'un mapping il suffit d'une Ident_L et d'un entier (Max) 
// et d'un entier ishyb...
RegionGraph::RegionGraph(Ident_L l,int mc,int ishyb)
{
  int cp=1;  // on numerote les horloges a partir de 1 !

N = l.Longueur();

 if (N) {
   Name = new Ident[N+1];
 }
 else {
   Name = 0;
 }
 Code = new Mapping<int>;

 _hybrid=ishyb;
 _Max= mc;

while (! l.Est_vide()) {
  Name[cp] = l.Tete();
  Code->Ajouter(l.Tete(),cp);
  cp++;
  l.Reste();
  }

}


// construire un rg par fusion de deux rg... les horloges de
// meme nom sont considerees comme identiques.

RegionGraph::RegionGraph(RegionGraph * r1,RegionGraph * r2)
{

  // on construit une liste d'horloges sans doublon.
  Ident_L l;
  int i,j,m;
  for (i=1 ;i <= r1->N;i++)
    l.Ajouterf(r1->Name[i]);

  for (i=1; i <= r2->N; i++) {
    j=1;
    while ( (j<= r1->N) && (! Eq_str(r1->Name[j],r2->Name[i]))) j++;
    if (j> r1->N) 
      l.Ajouter(r2->Name[i]);
  }

  m = (r1->_Max < r2->_Max) ? r2->_Max : r1->_Max;
  i = (r1->_hybrid || r2->_hybrid) ? 1 : 0;

  (*this) = RegionGraph(l,m,i);
  l.Vide();

}


// teste si r est contenu dans this...

int RegionGraph::Contient(RegionGraph * r)
{
  int res = 1;
  int i,j;

  // on verifie que toutes les horloges de r sont dans this
  for (i=1; i <= r->N;i++) {
    j=1;
    while ( (j<= N) && (! Eq_str(Name[j],r->Name[i]))) j++;
    if (j> N) 
      res = 0;
  }

  // on verifie que la cste max de r est < a celle de this
  if (_Max < r->_Max)
    res=0;
  
  return res;
}



int RegionGraph::Taille()
{return N;}

Ident RegionGraph::NameC(int i)
{
if (__DBMPLC==0) return Name[i];
 else return Name[i+1];
}

int RegionGraph::CodeC(Ident n)
{
  if (__DBMPLC==0) return Code->Recherche(n);
  else return Code->Recherche(n)-1;  // Pour PPL on n'a pas d'horloge x0=0 !!
}

int RegionGraph::Is_hybrid()
{return _hybrid;}

int RegionGraph::MaxC()
{
if ((__HYBRID) && (__FIXPOINT))  // pour les hitzone, on se contente de la cste max
  return __CMAX;
return _Max;}

void RegionGraph::Print()
{
  cout << " Region Graph : ";
  if (_hybrid) cout << "(hybrid)";
  cout << endl;
  cout << " Maximal constant: " << _Max << endl;
  cout << N << " clocks : " << endl;

int i;
 if (N) {
   cout << Name[1]; cout << "(" << CodeC(Name[1]) << ") ";
   for (i = 2; i < N+1; i++)
     cout << "," << Name[i] << "(" << CodeC(Name[i]) << ") "; 
 }
 cout << endl;
 /*
Mapping<int> ec = *Code;
 while (!ec.Est_vide()) {
   cout << ec.TeteN() << " -> " << ec.Tete() << endl;
   ec.Reste();
 }
 */
}

void RegionGraph::Destroy()
{

  for (int i=1;i<N+1;i++) 
    if (Name[i]) 
      delete(Name[i]);
  delete [] Name;

if (Code) 
  Code->Vide();
delete Code;
Code = 0;
delete this; 

}



SetReg::SetReg(RegionGraph * r,int i)
{
rg = r;
lz.Vide();
 __CPSR++;

if (i) 
  lz.Ajouter(new Zone(rg));
}

SetReg::SetReg(Zone * z)
{
 __CPSR++;
lz.Vide();
if (z) 
  {
    rg = z->Get_RegionG();
    lz.Ajouter(z->Copy());
  }
}

SetReg::SetReg(Zone * z1,Zone * z2)
{
 __CPSR++;
lz.Vide();
lz.Ajouter(z1->Copy());
Union(z2);
}

SetReg::SetReg(RegionGraph * r, Liste<Pt_Zone> l)
{
 __CPSR++;
lz.Vide();
lz = l;
rg = r;
}

//-------------------------------------------------------
//                     SETREG::divers
//-------------------------------------------------------

Liste<Pt_Zone> SetReg::Get_lz()
{return lz;}

void SetReg::Put_lz(Liste<Pt_Zone> l)
{lz = l;}

RegionGraph * SetReg::Get_rg()
{return rg;}

void SetReg::ExtensionRG(RegionGraph * r)
{
  Zone * zaux;
  for (Liste<Pt_Zone> laux = lz; !laux.Est_vide(); laux.Reste()) {
    zaux = laux.Tete();
    zaux->ExtensionRG(r);
  }
  rg = r;
}


Zone * SetReg::FstZone()
{
assert(! lz.Est_vide());

// if (lz.Est_vide()) 
//   {cout << " Erreur dans SetReg::FstZone() ! " << endl;
//    return (Zone *) 0;}


return lz.Tete();
}

void SetReg::ResteZone() 
{
assert(!lz.Est_vide());
lz.Cdr();
}

void SetReg::SupprimerZn(int c)
{
assert(c <= lz.Longueur());
lz.Supprimer(c);
}



int SetReg::Est_vide_lz()
{ return (lz.Est_vide());}


//-------------------------------------------------------
//                     SETREG::COMPACTER
//-------------------------------------------------------
// essaie de remplacer lz par un singleton ne contenant que l'enveloppe
// convexe. Retourne 1 si succes.

int SetReg::Compacter()
{
  int res=0;
  Zone * zc, * z;

  if (lz.Longueur() < 2) 
    return 1;

  zc = ConvexH();
  if (Est_inclu(zc)) {
    res = 1;
    __OPTICOMPACT++;
    while (!lz.Est_vide()) {
      z= lz.Tete();
      z->Destroy();
      delete z;
      lz.Cdr();
    }
    lz.Ajouter(zc);
  }
  __NOPTICOMPACT++;

  return res;
}



//-------------------------------------------------------
//                     SETREG::UNION (z)
//-------------------------------------------------------


void SetReg::Union(Zone * z)
{
Liste<Pt_Zone> laux = lz;
Liste<Pt_Zone> lres;

Zone * zaux;   // 22-01-98 : utilisation d'un pointeur au lieu d;une variable.
int fin=0;

if (z->Est_vide()) 
  return;

while (! fin && (! laux.Est_vide())) {
  zaux = laux.Tete();
  if (zaux->Est_inclu(z))
	fin = 1;
  else if (z->Est_inclu(zaux))
    {  	  lres.Ajouter(z->Copy());   // copy : ajout du 25/06
          laux.Cdr();
	  zaux->Destroy();  // 02/04
	  delete zaux;
	  fin=2;
	  }
  else {
    lres.Ajouter(zaux);
    laux.Cdr();
  }
  }

if (! fin) {
  lres.Ajouter(z->Copy());  // copy : ajout du 25/06
}
else 
  if (fin == 1)
    lres.Concat(laux);
  if (fin == 2)
    {
      // test si le reste de laux est inclu dans z...
      while (!laux.Est_vide()) {
	zaux = laux.Tete();
	if (! z->Est_inclu(zaux))
	  lres.Ajouter(zaux);
	else {zaux->Destroy();  // 02/04
	      delete zaux;}
	laux.Cdr();
      }
    }
lz = lres;

}


//-------------------------------------------------------
//                     SETREG::UNION_W (z)
//-------------------------------------------------------
// weak union for computing the hitzones

void SetReg::UnionW(Zone * z)
{ 
Liste<Pt_Zone> laux = lz;
Zone * zsup, * zfuture = (z->Add_FutureC());
Zone zaux (rg), * auxfuture;
 __CPZONE--; // on ne compte pas zaux
int fin=0;
int cp = 0;


if (z->Est_vide()) {
  zfuture->Destroy();
  delete zfuture;
  return;
}

while (! fin && (! laux.Est_vide())) {
  zaux = * laux.Tete();
  cp++;
  if (zaux.Est_equiv(z))
    fin = 1;
  else if (zaux.Est_equiv(zfuture))
    fin = 1;
  else {
    auxfuture = zaux.Add_FutureC();
    if (z->Est_equiv(auxfuture)) {
      zsup = lz.SupprimerRes(cp);
      zsup->Destroy();
      delete zsup;
      lz.Ajouter(z->Copy());
      fin = 1;
    }
    else laux.Reste();
  }
}
if (! fin) lz.Ajouter(z->Copy());  
zfuture->Destroy();
delete zfuture;
}

//-------------------------------------------------------
//                     SETREG::UNION_W (z)
//-------------------------------------------------------
// very weak union for computing the hitzones

void SetReg::UnionWW(Zone * z)
{ 
Liste<Pt_Zone> laux = lz;
Zone zaux (rg); __CPZONE--;
int fin=0;

if (z->Est_vide()) {
  return;
}

while (! fin && (! laux.Est_vide())) {
  zaux = * laux.Tete();
  if (zaux.Est_equiv(z))
    fin = 1;
  laux.Reste();
}
if (! fin) lz.Ajouter(z->Copy());  
}

//-------------------------------------------------------
//                     SETREG::UNION (sr)
//-------------------------------------------------------

void SetReg::Union(SetVal * sr)
{
Zone * zaux;
 SetReg * saux = (SetReg *) sr;
Liste<Pt_Zone> laux = saux->lz;
// static __test=0;
// static __testok=0;
// __test++;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  this->Union(zaux);
  laux.Reste();
  }

/*  
// On essaie de reduire lz a`  son enveloppe convexe...
 if ((lz.Longueur() >= 3*rg->Taille()) && (Alea(100) < 1)) {
   __testok++;
   cout << __test << " - " << __testok << " - " << __OPTIFORALL1 << endl;
   Zone * zc = ConvexH();
   if (Est_inclu(zc)) {
     //     cout << " ca marche avec :";zc->Print();cout << " pour " << endl;
     //     Print();
     __OPTIFORALL1++;
     while (!lz.Est_vide()) {
       z= lz.Tete();
       z->Destroy();
       lz.Cdr();
     }
     lz.Ajouter(zc);
   }
   else {
     __OPTIFORALL2++;
     zc->Destroy();
   }
 }
*/

}

//-------------------------------------------------------
//                     SETREG::INTERSECTION (z)
//-------------------------------------------------------

void SetReg::Intersection(Zone * z)
{
Liste<Pt_Zone> exlz;
Zone * zaux;
SetReg Sres(rg);  __CPSR--;

exlz=lz;
while (! lz.Est_vide()) {
  zaux = lz.Tete();
  zaux->Intersection(z);
  if (! zaux->Est_vide()) 
    Sres.Union(zaux);
  zaux->Destroy(); 
  delete zaux;
  lz.Reste();
  }

exlz.Vide();
lz = Sres.lz;

/*  Ancienne version - 02/04/98
exlz=lz;
while (! lz.Est_vide()) {
  zaux = lz.Tete();
  zaux->Intersection(z);
  if (! zaux->Est_vide()) laux.Ajouter(zaux);
  else zaux->Destroy(); // 27-01-98
  lz.Reste();
  }

exlz.Vide();
lz = laux;
*/
}


//-------------------------------------------------------
//                     SETREG::INTERSECTION (sr)
//-------------------------------------------------------

void SetReg::Intersection(SetVal * sr)
{
  SetReg * sr2 = (SetReg *) sr;
Liste<Pt_Zone> laux = sr2->lz;
Zone * zaux;
SetReg * saux, * sres;
sres = new SetReg(rg);

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  saux = (SetReg *) this->Copy();
  saux->Intersection(zaux);
  if (! saux->Est_vide()) sres->Union(saux);
  saux->Destroy();  // 27-01-98 !!!
  laux.Reste();
  }

// detruire lz !
laux = lz;
while (! lz.Est_vide()) {
  lz.Tete()->Destroy();
  delete lz.Tete();
  lz.Reste();
}
laux.Vide();
lz = sres->lz;
delete sres; __CPSR--;
}


//-------------------------------------------------------
//                     SETREG::CONVEXH
//-------------------------------------------------------

Zone * SetReg::ConvexH()
{
Zone * res;
Liste<Pt_Zone>laux = lz;

if (laux.Est_vide()) 
  res = new Zone(rg,1); // zone vide
 else {
   res = laux.Tete()->Copy();
   laux.Reste();
   while (! laux.Est_vide()) {
     res->ApproxUnion(laux.Tete());
     laux.Reste();
   }
 }
return res;
}



//-------------------------------------------------------
//                     SETREG::ADD_PAST
//-------------------------------------------------------

// cforall = 1 ssi on est ds le calcul de Forall -> on sous-approxime !
// par defaut: cforall = 0
void SetReg::Add_Past(Ident_L *ls,int cforall)
{
Liste<Pt_Zone> laux = lz;
Zone * zaux;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  zaux->Add_Past(ls,cforall);
  laux.Reste();
  }
}

//-------------------------------------------------------
//                     SETREG::ADD_FUTURE
//-------------------------------------------------------
// ls contient la liste des horloges inactives... (pente 0)
void SetReg::Add_Future(Ident_L *ls)
{
Liste<Pt_Zone> laux = lz;
Zone * zaux;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  zaux->Add_Future(ls);
  laux.Reste();
  }
}


void SetReg::Add_FermetureTemp(Ident_L *ls)
{
Liste<Pt_Zone> laux = lz;
Zone * zaux;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  zaux->Add_FermetureTemp(ls);
  laux.Reste();
  }
}


// ----------------------------------------------------------------
//                 SetReg::Forall
//-----------------------------------------------------------------
// ne retient que la partie P de this telle que Future(P) 
// est inclue dans P

void SetReg::Forall(Ident_L *lst)
{
  Liste<Pt_Zone> laux, lr, ls;
  Zone * z, * zc;
  int nbnborne =0; 
  SetReg * comple, * caux; 
  SetReg * copie1;
  //  SetReg * copie2;

//  SetReg * Saux;	   
//  int trouve, cpteur;
//  Zone *u, *zj;	   
//  Liste<Pt_Zone> l1;


  // cout << "-> SetReg::Forall avec : "; PrintIdent_L(lst);
  // cout << " et ;"; Print();


if (lz.Longueur()==0) 
  return;

if (lz.Longueur() == 1) {
  z = lz.Tete();
  z->Forall(lst);
  if (z->Est_vide()) {
    z->Destroy();
    delete z;
    lz.Vide();   
  }
  return;
}

 laux = lz;
 while (! laux.Est_vide()) {
   z = laux.Tete();
   if (z->Est_NonBorne(lst)) {
     nbnborne++;
     lr.Ajouter(z);
   }
   else ls.Ajouter(z);
   laux.Reste();
 }     

 if (nbnborne == 0) {   // le resultat est l'ensemble vide
   __OPTIZONE++;
   for (laux=lz;!laux.Est_vide();laux.Reste()) {
     laux.Tete()->Destroy();
     delete laux.Tete();
   }
   lz.Vide();
   return;
 }
 else if (nbnborne == lz.Longueur()) {
   __OPTIZONE++;
   return ;   // rien a`  faire...
 }


 // utiliser Compacter est couteux: on fait deux fois le meme complement : dans
 // Compacter (Est_inclu) et ensuite dans Exforall...
 // Plutot que ...
 //     if (Compacter()) 
 //       return;  // car dans ce cas _la_ zone est non-bornee...
 // ... On prefere donc calculer le complement et le passer en parametre a`  ExForall
  zc = ConvexH();
  comple = (SetReg *) Complement(); 
  caux = (SetReg *) comple->Copy();
  caux->Intersection(zc);
  if (caux->Est_vide()) {
    __OPTICOMPACT++;
    while (!lz.Est_vide()) {
      z= lz.Tete();
      z->Destroy();
      delete z;
      lz.Cdr();
    }
    zc->Forall(lst);    // ajoute le 3/11/99 !
    lz.Ajouter(zc);
    caux->Destroy();
    comple->Destroy();
    return ;
  }
  __NOPTICOMPACT++;
  zc->Destroy();   // ajout du 10-10-98
  delete zc;
  caux->Destroy(); // ajout du 10-10-98

  /// Il reste a` appliquer les grands moyens...


  copie1 = (SetReg *) this->Copy();
//copie2 = this->Copy();

copie1->Forall1(comple,lst);
// copie2->Forall2(ls,lr);


// On compare...
/*
// Comparaison
 if (! copie1->Est_inclu(copie2)) {
   cout << "C2 n'est pas inclu dans le resultat naif C1 !" << endl;
   cout << "Argument : "<< endl;
   aux->Print();
   cout << "On a trop de truc dans C2 !"<< endl << " C2 : " << endl;
   copie2->Print();
   cout << " Res. naif : " << endl;
   copie1->Print();

 }
 else 
 if (! copie2->Est_inclu(copie1)) {
   cout << "Le resultat naif C1 n'est pas inclu dans C2 !" << endl;
   cout << "Argument : "<< endl;
   aux->Print();
   cout << "On n'a pas assez de trucs dans C2 !" << endl << " C2 : " << endl;
   copie2->Print();
   cout << " Res. naif : " << endl;
   copie1->Print();
 }
*/



// On fait le menage...

lr.Vide();
ls.Vide();

comple->Destroy();
while (!lz.Est_vide()) {
      z= lz.Tete();
      z->Destroy();
      delete z;
      lz.Cdr();
    }
lz = copie1->Get_lz();
delete copie1; __CPSR--;

//copie2->Destroy();

 return; 
}




// Nouvelle version (a tester...)

void SetReg::Forall2(Liste<Pt_Zone> ls, Liste<Pt_Zone> lr)
{
 // Nouvelle version
  //  int cont = 1;
  SetReg * S = new SetReg(rg,ls);
  SetReg * R = new SetReg(rg,lr);
  

  /* A continuer...
lz.Vide();
 
 while (cont) {

   // On cherche un couple (z,zj) verifiant:
   // IntersecBar(z,zj) = g =/= 0 ^ Intersection(z,Past(g)) =/= 0 ^ 
   // Intersection(z,Past(g)) non inclu dans lr 

   l1=S->Get_lz();
   cont = ! l1.Est_vide();
   trouve = 0;
   cpteur = 1;
   while (cont) {
     z = l1.Tete();
     trouve = Rechercher_zj(z,u,zj,R);
      if (!trouve) {
       l1.Reste();
       cpteur++;
       cont = !l1.Est_vide();
     } 
     else {
       S->SupprimerZn(cpteur);
       cont = 0;
     }
   }
   if (!trouve) cont=0; // il n'y a pas de couple !
   else {
     cont = 1;
     Saux = z->Extraire(u);
     S->Union(Saux);
     u->Add_Future();
     u->AjouterBord(zj,z); // on essaie de remplacer les x-y <> par
                         // des <=>= si c'est possible
     R->Union(u);

     // z->Destroy(); ??? 

     //     cout << "Forall : on ajoute u = "; u->Print(); cout << endl;
     //     cout << "On ajoute dans S : " << endl; Saux->Print();
   }
 }

 */

  // S->Destroy();
//lz = R->Get_lz();
 
// le resultat ++ est R...
/// on le compare a`  l'ancienne methode...

// copie->ExForall(R,comple);
// comple->Destroy();
// 
// lz = copie->Get_lz();
// 

S->Destroy();
R->Destroy();
}


// Version naive ... (avec double complement)
// on passe le complement de this en argument pour eviter de le recalculer...

void SetReg::Forall1(SetReg * Comple,Ident_L *ls)
{
Liste<Pt_Zone> laux;

SetReg * res;
Comple->Add_Past(ls,1);
 res = (SetReg *) Comple->Complement();
laux = lz;
while (! lz.Est_vide()) {
  lz.Tete()->Destroy();
  delete lz.Tete();
  lz.Reste();
}
laux.Vide();
lz = res->lz;
delete res; __CPSR--;
}


//-------------------------------------------------------
//                     SETREG::REV_IN
//-------------------------------------------------------

void SetReg::Rev_In(Ident c,Ident ca, int ia)
{
Liste<Pt_Zone> laux = lz;
Zone * zaux;
int cp=0;
SetReg Sres(rg); __CPSR--;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  cp++;
  zaux->Rev_In(c,ca,ia);
  if (! zaux->Est_vide()) 
    Sres.Union(zaux);
  zaux->Destroy();
  laux.Reste();
}
lz.Vide();
lz = Sres.lz;

}

//-------------------------------------------------------
//                     SETREG::EST_VIDE
//-------------------------------------------------------


int SetReg::Est_vide()
{
return (lz.Est_vide());
}


//-------------------------------------------------------
//                     SETREG::PRINT
//-------------------------------------------------------

void SetReg::Print()
{
Liste<Pt_Zone> laux = lz;
Zone * zaux;

 cout << "(SetReg) ";

if (laux.Est_vide()) cout << " Empty set " << endl;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  if (! zaux->Est_vide()) zaux->PrintShort();
  laux.Reste();
  if (! laux.Est_vide()) cout << " v ";
  cout << endl; 
  }

}

//-------------------------------------------------------
//                     SETREG::EST_INCLU (z)
//-------------------------------------------------------

int SetReg::Est_inclu(Zone * z)
{ // teste si z est inclu dans this.
  // Nouvel algo (29-07-98: 
  // retourne 1 si 1) z inclu ds un z_i ou si 2) z inter ( Complement(this inter z)) == vide
SetReg * saux, * srcompl;
int res;

// cout << "SetReg::Est_inclu(zone) -> avec z= ";z->Print();cout << endl;
// Print();

res = Est_inclu_Z(z);
if (res) {
  //  cout << "ok avec Est_inclu_z" << endl;
  return res;
}

 saux = (SetReg *) Copy();
saux->Intersection(z);
 srcompl = (SetReg *) saux->Complement();
srcompl->Intersection(z);

res = srcompl->Est_vide();

saux->Destroy();
srcompl->Destroy();

/* Remarque:
   z C {...}   <=>   z ^ {...}-1 =0
   Clairement: z ^ ({...}^z)-1 =0     =>  z ^ {...}-1 =0  car {...}-1 C ({...}^z)-1
   et: z ^ {...}-1 =0   =>   z ^ ({...}^z)-1 =0
      car: dans ce cas, z C {...} et donc ({...}^z) = z et donc z ^ z-1 = 0 !
*/


// cout << " res inclusion = " << res << endl;
return res;
}

//-------------------------------------------------------
//                     SETREG::EST_INCLU (sr)
//-------------------------------------------------------

int SetReg::Est_inclu(SetVal * sr)
{ // teste si sr est inclu dans this.
  // deux versions possibles... directes ou par appel de Est_inclu(zone *)...
  // la methode directe est moins couteuse: un seul calcul de complement...

int res=1;
 SetReg * sraux, * srcompl, * sr2;
 sr2 = (SetReg *) sr;
Zone * zaux;
Liste<Pt_Zone> laux = sr2->lz;

// Methode indirecte~:
//  while (res && !laux.Est_vide()) {
//    zaux = laux.Tete();
//    res = Est_inclu(zaux);
//    laux.Reste();
//  }
//  return res;
// 

// on commence par un petit test...
// si ConvexH(sr) n'est pas inclue dans ConexH(this), c'est fini: 0  !
Zone * zcsr, * zcthis;
zcthis = ConvexH();
zcsr = sr2->ConvexH();

res = zcthis->Est_inclu(zcsr);
zcsr->Destroy();
delete zcsr;
zcthis->Destroy();
delete zcthis;

if (!res) {
  __OPTIEC++;
  return 0;
}
__NOPTIEC++;
res = 1;

 // sinon on fait les choses normalement...

 srcompl = (SetReg *) this->Complement();
while (res && !laux.Est_vide()) {
  zaux = laux.Tete();
  if (! Est_inclu_Z(zaux)) {
    sraux = (SetReg *) srcompl->Copy();
    sraux->Intersection(zaux);
    if (! sraux->Est_vide()) res=0;
    sraux->Destroy();
  }
  laux.Reste();
}
srcompl->Destroy();

return res; 
}

//-------------------------------------------------------
//                     SETREG::TEST_INCLUSION (z)
//-------------------------------------------------------

int SetReg::Test_inclusion(Zone * z)
{
// retourne 1 si This est inclu dans z
// retourne 2 si This est inclu dans Compl(z)
// retourne 0 sinon

Liste<Pt_Zone> laux = lz;
Zone * zaux;
int res = 1;

while (res && !laux.Est_vide()) {
  zaux = laux.Tete();
  if (! z->Est_inclu(zaux)) res = 0;
  laux.Reste();
}

if (res) return 1;

// On veut verifier si this est inclu dans Compl(z)
// i.e. si this intersecte' avec z est vide... :-)

 SetReg * saux = (SetReg *) this->Copy();
saux->Intersection(z);
 if (saux->Est_vide()) {
   saux->Destroy();
   return 2;
 }

saux->Destroy();
return 0;
}

//-------------------------------------------------------
//                     SETREG::EST_INCLU_ZW (z)
//-------------------------------------------------------
// teste si z est inclu "faiblement" dans une des zones de This.

int SetReg::Est_inclu_ZW(Zone * z)
{ 
int res=0;
Zone * zaux;
Zone * zfuture = z->Add_FutureC();
Liste<Pt_Zone> laux = this->lz;

if (z->Est_vide()) return 1;

while (!res && !laux.Est_vide()) {
  zaux = laux.Tete();
  res = (zaux->Est_equiv(z) || zaux->Est_equiv(zfuture));
  laux.Reste();
}
zfuture->Destroy();
delete zfuture; 
return res;
}

//-------------------------------------------------------
//                     SETREG::EST_INCLU_ZWW (z)
//-------------------------------------------------------
// teste si z est inclu "tres faiblement" dans une des zones de This.

int SetReg::Est_inclu_ZWW(Zone * z)
{ 
int res=0;
Zone * zaux;
Liste<Pt_Zone> laux = this->lz;

if (z->Est_vide()) return 1;

while (!res && !laux.Est_vide()) {
  zaux = laux.Tete();
  res = (zaux->Est_equiv(z));
  laux.Reste();
}
return res;
}

//-------------------------------------------------------
//                     SETREG::EST_INCLU_Z (z)
//-------------------------------------------------------
// teste si z est inclu dans une des zones de This.

int SetReg::Est_inclu_Z(Zone * z)
{ 
int res=0;
Zone * zaux;
Liste<Pt_Zone> laux = this->lz;

if (z->Est_vide()) return 1;

while (!res && !laux.Est_vide()) {
  zaux = laux.Tete();
  res = zaux->Est_inclu(z);
  laux.Reste();
}
return res;
}

//-------------------------------------------------------
//                     SETREG::ELIM_ZINCLUES (z)
//-------------------------------------------------------
// Elimine de this les zones inclues dans z

void SetReg::Elim_Zinclues(Zone * z)
{ 
Zone * zaux;
Liste<Pt_Zone> laux = this->lz, lres;

while (!laux.Est_vide()) {
  zaux = laux.Tete();
  if (! z->Est_inclu(zaux)) lres.Ajouter(zaux);
  else {zaux->Destroy();
        delete zaux;}
  laux.Reste();
}
lz.Vide();
lz = lres;
}


//-------------------------------------------------------
//                     SETREG::COMPLEMENT
//-------------------------------------------------------
// cree et retourne le complement de this

SetVal * SetReg::Complement()
{
SetReg * res, * sraux;
Zone * zaux, * ztot;

res = new SetReg(rg,1);
ztot = new Zone(rg);

Liste<Pt_Zone> laux = lz;
while (! laux.Est_vide()) {
  zaux = laux.Tete();
  sraux = ztot->Extraire(zaux);
  res->Intersection(sraux);
  sraux->Destroy(); // ajout du 25/06
  laux.Reste();
}

ztot->Destroy();  // ajout du 25/06
delete ztot;

return res;
}


// Complement2  verifie que Compl(Compl(this)) = this

SetReg * SetReg::Complement2()
{
SetReg * res, * verif;
int pb1, pb2;

 res = (SetReg *) Complement();
 verif = (SetReg *) res->Complement();


// cout << "|this| = " << lz.Longueur() << " ; |Compl(this)| = " << res->Get_lz().Longueur() << endl;
// Print();

// cout << "|Compl(Compl(this))| = " << verif->Get_lz().Longueur() << endl;
// verif->Print();

// verif devrait etre  identique a res...

pb1 = ! verif->Est_inclu(this);
 if (pb1) {
  cout << "this n'est pas inclu dans Compl(Compl(this)) " << endl;
  Print();
  verif->Print();
 }
pb2 = ! Est_inclu(verif);
 if (pb2) {
  cout << "Compl(Compl(this)) n'est pas inclu dans this " << endl;
  Print();
  verif->Print();
 }
if ( lz.Longueur() != verif->lz.Longueur()) 
  cout << lz.Longueur() << " - " << verif->lz.Longueur() << endl;
verif->Destroy();

return res;
}


//-------------------------------------------------------
//                     SETREG::COPY
//-------------------------------------------------------

SetVal * SetReg::Copy()
{
SetReg * res;

res = new SetReg(rg);

Liste<Pt_Zone> laux = lz;
Zone * zaux;


while (! laux.Est_vide()) {
  zaux = laux.Tete();
  res->lz.Ajouter(zaux->Copy());
  laux.Reste();
  }
return res;
}

//-------------------------------------------------------
//                     SETREG::DESTROY
//-------------------------------------------------------

void SetReg::Destroy()
{
Liste<Pt_Zone> laux = lz;

 __CPSR--;

while (!lz.Est_vide()) {
  lz.Tete()->Destroy();
  delete lz.Tete();
  lz.Reste();
}
laux.Vide();
delete this;
}

//-------------------------------------------------------
//                     SETREG::PROJECTION
//-------------------------------------------------------

void SetReg::Projection(Ident c,Ident ca, int ia)
{
Liste<Pt_Zone> laux = lz;
SetReg sres (rg); __CPSR--;

Zone * zaux;

while (! laux.Est_vide()) {
  zaux = laux.Tete();
  zaux->Projection(c,ca,ia);
  sres.Union(zaux);
  zaux->Destroy(); // Union fait une copie de zaux... 27-01-98
  delete zaux;
  laux.Reste();
}

lz.Vide();
lz = sres.lz;
}

//-------------------------------------------------------
//                     SETREG::AJOUTERF(z)
//-------------------------------------------------------

void SetReg::Ajouterf(Zone * z)
{lz.Ajouterf(z);}



//-------------------------------------------------------
//                     SETREG::SIZE()
//-------------------------------------------------------

int SetReg::Size()
{
  return lz.Longueur();
}
