/* File: setval.h -- Francois -- Last modified on 28 Jun 2001
 * 	
 *      
 *
 */




#ifndef SETVAL_H
#define SETVAL_H


#include "liste.h"
#include "map.h"
#include "lnu.h"
#include "specif.h"
#include "ta.h"
#include "env.h"
#include "zone.h"



int max(int i,int j);
int min(int i,int j);
int Impaire(int i);


// -------------------------------------------
//                      SetVal
// -------------------------------------------


class SetVal {
  public :
  //  virtual SetVal(RegionGraph * r,int i =0) =0;
  virtual  int Compacter() =0; // A voir...
  virtual  void Destroy() =0;
  virtual void Union(SetVal * sr) =0;
  virtual void Intersection(SetVal * sr) =0;
  virtual void Print() =0;
  virtual void Add_Past(Ident_L *ls=0,int cforall=0) =0;
  virtual void Add_Future(Ident_L *ls=0)  =0;
  virtual void Add_FermetureTemp(Ident_L *ls=0) =0;
  virtual void Forall(Ident_L *ls =0)  =0;
  virtual void Rev_In(Ident c,Ident ca =0, int ia =0) =0;
  virtual void Projection(Ident c,Ident ca =0, int ia =0) =0;
  virtual int Est_vide() =0;
  virtual int Est_inclu(SetVal * sr) =0;
  //  virtual void Projection(Ident c,Ident ca =0, int ia =0);
  virtual SetVal * Complement() =0;
  virtual SetVal * Copy() =0;
  virtual int Size() =0;
  virtual int Type() =0; // 0 dbm et 1 ppl
};

typedef SetVal * Pt_SetVal;


// -------------------------------------------
//                      SetReg
// -------------------------------------------


class SetReg : public SetVal {
  private : 
    Liste<Pt_Zone> lz;
    RegionGraph * rg;
  public :

    //      void * operator new(size_t s);
    //      void operator delete(void* addr);

    SetReg(RegionGraph * r,int i =0);    // 0 : vide ;   1 : tout
    SetReg(Zone * z);
    SetReg(Zone * z1,Zone * z2);
    SetReg(RegionGraph * r, Liste<Pt_Zone> l);
    Liste<Pt_Zone> Get_lz();
    RegionGraph * Get_rg();
    void ExtensionRG(RegionGraph * r);
    void Put_lz(Liste<Pt_Zone> l);
    Zone * FstZone();
    void ResteZone();
    void SupprimerZn(int c);
    int Est_vide_lz();
    int Compacter(); // essaie de replacer lz par un singleton avec l'env. convexe
    // retourne 1 si ca marche.
    void Destroy();
    void Union(Zone * z);
    void Union(SetVal * sr);
    void UnionW(Zone * z);     // weak union for computing Hitzones
    void UnionWW(Zone * z);     // weak weak union for computing Hitzones
    void Intersection(Zone * z);
    void Intersection(SetVal * sr);
    Zone * ConvexH();
    void Print();
    void Add_Past(Ident_L *ls=0,int cforall=0);
    void Add_Future(Ident_L *ls=0);
    void Add_FermetureTemp(Ident_L *ls=0);
    void Forall1(SetReg * comp,Ident_L * ls=0);
    void Forall2(Liste<Pt_Zone> ls, Liste<Pt_Zone> lr);
    void Forall(Ident_L *ls =0);
    void Rev_In(Ident c,Ident ca =0, int ia =0);
    int Est_vide();
    int Est_inclu(SetVal * sr);
    int Est_inclu(Zone * z);
    int Est_inclu_Z(Zone * z);     // test si *z est inclu dans une zone de *this
    int Est_inclu_ZW(Zone * z);     // test si *z est inclu "faiblement" dans *this
    int Est_inclu_ZWW(Zone * z);     // test si *z est inclu "tres faiblement" dans *this
    int Test_inclusion(Zone * z);
    void Elim_Zinclues(Zone * z);
    void Projection(Ident c,Ident ca =0, int ia =0);
    void Ajouterf(Zone * z);
    SetVal * Complement();
    SetReg * Complement2();
    SetVal * Copy();
    int Size();
    int Type() {return 0;} // 0 dbm et 1 ppl
};

typedef SetReg * Pt_SetReg;



#endif
