
#include "lnu.h"
#include "specif.h"
#include "ta.h"
#include "setval.h"
#include "PLC2.h"

#include <math.h>


void NewName(char *,int );



//------------------------------------------------------------------
//             Constructeurs SPECIF
//------------------------------------------------------------------

Specif::Specif(Lnu * f,Declaration * d,Ident namedecl)
{

  //  cout << "Specif::Specif    d= " << (Declaration *) d << endl;

_form = f;
_Decl = d;
_nf = -1;
_Ndecl = (Pt_Lnu *) 0;
_RG = (RegionGraph *) 0;
_NB = 0;
if (namedecl) 
  _nomdecl = strcpy(new char[strlen(namedecl)+1],namedecl);
else _nomdecl = 0;
__CPSPEC++;
}

Specif::Specif(Lnu * f,Number<Pt_Lnu> * nd)
{
_form = f;
_Decl = new Declaration;
_nf = 0;
_RG = (RegionGraph *) 0;
_NB = nd->Taille();
_nomdecl = (char *) 0;
_Ndecl = new Pt_Lnu[_NB];
for (int i=0;i< _NB;i++) 
  _Ndecl[i] = nd->Recherche(i);
__CPSPEC++;
}

Specif::Specif(Lnu * f,Ident nd)
{
_form = f;
_Decl = 0;
_nomdecl = strcpy(new char[strlen(nd)+1],nd);
_Ndecl = (Pt_Lnu *) 0;
_NB = 0;
_RG = (RegionGraph *) 0;
_nf = -1;
__CPSPEC++;
}

Specif::Specif(Lnu * f)
{
_form = f;
_Decl = 0;
_nomdecl = (char *) 0;
_Ndecl = (Pt_Lnu *) 0;
_NB = 0;
_RG = (RegionGraph *) 0;
_nf = -1;
__CPSPEC++;
}

//------------------------------------------------------------------
//             SPECIF Fonctions d'acces
//------------------------------------------------------------------

Ident Specif::Get_nomdecl()
{return _nomdecl;}

Lnu * Specif::Get_f()
{ return _form;}

int Specif::Est_nf()
{return _nf;}

Declaration * Specif::Get_d()
{ // on doit retourner une version non normalisee : avec un mapping !!
int i;
char t[20];
char * nom;

// cout << " Specif::Get_d() -  _nf = " << _nf << endl;

if (_nf == -1) return _Decl;
_Decl = new Declaration;

for (i=0;i<_NB;i++) {
  NewName(t,i);
  nom = strcpy(new char[strlen(t)+1],t);
  _Decl->Ajouter(nom,_Ndecl[i]);
  delete nom;
}
return _Decl;
}

Lnu * Specif::Get_def(int i)
{
assert(_nf != -1);
assert(i < _NB);

return _Ndecl[i];
}

Lnu * Specif::Get_def(Ident n)
{
Lnu * res = (Lnu *) 0;

if (! _Decl->Est_defr(n,res)) 
  cout << " Erreur dans Specif::Get_def(Ident n) " << endl;
return res;;
}


//------------------------------------------------------------------
//             QUOTIENT
//------------------------------------------------------------------


Specif * Specif::Quotient(Config * cf,int numeroquot,int Noi_nfo,int lastquot)
{
if (_nf == -1) {
  ElimIdent();
  NormF();
}
Specif * res;
Number<Pt_Lnu> * Dres = new Number<Pt_Lnu>;
Lnu * fres,* faux;
int numv = 0;
Quotvar qv;

Liste<Quotvar> * lvAq = new Liste<Quotvar>;
Liste<Quotvar> * lvDq = new Liste<Quotvar>;

  fres = _form->Quotient(cf,lvAq,lvDq,numv);
//  fres = fres->Normal();

while (! lvAq->Est_vide())
  {
    qv = lvAq->Tete();
    lvAq->Cdr();
    lvDq->Ajouter(qv);
    faux = _Ndecl[qv.var];
    faux = (faux->Quotient(qv.cf,lvAq,lvDq,numv));
    Dres->Ajouter(qv.Nvar,faux);
  }
delete lvAq;
res = new Specif(fres,Dres);
res->NormF();

if (__TABRESQUOT[0]) 
  __TABRESQUOT[0][numeroquot] = res->Taille();

// Sinplifications !
 if (lastquot) {  // cas du dernier quotient: on elimine les prop...
  res->SimplNil(1);
  __LASTQUOTIENT = 1;
 }

res->Simplify(Noi_nfo);
__LASTQUOTIENT = 0;

if (__TABRESQUOT[0]) 
  __TABRESQUOT[1][numeroquot] = res->Taille();

Liste<Quotvar> laux = *lvDq;
while (! laux.Est_vide()) {
  qv = laux.Tete();
  qv.cf->Destroy();
  laux.Reste();
}
lvDq->Vide();
delete lvDq;
Dres->Vide();
delete Dres;

return res;
}


//------------------------------------------------------------------
//             Simplifications
//------------------------------------------------------------------


Specif * Specif::Simplify_res()
{
Simplify();
return this->Copy();
}


void Specif::Simplify(int Noi_nfo)
{
int cont = 1;
int CpBs = 0;
int CpEqEq = 0;
int CpTrEq = 0;
int CpHz = 0;
int aux, aux2 = 0, aux3=0,aux4=0;
int arret = 0;
int UnguardVar = SIMPLUNGVAR;

SIMPLSPLITaux = 1;

if (_nf == -1) {
  ElimIdent();
  NormF();
}

if (PTRACE) 
  {cout << " Specification before the simplication: " << endl;
   Print();}
else 
 if (! Noi_nfo)  
   cout << _NB << " variables in the declaration before the simplifications. " << endl;

do {
cont = 1;
if (SIMPLUNGVAR != UnguardVar) 
  { ElimUngVar();
  // NormF();
  }

while (cont) {

  CpBs += BoolSimpl();
  aux = CstProp();
  while (aux) 
    {CpBs += BoolSimpl();
     aux = CstProp();}

  if (PTRACE) {
    cout << endl << "After Bool Simpl + Cst Prop : " << endl;
    Print();
  }

  if (SIMPLTE)  
    { 
      if (PTRACE) {
	cout << endl << " -> Triv Eq " << endl;
      }
      aux = TrivEq();
      CpTrEq += aux;
      while (aux) 
	{CpBs += BoolSimpl();
	aux = CstProp();}
      //  NormF();  // Est-ce bien utile ?


      if ((PTRACE) && (SIMPLTE%2)) {
	cout << endl << " After Triv Eq + Bool Simpl + Cst Prop : " << endl;
	Print();}
    }
  

  if (SIMPLEE)   { 

    if (PTRACE) {
      cout << endl << "-> Equivalent equation elim. " << endl;
    }
    aux3 = EquivEqElim();
    CpEqEq += aux3;
    if (aux3) NormF(); // a verifier !

    if (PTRACE) {
      cout << endl << " After Equiv Eq : " << endl;
      Print();
    }
  }

  if (SIMPLHZ) { 
    if (PTRACE) {
      cout << endl << "-> HitZone reduction " << endl;
    }
 

    //    if (__DBMPLC==1) {   // on suspend le flag PPL pendant HZ simplif.
    //      __DBMPLC=0;
      aux4 = HzoneRed();
      //      __DBMPLC=1;}
      //    else aux4 = HzoneRed();


    CpHz += aux4;
    aux = aux4;
    while (aux) 
      {CpBs += BoolSimpl();
      aux = CstProp();}
    NormF();
    if (PTRACE) {
      cout << endl << " After Hzone + Bool Simpl + Cst Prop : " << endl;
      Print();
    }
  }

  arret = (_NB == 0);
  cont = ((aux2 || aux3 || aux4) && !arret);
   }
}
while (UnguardVar-- >0) ;


if (! Noi_nfo) {
  cout << "--------------------------------------------------------" << endl;

  if (PTRACE || VERBOSE)
    {Print();
    cout << endl;
    
    cout << CpBs << " equations have been reduced to tt or ff by boolean simplifications."<< endl;
    cout << CpEqEq << " equivalent equations have been removed. "<< endl;
    cout << CpTrEq << " trivial equations have been removed. "<< endl;
    cout << CpHz << " tests have been removed by the Hzones. "<< endl;
    cout << endl;
    }
  cout << _NB << " in the final declaration."<< endl << endl;
}
}



//------------------------------------------------------------------
//             Calcul des contraintes
//------------------------------------------------------------------



Zone * *  Specif::InitTabConstraint()
{ // construit un tableau de (pteurs sur des) zones representant 
  // les contraintes de chaque variable

int i,cont = 1;
Zone * * tabres, * * tabaux;

if (_NB==0) return 0;

tabres = new Pt_Zone[_NB];
tabaux = new Pt_Zone[_NB];

// cout << "InitTabConstraint -> " << endl;

for (i=0;i<_NB;i++) {
  tabres[i] = new Zone(_RG);
  tabaux[i] = tabres[i];
}

// on debranche:
cont = 0; 

while (cont) {
  cont = 0;
  for (i=0;i<_NB;i++) {
    //       cout << "X"<<i<<" = ";_Ndecl[i]->Print();cout << endl;
    tabres[i] = _Ndecl[i]->Constraint(_RG,tabaux);
    //    cout << " Contrainte: "; tabres[i]->Print(); cout << endl;

    if (! tabres[i]->Est_inclu(tabaux[i]))   // (debugg++ < 0) 
      cont = 1;
  }
  for (i=0;i<_NB;i++) {
    tabaux[i]->Destroy();
    tabaux[i] = tabres[i];
  }
}

if (PTRACE>1) {
  cout << "Result of constraints computing : " << endl;
  Print();
  for (i=0;i<_NB;i++) {
    cout << "Cst of X"<<i<<" = "; 
    tabres[i]->Print();cout << endl;
  }
}

// cout << "InitTabConstraint (fin) " << endl;

delete [] tabaux;
return tabres;
}

//------------------------------------------------------------------
//             HitZones Reduction
//------------------------------------------------------------------

int Specif::HzoneRed()
{

if (PTRACE) {
   cout << " HzoneRed -> " << _NB << endl;
   Print();
}
   //   cout << " Reg graph: " << endl;
   //   _RG->Print();


if (! _nf) {
  cout << " Specif::HzoneRed : impossible without normal form !" << endl;
  return 0;}

if (_NB==0) 
  return 0;


int res = 0;
Pt_SetReg * Hzone, * HzoneW;
Zone * zaux;
Zone * * TabC;
int i,j;

Hzone = new Pt_SetReg[_NB];
HzoneW = new Pt_SetReg[_NB];

for (i=0;i<_NB;i++) {
  Hzone[i] = new SetReg(_RG);
  HzoneW[i] = new SetReg(_RG);}


// on instancie correctement le flag __HYBRID
__HYBRID = _RG->Is_hybrid();


// attention on a debranche le calcul des contraintes !!
TabC = InitTabConstraint();
zaux = _form->Constraint(_RG,TabC);

// cout << " La contrainte de _form est :"<< endl;
// zaux->Print();
// cout << endl;

// La contrainte de Xi correspond aux regions ou` Xi peut etre vraie...

Zone * Zinit = new Zone(_RG);
Zinit->Initial();
Zinit->Intersection(zaux);
zaux->Destroy();


 if (! Zinit->Est_vide()) {
   //      cout << "on propage Zinit dans _form... " << endl;
   _form->PropHzone(Zinit,Hzone,HzoneW,_NB,TabC);
   //     cout << "ok"<< endl;
 }
 else {
   _form->Destroy();
   _form = new LnuBool(Bot);
   for (i=0;i<_NB;i++) {
     TabC[i]->Destroy();
     _Ndecl[i]->Destroy();
     Hzone[i]->Destroy();
     HzoneW[i]->Destroy();}
   Zinit->Destroy();
   res=_NB;
   delete [] _Ndecl;
   delete [] Hzone;
   delete [] HzoneW;
   delete [] TabC;
   _NB=0;
   return res;
 }



int cont = 1;
// int nbit=0;

// cout << " On propage les hitzones " << endl;
// Print();

while (cont) { 
  //    cout << " iteration : " << ++nbit << endl;
  for (i=0;i<_NB;i++) {
    //        cout << " i = " << i << " - Long = " << HzoneW[i]->Get_lz().Longueur() << endl; 
      while (! HzoneW[i]->Est_vide_lz()) {
	zaux = HzoneW[i]->FstZone();
	HzoneW[i]->ResteZone(); // on elimine immediatement la zaux a propager
	if (SIMPLSPLIT == 2) Hzone[i]->UnionW(zaux);
	else if (SIMPLSPLIT == 3) Hzone[i]->UnionWW(zaux);
	else { Hzone[i]->Union(zaux);}

	_Ndecl[i]->PropHzone(zaux,Hzone,HzoneW,_NB,TabC);
	zaux->Destroy();
      }
  }
  cont = 0;
  for (i=0;i<_NB;i++)  
    if (! HzoneW[i]->Get_lz().Est_vide()) 
      {cont++;
      break;  // nouveau 22-01-98
      }
}

// cout << " On a calcule les SetReg pour chaque variable " << endl;

// L'affinage avec evaluation partielle est supprimee
// cf README_tar et exhzonered
if ((SIMPLSPLIT) && SIMPLSPLITaux) {

  assert(0); // 21/04/2004

  SIMPLSPLITaux = 0; // Nouveau: 26-02-97 : On ne split qu'une fois !

  // On eclate les variables suivant les Hzone respectives
  if (PTRACE || VERBOSE) 
    cout << " Splitting of the variables ... " << endl;
  // On calcule la taille de la nouvelle declaration:
  int Nsize=0;
  int * LongHz = new int[_NB];
  for (i=0;i<_NB;i++) {
    LongHz[i] = (Hzone[i]->Get_lz()).Longueur();
    Nsize += LongHz[i];
  }

  if (PTRACE || VERBOSE) {  
    cout << " New size   = " << Nsize << endl;
    cout << " Old taille = " << _NB << endl;
  }
  NFDeclaration Defsplit = new Pt_Lnu[Nsize];
  Pt_Zone * * Hz;
  Liste<Pt_Zone> lpz;
  int * Indice_Min = new int[_NB];

  Hz = new (Pt_Zone *)[_NB];
  for (i=0;i<_NB;i++) {
    if (i) Indice_Min[i] = Indice_Min[i-1]+LongHz[i-1];
    else Indice_Min[0] = 0;
    Hz[i] = new Pt_Zone[LongHz[i]];
    j=0;
    for (lpz=Hzone[i]->Get_lz(); ! lpz.Est_vide(); lpz.Reste()) {
      Hz[i][j] = lpz.Tete();
      j++;
    }
  }

  if (PTRACE>1) 
    for (i=0;i<_NB;i++) {
      cout << "HitZones for X"<<i<<" = ";_Ndecl[i]->Print();cout << endl;
      for(j=0;j<LongHz[i];j++) {
	cout << "Hz["<<i<<","<<j<<"] = ";Hz[i][j]->Print();cout << endl;
      }
    }

  if (VERBOSE) 
    cout << " Substitution of the splitted variables ..." << endl;
  // On renomme toute la declaration
  _form = _form->Hz_Substitute(Zinit,Indice_Min,LongHz,Hz,TabC);
  for (i=0;i<_NB;i++) {
    for (j=0;j<LongHz[i];j++) {
      Defsplit[Indice_Min[i]+j] = _Ndecl[i]->Copy();
      Defsplit[Indice_Min[i]+j] = Defsplit[Indice_Min[i]+j]->Hz_Substitute(Hz[i][j],Indice_Min,LongHz,Hz,TabC);
      if (PTRACE >1) {
	cout << " X"<<i<<" in ";Hz[i][j]->Print();
	cout << " becomes X'"<<Indice_Min[i]+j<<endl;
	cout << "X"<<i<<" = ";_Ndecl[i]->Print();cout << endl;
	cout << "X'"<<Indice_Min[i]+j<<" = ";Defsplit[Indice_Min[i]+j]->Print();cout << endl<< endl;
      }
    }
  }

  for (i=0;i<_NB;i++) _Ndecl[i]->Destroy();
  delete [] _Ndecl;  // ajout du 20-01-98
  int ex_NB = _NB;
  _NB = Nsize;
  _Ndecl= Defsplit;

  // On simplifie !
  
  Pt_SetReg * NHz = new Pt_SetReg[Nsize];
  for (i=0;i<Nsize;i++) 
    NHz[i] = new SetReg(_RG);
  for (i=0;i<ex_NB;i++)
    for (j=0;j<LongHz[i];j++) 
      NHz[Indice_Min[i]+j]->UnionWW(Hz[i][j]);
  //  cout << "On a calcule les SetReg pour chaque singleton de Zone" << endl;
  Pt_SetReg Sinit = new SetReg(_RG);
  Sinit->UnionWW(Zinit);
  _form = _form->SimplHzone(Sinit,res,TabC,1);
  //cout << " On a simplifie la formule initiale" << endl;

  
  for (i=0;i<Nsize;i++) {
    //    cout << " X"<<i<< " = "<< endl; _Ndecl[i]->Print();cout<< endl;
    _Ndecl[i] = _Ndecl[i]->SimplHzone(NHz[i],res,TabC,1);
  }

  //  cout << " on va faire le menage ... " << endl;

  // On fait le menage
    for (i=0;i<ex_NB;i++) delete [] Hz[i];
    delete [] Hz;
  for (i=0;i<ex_NB;i++) {
    Hzone[i]->Destroy();
    HzoneW[i]->Destroy();}
  delete [] NHz;
  delete [] Hzone;
  delete [] HzoneW;
  delete [] LongHz;
  delete [] Indice_Min;
  Sinit->Destroy();
  Zinit->Destroy();  // 22-01-98
  for (i=0;i<ex_NB;i++) 
    TabC[i]->Destroy();
  delete [] TabC;

  NormF();

  if (PTRACE || VERBOSE) 
    cout << "- end of splitting - " << endl;

}
else {  // On simplifie sans eclater les variables

  Pt_SetReg Sinit = new SetReg(_RG);
  Sinit->Union(Zinit);
  Zinit->Destroy();
  int StatLong =0, StatLongM, StatLongm, longi;
  StatLongM = StatLongm =Hzone[0]->Get_lz().Longueur();
  
  if (PTRACE) 
    cout << " Simplification w.r.t. the hitzones :" << endl;

  Sinit->Compacter();  // 31-08-98
  _form = _form->SimplHzone(Sinit,res,TabC,0);

  for (i=0;i<_NB;i++) {

    // Statistique
    longi = Hzone[i]->Get_lz().Longueur();
    StatLong += longi;
    if (longi < StatLongm) StatLongm=longi;
    if (longi > StatLongM) StatLongM=longi;

    if (PTRACE>1) {
      cout << " X"<< i << " = "; _Ndecl[i]->Print();cout << endl;
      cout << "in Hz: "; Hzone[i]->Print(); }
    if (Hzone[i]->Est_vide()) {
      //      cout << " Simplif !!!! " << endl; // 29-07-98 !!
      _Ndecl[i]->Destroy();
      //      _Ndecl[i] = new LnuBool(Top);
      _Ndecl[i] = new LnuBool(Bot); // correction du 19-02-99 !
    }
    else {
      //      cout << " Compactage de Hzone["<<i<<"] :" << endl;
      //      Hzone[i]->Print();
      //      Hzone[i]->Compacter();

      _Ndecl[i] = _Ndecl[i]->SimplHzone(Hzone[i],res,TabC,0);
    }
    if (PTRACE>1) {
      cout << " becomes  = "; _Ndecl[i]->Print();cout << endl;}
  }
  for (i=0;i<_NB;i++) {
    if (Hzone[i]) Hzone[i]->Destroy();
    if (HzoneW[i]) HzoneW[i]->Destroy();
    TabC[i]->Destroy();}
  delete [] Hzone;
  delete [] HzoneW;
  delete [] TabC;
  Sinit->Destroy();

  //  cout << " HzoneRed (fin) " << _NB << " , res = " << res << endl;
  // cout << "Long moy des Hitzones : " << (StatLong/_NB) << " - Min : " << StatLongm << " - Max : " << StatLongM << endl;
 

}

if (PTRACE) {
  cout << " HzoneRed (end) with " << endl;
  Print();
}

return res;
}


//------------------------------------------------------------------
//             Substitution
//------------------------------------------------------------------


void Substitution(NFDeclaration Nd,int _NB,NFDeclaration de)
{
int i;

for (i=0;i<_NB;i++) {
  Nd[i] = Nd[i]->Substitute(de);
}

}

//------------------------------------------------------------------
//             Equation triviales
//------------------------------------------------------------------

int Specif::TrivEq()
{
  //  cout << " TrivEq -> " << _NB << endl;


int res = 0;
NFDeclaration Dval = new Pt_Lnu[_NB];
Lnu * aux2;
int fin = 0,i,suppr;
int cpteur = _NB;
Lnu * ptop = new LnuBool(Top);

for (i=0;i<_NB;i++) 
  Dval[i] = ptop;

while (! fin) {
  suppr = 0;
  for (i=0;i<_NB;i++) 
    if (Dval[i]) {
      aux2 = _Ndecl[i]->Copy();
      aux2 = aux2->Substitute(Dval);
      aux2= aux2->Normal();
      if (! aux2->Equivalent(ptop))
	{ Dval[i] = (Lnu *) 0; 
	  suppr = 1;
	  cpteur--;}
      aux2->Destroy();
    }
  fin = ((! suppr) || (cpteur == 0));
}

if (cpteur) {
  for (i=0;i<_NB;i++) {
    if (Dval[i]) {
      res++;
      if (PTRACE) {
	cout << "X" << i << " = " ;_Ndecl[i]->Print();
	cout<< " is a trivial equation." << endl;}
      _Ndecl[i]->Destroy();
      _Ndecl[i] = new LnuBool(Top);
    }
  }
}

 delete [] Dval;
ptop->Destroy();

// cout << " TrivEq (fin) " << _NB << endl; 


return res;
}


//------------------------------------------------------------------
//             Equations equivalentes
//------------------------------------------------------------------


int Specif::EquivEqElim()
{
int res=0;
// cout << " EquivEqElim -> " << _NB << endl;
// Print();

if (! Est_nf()) 
  { cout << " The equivalent equations removing is not possible: not in normal form !"<< endl;
    return res;}

int _NBVar = _NB;
int _NBEqC = 1;
int * Tab = new int[_NBVar];
int * Tab2 = new int[_NBVar];
int newclass, fin = 0;
int i,v1,v2;
//Lnu * aux1, * aux2;

if (_NBVar == 0) return 0;

NFDeclaration daux = new Pt_Lnu[_NB];
int trivequiv = 0;
for (i=0;i<_NB;i++) {
  if (_Ndecl[i]->Type() == Var) {
    daux[i] = _Ndecl[i]->Copy();
    trivequiv = 1;}
  else daux[i] = (Lnu *) 0;
}

// cout << " trivequiv " << trivequiv << endl;

if (trivequiv) {
  _form = _form->Substitute(daux);
  for (i=0;i<_NB;i++) {
    if (daux[i]) {
// cout << " d["<<i<<"] = " ; daux[i]->Print();cout << endl;
      _Ndecl[i]->Destroy();
      _Ndecl[i] = (Lnu *) 0;
    }
    else  _Ndecl[i] = _Ndecl[i]->Substitute(daux);
  }
  for (i=0;i<_NB;i++) 
    if (daux[i]) daux[i]->Destroy();  
  Compact();
}

 delete [] daux;
_NBVar = _NB;


for (i=0;i<_NBVar;i++) 
  Tab[i] = (Tab2[i] = 0);


while (! fin) {
  fin = 1;
  for (i = 0;i < _NBEqC; i++) {
    v1 = 0;
    while ((v1 < _NBVar) && (Tab[v1] != i)) v1++;
    // v1 est l'indice du premier Ident de la classe i
    if (v1 < _NBVar) 
      Tab2[v1] = i;  // la classe de v1 au prochain coup sera i
    newclass = 0;
    for (v2 = v1+1;v2 < _NBVar;v2++) 
      if (Tab[v2] == i) {
	if (! _Ndecl[v1]->Est_equiv_mod(_Ndecl[v2],Tab))
	  {
	    newclass = 1; 
	    Tab2[v2] = _NBEqC; // v2 sera ds la classe _NBEqC
	  }
	else {
	  Tab2[v2] = Tab2[v1];
	}
      }
    if (newclass) 
      {_NBEqC++;
       fin = 0;}
  }
for (i=0;i<_NBVar;i++) Tab[i] = Tab2[i];
}

// cout << " _NB de classes = " << _NBEqC << endl;
// cout << " _NB de var = " << _NBVar << endl;
// for (i=0;i<_NBVar;i++) 
//   cout << " Tab["<< i<< "] = " << Tab[i] << endl;


if (_NBEqC == _NBVar) {
  delete [] Tab;
  delete [] Tab2;
  //   cout << " EquivEqElim (fin - ss modif) " << endl;
  return res;
}

res = _NBVar-_NBEqC;

//  Tab[i] classe de la variable i
//  Sub[i] representant de la classe i

int * Sub = new int[_NBEqC];
//Lnu * auxf;

for (i=0;i<_NBEqC;i++) Sub[i] = -1;

for (v1=0;v1<_NBVar;v1++)
  if (Sub[Tab[v1]] == -1) Sub[Tab[v1]] = v1;


if (PTRACE) 
  cout << " _NB of classes = " << _NBEqC << " - _NB of var = " << _NBVar << endl;

_form->NF_Substitute(Tab,Sub);
for (v1=0;v1<_NBVar;v1++) {
  if (Sub[Tab[v1]] == v1) {
    _Ndecl[v1]->NF_Substitute(Tab,Sub);
  }
  else {
    if (PTRACE>1) {
      cout << "X"<<v1<<" = "; 
      _Ndecl[v1]->NF_Substitute(Tab,Sub); _Ndecl[v1]->Print();
      cout << " is equivalent to : X" << Sub[Tab[v1]] <<endl;
      cout << "X" << Sub[Tab[v1]] << " = "; 
      _Ndecl[Sub[Tab[v1]]]->Print(); cout << endl;}
    _Ndecl[v1]->Destroy();
    _Ndecl[v1] = (Lnu *) 0;
  }
}

Compact();

delete [] Tab;
delete [] Tab2;
delete [] Sub;

this->NormF();

// cout << " EquivEqElim (fin) " << _NB << endl;

return res;
}



//------------------------------------------------------------------
//             Propagation des constantes
//------------------------------------------------------------------


int Specif::CstProp()
{

  //  cout << " CstProp -> " << _NB << endl;
  
NormF();

if (_NB == 0) return 0;

int res = 0,i;
Lnu * aux, * aux2;
NFDeclaration dsub = new Pt_Lnu[_NB];

for (i=0;i<_NB;i++) {
  aux = _Ndecl[i];
  switch(aux->Type()) {
  case Top :
  case Bot :
  case AP :
  case NAP :
  case Test :    // ajout du 12-08-97
    res++;
    dsub[i] = _Ndecl[i]->Copy();
    break;
  case Forall :
  case Exists :
  case Diam :
  case Box :
  case In :
      case Impl :
  case Var :
    aux2 = new LnuVar(i);
    if (aux->Est_subf(aux2))
      dsub[i] = (Lnu *) 0;
    else dsub[i] = _Ndecl[i]->Copy();
    aux2->Destroy();
    break;
//   case And :
//     if (_Ndecl[i]->Is_PG_Impl()) {
//       res++;
//       dsub[i] = _Ndecl[i]->Copy();
//     }
//     dsub[i] = (Lnu *) 0;
//     break;
  default : 
    dsub[i] = (Lnu *) 0;
    break;
  }

}

_form = _form->Substitute(dsub);
Substitution(_Ndecl,_NB,dsub);
for (i=0;i<_NB;i++)
  if (dsub[i])   // suppression des conditions ???  - 17-05-97
    dsub[i]->Destroy();
delete []dsub;

NormF();

// cout << " CstProp (fin)  " << _NB << endl; 
return res;
}

//------------------------------------------------------------------
//             Simplifications booleennes
//------------------------------------------------------------------


int Specif::BoolSimpl()
{
  //   cout << " BoolSimpl -> " << _NB << endl;

Lnu * aux;
int res=0, dejaOK,nouvOK,i;
LnuBool ft (Top); __CPLNU--; // on ne compte pas ca...
LnuBool fb (Bot);  __CPLNU--; // on ne compte pas ca...

_form = _form->Normal();
for (i=0;i<_NB;i++) {
  aux = _Ndecl[i];
  dejaOK = ((aux->Equivalent(&ft)) || (aux->Equivalent(&fb)));
  aux = aux->Normal();
  nouvOK = ((aux->Equivalent(&ft)) || (aux->Equivalent(&fb)));
  if (!dejaOK && nouvOK) res++;
  _Ndecl[i] = aux;
}
// cout << " BoolSimpl (fin) " << _NB << endl; 
return res;
}


//---------------------------------------------------------
//               PRINT a specification
//---------------------------------------------------------


void Specif::Print()
{
Declaration dec;



//  cout << " _NB = " << _NB << endl;
//  cout << " Decl = " << (Declaration *) Decl << endl;
//  cout << " Decl->Taille = " << Decl->Taille() << endl;
//  cout << " _Ndecl = " << (Pt_Lnu *) _Ndecl << endl;

cout << endl << "Specification : " << endl;

_form->Print();

if (_nomdecl) 
  cout << endl << " Declaration : " << _nomdecl << " ["<< endl;
else 
  cout << endl << " Declaration :     ["<< endl;



if (_Decl && ! _Decl->Est_vide()) {
  dec = *_Decl;
  while (! dec.Est_vide()) {
    cout << dec.TeteN() << " = ";
    (dec.Tete())->Print();
    dec.Reste();
    if (!dec.Est_vide()) cout << " ; " << endl;
    else cout << endl;
  }
  cout << endl << _Decl->Taille() << " identifiers. " << endl;
}
else {
  for (int i=0;i<_NB;i++) {
    cout << " X"<<i<< " = ";
    if (_Ndecl[i]) _Ndecl[i]->Print();
    else cout << "-- NDEF --";
    if (i < _NB-1) cout << " ;" << endl;
    else cout << endl;
  }
  cout << "];" << endl << _NB << " identifiers. " << endl;
}

}


//----------------------------------------------------------
//               PRINT a specification in LaTeX format
//----------------------------------------------------------


void Specif::PrintLatex()
{
  //Declaration dec;
ofstream OFSLatex;

 if ((LATEXOUTPUT) && strlen(LATEXOUTPUT)) {
   cout << endl << "output file : " << LATEXOUTPUT << endl;
   OFSLatex.open(LATEXOUTPUT,ios::app);
   PrintLatexAux(OFSLatex);
 }
 else {
   cout << endl << "standard output." << endl;
   PrintLatexAux(cout);
 }
}


void Specif::PrintLatexAux(ostream & latexoutput)
{
Declaration dec;
int longueur;


 latexoutput << "\\include{Header}" << endl<<endl;
 latexoutput << "\\begin{document}" << endl;


 latexoutput << " \\mbox{Form.}  $ \\vardefdecla  ";
 _form->PrintLatex(latexoutput);
 latexoutput << "$ \\\\" << endl;

 if (! _Decl->Est_vide()) 
   longueur = _Decl->Taille();
 else longueur = _NB;

 if (longueur) {
   if (_nomdecl) 
     latexoutput << "Declaration : " << _nomdecl << " \\\\"<< endl;
   else 
     latexoutput << "Declaration :  \\\\    "<< endl;
 }

 latexoutput << "\\[ \\begin{array}{lll} " << endl;

if (! _Decl->Est_vide()) {
  dec = *_Decl;
  while (! dec.Est_vide()) {
    latexoutput << dec.TeteN() << " & \\vardefdecla & ";
    (dec.Tete())->PrintLatex(latexoutput); 
    latexoutput << "\\\\"<< endl;
    latexoutput << "%" << endl;
    dec.Reste();
  }
  latexoutput << "\\end{array} \\]" << endl;
  latexoutput << longueur << " identifiers. " << endl;
}
else {
  for (int i=0;i<_NB;i++) {
    latexoutput << " X_{"<<i<< "} \\vardefdecla ";
    _Ndecl[i]->PrintLatex(latexoutput);
    latexoutput << "\\\\"<< endl;
    latexoutput << "%" << endl;
  }
  latexoutput << "\\end{array} \\]" << endl;
  latexoutput << _NB << " identifiers. " << endl;
}
 latexoutput << "\\end{document} " << endl;

}

//------------------------------------------------------------------
//             Copy
//------------------------------------------------------------------


Specif * Specif::Copy(int v)
{
Specif * res;

Lnu * _Nform;

if (v == -1) _Nform = _form;
else _Nform = _form->Copy();

if ((_Decl) && (! _Decl->Est_vide())) {
   Declaration Daux = *_Decl;
   Declaration * ND = new Declaration;
   while (! Daux.Est_vide()) {
     ND->Ajouter(Daux.TeteN(),Daux.Tete()->Copy());
     Daux.Reste();
   }
   res = new Specif(_Nform,ND);
 }
else 
  if (_Ndecl && _NB) {
    Number<Pt_Lnu> * nd = new Number<Pt_Lnu>;
    int i;
    for (i=0;i<_NB;i++) 
      nd->Ajouter(i,_Ndecl[i]->Copy());
    res = new Specif(_Nform,nd);
  }
  else 
    res = new Specif(_Nform);
 
return res;
}


//------------------------------------------------------------------
//             Fonctions auxiliaires de CHECK
//------------------------------------------------------------------


Ident_L Elimpaire(Ident_L l)
{ // elimine les doublons
Ident_L res,laux;
Ident aux;
int trouve;
while (! l.Est_vide()) {
  aux = l.Tete();
  laux = res;
  trouve = 0;
  while (!trouve && !laux.Est_vide()) {
    if (Eq_str(laux.Tete(),aux)) trouve = 1;
    laux.Reste();
  }
  if (! trouve) res.Ajouter(aux);
  l.Reste();
}
return res;
}

int TestDep(Ident_L lv,Mapping<int> m)
{
int res = 1;
while (! lv.Est_vide()) {
  if (m.Recherche(lv.Tete()) == 1) res = 0;
  lv.Reste();
}
return res;
}


// par defaut MaxDefaut = -1
RegionGraph * Specif::RegionG(int MaxDefaut)
{
// On calcule le nombre d'horloges et les constantes max
Ident_L lc,lc2;
int i,m=-1,trouve;
Map_int mcm;
McLi cl;
int ishyb;

cl = _form->LclocksM();
mcm = cl.mc;
ishyb = cl.ishyb;

for (i=0;i<_NB;i++) {
  cl = _Ndecl[i]->LclocksM();
  mcm.Concat(&(cl.mc));
  ishyb = (ishyb || cl.ishyb);
}

while (! mcm.Est_vide()) {
  if (mcm.Tete() > m) 
    m = mcm.Tete();
  lc2 = lc;
  trouve = 0;
  while (!trouve && !lc2.Est_vide()) {
    if (Eq_str(lc2.Tete(),mcm.TeteN())) trouve = 1;
    lc2.Reste();
  }
  if (! trouve) {lc.Ajouter(mcm.TeteN());}
  mcm.Reste();
}

// On en deduit le Graphe des Regions

 if (MaxDefaut != -1)  
   if (MaxDefaut >= m) 
     m = MaxDefaut;
   else {
     m = MaxDefaut; // modif 13/04/2004 -> pour EZone.
     cout << "Warning ! The default value for Max is less than the real max... " << endl;
   }

RegionGraph * res = new RegionGraph(lc,m,ishyb);
return res;
}

//------------------------------------------------------------------
//             Check
//------------------------------------------------------------------


SetVal * Specif::Check(int TestV)
{
// teste si le processus nil sat. la specification

  __UNDERAPPROX=0;
  __OVERAPPROX=0;
  __ABSTRACTION=0;
  __FIXPOINT = 1;   // important pour la normalisation !!!

  NormF();          // on norme car la norme est differente !

// on instancie correctement le flag __HYBRID
__HYBRID = _RG->Is_hybrid();

 if (PTRACE) {
   cout << " Debugg : " << endl;
   _RG->Print();
   Print();
 }

 if (__MINFIXPOINT) {
  Reverse();
  if (PTRACE) {
    cout << " On inverse... " << endl;
    Print();
  }
 }


// On calcule le p.g.p.f. de {X1,...,Xn} = F({X1,...,Xn})
// ou le p.p.p.f. de la Reverse(spec)... si __MINFIXPOINT=1

Pt_SetVal * Def;
Def = new Pt_SetVal[_NB];
SetVal * auxsr = 0, * ancsr;
int i,it=0,incl,vo_dedans=1,inutile;
int_L * Depend[_NB];

int __test=0;

 if (__DBMPLC) __CurrentRG = _RG;

for (i=0;i<_NB;i++) {
  if (__MINFIXPOINT) 
    Def[i] = (__DBMPLC) ? (SetVal*)new PLC(0) : (SetVal *)new SetReg(_RG,0);
  else Def[i] = (__DBMPLC) ? (SetVal*)new PLC(1) : (SetVal*)new SetReg(_RG,1);
  Depend[i] = new int_L;
}

for (i=0;i<_NB;i++) 
  _Ndecl[i]->Liste_Var(Depend[i]);

int_L li_aux;
// for (i=0;i<_NB;i++) {
// _Ndecl[i]->Print();
// cout << endl << " : ";
// li_aux = * Depend[i];
// while (! li_aux.Est_vide()) {
//  cout << li_aux.Tete() << " " ;
//  li_aux.Reste();
// }
// }

int Modif[_NB];
int NModif[_NB];
for (i=0;i<_NB;i++)
  Modif[i] = 1;

int fin = 0;
int economie = 0;
int longmoy, longmax, longaux;

//if (PTRACE%2)
 if (__MINFIXPOINT)
   cout << "Check procedure for not(spec) " <<endl;
 cout << " Fixpoint computation  (" << _NB <<" var.) :" << endl;


// On construit un ens contenant v0 
Zone z0 (_RG);
SetVal * Setvo;
 if (__DBMPLC) 
   Setvo = new PLC(2);
 else {
   z0.Initial();
   Setvo = new SetReg (& z0);
 }

// cout << " _NB = " << _NB << endl;
while (! fin) {
  cout << "it: " << it+1 <<  "-  (" << economie << ") ";
  if (it) {
    cout << ", Av. size : " << longmoy << " , Max size : " << longmax;
    if (__POLYMEM) cout << "  (PPL: "<<__POLYMEM << ")";
  }
  cout << endl;
  it++;
  fin = 1;
  for (i=0;i<_NB;i++) {
    // On commence par verifier qu'au moins une var dont depend X_i a ete modifiee:
    li_aux = * Depend[i];
    inutile = 1;
    while (inutile && (! li_aux.Est_vide())) {
      inutile = (Modif[li_aux.Tete()]) ? 0 : 1;
      li_aux.Reste();
    }

    //  cout << " inutile ? " << inutile << endl;

    if (inutile && (it>1)) {  // a la premiere it on DOIT tout calculer
      NModif[i] = 0;
      economie++;
      if (PTRACE)
	cout << " - it : " << it << " unnecessary to compute again X" << i << endl;
    }
    else {
      if (PTRACE) {
	cout << "it = " << it << " X" << i << " = "; _Ndecl[i]->Print();cout << endl;
      }
      ancsr = Def[i];
      auxsr = _Ndecl[i]->StateSat(_RG,Def,__DBMPLC);
      auxsr->Compacter();
      if (PTRACE) {
	cout << "it = " << it << " X" << i << endl;
	cout << "  Def = "; Def[i]->Print();
	cout << " nDef = "; auxsr->Print();
      }
      if (__MINFIXPOINT)
	incl = (ancsr->Est_inclu(auxsr));
      else incl = (auxsr->Est_inclu(ancsr));
      if (PTRACE) {
	if (__MINFIXPOINT)
	  cout << "Is  nDef included in Def ? " << incl << endl;
	else cout << "Is  Def included in nDef ? " << incl << endl;
      }
      if (! incl) {
	fin = 0;
	NModif[i] = 1;
      }
      else {
	__test++;
	SetVal * auxsr2;
	NModif[i] = 0;
	//	if (auxsr->Get_lz().Longueur() > ancsr->Get_lz().Longueur()) {
	if (auxsr->Size() > ancsr->Size()) {
	  auxsr2 = auxsr; // dans ce cas on prefere garder le ancsr !
	  auxsr = ancsr;
	  ancsr = auxsr2;
	}
      }
      ancsr->Destroy();
      Def[i] = auxsr;
    }
  }
// On calcule le SetReg provisoir de this->form (resultat de la fct)
// pour ne pas faire de trucs inutiles...

  if (fin) 
    cout << "Fixed point is computed !" << endl;

  //  cout << "Test d'inclusion de init dans [[spec]] ..." << endl;
  //  cout << "INIT = "; Setvo->Print();
  auxsr = this->_form->StateSat(_RG,Def,__DBMPLC);
  //  cout << "[[spec]] = "; auxsr->Print();

  //  if (auxsr->Est_inclu(Setvo)) 
  //    cout << "init est inclu..." << endl;
  //  else cout << "init N'est PAS inclu..." << endl;

  if (! auxsr->Est_inclu(Setvo)) 
    {
      if (! __MINFIXPOINT) 
	fin = 1;
      vo_dedans = 0; 
    }
  else {
    if (__MINFIXPOINT)
      fin = 1;
    vo_dedans = 1;
  } 
  if (!fin) 
    auxsr->Destroy();

  longmoy = 0;
  longmax = 0;
  for (i=0;i<_NB;i++) {
    Modif[i] = NModif[i];
    longaux = Def[i]->Size();
    longmoy += longaux;
    if (longmax < longaux) 
      longmax = longaux;
  }
  if (_NB) 
    longmoy /= _NB;

  // on verifie que le nb d'iterations ne depasse pas la borne (syst hybride)
  if (!fin && (__NBFIXPOINT>0)) 
    fin = (it >= __NBFIXPOINT);
}


cout << endl;

if ((__NBFIXPOINT>0) && (it >= __NBFIXPOINT))
  cout << "Computation stopped after "<<__NBFIXPOINT<< " iterations." << endl;
 else { 
   if (! __MINFIXPOINT) {
     /* .  init \in [[sp]]
	    Si sur-approx : rien de sur
	    Sinon : init |= sp  
        .  init \not\in [[sp]]
	    Si sous-approx : rien de sur
	    Sinon init |=/= sp 
     */

     if (vo_dedans) {
       if ((! __HYBRID) || (! __OVERAPPROX)) {
	 if (TestV)
	   cout << "Yes. " << endl;
	 else {
	   cout << " v0 satisfies the specification. " << endl;
	 }
       }
       else {
	 cout << " v0 belongs to the computed set of states but an overapproximation " << endl;
	 cout << " has been done: no conclusion can be done. " << endl;
       }
     }
   else {
     if ((! __HYBRID) || (! __UNDERAPPROX)) {
       if (TestV)
	 cout << "No. " << endl;
       else {
       cout << " v0 does NOT satisfy the specification. " << endl;
       }
     }
     else {
       cout << " v0 does not belong to the computed set of states but an underapproximation " << endl;
     cout << " has been done: no conclusion can be done. " << endl;
     }
   }
   }
   else { // __MINFIXPOINT
     /* .  init \in [[- sp]]
	    Si sur-approx : rien de sur
	    Sinon : init |= - sp  =>  init |=/= sp
        .  init \not\in [[- sp]]
	    Si sous-approx : rien de sur
	    Sinon init |=/= -sp => init |= sp
     */

     if (vo_dedans) {
       if ((! __HYBRID) || (! __OVERAPPROX)) {
	 if (TestV)
	   cout << "No. " << endl;
	 else {
	   cout << " v0 does not satisfy the specification. " << endl;
	 }
       }
       else { // c'est une overapprox ds le calcul de (-sp) --> underapprox
	 cout << " v0 belongs to the set [[- spec]] but an overapproximation " << endl;
	 cout << " has been done: no conclusion can be done. " << endl;
       }
     }
   else {
     if ((! __HYBRID) || (! __UNDERAPPROX)) {
       if (TestV)
	 cout << "Yes. " << endl;
       else {
       cout << " v0 satisfies the specification. " << endl;
       }
     }
     else {
       cout << " v0 does not belong to the set [[- spec]] but an underapproximation " << endl;
     cout << " has been done: no conclusion can be done. " << endl;
     }
   }
   }
 }

/*
 cout << " Approx: " << endl;
 cout << " - under-approx -> " << __UNDERAPPROX << endl;
 cout << " - over-approx  -> " << __OVERAPPROX << endl;
 cout << " - __abstraction-> " << __ABSTRACTION << endl;
 cout << " __test = " << __test << endl;
 */

for (i=0;i<_NB;i++) {
  Def[i]->Destroy();
  Depend[i]->Vide();
}


delete [] Def; // ajout 27-01-98
 Setvo->Destroy();

__FIXPOINT = 0;

return auxsr;
}


//------------------------------------------------------------------
//             MCheck
//------------------------------------------------------------------

void Specif::MCheck(int TestV)
{
SetVal * res;
res = Check(TestV);
if (! TestV) 
  res->Print();
res->Destroy();
}

//------------------------------------------------------------------
//             REVERSE
//------------------------------------------------------------------


void Specif::Reverse()
{
  //Specif * res = Copy();

_form = _form->Reverse(1);

for (int i=0;i<_NB;i++) 
    _Ndecl[i] = _Ndecl[i]->Reverse(1);


NormF();

//return res;
}

//------------------------------------------------------------------
//             NORMF_RES
//------------------------------------------------------------------


Specif * Specif::NormF_res()
{
  //  cout << " NormF_res -> " << endl;
NormF();
// cout << " NormF_res <- " << endl;
return this;
}




//------------------------------------------------------------------
//             ELIM_IDENT
//------------------------------------------------------------------
//    ElimIdent : "Suppression" des noms (char *) des variables.
//    Remplacement par des numeros. Une _Ndecl est definie.



Specif * Specif::ElimIdent_res()
{
ElimIdent();
return this;
}

void Specif::ElimIdent()
{
Map_int MaR, MdR;
Number<Pt_Lnu> D, Daux;
int nv = 0,numero;
Lnu * aux;
Ident oldname;

// if (PTRACE) {
//   cout << " -> Specif::ElimIdent "<< endl;
//   Print();
// }

 if (_Decl) {
   
   if (_nf == -1) { 
     _form = _form->ElimIdent(&MaR,&MdR,nv);
     
     while (!MaR.Est_vide()) {
       oldname = MaR.TeteN();
       numero = MaR.Tete();
       MaR.Reste();
       MdR.Ajouter(oldname,numero);
       aux = _Decl->Recherche(oldname)->ElimIdent(&MaR,&MdR,nv);
       D.Ajouter(numero,aux);
     }
     _Decl->Vide();
     _NB = D.Taille();
     _Ndecl = new Pt_Lnu[_NB];
     Daux = D;
     while (! D.Est_vide()) {
       _Ndecl[D.TeteN()] = D.Tete();
       D.Reste();
     }
     Daux.Vide();
     _nf =0;
     
   }
 }
MdR.Vide();
D.Vide();

//if (PTRACE) 
//  cout << " <- Specif::ElimIdent (fin) "<< endl;

}


/* *******************************************************************

				NORMF

**********************************************************************/


// si __FIXPOINT = 1  on normalise POUR le calcul du point fixe - 10/10/98
// cela ne change que la fonction NormF pour LnuBin, LnuCD, LnuUn, LnuMod

void Specif::NormF()
{  
Number<int> MaR, MdR;
int i,nv = 0, Ntaille;
Number<Pt_Lnu> * Dres = new Number<Pt_Lnu>;
Number<Pt_Lnu> Daux;
Lnu * _Nform, * aux;
int oldname,newname;

// cout << " NormF::Debbug -> " << endl; Print();

if (_nf == -1) 
  ElimIdent();
else if (_Decl) _Decl->Vide();

 _form = _form->Normal(); // nouveau: 01-08-98
_Nform = _form->NormF(&MaR,&MdR,nv,Dres);

while (!MaR.Est_vide()) {
  oldname = MaR.TeteN();
  newname = MaR.Tete();
  MaR.Reste();
  MdR.Ajouter(oldname,newname);
  // cout << " NormF : " << oldname << " -> " << newname << endl;
  _Ndecl[oldname] = _Ndecl[oldname]->Normal(); // nouveau: 01-08-98
  aux = _Ndecl[oldname]->NormF(&MaR,&MdR,nv,Dres);
  Dres->Ajouter(newname,aux);
}

_form = _Nform;
_nf = 1;

Ntaille = Dres->Taille();

if (Ntaille < _NB) // On doit eliminer certaines var non accessibles !
  { 
    for (i=0;i<_NB;i++) 
      if (! MdR.Est_def(i)) 
	if (_Ndecl[i]) _Ndecl[i]->Destroy();
  }

delete [] _Ndecl;
_NB = Ntaille;

if (_NB) 
  _Ndecl = new Pt_Lnu[_NB];
else _Ndecl = 0; 

Daux = * Dres;
while (! Daux.Est_vide()) {
  _Ndecl[Daux.TeteN()] = Daux.Tete();
  Daux.Reste();
}

Dres->Vide();
MdR.Vide(); // ajout 21-01-98

if (_RG) 
  _RG->Destroy();

_RG = this->RegionG();

// cout << " NormF::Debbug <- " << endl; Print();
}


//------------------------------------------------------------------
//             DESTROY
//------------------------------------------------------------------

void Specif::Destroy()
{

__CPSPEC--;

   if (_nomdecl) 
     delete _nomdecl;

   //  cout << " Specif::Destroy() -> " << endl;
   //  Print();


  _form->Destroy();

//   cout << " _NB = " << _NB << endl;
//   cout << " Decl = " << (Declaration *) Decl << endl;
//   cout << " Decl->Taille = " << Decl->Taille() << endl;
//   cout << " _Ndecl = " << (Pt_Lnu *) _Ndecl << endl;

   if (_Decl) {
    for (Declaration Dec= (*_Decl); !Dec.Est_vide(); Dec.Reste()) 
      if (Dec.Tete())
	Dec.Tete()->Destroy();
    _Decl->Vide();
    //XXXX    //    delete Decl; on ne detruit pas Decl car ca pose des pb lorsque
    //    la declaration est definie par ailleurs comme une var de l'envir.
  }
  

  if (_Ndecl) {
    for (int i=0;i<_NB;i++) {
      if (_Ndecl[i]) _Ndecl[i]->Destroy();
    }

      delete [] _Ndecl;

  }

  //  cout << " Specif::Destroy() (fin) " << endl;

}


//------------------------------------------------------------------
//             SPLIT VAR
//------------------------------------------------------------------

int Specif::SplitVar(int v)
{
  cout << "Splitting does not exist any more." << endl;
assert(0);
return 1;
}

//------------------------------------------------------------------
//             Simplification Split 
//------------------------------------------------------------------

int Specif::SplitSimpl()
{
int res = 0,i=0,cont = 1;

if (_NB == 0) return 0;

// cout << " -> Split " << endl;

// Ancienne version 
// while (cont) {
//  cont = (! SplitVar(i)) && (i+1<_NB);
//  i++;
// }

while (cont) {
  if (! SplitVar(i)) i++;
  else res++;
  cont = (i < _NB);
}

// cout << " <- Split " << endl;
return res;
}


//------------------------------------------------------------------
//             COMPACT
//------------------------------------------------------------------

void Specif::Compact()
{
// compacte (avec renommage) une spec ou certaines var ne sont plus 
// utilisees (ni definies =0).

//  cout << "compact : " << endl;
//  Print();

int i, New_NB=0;
int * NewNum = new int[_NB];
NFDeclaration Daux = new Pt_Lnu[_NB];

for (i=0;i<_NB;i++) {
  NewNum[i] = -1;
  Daux[i] = (Lnu *) 0;
  if (_Ndecl[i]) 
    { NewNum[i] = New_NB;
      Daux[i] = new LnuVar(New_NB);
      New_NB++;}
}
	
NFDeclaration Nres = new Pt_Lnu[New_NB];
_form = _form->Substitute(Daux);

for (i=0;i<_NB;i++)
  if (NewNum[i] != -1) // Note: si ==-1 alors _Ndecl[i]==0 !! inutile de detruire !
    {
      //      cout << "X" << i << " devient X"<< NewNum[i] << " - "<< endl;
      //      _Ndecl[i]->Print(); cout << endl;
      Nres[NewNum[i]] = _Ndecl[i]->Substitute(Daux);
    }
 for (i=0;i<_NB;i++)   // 21-01-98
  if (Daux[i]) Daux[i]->Destroy();


 delete [] Daux;  // 21-01-98
 delete [] _Ndecl;
_Ndecl = Nres;
_NB = New_NB;
}


//------------------------------------------------------------------
//             Basic SPEC
//------------------------------------------------------------------

Specif * Specif::BSpec()
{
_form = _form->BSpec();
Lnu * aux;
Declaration * Dres;
Declaration Daux;

if (_nf == -1) {
  Daux = *_Decl;
  Dres = new Declaration;
  while (! Daux.Est_vide()) {
    aux = Daux.Tete();
    Dres->Ajouter(Daux.TeteN(),aux->BSpec());
    Daux.Reste();
  }
  _Decl->Vide();
  _Decl = Dres;
}
else 
  for (int i=0;i<_NB;i++) 
    _Ndecl[i] = _Ndecl[i]->BSpec();
return this;
}

//------------------------------------------------------------------
//             SIMPLIF-NIL
//------------------------------------------------------------------
// remplace les prop atomique par des booleens...

// Si no_simpl vaut 1, on n'appelle pas les simplif usuelles (il y a juste
// substitution des Prop...

Specif * Specif::SimplNil(int nosimpl)
{
_form = _form->SimplNil();

Lnu * aux;
Declaration * Dres;
Declaration Daux;

if (_nf == -1) {
  if (_Decl) { 
    Daux = *_Decl;
    Dres = new Declaration;
    while (! Daux.Est_vide()) {
      aux = Daux.Tete();
      Dres->Ajouter(Daux.TeteN(),aux->SimplNil());
      Daux.Reste();
    }
    _Decl->Vide();
    _Decl = Dres;
  }
}
else 
  for (int i=0;i<_NB;i++) 
    _Ndecl[i] = _Ndecl[i]->SimplNil();

if (! nosimpl) 
  Simplify();
return this;
}


//------------------------------------------------------------------
//             ELIMINATION DES VARIABLES GARDEES
//------------------------------------------------------------------

void Specif::ElimUngVar()
{
int i,j,cdt=0;
Lnu * auxTop = new LnuBool(Top);

if (_nf == -1) 
  ElimIdent();
NormF();

for (i=(_NB-1);i>=0;i--) {
  if (_Ndecl[i]->Type() == And) cdt=1;
  else if (_Ndecl[i]->Type() == Or) cdt=2;
  //  if (_Ndecl[i]->IsThereUngVar(i,cdt)) 
  _Ndecl[i] = _Ndecl[i]->Normal();
  _Ndecl[i] = _Ndecl[i]->SubstituteUngVar(i,auxTop,cdt);
  _Ndecl[i] = _Ndecl[i]->Normal();
  for (j=0;j<i;j++) {
    _Ndecl[j] = _Ndecl[j]->Normal();
    _Ndecl[j] = _Ndecl[j]->SubstituteUngVar(i,_Ndecl[i],cdt);
    _Ndecl[j] = _Ndecl[j]->Normal();
  }
}

// et on redescend...

for (i=0;i<_NB;i++) {
  if (_Ndecl[i]->Type() == And) cdt=1;
  else if (_Ndecl[i]->Type() == Or) cdt=2;
  //  if (_Ndecl[i]->IdThereUngVar(i,cdt)) 
  _Ndecl[i] = _Ndecl[i]->Normal();
  _Ndecl[i] = _Ndecl[i]->SubstituteUngVar(i,auxTop,cdt);
  _Ndecl[i] = _Ndecl[i]->Normal();
  for (j=i+1;j<_NB;j++) {
    _Ndecl[j] = _Ndecl[j]->Normal();
    _Ndecl[j] = _Ndecl[j]->SubstituteUngVar(i,_Ndecl[i],cdt);
    _Ndecl[j] = _Ndecl[j]->Normal();
  }  
}

auxTop->Destroy();
}


