/* File: specif.h -- Francois -- Last modified on 15 Nov 2001
 *
 *      
 *

 */

#ifndef SPECIF_H
#define SPECIF_H

#include <iostream>
#include <string.h>
#include <fstream.h>


#include "liste.h"
#include "map.h"
#include "number.h"
#include "lnu.h"
#include "setval.h"

extern int __POLYMEM;

class Specif {
  private :
    Lnu * _form;
    Declaration * _Decl;
    int _NB;
    int _nf;
    NFDeclaration _Ndecl;
    RegionGraph * _RG;
    Ident _nomdecl;

  public :
  
    Specif(Lnu * f,Declaration * d,Ident namedecl =0);
    Specif(Lnu * f,Number<Pt_Lnu> * nd);
    Specif(Lnu * f,Ident nd);  // utile pour le parser...
    Specif(Lnu * f);  
    int Taille() {return _NB;}
    void ElimIdent();
    Specif * ElimIdent_res();
    int Est_nf();
    Lnu * Get_f();
    Lnu * Get_def(int i);
    Lnu * Get_def(Ident n);
    Ident Get_nomdecl();
    Declaration * Get_d();
    RegionGraph * RegionG(int M =-1);
    Specif * Quotient(Config * cf,int numeroquot, int Noinfo = 0, int lastquot =0);
    void Print();
    void PrintLatex();
    void PrintLatexAux(ostream &);
    Specif * Copy(int v =0);   // v=-1 lorsqu'on ne recopie pas form.
    int BoolSimpl();
    int TrivEq();
    int EquivEqElim();
    int CstProp();
    int HzoneRed();
    Zone * * InitTabConstraint();
    int SplitVar(int v);
    int SplitSimpl();
    void NormF();
    void Compact();
    void ElimUngVar();
    void Reverse(); // utilise pour avoir -spec
    Specif * NormF_res();
    void Simplify(int Noinfo =0);
    Specif * Simplify_res();
//    SetReg * StateSat(RegionGraph * rg,Mapping <SetReg *> * Def);
    SetVal * Check(int TestV =0);
    void MCheck(int TestV =0);
    void Destroy();
    //    void DestroyS();  // ecrase aussi la declaration !!
    Specif * BSpec();
    Specif * SimplNil(int nosimpl =0);
};

typedef Specif * Pt_Specif;

extern RegionGraph * __CurrentRG;

#endif




