/* File: ta.cc -- Francois -- Last modified on 2 Aug 2001
 * 	
 *      ceci est un modele d'en-tete de fichier C++
 *
 */



// #include "c:\bc31\mcc\TA.h"
#include "ta.h"
#include "env.h"

Ident Transition::From()
    {return n1;}

Ident Transition::To()
    {return n2;}

Ident Transition::Get_label()
    {return lab;}

Assign_L * Transition::Get_rs()
    {return r;}

Lnu * Transition::Get_cond()
    {return cond;}

void Transition::Print()
{ Assign_L r2 = *r;
  Assign ass; 
 cout << n1 << '\t' << "- " << lab << ",";
 if (strlen(lab) < 5) cout << '\t';
 cout <<"(";
 cond->Print();
 cout << "),"<< " ";
 if (! r2.Est_vide())
   { ass = r2.Tete();
     cout << "{" << ass._ci << ":=";
   if (ass._cj) {
     if (ass._k) cout << ass._cj <<"+"<<ass._k;
     else cout << ass._cj;
   }
   else cout << ass._k;
   r2.Reste();
   while (! r2.Est_vide())
     { 
       ass= r2.Tete();
       cout << "," << ass._ci << ":=";
       if (ass._cj) {
	 if (ass._k) cout << ass._cj <<"+"<<ass._k;
	 else cout << ass._cj;
       }
       else cout << ass._k;
       r2.Reste(); }
   cout << "}";
   }
 else cout << "{ }";
 cout << '\t' << '\t' << "-> " << n2;
}


void Transition::PrintVCG(ostream & vcgoutput)
{ Assign_L r2 = *r;
 Assign ass; 

 vcgoutput << "edge:{thickness:3 sourcename:\""<<n1<<"\" targetname:\""<<n2<<"\"";
 vcgoutput << " label:\"\\f01 "; 
 cond->Print(vcgoutput);
 vcgoutput << "\\n\\f31 " << lab;
 if (! r2.Est_vide())
   {
     ass = r2.Tete();
     vcgoutput << "\\n"<< ass._ci <<":=";
     if (ass._cj) {
       if (ass._k) vcgoutput << ass._cj <<"+"<<ass._k;
       else vcgoutput << ass._cj;
     }
     else cout << ass._k;
     r2.Reste();
     while (! r2.Est_vide())
       { 
	 ass = r2.Tete();
	 vcgoutput << ","<< ass._ci <<":=";
	 if (ass._cj) {
	   if (ass._k) vcgoutput << ass._cj <<"+"<<ass._k;
	   else vcgoutput << ass._cj;
	 }
	 else cout << ass._k;
	 r2.Reste(); }
     vcgoutput << "\"";
   }
 else vcgoutput << "\"";
 vcgoutput << "}" << endl;
}


void Transition::Destroy()
{
  delete n1;
  delete n2;
  delete lab;
  Assign_L laux = *r;
  Assign ass;
while (!laux.Est_vide()) {
  ass = laux.Tete();
  delete ass._ci;
  delete ass._cj;
  laux.Reste();}
 r->Vide();
 delete r;
 cond->Destroy();
}


Transition * Transition::Copy()
{
Assign_L * rc = 0;
Lnu * condc = 0;
Assign ass1, ass2;

 if (r) {
   rc = new Assign_L;
   for (Assign_L  laux = *r;!laux.Est_vide();laux.Reste()) {
     ass1 = laux.Tete();
     ass2._ci = strcpy(new char[strlen(ass1._ci)+1],ass1._ci);
     if (ass1._cj) 
       ass2._cj = strcpy(new char[strlen(ass1._cj)+1],ass1._cj);
     else ass2._cj = 0;
     ass2._k = ass1._k;
     rc->Ajouterf(ass2);
   }
 }
 
if (cond) 
  condc = cond->Copy();
 
return new Transition(n1,n2,lab,rc,condc); 
}

//----------------------------------------------------------------
//                       VerifElet
//----------------------------------------------------------------


VerifElet* VerifElet::Copy()
{

if (_vflag) 
  return new VerifElet(strcpy(new char(strlen(_nta)+1),_nta),
		       _vflag[0],_vflag[1],_vflag[2],_vflag[3],
		       _vflag[4]);
 else
   return new VerifElet(strcpy(new char(strlen(_nta)+1),_nta));
}


//----------------------------------------------------------------
//                    Timed Automata
//----------------------------------------------------------------

TA::TA()
{bta=-1;}

TA::TA(Ident_L * lc, Map_propL * ln, Transition_L * l,Map_lnu * linv,Map_propL * lact)
{
  // rmq: lact tjs =/= 0 car ce constructeur est appele depuis le suivant...




  int trouve;
  Transition_L laux;
  Transition * t;
  Ident no, labt, nod;
  Ident_L alpaux;
  Map_lnu linvaux;
  bta = 1;  // par defaut...
  liste_t = *l;
  liste_c = *lc;
  liste_np = *ln;
  liste_activ = *lact;
  int is_hybrid = (! liste_activ.Est_vide());

  RegionGraph * regG;
  nom=0;

  if (linv) 
    Linvariants = *linv;

  _Rg=0;
  regG = Get_RG(is_hybrid); 

 if (linv) 
    { 
    if (! Linvariants.Est_vide()) bta = 0;
    linvaux = Linvariants;
    while (! linvaux.Est_vide()) {
      if (! liste_np.Est_def(linvaux.TeteN())) {
	cout << "WARNING !! an invariant has been assigned to an undefined node " << linvaux.TeteN() << endl;
      }
      if (! linvaux.Tete()->Is_Invar(is_hybrid)) {
	cout << "Error in definition of the automaton: the formula assigned to "<<linvaux.TeteN();
	cout << " is not an invariant !" << endl;
      }
      else {       // Verifier la strongly-connection...
	SetVal * Sinv, * SinvCF, * SinvCP;
	//	Specif * auxspec;
	//	RegionGraph * regG;
	Ident_L * lcinact=0;
	// auxspec = new Specif(linvaux.Tete());
	//	regG = auxspec->RegionG();

	Sinv = linvaux.Tete()->StateSat(regG,0);
	if (lact->Est_def(linvaux.TeteN()))
	  lcinact = lact->Recherche(linvaux.TeteN());
	SinvCF = Sinv->Copy();
	SinvCF->Add_Future(lcinact);
	SinvCP = Sinv->Copy();
	SinvCP->Add_Past(lcinact);

	SinvCF->Intersection(SinvCP);
	if ((! SinvCF->Est_inclu(Sinv)) || (!Sinv->Est_inclu(SinvCF))) {
	  cout << "ERROR ! ";
	  cout << "Invariant ";
	  linvaux.Tete()->Print();
     	  cout << " of "<< linvaux.TeteN() <<" is not strongly connected."<< endl;
	  //	  PrintIdent_L(lcinact);
	  //	  cout << "Inv = " << endl; Sinv->Print();
	  //	  cout << "Inv + passe " << endl; SinvCP->Print();
	  //	  cout << "Inv + future = " << endl; Sinv->Add_Future(lcinact); Sinv->Print(); 
	  //	  cout << "Inv + future inter Inv + Passe = " << endl; SinvCF->Print();
	  
	}
	else if (PTRACE) 
	  cout << "Invariant of "<< linvaux.TeteN() <<" is strongly connected" << endl;
      }
      linvaux.Reste();
    }
    }

  if (ln) n_init = strcpy(new char[strlen(ln->TeteN())+1],ln->TeteN());
  else cout << " Error in TA::TA !" << endl;

  while (! l->Est_vide())
    {
      t = l->Tete();
      // Verification de la guarde :
      if (! t->Get_cond()->Is_Guard()) {
	cout << "Error in definition of TA: the guard of the following transition ";
	cout << "contains modal operators :"<< endl; t->Print();cout << endl;
      }

      // Verification des noeuds source et dest
      no = t->From();
      nod = t->To();
      if (! ln->Est_def(no)) 
	cout << "WARNING ! " <<no<< " is not defined in the list of nodes ! " << endl;
      if (! ln->Est_def(nod)) 
	cout << "WARNING ! " <<nod<< " is not defined in the list of nodes ! " <<endl;

      if (map_n_lt.Est_def(no))
	{ laux = map_n_lt.Recherche(no);
	  map_n_lt.Supprimer(no);
	  }
	else
	{ laux.NewListe();}
      laux.Ajouter(t);
      map_n_lt.Ajouter(no,laux);

      // on verifie si le lab de cette transition est deja dans Alph
      alpaux = Alph;
      trouve = 0;
      labt = t->Get_label();
      while ((! alpaux.Est_vide()) && !trouve) {
	trouve = (Eq_str(labt,alpaux.Tete()));
	alpaux.Reste();
      }
      if (!trouve) Alph.Ajouter(labt);

      l->Reste();
    }
}


TA::TA(Ident_L * lc, Ident_L * lnoeud, Transition_L * l, Map_lnu * linv,
 Map_propL * ln, Map_propL * lact)
{
TA * res;
Ident_L * laux, lnoeudc;
Map_propL mpaux;
Ident_L lnaux;
int trouve;

// cout << "Constructeur TA::TA 2" << endl;

 _Rg =0;

assert(lnoeud);
assert(!lnoeud->Est_vide());

lnoeudc = *lnoeud;

if (! ln) 
  ln = new Map_propL;

// On verifie que tout element de ln est dans lnoeud...

 for (mpaux = *ln;!mpaux.Est_vide();mpaux.Reste()) {
   trouve = 0;
   lnaux = *lnoeud;
   while (!trouve && !lnaux.Est_vide()) {
     if (Eq_str(mpaux.TeteN(),lnaux.Tete()))
       trouve = 1;
     lnaux.Reste();
   }
   if (!trouve)
     cout << "WARNING ! "<< mpaux.TeteN() << " (used for atomic propositions) is not defined in the list of nodes !" << endl;
 }

// on complete ln avec des (n,{}) pour les noeuds de lnoeud non etiquetes de prop

 if (! ln->Est_def(lnoeud->Tete())) 
   ln->Ajouter(lnoeud->Tete(),0);
 else  // on verifie que le premier de ln est bien l'etat initial
   if (! Eq_str(lnoeud->Tete(),ln->TeteN())) {
     laux = ln->Recherche(lnoeud->Tete());
     ln->Supprimer(lnoeud->Tete());
     ln->Ajouter(lnoeud->Tete(),laux);
   }
 lnoeud->Reste();
 while (! lnoeud->Est_vide()) {
   if (! ln->Est_def(lnoeud->Tete())) 
     ln->Ajouterf(lnoeud->Tete(),0);
   lnoeud->Reste();
 }


if (! lact) 
  lact = new Map_propL;

// On verifie que tout element de lact est dans lnoeud (i.e. laux)...
 for (mpaux = *lact;!mpaux.Est_vide();mpaux.Reste()) {
   trouve = 0;
   lnaux = lnoeudc;
   while (!trouve && !lnaux.Est_vide()) {
     if (Eq_str(mpaux.TeteN(),lnaux.Tete()))
       trouve = 1;
     lnaux.Reste();
   }
   if (!trouve)
     cout << "WARNING ! "<< mpaux.TeteN() << " (used in Activity part) is not defined in the list of nodes !" << endl;
 }



DestroyIdent_L(&lnoeudc);

res = new TA(lc,ln,l,linv,lact);

(*this) = (*res);
delete res;
}



RegionGraph * TA::Get_RG(int ish)
  {

    //    cout << "TA::Get_RG(int ish)" << endl;
    //    Print();
    //    cout << "ish = " << ish << endl;


    //    cout << "_Rg = " << _Rg << endl;

    if (_Rg) { // verifier que meme ishyb
      if (_Rg->Is_hybrid() == ish) 
	return _Rg;
    } // sinon on recalcule
    
    cout << "*"<< endl;

    int m=-1;
    Lnu * auxf;

    // Pour toute transition et tout invariant, on recupere la Cste max:
    Transition_L lt = liste_t;
    Map_lnu li = Linvariants;

    while (!lt.Est_vide()) {
      auxf = lt.Tete()->Get_cond();
      m = max(auxf->MaxCste(),m);
      lt.Reste();
    }

    while (!li.Est_vide()) {
      auxf = li.Tete();
      m = max(auxf->MaxCste(),m);
      li.Reste();
    }
    return new RegionGraph(liste_c,m,ish);
  }
 
int TA::Get_CsteMax()
  {

    int m=-1;
    Lnu * auxf;

    // Pour toute transition et tout invariant, on recupere la Cste max:
    Transition_L lt = liste_t;
    Map_lnu li = Linvariants;

    while (!lt.Est_vide()) {
      auxf = lt.Tete()->Get_cond();
      m = max(auxf->MaxCste(),m);
      lt.Reste();
    }

    while (!li.Est_vide()) {
      auxf = li.Tete();
      m = max(auxf->MaxCste(),m);
      li.Reste();
    }
    return m;
  }
 



TA* TA::Copy()
{
assert(bta!=-1);

// Ident_L * lc, Map_propL * ln, Transition_L * l,Map_lnu * linv
Ident_L *clocks, laux, *lprop, *laux2;
Map_propL * nodes, ln, * activity;
Transition_L * trans, lt;
Map_lnu * inva, li;

clocks = new Ident_L;
 for (laux = liste_c;!laux.Est_vide();laux.Reste()) 
   clocks->Ajouterf(strcpy(new char[strlen(laux.Tete())+1],laux.Tete()));

nodes = new Map_propL;
 for (ln = liste_np; !ln.Est_vide();ln.Reste()) {
   laux2 = ln.Tete();
   lprop = CopyIdent_L(laux2);
   /*
   if (laux2) {
     lprop = new Ident_L;
     while (! laux2->Est_vide()) {
       lprop->Ajouterf(strcpy(new char[strlen(laux2->Tete())+1],laux2->Tete()));
       laux2->Reste();
     }
   }
   else 
     lprop = 0;
   */
   nodes->Ajouterf(ln.TeteN(),lprop);
 }

activity = new Map_propL;
 for (ln = liste_activ; !ln.Est_vide();ln.Reste()) {
   laux2 = ln.Tete();
   lprop = CopyIdent_L(laux2);
   activity->Ajouterf(ln.TeteN(),lprop);
 }

trans = new Transition_L;
 for (lt= liste_t;!lt.Est_vide();lt.Reste()) 
   trans->Ajouterf(lt.Tete()->Copy());

inva = new Map_lnu;
for (li=Linvariants;!li.Est_vide();li.Reste()) 
  inva->Ajouterf(li.TeteN(),li.Tete()->Copy());

return new TA(clocks,nodes,trans,inva,activity);
}




Transition_L TA::Get_Transition()
{assert(bta!=-1);
return liste_t;}

int TA::Is_BTA()
{assert(bta!=-1);
return bta;}

int TA::Is_a_node(char * s)
{
assert(bta!=-1);
return liste_np.Est_def(s);
}


Map_lnu TA::Get_Linvariant()
{assert(bta!=-1);
return Linvariants;}

Lnu * TA::Get_Invariant(Ident n)
{
assert(bta!=-1);
Lnu * inv;
if (Linvariants.Est_def(n)) 
  inv = Linvariants.Recherche(n)->Copy();
else inv = new LnuBool(Top);
return inv;
}

SetReg * TA::Get_Z_Invariant(Ident n,RegionGraph * rg)
{
assert(bta!=-1);
Lnu * inv;
if (Linvariants.Est_def(n)) 
  inv = Linvariants.Recherche(n)->Copy();
else inv = new LnuBool(Top);

 SetReg * res;
 if (rg) 
   res = (SetReg *) inv->StateSat(rg,0);
 else res = (SetReg *) inv->StateSat(Get_RG(0),0);


return res;
}



Map_propL TA::Get_Noeud()
{assert(bta!=-1);
return liste_np;}

Map_propL TA::Get_Activity()
{assert(bta!=-1);
return liste_activ;}

Ident_L * TA::Get_Act_node(char * s)
{
assert(s!=0);
Ident_L * lcinac;
if (! liste_activ.Est_defr(s,lcinac)) 
  return 0;
return lcinac;
}

// n = noeud, c = clock
int TA::Is_Active_CN(char * c,char * n)
{
assert(n!=0);
int trouve=1;

//trouve=liste_np.Est_def(c);
//assert(trouve);

Ident_L *l;
trouve=liste_activ.Est_defr(n,l);
if (!trouve) 
  return 1;  // toutes les horl. sont actives dans le noeud s !

trouve=0;
 for (Ident_L laux = *l;! laux.Est_vide();laux.Reste()) {
   if (Eq_str(laux.Tete(),c)) trouve=1;
 }
if (trouve) return 0;
else return 1; 
}




Ident TA::Get_init()
{assert(bta!=-1);
return n_init;}

Ident TA::Get_nom()
{assert(bta!=-1);
return nom;}

void TA::Put_nom(Ident n)
{
assert(bta!=-1);
  //  cout << "TA::Put_nom " << endl;
  //  cout << n << endl;
  //XXXXif (nom) delete nom;   // ajout 15-06-97 - 23-03-98
if (n) nom = strcpy(new char[strlen(n)+1],n);
else nom = strcpy(new char[1],"");
// cout << "TA::Put_nom (fin)" << endl;
}

Ident_L TA::Get_Clocks()
{assert(bta!=-1);
return liste_c;}

Ident_L TA::Get_Alph()
{assert(bta!=-1);
return Alph;}

Transition_L TA::Get_T_from_n(Ident n)
{assert(bta!=-1);
return map_n_lt.Recherche(n);}



void TA::PrintVCG(ostream & vcgoutput)
{ 
assert(bta!=-1);
Transition * t;
Transition_L lt;
//Ident_L lc,alpaux;
Ident_L * lp, Lp, * lcnul;
Map_propL ln = liste_np;
Lnu * aux;


vcgoutput << "graph: {" << endl;
vcgoutput << "title:\""<<nom <<"\"" << endl;
vcgoutput << "node.textmode:center" << endl;

while (! ln.Est_vide())
  {
  vcgoutput << "node:{title: \""<<ln.TeteN() << "\" label:\"";
  vcgoutput << ln.TeteN();
  lp = ln.Tete();
  if (lp) {
     Lp = *lp;
     if (! Lp.Est_vide()) {
       vcgoutput << "\\n\\f05 ";
       vcgoutput << Lp.Tete();
       Lp.Reste();
       while (! Lp.Est_vide()) {
	 vcgoutput << " " << Lp.Tete();Lp.Reste();}
     }
  }
  
  //Invariant de ln.TeteN() !
  if (Linvariants.Est_defr(ln.TeteN(),aux)) {
    vcgoutput << "\\n\\f01 ";
    aux->Print(vcgoutput);
  }
  
  // Les horloges de pente nulle
  if (liste_activ.Est_defr(ln.TeteN(),lcnul)) {
    if (lcnul) {
      Lp=*lcnul;
      if (!Lp.Est_vide()) {
	vcgoutput << "\\n(" << Lp.Tete(); 
	Lp.Reste();
	while (!Lp.Est_vide()) {
	  vcgoutput << "," <<Lp.Tete(); 
	  Lp.Reste();
	}
	vcgoutput << ")";
      }
    }
  }

  vcgoutput<<"\"";
  if (Eq_str(ln.TeteN(),n_init)) 
    vcgoutput << " bordercolor:02";
  vcgoutput << " shape: ellipse}" << endl;
  ln.Reste();
  }

lt = liste_t;
while (! lt.Est_vide())
  {
   t = lt.Tete();
   t->PrintVCG(vcgoutput); cout << endl;
   lt.Reste();
  }
 vcgoutput << endl << "}" << endl;

}


void TA::Print()
{
assert(bta!=-1);
Transition * t;
Transition_L lt;
Ident_L lc,alpaux;
Ident_L * lp, Lp;
Map_propL ln = liste_np;

if (bta) cout << " Basic TA : ";
else cout << " TA : ";
cout << nom << endl;
cout << " Nodes : ";
while (! ln.Est_vide())
  {
   cout << ln.TeteN() << " ";
   lp = ln.Tete();
   if (lp) {
     Lp = *lp;
     if (! Lp.Est_vide()) {
       cout << "[";
       cout << Lp.Tete();
       Lp.Reste();
       while (! Lp.Est_vide()) {
	 cout << " " << Lp.Tete();Lp.Reste();}
       cout << "]; ";
     }
   }
   ln.Reste();
  }
cout << endl;
cout << " Initial node: " << n_init << endl;
lc = liste_c;
cout << " Clocks : ";
while (! lc.Est_vide())
  {
   cout << lc.Tete() << " ";
   lc.Reste();
  }
cout << endl;
alpaux = Alph;
cout << " Alphabet : ";
while (! alpaux.Est_vide())
  {
   cout << alpaux.Tete() << " ";
   alpaux.Reste();
  }
cout << endl;

cout << " Transitions : " << endl;
lt = liste_t;
while (! lt.Est_vide())
  {
   t = lt.Tete();
   t->Print(); cout << endl;
   lt.Reste();
  }
if (! Linvariants.Est_vide()) {
  cout << "Invariants : " << endl;
  Map_lnu linvaux = Linvariants;
  while (! linvaux.Est_vide()) {
    cout << linvaux.TeteN() << " |= ";
    linvaux.Tete()->Print();cout<< endl;
    linvaux.Reste();
  }
}

// Les horloges de pente nulle
 if (!liste_activ.Est_vide()) {
   cout << "Clocks with slope zero:" << endl;
   for (ln = liste_activ; !ln.Est_vide();ln.Reste()) {
     if (ln.Tete() && (!ln.Tete()->Est_vide())) {
       cout << ln.TeteN() << " :";
       Lp = * ln.Tete();
       while (!Lp.Est_vide()) {
	 cout << " "<<Lp.Tete();
	 Lp.Reste();
       }
       cout << endl;
     }
   }
 }

}


void TA::Printc()
{
assert(bta!=-1);
  //Transition * t;
Transition_L lt;
Map_propL ln = liste_np;


this->Print();


cout << "List of Transitions from ... " << endl;
while (! ln.Est_vide())
  {
  cout << ln.TeteN() << " : " << endl;
  if (map_n_lt.Est_def(ln.TeteN()))
    {
     lt = map_n_lt.Recherche(ln.TeteN());
     while (! lt.Est_vide())
       {  (lt.Tete())->Print();
	  lt.Reste();
       }
    }
  ln.Reste();
  }
}


Transition_L TA::Get_T_to_n(Ident n)
{
assert(bta!=-1);
Transition_L res,lt;
Transition * t;
lt = liste_t;

while (! lt.Est_vide()) {
   t = lt.Tete();
   lt.Reste();
   if (! strcmp((t->To()),n))
	res.Ajouter(t);
   }
return res;
}

Transition_L TA::Get_T_from_n_l(Ident n,Ident l)
{
assert(bta!=-1);
Transition_L res,lt;
Transition * t;
if (map_n_lt.Est_def(n))
   {
    lt = map_n_lt.Recherche(n);
    while (! lt.Est_vide()) {
       t = lt.Tete();
       lt.Reste();
       if (! strcmp((t->Get_label()),l))
	   res.Ajouter(t);
     }
   }
return res;
}

Transition_L  TA::Get_T_to_n_l(Ident n,Ident l)
{
assert(bta!=-1);
Transition_L res,lt;
Transition * t;
lt = liste_t;

while (! lt.Est_vide()) {
   t = lt.Tete();
   lt.Reste();
   if (!strcmp((t->To()),n) && !strcmp((t->Get_label()),l))
	res.Ajouter(t);
   }
return res;
}

void TA::Destroy()
{
Map_n_lt maux = map_n_lt;
Transition_L laux;
//Ident_L l;
Map_propL lp;
Lnu * auxf;

if (bta==-1) return;

while (! maux.Est_vide()) {
  //XXXX  delete maux.TeteN();
  laux = maux.Tete();
  while (! laux.Est_vide()) {
    if (laux.Tete()) laux.Tete()->Destroy();
    laux.Reste();}
  maux.Tete().Vide();
  maux.Reste();
}
map_n_lt.Vide();

// laux = liste_t;
// while (! laux.Est_vide()) {
//  if (laux.Tete()) laux.Tete()->Destroy();
//  laux.Reste();}
liste_t.Vide();

lp = liste_np;
while (! lp.Est_vide()) {
  if (lp.Tete()) lp.Tete()->Vide();
  //XXXX  delete lp.Tete();
  lp.Reste();}
liste_np.Vide();

 /*
l = liste_c;
while (! l.Est_vide()) {
  //XXXX  delete l.Tete();
  l.Reste();}
 */

liste_c.Vide();

Map_lnu Linv = Linvariants;
 while (! Linv.Est_vide()) {
   auxf = Linv.Tete();
   auxf->Destroy();
   Linv.Reste();
 }
 Linvariants.Vide();

}


char * AjouterCar(char * s,char c)
{
char * res;
int l; 
if (! s) cout << "Erreur AjouterCar !! " << endl;

l = strlen(s);
res = new char[l+2];
strcpy(res,s);
res[l] = c;
res[l+1] = '\0';
return res;
}



Fsynchro * TA::MakeFs(Ident nfs)
{   
// retourne une Fct de synchro base sur la synchro binaire avec !, ?

  if ((! Eq_str(nfs,"Fbinary")) &&
      (! Eq_str(nfs,"Fbisim")) &&
      (! Eq_str(nfs,"Fnil")))
    {
    cout << "I don't know how to build such a "<<nfs<<" synch. fct ? " << endl;
    return (Fsynchro *) 0;
  }

  assert(bta!=-1 || Eq_str(nfs,"Fnil"));


Ident_L alpaux = Alph;
Ident lab;
Fsynchro * res = new Fsynchro;
Synch_Vect * sv;
Pt_Synch_Vect_L * lsv;

if (Eq_str(nfs,"Fnil")) {
  sv = new Synch_Vect("","*");
  lsv = new Pt_Synch_Vect_L();
  lsv->Ajouter(sv);
  res->Ajouter("*",lsv);

  if (bta == -1) return res;
}

if (Eq_str(nfs,"Fbisim")) {
  while (! alpaux.Est_vide()) {
    lab = alpaux.Tete();
    sv = new Synch_Vect("",lab);
    lsv = new Pt_Synch_Vect_L();
    lsv->Ajouter(sv);
    res->Ajouter(AjouterCar(lab,'r'),lsv);    
    sv = new Synch_Vect(lab,"");
    lsv = new Pt_Synch_Vect_L();
    lsv->Ajouter(sv);
    res->Ajouter(AjouterCar(lab,'l'),lsv);    
    alpaux.Reste();
  }
}

if (Eq_str(nfs,"Fbinary")) {
  while (! alpaux.Est_vide()) {
    lab = alpaux.Tete();
    if (Is_Sen(lab)) {   // a!
      sv = new Synch_Vect(Trans_Rec(lab),lab);
      lsv = new Pt_Synch_Vect_L();
      lsv->Ajouter(sv);
      res->Ajouter(Rem_RS(lab),lsv);   // a -> (a?,a!)
      sv = new Synch_Vect("",lab);
      lsv = new Pt_Synch_Vect_L();
      lsv->Ajouter(sv);
      res->Ajouter(lab,lsv);   // a! -> (_,a!)
    }
    else 
      if (Is_Rec(lab)) {  // a?
	sv = new Synch_Vect(Trans_Sen(lab),lab);
	lsv = new Pt_Synch_Vect_L();
	lsv->Ajouter(sv);
	res->Ajouter(Rem_RS(lab),lsv);   //  a -> (a!,a?)
	sv = new Synch_Vect("",lab);
	lsv = new Pt_Synch_Vect_L();
	lsv->Ajouter(sv);
	res->Ajouter(lab,lsv);           //  a? -> (_,a?)
      }
      else 
	if (!Eq_str(lab,"InvFail")) 
	  {
	    sv = new Synch_Vect("",lab);
	    lsv = new Pt_Synch_Vect_L();
	    lsv->Ajouter(sv);
	    res->Ajouter(lab,lsv);
	  }
    alpaux.Reste();
  }
  sv = new Synch_Vect("*","");
  lsv = new Pt_Synch_Vect_L();
  lsv->Ajouter(sv);
  res->Ajouter("*",lsv);
  
  // Les erreurs
  lsv = new Pt_Synch_Vect_L();
  sv = new Synch_Vect("InvFail","");
  lsv->Ajouter(sv);
  sv = new Synch_Vect("","InvFail");
  lsv->Ajouter(sv);
  res->Ajouter("InvFail",lsv);
}

if (PTRACE) {
  Fsynchro fs = *res;
  Pt_Synch_Vect_L lv;
  cout << " Resultat de MakeFs : " << endl;
  
  while(! fs.Est_vide()) {
    lv = *(fs.Tete());
    while (! lv.Est_vide()) {
      cout << fs.TeteN() << " -> ";
      cout << "("; 
      if (Eq_str(lv.Tete()->Get_la(),"")) cout << "_";
      else cout << lv.Tete()->Get_la();
      cout << ",";
      if (Eq_str(lv.Tete()->Get_lb(),"")) cout << "_";
      else cout << lv.Tete()->Get_lb();
      cout << ")" << endl;
      lv.Reste();
    }
    fs.Reste();
  }
}
return res;
}

Ident_L * IdentL_Copy(Ident_L * li)
{

if (! li) return li;

Ident_L * res = new Ident_L;
Ident_L laux = *li;
Ident id;
while (! laux.Est_vide()) {
  id = strcpy(new char[strlen(laux.Tete())+1],laux.Tete());
  res->Ajouter(id);
  laux.Reste();
}
return res;
}

Assign_L * AssignL_Copy(Assign_L * li)
{

if (! li) return li;

Assign_L * res = new Assign_L;
Assign_L laux = *li;
Assign ass, assc;

while (! laux.Est_vide()) {
  ass = laux.Tete();
  assc.Copy(ass);
  //  assc._ci = strcpy(new char[strlen(ass._ci)+1],ass._ci);
  //  assc._cj = strcpy(new char[strlen(ass._cj)+1],ass._cj);
  //  assc._k = ass._k;
  res->Ajouterf(ass);
  laux.Reste();
}
return res;
}

//    TA::MAKEBTA
// return a copy of the corresponding Basic TA

TA * TA::MakeBTA()
{
TA * res;
Transition_L *lt, ltaux;
Transition * t, * taux;
Map_propL * lnp, lnpaux;
Ident_L * lc;
Ident id;
Map_lnu linvaux;
Lnu * f;


lc = IdentL_Copy(&liste_c);

lnp = new Map_propL;
lnpaux = liste_np;
while (!lnpaux.Est_vide()) {
  lnp->Ajouterf(lnpaux.TeteN(),IdentL_Copy(lnpaux.Tete()));
  lnpaux.Reste();
}

lt = new Transition_L;
ltaux = liste_t;
while (! ltaux.Est_vide()) {
  taux = ltaux.Tete();
  t = new Transition(taux->From(),taux->To(),taux->Get_label(),
		     AssignL_Copy(taux->Get_rs()), taux->Get_cond()->Copy());
  lt->Ajouter(t);
  ltaux.Reste();
}

// On ajoute les "InvFail" ...


linvaux = Linvariants;
while (! linvaux.Est_vide()) {
  f = linvaux.Tete()->Copy();
  id = linvaux.TeteN();
  f = f->Reverse();
  t = new Transition(id,id,"InvFail",new Assign_L,f);
  lt->Ajouter(t);
  linvaux.Reste();
}

res = new TA(lc,lnp,lt);
res->Put_nom(nom);
return res;
}
  


//-----------------------------------------------------------
//                      Synchronization function
//-----------------------------------------------------------

void Synch_Vect::Print()
    {cout << "(" << la << "," << lb << ")";}

Ident Synch_Vect::Get_la()
    {return la;}

Ident Synch_Vect::Get_lb()
    {return lb;}

void Synch_Vect::Destroy()
{
  delete la;
  delete lb;
}

Synch_Vect * Synch_Vect::Copy()
{
return new Synch_Vect(la,lb);
}

