/* File: ta.h -- Francois -- Last modified on 30 Jul 2001
 * 	
 *      ceci est un modele d'en-tete de fichier C
 *
 */


#ifndef TA_H
#define TA_H


#include <string.h>
#include "lnu.h"


class TA;
typedef TA * Pt_TA;


typedef Liste<Ident> Ident_L;

class Assign {   // ci := cj + k
 public:
  Ident _ci;
  Ident _cj;
  int _k;
  Assign()
    {_ci=0;_cj=0;_k=0;}
  Assign(Ident c1,Ident c2,int k)
    {_ci=c1;_cj=c2;_k=k;}
  void Copy(Assign a)
    {_ci = strcpy(new char[strlen(a._ci)+1],a._ci);
     _cj = strcpy(new char[strlen(a._cj)+1],a._cj);
     _k = a._k;}
};

typedef Liste<Assign> Assign_L;


class Transition {
  private :
    Ident n1;
    Ident n2;
    Ident lab;
    Assign_L * r; 
    Lnu * cond;

  public :

    Transition(Ident m1,Ident m2,Ident l,Assign_L * rs, Lnu * c)
      {n1= strcpy(new char [strlen(m1)+1],m1);
       n2= strcpy(new char [strlen(m2)+1],m2);
       lab = strcpy(new char [strlen(l)+1],l);
       r = rs;
       cond = c;}

  Ident From();
  Ident To();
  Ident Get_label();
  Assign_L * Get_rs();
  Lnu * Get_cond();

  void Print();
  void PrintVCG(ostream & vcgoutput);
  void Destroy();
  Transition * Copy();
};


typedef Transition * Pt_Transition;
typedef Liste<Pt_Transition> Transition_L;
typedef Mapping<Transition_L> Map_n_lt;

typedef Mapping<Ident_L *> Map_propL;
typedef Mapping<Lnu *> Map_lnu;

class TA {
  private :
  
  Ident nom;  // nom de l'automate
  Map_n_lt map_n_lt;
  Transition_L liste_t;
  Map_propL liste_np;  // (noeud ; prop1, prop2, ...)
  Map_propL liste_activ;  // (noeud ; x1, x2, ...) horloges a pente nulle
  Ident_L liste_c;
  Ident n_init;
  Ident_L Alph;
  Map_lnu Linvariants;
  int bta;   // =1 if Basic timed automaton
  // = -1 if empty
  RegionGraph * _Rg;


  public :

    TA(); // special empty ta for MakeFs('Fnil')
  
  TA(Ident_L * lc, Map_propL * ln, Transition_L * l, Map_lnu * linv = 0,Map_propL * lact=0); 

  TA(Ident_L * lc, Ident_L * lnoeud, Transition_L * l, Map_lnu * linv = 0,
 Map_propL * ln = 0,Map_propL * lact=0);

  Transition_L Get_Transition();
  Map_propL Get_Noeud();
  Map_propL Get_Activity();
  Ident_L * Get_Act_node(char * s);
  int Is_Active_CN(char * c,char * n);

  Ident Get_init();
  void Put_nom(Ident n);
  Ident Get_nom();
  Ident_L Get_Clocks();
  Ident_L Get_Alph();
  int Is_BTA();
  int Is_a_node(char * s);
  Map_lnu Get_Linvariant();
  RegionGraph * Rg();

  Lnu * Get_Invariant(Ident n); // retourne une copie de l'invariant de n
  SetReg * Get_Z_Invariant(Ident n, RegionGraph * rg =0);

  Transition_L Get_T_from_n(Ident n);
  Transition_L Get_T_to_n(Ident n);
  Transition_L Get_T_from_n_l(Ident n,Ident l);
  Transition_L Get_T_to_n_l(Ident n, Ident l);

  void Printc();
  void Print();
  void PrintVCG(ostream & vcgoutput);
  Fsynchro * MakeFs(Ident nfs);    // return a synch. function of type "nfs"
  TA * MakeBTA();                  // return a basic timed automata
  void Destroy();
  TA* Copy();
  RegionGraph * Get_RG(int ish);
  int  Get_CsteMax();
};


class Synch_Vect {
  private :
    Ident la;
    Ident lb;       // l = f (la,lb)
  public :
    Synch_Vect(Ident a,Ident b)
    {la = strcpy(new char[strlen(a)+1],a);
     lb = strcpy(new char[strlen(b)+1],b);}

    void Print();

    Ident Get_la();

    Ident Get_lb();
    void Destroy();
    Synch_Vect * Copy();
};

class VerifElet { 
  public : 
    char * _nta; 
  int * _vflag; 

  VerifElet(char *naut,int v0,int v1,int v2, int v3, int v4)
    {_nta = naut; _vflag = new int[5]; _vflag[0]=v0;_vflag[1]=v1;
    _vflag[2]=v2;_vflag[3]=v3;_vflag[4]=v4;}

  VerifElet(char * naut)
    {_nta = naut; _vflag=0;}

  VerifElet* Copy();
};




#endif
