/* File: table.cc -- Francois -- Last modified on 25 Jul 2001
 * 	
 *      Gestion des tables de synchronisation
 *
 */

#include<cassert>
#include<iostream>
#include<stdio.h>

#include "table.h"
#include "env.h"


//----------------------------------------------------------------------
//         Construction d'une table de Synchro a` partir du parser
//----------------------------------------------------------------------

STable::STable(Ident_L * lta, Liste<Id_LId *> * l)
{
int i, trouve;
Ident_L laux;
Liste<Id_LId *> lidaux;
Id_LId il;
paire pairaux;
Liste<paire> lpaux;

_taille = lta->Longueur();
_nomta = new Ident[_taille];
laux = *lta;
 for (i=0;i<_taille;i++) {
   _nomta[i] = laux.Tete();
   laux.Reste();
 }
lta->Vide();
delete lta;

lidaux = * l;
 while (! lidaux.Est_vide()) {
   il = * lidaux.Tete();
   pairaux._AV = il._AV;
   pairaux._VS = new Ident[_taille];
   laux = *il._LAC;
   i=0;
   //   assert(laux.Longueur() == _taille);
   if (laux.Longueur() != _taille) 
     cout << endl << " Error: the definition of action "<< il._AV << " is not correct !" << endl << endl  << '\a';
   else {
     while(! laux.Est_vide()) {
       pairaux._VS[i] = laux.Tete();
       laux.Reste();
       i++;
     }
     Ajouter(pairaux);
     il._LAC->Vide();
   }
   lidaux.Reste();
 }
 
 // On verifie que les alphabets des TA correspondent exactement aux
 // actions de la table...
Objet * o;
TA * aut;
Ident_L alphaA;

 for (i=0;i<_taille;i++) {
   if (Envir.Est_def(_nomta[i],o,1)) {
     if (o->Otype().Est_typeb() && (o->Otype().Valb() == Ta)) {
       // on verifie que o->OTA() est ok
       aut = o->OTA();
       alphaA = aut->Get_Alph();
       
       // verifions que alphaA est inclu dans la table
       for (laux = alphaA; !laux.Est_vide(); laux.Reste()) {
	 trouve = 0;
	 lpaux = _laction;
	 while (!trouve && !lpaux.Est_vide()) {
	   if (Eq_str(laux.Tete(),lpaux.Tete()._VS[i])) trouve=1;
	   lpaux.Reste();
	 }
	 if (!trouve) 
	   cout << "WARNING ! action "<<laux.Tete()<<" of " << _nomta[i] << " doesn't occur in the synchronization table !" << '\a' << endl;
       }

       // verifions que les actions de la table  sont des actions des TA
       for (lpaux = _laction; !lpaux.Est_vide(); lpaux.Reste()) 
	 if (! Eq_str(lpaux.Tete()._VS[i],".")) {
	   trouve = 0;
	   laux = alphaA;
	   while (!trouve && !laux.Est_vide()) {
	     if (Eq_str(laux.Tete(),lpaux.Tete()._VS[i])) trouve=1;
	     laux.Reste();
	   }
	   if (!trouve) 
	     cout << "WARNING ! action "<<lpaux.Tete()._VS[i]<<" should occur in " << _nomta[i] << '\a' << endl;
	 }
     }
     else 
       cout << "WARNING ! " << _nomta[i] << " is not a TA ! " << '\a' << endl;
   }
   else 
     cout << "WARNING ! " << _nomta[i] << " is not defined ! " << '\a' << endl;
 }

}




//----------------------------------------------------------------------
//         Fonctions d'acces
//----------------------------------------------------------------------

int STable::Taille() 
{return _taille;}

char * STable::Composant(int i)
{
assert(i<_taille);
assert(i>=0);
return _nomta[i];
}


//----------------------------------------------------------------------
//         Affichage d'une table de Synchro 
//----------------------------------------------------------------------

void STable::Print()
{
int i;
Liste<paire> laux;
paire pairaux;
 
 cout << "Synchronization table :  ("<<_taille<<") " << endl;
  cout << "Parallel composition : ( ";
  for (i=0;i<_taille-1;i++) 
    cout << _nomta[i] << " | ";
  if (_taille) cout << _nomta[_taille-1];
  cout << " )"<<endl;

  laux = _laction;
  while (!laux.Est_vide()) {
    pairaux = laux.Tete();
    for (i=0;i<_taille;i++) 
      cout << pairaux._VS[i] << '\t';
    cout << "--> " << pairaux._AV << endl;
    laux.Reste();
  }

}


//----------------------------------------------------------------------
//         Destruction d'une table de Synchro 
//----------------------------------------------------------------------

void STable::Destroy()
{
int i;
paire pairaux;
Liste<paire> laux;

for (i=0;i<_taille;i++) 
  delete _nomta[i];
delete [] _nomta;

laux = _laction;
 while (! laux.Est_vide()) {
   pairaux = laux.Tete();
   delete pairaux._AV;
   for (i=0;i<_taille;i++) 
     delete pairaux._VS[i];
   delete [] pairaux._VS;
   laux.Reste();
 }
_laction.Vide();
delete this;
}


//----------------------------------------------------------------------
//         Copie d'une table de Synchro 
//----------------------------------------------------------------------
 

STable * STable::Copy()
{
char * * nom, * * taux;
Liste<paire> laux, lact;
int i;

// on construit nom
nom = new Ident[_taille];
for (i=0;i<_taille;i++) 
  nom[i] = strcpy(new char[strlen(_nomta[i])+1],_nomta[i]);

// on construit lact
 for (laux=_laction;!laux.Est_vide();laux.Reste()) {
   taux = new Ident[_taille];
   for (i=0;i<_taille;i++) 
     taux[i] = strcpy(new char[strlen(laux.Tete()._VS[i])+1],laux.Tete()._VS[i]);
   lact.Ajouterf(paire(strcpy(new char[strlen(laux.Tete()._AV)+1],laux.Tete()._AV),
		       taux));
 }

return new STable(_taille,nom,lact);

}

//---------------------------------------------------------------------
//             Permute deux composants de la table
//---------------------------------------------------------------------
//  Note: fct privee

void STable::Permuter(int i,int j)
{
paire pairaux;
Liste<paire> laux;

assert(i<_taille);
assert(j<_taille);

char * auxname;

auxname = _nomta[i];
_nomta[i]=_nomta[j];
_nomta[j]=auxname;

laux = _laction;
 while (!laux.Est_vide()) {
   pairaux = laux.Tete();
   auxname = pairaux._VS[i];
   pairaux._VS[i] = pairaux._VS[j];
   pairaux._VS[j] = auxname;
   laux.Reste();
 }

}

//---------------------------------------------------------------------
//                TEST
//---------------------------------------------------------------------
void STable::Test(char * nta)
{
Fsynchro * faux;
STable * taux;
Fsynchro Fs;
Pt_Synch_Vect_L lv;


ElimComposant(nta,faux,taux);

 cout <<endl << " Resultat du test... " << endl;

 if (faux) {
   cout << "Synchro. function :" << endl;
   Fs = *faux;
   while(! Fs.Est_vide()) {
     lv = *(Fs.Tete());
     cout << Fs.TeteN() << " -> {";
     while (! lv.Est_vide()) {
       cout << "("; 
       if (Eq_str(lv.Tete()->Get_la(),"")) cout << "_";
       else cout << lv.Tete()->Get_la();
       cout << ",";
       if (Eq_str(lv.Tete()->Get_lb(),"")) cout << "_";
       else cout << lv.Tete()->Get_lb();
       cout << ") ";
       lv.Reste();
     }
     cout << "}" << endl;
     Fs.Reste();
   }
   cout << endl;
 }

 if (taux) 
   taux->Print();

}

//---------------------------------------------------------------------
//                STABLE::ELIMCOMPOSANT
//---------------------------------------------------------------------
// Construit : fsb la fct de synchro binaire correspondant a` (nta || reste)
// et tbss la table du systeme 'reste'
//
//  f(a1,...,an) = b
// 1 cas a1=0 : f'(a2,...,an) = b  et fb(b,"") = b
// 2 cas ai=0 (i>1) : fb("",b) = b
// 3 cas ai=/=0 et aj=0 j=/=j : 
//        f'(a2,...,an) = ai  et fb(ai,a1) = b
//  (verifier que: b(k) = ai <=> a(k)i = ai et a(k)j = 0 (j=/=i)
// 4 cas general:
//   f'(a2,...,an) = c      et fb(c,a1)=b
//   c est soit: tel que f(0,a2,...,an)=c
//         soit:         f'(a2,...,an)=c  (deja defini dans f')
//         soit: un nouveau label...


// fct auxilliaire...
void Ajouter_Fsynchro(char * blab,Synch_Vect * bsv,Fsynchro * fsb)
{
  Fsynchro faux = *fsb;
  Pt_Synch_Vect_L vslaux;
  Pt_Synch_Vect_L * ptlaux;
  int trouve = 0;

  while (! trouve && !faux.Est_vide()) {
    if (Eq_str(blab,faux.TeteN())) 
      trouve = 1;
    else faux.Reste();
  }

  if (trouve) {  // il faut verifier qu'un bsv identique n'est pas deja la !
    vslaux = * faux.Tete();
    trouve = 0;
    while (!trouve && !vslaux.Est_vide()) {
      trouve = Eq_str(bsv->Get_la(),vslaux.Tete()->Get_la()) &&
	Eq_str(bsv->Get_lb(),vslaux.Tete()->Get_lb());
      vslaux.Reste();
    }
    if (trouve) {
      bsv->Destroy();
      delete bsv;
    }
    else
      faux.Tete()->Ajouter(bsv);
  }
  else {
    ptlaux = new Pt_Synch_Vect_L();
    ptlaux->Ajouter(bsv);
    fsb->Ajouter(blab,ptlaux);
  }
}  

void STable::Ajouter(paire p)
{
Liste<paire> laux;
paire pairaux;
int i,trouve = 0;

 laux = _laction;
 while (!trouve && !laux.Est_vide()) {
   pairaux = laux.Tete();
   if (Eq_str(pairaux._AV,p._AV)) {
     trouve = 1;
     for (i=0;i<_taille;i++) 
       if (! Eq_str(pairaux._VS[i],p._VS[i]))
	 trouve = 0;
   }
   laux.Reste();
 }
if (! trouve) 
  _laction.Ajouter(p);
}

void NewLabel(char tab[20])
{
  sprintf(tab, "~a%d", __NOUVEAULABEL);
  __NOUVEAULABEL++;
}


Liste<char **> STable::LVecteur()
{
  Liste<paire> lac = _laction;
  Liste<char **> res;

  while (!lac.Est_vide()) {
    res.Ajouter(lac.Tete()._VS);
    lac.Reste();
  }
  return res;
}

void STable::ElimComposant(char * nta,Fsynchro * & fsb,STable * & tbss)
{
int i=0,trouve=0,pb;
char nlabel[20];
paire pairaux, pairaux2;
Liste<paire> laux, laux2;
Synch_Vect * bsv;
 char * blab, * clab, * a_ilab, * a_1lab; // voir la definition

 //   cout << "Elim composant > " << endl;
 //  Print();
 //  cout << "Elimination de " << nta << endl;
 while (!trouve && i<_taille) {
   trouve = Eq_str(nta,_nomta[i]);
   i++;
 }
 if (!trouve) {
   cout << "Error in STable::ElimComposant, there is no "<<nta<<" in the " << endl;
   cout << "synchronization table : " << endl;
   Print();
   fsb=0;
   tbss=0;
   return;
 }
 i--; // i est le numero de nta
 
 // cout << " c'est le composant "<< i << " qu'il faut eliminer ! " << endl;

 if (i != 0) 
   Permuter(0,i);

 // nta est maintenant en position 0

tbss = new STable();
fsb = new Fsynchro;

tbss->_taille = _taille-1; 

 if (_taille <= 1) {
   tbss->_nomta = 0;
   laux = _laction;
   while (!laux.Est_vide()) {
     pairaux = laux.Tete();
     blab =   pairaux._AV;
     a_1lab = pairaux._VS[0];
     bsv = new Synch_Vect("",a_1lab);
     Ajouter_Fsynchro(blab,bsv,fsb);   //maintient la structure de mapping de fsb
     laux.Reste();
   } 
   // fin du cas avec 1 seul TA !
 }
 if (_taille == 2) {
   tbss->_nomta = new Ident[1];
   tbss->_nomta[0] = strcpy(new char[strlen(_nomta[1])+1],_nomta[1]);
   laux = _laction;
   while (!laux.Est_vide()) {
     pairaux = laux.Tete();
     blab =   pairaux._AV;
     a_1lab = pairaux._VS[0];
     a_ilab = pairaux._VS[1];
     // construction de tbss:
     if (! Eq_str(a_ilab,".")) {
       pairaux2._AV = strcpy(new char[strlen(a_ilab)+1],a_ilab);
       pairaux2._VS = new Ident[1];
       pairaux2._VS[0] = strcpy(new char[strlen(a_ilab)+1],a_ilab);
       tbss->Ajouter(pairaux2);
     }
     // construction de la fct binaire
     if (Eq_str(a_ilab,".")) 
       bsv = new Synch_Vect("",a_1lab);
     else if (Eq_str(a_1lab,".")) 
       bsv = new Synch_Vect(a_ilab,"");
     else bsv = new Synch_Vect(a_ilab,a_1lab);
     Ajouter_Fsynchro(blab,bsv,fsb);   //maintient la structure de mapping de fsb
     laux.Reste();
   }    

 }
 else {
   tbss->_nomta = new Ident[tbss->_taille];
   for (i=1;i<_taille;i++) 
     tbss->_nomta[i-1] = strcpy(new char[strlen(_nomta[i])+1],_nomta[i]);

   laux = _laction;
   while (!laux.Est_vide()) {   // Boucle principale !

     pairaux = laux.Tete();
     blab =   pairaux._AV;
     a_1lab = pairaux._VS[0];
     
     if (Eq_str(a_1lab,".")) {  // cas 1
       bsv = new Synch_Vect(blab,"");
       Ajouter_Fsynchro(blab,bsv,fsb);   //maintient la strcuture de mapping de fsb
       pairaux2._AV = strcpy(new char[strlen(blab)+1],blab);
       pairaux2._VS = new Ident[_taille-1];
       for (i=1;i<_taille;i++) 
	 pairaux2._VS[i-1] = strcpy(new char[strlen(pairaux._VS[i])+1],pairaux._VS[i]);
       tbss->Ajouter(pairaux2);
     }
     else { // Autres cas !
       int nbnul=0,pos;
       for (i=1;i<_taille;i++)
	 if (Eq_str(pairaux._VS[i],".")) 
	   nbnul++;
	 else pos = i;
      
       if (nbnul == _taille-1) { // cas 2
	 bsv = new Synch_Vect("",a_1lab);
	 Ajouter_Fsynchro(blab,bsv,fsb);
       }
       else if (nbnul == _taille-2) {   // cas 3 avec i = pos
	 a_ilab = pairaux._VS[pos];

	 // maintenant on va construire: f(...,ai...) = c
	 // c=ai ssi b(k) =/= ai pour tout k
	 // c = nouveau label sinon

	 laux2 = _laction;
	 pb = 0;
	 while( !pb && !laux2.Est_vide()) {
	   if (Eq_str(laux2.Tete()._AV,a_ilab)) {
	     for (i=0;i<_taille;i++)
	       if (i!=pos && !Eq_str(laux2.Tete()._VS[i],".")) pb=1;
	     if (! Eq_str(laux2.Tete()._VS[pos],a_ilab)) pb=1;
	   }
	   laux2.Reste();
	 }
	 if (pb) {
	   NewLabel(nlabel);
	   clab = strcpy(new char[strlen(nlabel)+1],nlabel);
	 }
	 else clab = strcpy(new char[strlen(a_ilab)+1],a_ilab);

	 bsv = new Synch_Vect(clab,a_1lab);
	 Ajouter_Fsynchro(blab,bsv,fsb);

	 pairaux2._AV = clab;
	 pairaux2._VS = new Ident[_taille-1];
	 for (i=1;i<_taille;i++) 
	   if (i==pos) 
	     pairaux2._VS[i-1] = strcpy(new char[strlen(a_ilab)+1],a_ilab);
	   else
	     pairaux2._VS[i-1] = strcpy(new char[1],".");
	 tbss->Ajouter(pairaux2);
	 
       }
       else { // cas general !!!
	 // On doit rechercher (si il existe) un label c tq:
	 // f(0,a2,...,an) = c ou f'(a2,...,an) = c
	 // sinon on en cree un nouveau...
	 //	 cout << " Cas general... " << endl;
	 laux2 = _laction;
	 trouve = 0;
	 while (!trouve && !laux2.Est_vide()) {
	   pb=1;
	   if (Eq_str(laux2.Tete()._VS[0],".")) {
	     i=1;pb=0;
	     while (!pb && i<_taille) {
	       pb = !Eq_str(laux2.Tete()._VS[i],pairaux._VS[i]);
	       i++;
	     }
	   } 
	   if (pb) laux2.Reste();
	   else trouve=1;
	 }
	 if (trouve) {
	   clab = strcpy(new char[strlen(laux2.Tete()._AV)+1],
			 laux2.Tete()._AV);
	   //	   cout << "sous-cas 1, c = " << clab << endl;
	 }
	 else {  // on cherche dans le debut de la table tbss
	   laux2 = tbss->_laction;
	   trouve = 0;
	   while (!trouve && !laux2.Est_vide()) {
	     i=1;
	     pb = 0;
	     while (!pb && i<_taille) {
	       pb = !Eq_str(laux2.Tete()._VS[i-1],pairaux._VS[i]);
	       i++;
	     }
	     if (pb) laux2.Reste();
	     else trouve=1;
	   }
	   if (trouve) {
	     clab = strcpy(new char[strlen(laux2.Tete()._AV)+1],
			   laux2.Tete()._AV);
	     //	     cout << "sous-cas 2, c = " << clab << endl;
	   }
	   else { NewLabel(nlabel);
	   clab = strcpy(new char[strlen(nlabel)+1],nlabel);
	   //	   cout << "sous-cas 3, c = " << clab << endl;
	   }
	 }
	 // Il reste a` construire f'(a2,...,an)=c et fb(c,a1)=b
	 bsv = new Synch_Vect(clab,a_1lab);
	 Ajouter_Fsynchro(blab,bsv,fsb);

	 pairaux2._AV = clab;
	 pairaux2._VS = new Ident[_taille-1];
       for (i=1;i<_taille;i++) 
	 pairaux2._VS[i-1] = strcpy(new char[strlen(pairaux._VS[i])+1],
				    pairaux._VS[i]);
       tbss->Ajouter(pairaux2);
       }  // fin cas general
     } // Else : Autre cas !
     laux.Reste();
   }  // while (!laux...)  
 } // fin des cas avec nta > 1  
 
 //   cout << "Elim composant (fin) " << endl;
}


