/* File: table.h -- Francois -- Last modified on 25 Jul 2001
 * 	
 *      Table de synchronisation 
 *
 */


#ifndef TABLE_H
#define TABLE_H


#include "liste.h"
#include "lnu.h"

extern int __NOUVEAULABEL;

// Id_LId est utilise dans le parser...
class Id_LId {
  public :
    char * _AV;
    Liste<char *> * _LAC;

    Id_LId(char * v,Liste<char *> * l) 
      {_AV = v; _LAC = l;}
    Id_LId() 
      {_AV = 0; _LAC = 0;}
};
  

class STable {
  private :

    class paire {
    public : 
      char * _AV;  // action visible
      char * * _VS;  // Vecteur de synchro
      paire() 
	{_AV=0; _VS=0;}
      paire(char * av, char ** vs) 
	{_AV=av; _VS=vs;}
  };

  int _taille;
  char * * _nomta;
  Liste<paire> _laction;

  void Ajouter(paire p);
  void Permuter(int i, int j);  // permuter les composants i et j

  public :
    STable() 
    {_taille =0; _nomta = 0;}
    STable(Liste<char *> * lta, Liste<Id_LId *> * l);
    STable(int t,char * * nom,Liste<paire> lact)
      {_taille = t; _nomta = nom; _laction = lact;}
    int Taille();
    char * Composant(int i);
    void Print();
    void Destroy();
    STable* Copy();
    void Test(char * nta);
    Liste<char **> LVecteur();
    void ElimComposant(char * nta,Fsynchro * & fsb,STable * & tbss);
};


#endif


