/* File: type.cc -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      type...
 *
 */

#include "type.h"
#include "env.h"
#include <iostream>


type::type(TYPEB t)
{base = 1;
valb = t;}

type::type(Ltype * l,TYPEB t)
{base = 0;
 valf.larg = l;
 valf.val  = new type(t);
}

type::type(Ltype * l,type * t)
{base = 0;
valf.larg = l;
valf.val = t;
}

TYPEB type::Valb()
{if (!base) 
  cout << "Erreur type::Valb() " << endl;
return valb;
}

TYPEF type::Valf()
{if (base) 
  cout << "Erreur type::Valf() " << endl;
return valf;
}



void type::Print()
{
  if (base) {
    switch(valb) {
    case Void : cout << "void "; break;
    case Int : cout << "int "; break;
    case Flnu : cout << "Lnu ";break;
    case Ta : cout << "TA ";break;
    case Dec : cout << "Decl "; break;
    case Fsy : cout << "Fct_Synch "; break;
    case Spec : cout << "Specif "; break;
    case Undef : cout << "Undef "; break;
    case Star : cout << " * "; break;
    case String : cout << "String "; break;
    case CFlag : cout << "Flag "; break;
    case Table : cout << "Table "; break;
    case System : cout << "System "; break;
    case Dbm : cout << "DBM "; break;
    case Setval : cout << "SetVal "; break;
    case Lid : cout << "List id "; break;
    default : cout << " ??? ";
    }
  }
  else {
    valf.larg->Print();
    cout << " -> ";
    valf.val->Print();
  }
}

void type::Destroy()
{
  if (! base) {
    valf.larg->Destroy();
    valf.val->Destroy();
  }
  //XXXX  delete this;
}

int type::Egal(type *t)
{
if (!t) return 0;
if (base != t->base) return 0;
if (base) 
  return (valb == t->valb);
else 
  return ((valf.val->Egal(t->valf.val)) && (valf.larg->Egal(t->valf.larg)));
}

int type::Egal(Objet * o)
{return o->Otype().Egal(this);}

int type::EstComp(type *t)
{  // 1 si t < this
if (!t) return 0;
if (base != t->base) return 0;
if (base) {
  // Dbm < Setval
  if ((valb == Setval) && (t->valb == Dbm)) return 1;
  // (int v string) < flag
  if ((valb == CFlag) && ((t->valb == Int) || (t->valb == String))) return 1;
  else return ((valb == t->valb) || (valb == Star));
}
else 
  return ((valf.val->EstComp(t->valf.val)) && (valf.larg->EstComp(t->valf.larg)));
}

int type::EstComp(Objet * o)
{return o->Otype().EstComp(this);}

void Ltype::Print()
{
  Element * aux;
  if (debut) {
    cout << "( ";
    aux = debut;
    if (aux) {
      aux->val->Print();
      aux = aux->suivant;
    }
    while (aux) {
      cout << ", ";
      aux->val->Print();
      aux = aux->suivant;
    }
    cout << ")";
  }
}

void Ltype::Ajouter(type * t)
{ Element * aux;
aux = new Element;
aux->val = t;
aux->suivant = debut;
debut = aux;
}

void Ltype::Ajouter(TYPEB t)
{Ajouter(new type(t));}

void Ltype::Ajouterf(TYPEB t)
{Ajouterf(new type(t));}

void Ltype::Ajouterf(type * t)
{ Element * aux;
Element * l;
aux = new Element;
aux->val = t;
aux->suivant = 0;
if (debut == 0)
  { debut = aux; }
else {
  l = debut;
  while (l->suivant != 0)  {
    l = l->suivant;}
  l->suivant = aux;
}
}

int Ltype::Est_vide()
{return (debut == 0);}

void Ltype::Vide()
{
  Element * aux;
  Element * aux2;
  aux = debut;
  while (aux != 0)
    { aux2 = aux;
    aux = aux->suivant;
    //XXXX    delete aux2; 
}
  debut = 0;
}

void Ltype::Destroy()
{
  Element * aux;
  Element * aux2;
  aux = debut;
  while (aux != 0)
    { aux2 = aux;
    aux = aux->suivant;
    aux2->val->Destroy();}
  debut = 0;
}



int Ltype::Egal(Ltype * l)
{
Element * aux1, * aux2;  
int res = 1;

if (!l) return 0;
aux1 = debut;
aux2 = l->debut;

while (res && (aux1 && aux2)) {
  res = (aux1->val->Egal(aux2->val));
  aux1 = aux1->suivant;
  aux2 = aux2->suivant;
}

if (res && ((!aux1) && (!aux2))) return 1;
else return 0;
}

int Ltype::EstComp(Ltype * l)
{ // teste si this contient l

Element * aux1, * aux2;
type tvoid (Void);  
int res = 1;

if (!l) return 0;
aux1 = debut;

if (l->Est_vide() && (! Est_vide())) {
  // On teste si this = [Void]
  if ((aux1->val->Egal(&tvoid)) && (aux1->suivant == 0)) return 1;
  else return 0;
}

aux2 = l->debut;

while (res && (aux1 && aux2)) {
  res = (aux1->val->EstComp(aux2->val));
  aux1 = aux1->suivant;
  aux2 = aux2->suivant;
}

if (res && ((!aux1) && (!aux2))) return 1;
else return 0;
}

int Ltype::Egal(LObjet * l)
{
if (!l) return 0;
LObjet laux = *l;
Objet * ob;
Element * aux = debut;
int res = 1;

while (res && (aux && !laux.Est_vide())) {
  ob = laux.Tete();
  res = ob->Otype().Egal(aux->val);
  aux = aux->suivant;
  laux.Reste();
}

if (res && (laux.Est_vide() && !aux)) return 1;
else return 0;
}

int Ltype::EstComp(LObjet * l)
{
if (!l) return 0;
LObjet laux = *l;
type tvoid (Void);  
type tob;
Element * aux = debut;
int res = 1;

if (l->Est_vide() && (! Est_vide())) {
  // On teste si this = [Void]
  if ((aux->val->Egal(&tvoid)) && (aux->suivant == 0)) return 1;
  else return 0;
}


while (res && (aux && !laux.Est_vide())) {
  tob = laux.Tete()->Otype();
  res = aux->val->EstComp(&tob);
  aux = aux->suivant;
  laux.Reste();
}

if (res && (laux.Est_vide() && !aux)) return 1;
else return 0;
}



