/* File: zone.cc -- Francois -- Last modified on 2 Feb 2001
 * 	
 *      zones et DBM
 *
 */


#include <iostream>
#include "zone.h"
#include "liste.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

Ident Name(int i)
{
char * tab = new char[5];
sprintf(tab, "X%d", i);
return tab;
}


/* ==================================================================

				BORNE

=================================================================== */


Borne::Borne()
{_val=0;_epsi=-1;}

Borne::Borne(int v)
{_val=v;_epsi=1;}

Borne::Borne(int v,int e)
{
_val=v;
_epsi=e;
}

int Borne::Is_Inf()
{return (_epsi == -1);}

int Borne::Is_Supe0()
{ return ((_val==0) && (_epsi==1));}

Borne Borne::Increm(int k,int M)
{
int v;
if (_epsi == -1) return Borne(0,-1);

v=_val+k;
if ((v>=-M) && (v<=M)) return Borne(v,_epsi);

if (v>M) return Borne(0,-1);
//if (v<-M) 
return Borne(-M,0);
}

Borne Borne::Reverse()
{
assert(_epsi != -1);
 return (_epsi == 0) ? Borne(-_val,1) : Borne(-_val,0);
}

void Borne::ImposeNonStricte()
{if (_epsi == 0) _epsi=1;}


void Borne::Reduction(int M)
{
  if (_epsi == -1) 
    return;

  if (_val>M) {
    _val=0;
    _epsi=-1;
    return;
  }

  if (_val<-M) {
    _val=-M;
    _epsi=0;
  }
}


void Borne::Print()
{
  cout << *this;
}
void Borne::PrintRev()
{
if (_epsi == -1) 
  cout << "-inf<";
else if (_epsi == 0) 
  cout <<-_val<<"< ";
else  
  cout <<-_val<<"<= ";
}


int operator <= (const Borne & b1, const Borne & b2)
{
if (b2._epsi == -1) return 1;
if (b1._epsi == -1) return 0;

if ((b1._val < b2._val) || 
    ((b1._val == b2._val) && (b1._epsi <= b2._epsi)))
  return 1;
return 0;
}

int operator == (const Borne & b1, const Borne & b2)
{
  return ((b1._epsi == -1) && (b2._epsi == -1)) || 
    ((b1._val == b2._val) && (b1._epsi == b2._epsi));
}

int operator != (const Borne & b1, const Borne & b2)
{
  return (! (b1 == b2));
}

int operator < (const Borne & b1, const Borne & b2)
{
if ((b1 <= b2) && (b1 != b2)) return 1;
return 0;
}

Borne min (const Borne & b1, const Borne & b2)
{
if (b1 <= b2) return b1;
 else return b2;
}

Borne max (const Borne & b1, const Borne & b2)
{
if (b1 <= b2) return b2;
 else return b1;
}

Borne operator + (const Borne & b1, const Borne & b2)
{
if ((b1._epsi == -1) || (b2._epsi == -1))
  return Borne(0,-1);

return Borne(b1._val+b2._val,b1._epsi*b2._epsi);
}

Borne operator + (const Borne & b, int k)
{return Borne(b._val+k,b._epsi);}


ostream & operator << (ostream & os, const Borne & b)
{
if (b._epsi == -1) 
  os << "<inf ";
else if (b._epsi == 0) 
  os << "<"<<b._val<<" ";
else  
  os << "<="<<b._val<<" ";
return os;
}


int Est_egal(const Borne & b1,const Borne & b2)
{
  // renvoie 1 ssi b1="<=k" et b2="<=-k"
  int res=0;
  if ((b1._epsi == 1) && (b2._epsi == 1) && (b1._val == -b2._val))
    res=1;
  return res;
}


/* ==================================================================

				ZONE

=================================================================== */


Zone::Zone()
{
  // jamais utilise directement
_est_vide=0;
_Dbm = 0;
_rg=0;
}


Zone::Zone(RegionGraph * r,int Vide)
{
int i,j;

assert(r);
_rg = r;
_Ndbm = r->Taille()+1;
_est_vide = Vide;
_Dbm = 0;
 if (! _est_vide) {
   _Dbm = new Pt_Borne[_Ndbm];
   for (i=0;i<_Ndbm;i++)
     _Dbm[i] = new Borne[_Ndbm];
   
   _Dbm[0][0]=Borne(0);
   for (i=1;i<_Ndbm;i++) {
     _Dbm[0][i] = Borne(0);
     _Dbm[i][0] = Borne();
   }
     
   for (i=1;i<_Ndbm;i++) 
     for (j=1;j<_Ndbm;j++) 
       if (i==j) 
	 _Dbm[i][j]=Borne(0);
       else _Dbm[i][j]=Borne();
 }

}

Zone::Zone(RegionGraph * r,Borne b,int vi, int vj)
{
int i,j;

assert(r);
_rg = r;
_Ndbm = r->Taille()+1;
assert((vi < _Ndbm) && (vj < _Ndbm));

_est_vide = 0;
 _Dbm = new Pt_Borne[_Ndbm];
 for (i=0;i<_Ndbm;i++)
   _Dbm[i] = new Borne[_Ndbm];
   
 _Dbm[0][0]=Borne(0);
 for (i=1;i<_Ndbm;i++) {
   _Dbm[0][i] = Borne(0);
   _Dbm[i][0] = Borne();
 }
     
 for (i=1;i<_Ndbm;i++) 
   for (j=1;j<_Ndbm;j++) 
     if (i==j) 
       _Dbm[i][j]=Borne(0);
     else _Dbm[i][j]=Borne();

 _Dbm[vi][vj] = b;
Normal();
}




Zone::Zone(RegionGraph * r,LnuTest * f)
{

Ident cx,cy;
int v,nx,ny;
int a;

// cout << "zone::zone(r,f) -> ";f->Print();cout << endl;

// on prend la zone [[tt]]
*this = Zone(r,0);

// on continue

cx = f->Get_c1();
cy = f->Get_c2();
a = 10*(Eq_str(cx,"")) + (Eq_str(cy,""));

// cout << endl << " a = " << a << " - v = " << f->Get_n2()-f->Get_n1() << endl;

//  a = 11 ssi "" ^ ""
//  a = 10 ssi "" ^ c2
//  a =  1 ssi c1 ^ ""
//  a =  0 ssi c1 ^ c2
switch (a) {
 case 0 :                    //  a =  0 ssi c1 ^ c2
  nx = _rg->CodeC(cx);
  ny = _rg->CodeC(cy);
  v = f->Get_n2()-f->Get_n1();
  switch(f->Get_opc()) {
  case Inf :
    _Dbm[nx][ny] = Borne(v,0);
    break;
  case Infe :
    _Dbm[nx][ny] = Borne(v,1);
    break;
  case Egal :
    _Dbm[nx][ny] = Borne(v,1);
    _Dbm[ny][nx] = Borne(-v,1);
    break;
  case Sup  :
    _Dbm[ny][nx] = Borne(-v,0);
    break;
  case Supe :
    _Dbm[ny][nx] = Borne(-v,1);
    break;
  default : cout << " Erreur dans Zone::Zone(d,f) ! " << endl;
  }
  break;
 case 10 :  //  a = 10 ssi "" ^ c2
  ny = _rg->CodeC(cy);
  v = f->Get_n1()-f->Get_n2();
  switch(f->Get_opc()) {
  case Inf :
    _Dbm[0][ny]=Borne(-v,0);
    break;
  case Infe :
    _Dbm[0][ny]=Borne(-v,1);
    break;
  case Egal :
    _Dbm[ny][0]=Borne(v,1);
    _Dbm[0][ny]=Borne(-v,1);
    break;
  case Sup :
    _Dbm[ny][0]=Borne(v,0);
    break;
  case Supe :
    _Dbm[ny][0]=Borne(v,1);
    break;
  default:
    cout << " Erreur 2 dans Zone::Zone(d,f) " << endl;
    break;
  }
  break;
 case 1 : //  a =  1 ssi c1 ^ ""
  nx = _rg->CodeC(cx);
  v = f->Get_n2()-f->Get_n1();
  switch(f->Get_opc()) {
  case Inf :
    _Dbm[nx][0]=Borne(v,0);
    break;
  case Infe :
    _Dbm[nx][0]=Borne(v,1);
    break;
  case Egal :
    _Dbm[nx][0]=Borne(v,1);
    _Dbm[0][nx]=Borne(-v,1);
    break;
  case Sup :
    _Dbm[0][nx]=Borne(-v,0);
    break;
  case Supe :
    _Dbm[0][nx]=Borne(-v,1);
    break;
    default : 
    cout << " Erreur 3 dans Zone::Zone(d,f) " << endl;
	break;
  }
  break;
  default : cout << " Erreur 4 dans Zone::Zone(d,f) " << endl;
  break;
}

// cout << "Fin de zone(r,f), avant la normalisation..." << endl;
// PrintM();

Normal();

//   cout << "zone::zone(r,f) <- ";cout << endl;
//   PrintShort(); cout << endl;
//   Print(); cout << endl;


}


int Borne::Val()
{return _val;}


// ==========================================================
//                   FLOYD
// ==========================================================


void Zone::Floyd() 
{
int i,j,k;
// int test=1;

if (_est_vide) 
  return;

/*
 test= (_Dbm[3][0] == Borne(0,1));

 if (test) {
   cout << " Test - floyd " << endl;
   PrintM();
 }
*/

for (k=0;k<_Ndbm;k++) 
  for (i=0;i<_Ndbm;i++) 
    for (j=0;j<_Ndbm;j++) 
      _Dbm[i][j] = min(_Dbm[i][j],_Dbm[i][k]+_Dbm[k][j]);

/*
 if (test) {
   cout << " et : " << endl;
   PrintM();
 }
*/

}

// ==========================================================
//                   Normal
// ==========================================================


void Zone::Normal()
{
int i,j,M, vide=0;
Borne bnul = Borne(0,1);

M = _rg->MaxC();

 if (_est_vide) {
   assert(_Dbm==0);
   return;
 }
 
 __ZNORMAL++;

Floyd();

// test si vide

for (i=0;i<_Ndbm;i++)
  if (_Dbm[i][i] < bnul) 
    vide = 1;
 

 if (vide) {
   Vider();
   return;
 }

 // affaiblissement des contraintes w.r.t. Max !
 /* 
 int test= (_Dbm[3][0] == Borne(0,1));
 if (test) {
   cout << " Test - Normal-Reduc " << endl;
   PrintM();
 }
 */

 if (! __NOABSTRACT) 
   for (i=0;i<_Ndbm;i++) 
     for (j=0;j<_Ndbm;j++) 
       _Dbm[i][j].Reduction(M);

/*
 if (test) {
   cout << " Test - apres reduc " << endl;
   PrintM();
 }
*/
}



// ==========================================================
//                   ExtensionRG
// ==========================================================
void Zone::ExtensionRG(RegionGraph * r)
{

  // on verifie que r est plus grand que This->_rg
  assert(r->Contient(_rg));

  Zone * res = new Zone(r);
  
  // chaque contrainte de this est reportee dans res...
  int i,j,ni,nj;
  for (i=0;i<_Ndbm;i++) {
    if (i) ni = r->CodeC(_rg->NameC(i));
    else ni = 0;

    for (j=0;j<_Ndbm;j++) {
      if (j) nj = r->CodeC(_rg->NameC(j));
      else nj = 0;
      res->_Dbm[ni][nj] = _Dbm[i][j];
    }
  }

  res->Normal();
  
  // detruire this->_rg ?
  this->Destroy_D();

  (*this) = (*res);

  delete res;
}




// ==========================================================
//                   Vider
// ==========================================================
void Zone::Vider()
{
  int i;
  if (_est_vide) 
    return;
  
  _est_vide = 1;
  for (i=0;i<_Ndbm;i++) 
    delete [] _Dbm[i];
  delete [] _Dbm;
  _Dbm=0;
}




// ==========================================================
//                   Print
// ==========================================================

void Zone::Print()
{
int i,j;

 if (_est_vide) {
   cout << "empty zone ";
   return ;
 }

 if (Est_tot()) {
   cout << "Top ";
   return;
 }

 for (i=1;i<_Ndbm;i++) 
   if ((! _Dbm[0][i].Is_Supe0()) || (! _Dbm[i][0].Is_Inf())) 
     {
       if (Est_egal(_Dbm[0][i],_Dbm[i][0])) 
	 cout << _rg->NameC(i) << " = " << _Dbm[i][0].Val() << " ; ";
       else {
	 if (! _Dbm[0][i].Is_Supe0()) 
	   _Dbm[0][i].PrintRev();
	 cout << _rg->NameC(i) << " ";
	 if (! _Dbm[i][0].Is_Inf()) 
	   _Dbm[i][0].Print();
	 cout << " ; ";
       }
     }

 for (i=1;i<_Ndbm;i++) 
   for (j=i+1;j<_Ndbm;j++) 
     if ((! _Dbm[j][i].Is_Inf()) || (! _Dbm[i][j].Is_Inf()))   {
       if (Est_egal(_Dbm[i][j],_Dbm[j][i])) 
	 cout << _rg->NameC(i) << "-" << _rg->NameC(j) << " = " <<_Dbm[i][j].Val()<< " ; ";
       else {
	 if (! _Dbm[j][i].Is_Inf()) 
	   _Dbm[j][i].PrintRev();
	 cout << _rg->NameC(i) << "-" << _rg->NameC(j);
	 if (! _Dbm[i][j].Is_Inf()) 
	   _Dbm[i][j].Print();
	 cout << " ; ";
       }
   }

}


// ==========================================================
//                   Print Short 
// ==========================================================

void Zone::PrintShort()
{
Zone * z = Copy();
z->Compact();
z->Print();


/*
 cout << endl << " verif ! " << endl;
 z->Normal();
 z->Print();
*/

z->Destroy();
delete z;
}


Zone * Zone::Copy()
{
Zone * res;
int i,j;

if (_est_vide) 
  return new Zone(_rg,1);
 
res = new Zone(_rg,0);

for (i=0;i<_Ndbm;i++) 
  for (j=0;j<_Ndbm;j++) 
    res->_Dbm[i][j] = _Dbm[i][j];
return res;
}


// ==========================================================
//                   Print-Matrice
// ==========================================================

void Zone::PrintM()
{
int i,j;

 cout << endl;

 if (_est_vide) {
   cout << "empty zone ";
   return ;
 }

 cout << '\t' << "0" << '\t';
 for (i=1;i<_Ndbm;i++) 
   cout << _rg->NameC(i) << '\t';
 cout << endl;
 for (i=0;i<_Ndbm;i++) {
   if (i) cout << _rg->NameC(i) << '\t';
   else cout << "0" << '\t';
     for (j=0;j<_Ndbm;j++) 
    cout << _Dbm[i][j] << '\t';
  cout << endl;
 }
 cout << endl;


}

// ==========================================================
//                   Compact 
// ==========================================================
// on ne garde que des contraintes necessaires et non redondantes
// (suivant la simplif de "efficient and compact data structure...") 

void Zone::Compact()
{
int * Repres;
int * Classe;
Liste<int> * Lmemb;
int i,j,k, trouve, cl, nbc=0, prev;
Borne bnul=Borne(0,1);

 if (_est_vide) 
   return;



 // necessaire ?
Floyd();


// cout << "Compacter !" << endl;
// PrintM();


 Repres = new int[_Ndbm];
 Classe = new int[_Ndbm];
 Lmemb = new Liste<int>[_Ndbm];

 for (i=0;i<_Ndbm;i++) {
   Repres[i]=-1;
   Classe[i]=-1;
 }

 for (i=0;i<_Ndbm;i++) {
   trouve = 0;
   cl=0;
   while ((! trouve) && (cl < nbc)) {
     if (_Dbm[i][Repres[cl]]+_Dbm[Repres[cl]][i] == bnul) {
       Lmemb[cl].Ajouterf(i);
       Classe[i] = cl;
       trouve=1;
     }
     else 
       cl++;
   }
   if (! trouve) {
     Repres[cl]=i;
     Classe[i]=cl;
     nbc++;
   }
 }

 /*
for (i=0;i<_Ndbm;i++) 
  cout << " Classe de " << i << " : " << Classe[i] << " - repres: " << Repres[Classe[i]] << endl;
 */

 // Elimination des bornes redondantes. 
 // elim = remplacement par <inf, i.e. Borne().
 //                     ou par (0,<=) si x0-xi 

 for (i=0;i<_Ndbm;i++) {
   if (Repres[Classe[i]]==i) {  // i in L
     for (j=0;j<_Ndbm;j++) 
       if (i != j) 
	 if ((Classe[i] != Classe[j]) && (Repres[Classe[j]] != j)) 
	   _Dbm[i][j] = (i==0) ? Borne(0,1) : Borne();
	 else if (Repres[Classe[j]]==j) {
	   for (k=0;k<_Ndbm;k++) {
	     if ((k!=i) && (k!=j) && (Repres[Classe[k]]==k) && 
		 (_Dbm[i][j] == _Dbm[i][k]+_Dbm[k][j])) {
	       _Dbm[i][j] = (i==0) ? Borne(0,1) : Borne();
	       break;
	     }
	   }
	 }
   }
   else 
     for (j=0;j<_Ndbm;j++) 
       if (i != j) 
	 if (Classe[i] != Classe[j])
	   _Dbm[i][j] = (i==0) ? Borne(0,1) : Borne();
 }

 // elim des cycles negatifs
 for (cl=0;cl<nbc;cl++) {
   Liste<int> lo;
   prev = Repres[cl];
   if (Lmemb[cl].Longueur() > 1) {
     for (lo=Lmemb[cl]; !lo.Est_vide(); lo.Cdr()) {
       _Dbm[lo.Tete()][prev] = Borne(); // x0 est tjs representant de sa classe !
       prev = lo.Tete();
     }
     _Dbm[Repres[cl]][prev] = (cl==0) ? Borne(0,1) : Borne();
   }
 }

 if (Repres) 
   delete [] Repres;
 if (Classe) 
   delete [] Classe;
 if (Lmemb)
   delete [] Lmemb;


 // cout << "Res : " << endl;
 // PrintM();

}

// ==========================================================
//                   Destroy_D 
// ==========================================================

void Zone::Destroy_D()
{
int i;
assert(_Dbm);
for (i=0;i<_Ndbm;i++)
  if (_Dbm[i]) 
    delete [] _Dbm[i];
delete [] _Dbm; 
_Dbm = (Borne * *) 0;
}

// ==========================================================
//                   Destroy
// ==========================================================

void Zone::Destroy()
{
if (_est_vide) 
  return ;
Destroy_D();
}


// ==========================================================
//                   Initial
// ==========================================================

void Zone::Initial()
{
Zone zaux = Zone(_rg,0);
int i;

 if (_Dbm) {
   for (i=0;i<_Ndbm;i++) 
     delete [] _Dbm[i];
   delete [] _Dbm;
 }

 _Dbm = zaux._Dbm;
 _est_vide=0;
 
 for (i=1;i<_Ndbm;i++) 
   _Dbm[i][0] = Borne(0,1);

 Normal(); 
}

// ==========================================================
//                   Get_RegionG
// ==========================================================
RegionGraph * Zone::Get_RegionG()
{ return _rg;}


// ==========================================================
//                   Est_vide
// ==========================================================
int Zone::Est_vide()
{return _est_vide;}


// ==========================================================
//                   Intersection
// ==========================================================

void Zone::Intersection(Zone * z)
{
int i,j;

__ZINTER++;

assert(z);

 if (_est_vide) return;

 if (z->_est_vide) {
   Vider();
   return;
 }

assert(_Ndbm == z->_Ndbm);
for (i=0;i<_Ndbm;i++)
  for (j=0;j<_Ndbm;j++) 
    _Dbm[i][j] = min(_Dbm[i][j],z->_Dbm[i][j]);

Normal();
}


Zone * Zone::IntersectionC(Zone * z)
{
Zone * res = Copy();
res->Intersection(z);
return res;
}
 
// ==========================================================
//                   ApproxUnion
// ==========================================================

void Zone::ApproxUnion(Zone * z)
{
int i,j;
Zone * zaux;

assert(z);

 if (z->_est_vide) {
   return;
 }

if (_est_vide) {
  zaux = z->Copy();
  (*this) = (*zaux);
  delete zaux;
  return;
}


assert(_Ndbm == z->_Ndbm);
for (i=0;i<_Ndbm;i++)
  for (j=0;j<_Ndbm;j++) 
    _Dbm[i][j] = max(_Dbm[i][j],z->_Dbm[i][j]);

}
 


// ==========================================================
//                   Add_Past
// ==========================================================
// cforall = 1 ssi on vient de SetReg::Forall (le double complement
// entraine une sous-approx au lieu d' une sur-approx
// par defaut : cforall = 0
void Zone::Add_Past(Ident_L *ls,int cforall)
{
int i,j,n;

if (_est_vide)
  return;

 __ZADDPAST++;

//cout << " -> Add_Past avec : "; PrintIdent_L(ls);
//cout << " et :"; Print();cout << endl;

n = _Ndbm-1;

 if ((ls && !ls->Est_vide()) && (n>2)) {
   if (cforall) {
     if (!__UNDERAPPROX && PTRACE) 
       cout << "Under-approximation !" << endl;
     __UNDERAPPROX=1;
   }
   else {
     if (!__OVERAPPROX && PTRACE) 
       cout << "Over-approximation !" << endl;
     __OVERAPPROX=1;
   }
 }


 if ((!ls) || (ls->Est_vide())) {  // procedure standard pour TA !
   for(i=1;i<_Ndbm;i++)
     _Dbm[0][i]=Borne(0,1);
   Normal();
   return;
 }


// pour optimiser les tests on utilise un tableau 
// t.q. Activ[i] = 1 ssi l'horloge i est activ (pente 1)
 int *Activ = new int[_Ndbm];
 Ident cl;

 for (i=1;i<_Ndbm;i++) 
   Activ[i]=1;
 if (ls) {
   for (Ident_L laux = *ls;!laux.Est_vide();laux.Reste()) {
     cl = laux.Tete();
     Activ[_rg->CodeC(cl)]=0;
   }
 }

 for (i=1;i<_Ndbm;i++) {
   if (Activ[i]) 
     _Dbm[0][i]=Borne(0,1);
 }

   for (i=1;i<_Ndbm;i++) {
     if (! Activ[i]) 
       for (j=1;j<_Ndbm;j++) {
	 if (Activ[j]) 
	   _Dbm[i][j]=_Dbm[i][0];
       }
   }

 // cout << "Affichage avant Normalisation: "; Print();
delete [] Activ;
Normal();
//cout << " <- Add_Past avec : ";Print();cout << endl;
}


Zone * Zone::Add_PastC(Ident_L *ls)
 {
Zone * res;
res = this->Copy();
res->Add_Past(ls);
return res;
}


// ==========================================================
//                   Est_NonBorne
// ==========================================================
// teste si aucune horloge n'est bornee 
// sauf les inactives !!

int Zone::Est_NonBorne(Ident_L *ls)
{
  int i,j,res = 1;
  Borne binf=Borne();

if (_est_vide) 
  return 0;

 if ((!ls) || (ls->Est_vide())) {
    for (i=1;i<_Ndbm;i++) 
	if (_Dbm[i][0] < binf) 
	  res=0;
    return res;
  }

  // cas general
 //Zone * auxz = Add_FutureC(ls,1);
 //res = this->Est_inclu(auxz);
 //auxz->Destroy();
 //delete auxz;

int * Activ = new int[_Ndbm];
char * cl;
 Activ[0]=0;
 for (i=1;i<_Ndbm;i++) 
   Activ[i]=1;
 if (ls) {
   for (Ident_L laux = *ls; !laux.Est_vide(); laux.Reste()) {
     cl = laux.Tete();
     Activ[_rg->CodeC(cl)]=0;
   }
 }

 for (i=1;(i<_Ndbm) && res;i++) 
   if (Activ[i]) 
     for (j=0;j<_Ndbm;j++) {
       if ((! Activ[j]) && (_Dbm[i][j] < binf))
	 res=0;
     }
 delete [] Activ;
 return res;
}

// ==========================================================
//                   Forall
// ==========================================================

void Zone::Forall(Ident_L *ls)
{
if (_est_vide)
  return;

__ZFORAL++;

//cout << " -> Forall avec : "; PrintIdent_L(ls);
//cout << " et :"; Print();cout << endl;

 if (! Est_NonBorne(ls)) 
   Vider();

 //cout << " <- Forall avec : ";Print();cout << endl;

}



// ==========================================================
//                   Add_Future
// ==========================================================
// ls : liste des horloges INACTIVES (pente 0)
void Zone::Add_Future(Ident_L *ls)
{
int i,n,j,mx;
if (_est_vide)
  return;

__ZADDFUTUR++;

// cout << " -> Add_Future avec : "; PrintIdent_L(ls);
// cout << " et :"; PrintM();cout << endl;

n = _Ndbm-1;

 if ((!ls) || (ls->Est_vide())) {
   for (i=1;i<_Ndbm;i++) 
     _Dbm[i][0]=Borne();
   return;
 }


if (ls && !ls->Est_vide() && (n>2))
  {
    if ((!__OVERAPPROX) && PTRACE)
      cout << " Over-approximation ! " << endl;
  __OVERAPPROX=1;
  }

// pour optimiser les tests on utilise un tableau 
// t.q. Activ[i] = 1 ssi l'horloge i est activ (pente 1)
 int *Activ = new int[_Ndbm];
 Ident cl;

 Activ[0]=0;
 for (i=1;i<_Ndbm;i++) 
   Activ[i]=1;
 if (ls) {
   for (Ident_L laux = *ls; !laux.Est_vide(); laux.Reste()) {
     cl = laux.Tete();
     Activ[_rg->CodeC(cl)]=0;
   }
 }

 mx = _rg->MaxC(); // tous le meme Max...
 /*
 for (i=1;i<_Ndbm;i++) {
   if (Activ[i]) 
     _Dbm[i][0]=Borne();
 }
 */

 for (i=1;i<_Ndbm;i++) {
   if (Activ[i]) {
     for (j=0;j<_Ndbm;j++) 
       if (!Activ[j]) 
	 _Dbm[i][j]=Borne();
   }
 }
delete [] Activ;
 // inutile de normaliser !
 // ... theoriquement !
 //  Normal();

/*
Zone * zaux2 = Copy();
 zaux2->Normal();
 if (! (zaux2->Est_inclu(this))) {
   cout << endl << "Erreur : Futur !! il faut normaliser !" << endl;
   PrintM(); cout << endl;
   zaux2->PrintM(); cout << endl;
   exit(1);
 }
 zaux2->Copy();
*/

 // cout << " <- Add_Future avec : ";PrintM();cout << endl;

}


Zone * Zone::Add_FutureC(Ident_L *ls)
{
Zone * res;
res = this->Copy();
res->Add_Future(ls);
return res;
}



// ==========================================================
//                   Add_FermetureTemp
// ==========================================================
// ls : liste des horloges INACTIVES (pente 0)
void Zone::Add_FermetureTemp(Ident_L *ls)
{
int i,n;
if (_est_vide)
  return;

n = _Ndbm-1;

 if ((!ls) || (ls->Est_vide())) {
   for (i=1;i<_Ndbm;i++) 
     (_Dbm[i][0]).ImposeNonStricte();
   return;
 }




 cout << "WARNING ! AddFermetureTemp is not fully implemented for stopwatches automata !" << endl;


if (ls && !ls->Est_vide() && (n>2))
  {
    if ((!__OVERAPPROX) && PTRACE)
      cout << " Over-approximation ! " << endl;
  __OVERAPPROX=1;
  }

// pour optimiser les tests on utilise un tableau 
// t.q. Activ[i] = 1 ssi l'horloge i est activ (pente 1)
 int *Activ = new int[_Ndbm];
 Ident cl;

 Activ[0]=0;
 for (i=1;i<_Ndbm;i++) 
   Activ[i]=1;
 if (ls) {
   for (Ident_L laux = *ls; !laux.Est_vide(); laux.Reste()) {
     cl = laux.Tete();
     Activ[_rg->CodeC(cl)]=0;
   }
 }


for (i=1;i<_Ndbm;i++) 
  if (Activ[i]) 
    (_Dbm[i][0]).ImposeNonStricte();

delete [] Activ;

}


// ==========================================================
//                   Rev_In
// ==========================================================
void Zone::Rev_In(Ident c, Ident ca, int ia)
{
int i, cx, cy;

if (_est_vide) 
  return;

__ZREVIN++;


//   cout << "Rev_in -> avec : "<< c << " := " << ca << " + " << ia << endl;
//   PrintShort();cout << endl;
//   PrintM();

cx = _rg->CodeC(c);
if (ca) 
  cy = _rg->CodeC(ca);
 else cy = 0;   //  ca=0 <=> ca=x_0=0

 if (cx == cy) {   // xi := xi + ia
   // Rev_In(z,xi:=xi+k) = z[xi:=xi-k]
   Projection(c,ca,-ia);
 }
 else {   // xi := xj + ia   avec i =/= j
   // calcul de z' = this intersec. [[ xi == xj+ ia ]]
   Zone * zaux = new Zone(_rg);  // ztot;
   zaux->_Dbm[cx][cy] = Borne(ia,1);
   zaux->_Dbm[cy][cx] = Borne(-ia,1);

   Intersection(zaux);
   if (! _est_vide) {
     // on relache les contraintes sur xi...
     _Dbm[0][cx] = Borne(0,1);
     _Dbm[cx][0] = Borne();
     for (i=1;i<_Ndbm;i++) 
       if (i != cx) 
	 {
	   _Dbm[cx][i] = Borne();
	   _Dbm[i][cx] = _Dbm[i][0];
	 }
     //     Normal();
   }
   zaux->Destroy();
   delete zaux;
 }

//    cout << "Rev_in <- avec : " << endl;
//   PrintShort();cout << endl;
//    PrintM();


}

Zone * Zone::Rev_InC(Ident c, Ident ca, int ia)
{
Zone * res = this->Copy();
res->Rev_In(c,ca,ia);
return res;
}


// ==========================================================
//                   Projection
// ==========================================================
void Zone::Projection(Ident c, Ident ca, int ia)
{
int i, cx, cy;
int M = _rg->MaxC();

if (_est_vide)
  return;

__ZPROJ++;

//PrintM();

cx = _rg->CodeC(c);
if (ca) 
  cy = _rg->CodeC(ca);
 else cy = 0;   //  ca=0 <=> ca=x_0=0

 if (cx == cy) {   // xi := xi + ia
   _Dbm[cx][0] = _Dbm[cx][0] + ia;
   _Dbm[0][cx] = min(Borne(0,1),_Dbm[0][cx] + (-ia));   
   for (i=1;i<_Ndbm;i++) 
     if (i != cx)
       {
	 _Dbm[cx][i] = _Dbm[cx][i] + ia;
	 _Dbm[i][cx] = _Dbm[i][cx] + (-ia);
       }
   Normal();
 }
 else {   // xi := xj + ia   avec i =/= j
   for (i=0;i<_Ndbm;i++) 
     if ((i != cx) && (i != cy)) {
     _Dbm[cx][i] = _Dbm[cy][i].Increm(ia,M);
     _Dbm[i][cx] = _Dbm[i][cy].Increm(-ia,M);
     }
   _Dbm[cx][cy] = Borne(ia,1);
   _Dbm[cy][cx] = Borne(-ia,1);
   if (ia != 0) 
     Normal();
   else {  // on verifie que la normalisation n'est pas necessaire
     /*
     Zone * zaux = Copy();
     zaux->Normal();
     if (! (zaux->Est_inclu(this))) {
       cout << endl << "Pb dans Projection: il faut normaliser !" << endl;
       if (ca) 
	 cout << c << " := " << ca << " + " << ia << endl;
       else cout << c << " := " << ia << endl;
       PrintM(); cout << endl;
       zaux->PrintM();
     }
     zaux->Destroy();
     delete zaux;
     */
     ;
   }
 }
}

// ==========================================================
//                   Est_tot
// ==========================================================

int Zone::Est_tot()
{
int i,j, res=1;
Borne bnul = Borne(0,1);
Borne binf = Borne();

if (_est_vide) 
  return 0;

 for (i=1;i<_Ndbm;i++) 
   if (_Dbm[0][i] != bnul)
     res=0;

 if (res) {
   for (i=1;i<_Ndbm;i++) 
     for (j=0;j<_Ndbm;j++) 
       if ((i != j) && (_Dbm[i][j] != binf)) 
	 res=0;
 }
return res;
}


// ==========================================================
//                   Est_inclu
// ==========================================================

int Zone::Est_inclu(Zone * z)   // test si *z est inclu dans *this
{
int i,j, res=1;

__ZESTINCL++;

assert(z);
assert(_Ndbm == z->_Ndbm);

if (z->_est_vide) 
  return 1;
if (_est_vide) 
  return 0;

for (i=0;(i<_Ndbm) && res;i++) 
    for (j=0;(j<_Ndbm) && res ;j++) 
      if (_Dbm[i][j] < z->_Dbm[i][j]) {
	res=0;
	//	cout << "i= " << i << "; j= " << j << "; " << _Dbm[i][j] << " < " << z->_Dbm[i][j] << endl;
      }

/*
 if (! res) {
   z->PrintM();
   cout << " n' est pas inclu dans : " << endl;
   PrintM();
 }
*/
 return res;
}

int Zone::Est_equiv(Zone * z)   // test si *z = *this
{
return  ((this->Est_inclu(z)) && (z->Est_inclu(this)));
}


// ==========================================================
//                   Complement
// ==========================================================

SetReg * Zone::Complement()
{
Zone * zaux;
SetReg * res = new SetReg(_rg);
Liste<Pt_Zone> l;

 if (_est_vide) {
   zaux = new Zone(_rg);
   l.Ajouter(zaux);
   res->Put_lz(l);
   return res;
 }

__ZCOMPL++;

zaux = Copy();
zaux->Compact();

/*
 cout << "test... " << endl;
 Print(); cout << endl;
 PrintM();

 cout << " vs. " << endl;
 zaux->Print();
 cout << endl;
 zaux->PrintM();
*/

Borne binf = Borne();
Borne bnul = Borne(0,1);
int i,j;

// pour nier une borne D[i][j], on donne ztot + D[j][i]=Reverse(D[i][j])
 for (i=1;i<_Ndbm;i++) { // attention: on place Reverse(b) en (j,i) !!
   if (zaux->_Dbm[0][i] != bnul) l.Ajouter(new Zone(_rg,zaux->_Dbm[0][i].Reverse(),i,0));
   else if (_Dbm[0][i] != bnul) __ZCOMPLOPTI++;
   if (zaux->_Dbm[i][0] != binf) l.Ajouter(new Zone(_rg,zaux->_Dbm[i][0].Reverse(),0,i));
   else if (_Dbm[i][0] != binf) __ZCOMPLOPTI++;
 }

 for (i=1;i<_Ndbm;i++) 
   for (j=1;j<_Ndbm;j++) 
     if (i != j) 
       { // attention: on place Reverse(b) en (j,i) !!
	 if (zaux->_Dbm[i][j] != binf) l.Ajouter(new Zone(_rg,zaux->_Dbm[i][j].Reverse(),j,i));
	  else if (_Dbm[i][j] != binf) __ZCOMPLOPTI++;
       }
res->Put_lz(l);
 zaux->Destroy();
 delete zaux;

 
return res;
}


// ==========================================================
//                   Extraire
// ==========================================================


SetReg * Zone::Extraire(Zone * z)
{
SetReg * res;
assert(z);
res = z->Complement();
res->Intersection(this);
return res;
}

